C SPARSE-       START OF PARSE
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
C THIS ROUTINE DETAILS ON BIT 2 OF PRSFLG
C
       INTEGER FUNCTION SPARSE(LBUF,LLNT,VBFLAG)
       IMPLICIT INTEGER(A-Z)
       INTEGER LBUF(40)
       LOGICAL LIT,QHERE,OTEST,DFLAG,VBFLAG
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C PARSER STATE
C
       COMMON /ORPHS/ OFLAG,OACT,OSLOT,OPREP,ONAME
       COMMON /LAST/ LASTIT
       COMMON /PV/ ACT,O1,O2,P1,P2
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /DEBUG/ DBGFLG,PRSFLG,GDTFLG
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C SPARSE, PAGE 2
C
C VOCABULARIES
C
       COMMON /BUZVOC/ BVOC(20)
       COMMON /PRPVOC/ PVOC(45)
       COMMON /DIRVOC/ DVOC(75)
       INTEGER AVOC(405)
       COMMON /ADJVOC/ AVOC1(184),AVOC2(114),AVOC3(106),AVOCND
       INTEGER VVOC(935)
       COMMON /VRBVOC/ VVOC1(92),VVOC1A(108),VVOC1B(38),VVOC2(104),
     1       VVOC3(136),
     2       VVOC4(116),VVOC5(134),VVOC6(117),VVOC7(89),VVOCND
       INTEGER OVOC(1021)
       COMMON /OBJVOC/ OVOC1(159),OVOC2(144),OVOC3(150),OVOC4(128),
     1       OVOC5(111),OVOC6(104),OVOC6A(97),OVOC7(127),OVOCND
C
       EQUIVALENCE (VVOC(1),VVOC1(1))
       EQUIVALENCE (AVOC(1),AVOC1(1))
       EQUIVALENCE (OVOC(1),OVOC1(1))
C
C      BEGINNING DATA SECTION
       DATA R50MIN/1600/,R50WAL/36852/


       OTEST(R)=(R.GT.0).AND.(R.LT.R50MIN)

C
C SPARSE, PAGE 7
C
C SET UP FOR PARSING
C
       SPARSE=-1   
C ASSUME PARSE FAILS.
       ADJ=0
C CLEAR PARTS HOLDERS.
       ACT=0
       PREP=0
       PPTR=0
       O1=0
       O2=0
       P1=0
       P2=0
C
       BUZLNT=20
       PRPLNT=45 
C JDM was 48?????????
       DIRLNT=75
C SPARSE, PAGE 8
C
C NOW LOOP OVER INPUT BUFFER OF LEXICAL TOKENS.
C
C       DO 1000 I=1,LLNT,2 
C  CANNOT BE DO LOOP, AS IT IS BRANCHED INTO, THEREFORE FAKE WITH GOTO
        I = 1
9801    CONTINUE
C TWO WORDS/TOKEN.
         LBUF1=LBUF(I)   
C GET CURRENT TOKEN.
         LBUF2=LBUF(I+1)
         IF(LBUF1.EQ.0) GO TO 1500    
C END OF BUFFER?
C
C CHECK FOR BUZZ WORD
C
         DO 50 J=1,BUZLNT,2
           IF((LBUF1.EQ.BVOC(J)).AND.(LBUF2.EQ.BVOC(J+1)))
     1       GO TO 1000 
C IGNORE BUZZ WORDS.
50         CONTINUE
C
C CHECK FOR ACTION OR DIRECTION
C
         IF(ACT.NE.0) GO TO 75 
C GOT ACTION ALREADY?
         J=1
C CHECK FOR ACTION.
125         IF((LBUF1.EQ.VVOC(J)).AND.(LBUF2.EQ.VVOC(J+1)))
     1       GO TO 3000
150         J=J+2
C ADV TO NEXT SYNONYM.
         IF(.NOT.OTEST(VVOC(J))) GO TO 125  
C ANOTHER VERB?
         J=J+VVOC(J)+1   
C NO, ADVANCE OVER SYNTAX.
         IF(VVOC(J).NE.-1) GO TO 125    
C TABLE DONE?
C
75         IF((ACT.NE.0).AND.((VVOC(ACT).NE.R50WAL).OR.
     1       (PREP.NE.0))) GO TO 200    
C NO ACTION OR WALK?
         DO 100 J=1,DIRLNT,3 
C THEN CHK FOR DIR.
           IF((LBUF1.EQ.DVOC(J)).AND.(LBUF2.EQ.DVOC(J+1)))
     1       GO TO 2000
100         CONTINUE
C
C NOT AN ACTION, CHECK FOR PREPOSITION, ADJECTIVE, OR OBJECT.
C
200         DO 250 J=1,PRPLNT,3 
C LOOK FOR PREPOSITION.
           IF((LBUF1.EQ.PVOC(J)).AND.(LBUF2.EQ.PVOC(J+1)))
     1       GO TO 4000
250         CONTINUE
C
         J=1
C LOOK FOR ADJECTIVE.
300         IF((LBUF1.EQ.AVOC(J)).AND.(LBUF2.EQ.AVOC(J+1)))
     1       GO TO 5000
         J=J+1
325         J=J+1
C ADVANCE TO NEXT ENTRY.
         IF(OTEST(AVOC(J))) GO TO 325  
C A RADIX 50 CONSTANT?
         IF(AVOC(J).NE.-1) GO TO 300    
C POSSIBLY, END TABLE?
C
         J=1
C LOOK FOR OBJECT.
450         IF((LBUF1.EQ.OVOC(J)).AND.(LBUF2.EQ.OVOC(J+1)))
     1       GO TO 600
         J=J+1
500         J=J+1
         IF(OTEST(OVOC(J))) GO TO 500
         IF(OVOC(J).NE.-1) GO TO 450
C
C NOT RECOGNIZABLE
C
         IF(VBFLAG) CALL RSPEAK(601)
         RETURN
C SPARSE, PAGE 9
C
C OBJECT PROCESSING (CONTINUATION OF DO LOOP ON PREV PAGE)
C
600         OBJ=GETOBJ(J,ADJ,0) 
C IDENTIFY OBJECT.
         IF(OBJ.LE.0) GO TO 6000    
C IF LE, COULDNT.
         IF(OBJ.NE.ITOBJ) GO TO 650    
C "IT"?
         OBJ=GETOBJ(0,0,LASTIT)    
C FIND LAST.
         IF(OBJ.LE.0) GO TO 6000    
C IF LE, COULDNT.
C
650         IF(PREP.EQ.9) GO TO 8000    
C "OF" OBJ?
         IF(PPTR.EQ.2) GO TO 7000    
C TOO MANY OBJS?
         PPTR=PPTR+1
         IF(PPTR.EQ.1)O1=OBJ
         IF(PPTR.EQ.2)O2=OBJ
C STUFF INTO VECTOR.
         IF(PPTR.EQ.1)P1=PREP
         IF(PPTR.EQ.2)P2=PREP
700         PREP=0
         ADJ=0
1000       CONTINUE
          I = I+2
          IF(I.LE.LLNT)GOTO 9801   
C AT LAST.
C
C NOW SOME MISC CLEANUP
C
1500       IF(ACT.EQ.0) ACT=ZAND(OFLAG,OACT)  
C IF NO ACT, STEAL ORPHAN.
       IF(ACT.EQ.0) GO TO 9000 
C IF STILL NONE, PUNT.
       IF(ADJ.NE.0) GO TO 10000    
C IF DANGLING ADJ, PUNT.
C
       IF((OFLAG.NE.0).AND.(OPREP.NE.0).AND.(PREP.EQ.0).AND.
     1       (O1.NE.0).AND.(O2.EQ.0).AND.(ACT.EQ.OACT))
     2       GO TO 11000
C
       SPARSE=0   
C PARSE SUCCEEDS.
       IF(PREP.EQ.0) GO TO 1750    
C IF DANGLING PREP,
       IF(PPTR.EQ.1)PPQQ=P1
       IF(PPTR.EQ.2)PPQQ=P2
       IF((PPTR.EQ.0).OR.(PPQQ.NE.0))
     1       GO TO 12000 
C AND HAVE 'PICK FROB UP',
       IF(PPTR.EQ.1)P1 = PREP
       IF(PPTR.EQ.2)P2 = PREP
C CVT TO 'PICK UP FROB'.
1750       CONTINUE   
C WIN.
       RETURN
C SPARSE, PAGE 10
C
C SPECIAL PARSE PROCESSORS
C
C 2000--       DIRECTION
C
2000       PRSA=WALKW   
C VERB IS WALK.
       PRSO=DVOC(J+2)   
C GET DIRECTION.
       SPARSE=1   
C WIN TOTALLY.
       RETURN
C
C 3000--       ACTION
C
3000       ACT=J
C SAVE INDEX TO VERB.
       OACT=0
C NO ORPHAN.
       GO TO 1000   
C DONE.
C
C 4000--       PREPOSITION
C
4000       IF(PREP.NE.0) GO TO 4500    
C ALREADY HAVE ONE?
       PREP=PVOC(J+2) 
C NO, GET INDEX.
       ADJ=0
C NO ADJECTIVE.
       GO TO 1000
C
4500       IF(VBFLAG) CALL RSPEAK(616)    
C YES, GAG AND LOSE.
       RETURN
C
C 5000--       ADJECTIVE
C
5000       ADJ=J
C SAVE ADJECTIVE.
       J=ZAND(ONAME,OFLAG)
       IF((J.NE.0).AND.(I.GE.LLNT)) GO TO 600
       GO TO 1000
C
C 6000--       UNIDENTIFIABLE OBJECT (INDEX INTO OVOC IS J)
C
6000       IF(OBJ.LT.0) GO TO 6100 
C IF LT, AMBIGUOUS.
       I=579
C NOT HERE OR
       IF(LIT(HERE)) I=618 
C NOT LIT.
       IF(VBFLAG) CALL RSPEAK(I)
       RETURN
C LOSE.
C
6100       IF(OBJ.NE.-10000) GO TO 6200    
C INSIDE VEHICLE?
       IF(VBFLAG) CALL RSPSUB(620,ODESC2(AVEHIC(WINNER)))
       RETURN
C
6200       IF(VBFLAG) CALL RSPEAK(619)    
C CANT DISTINGUISH.
       IF(ACT.EQ.0) ACT=ZAND(OFLAG,OACT)  
C IF NO ACT, GET ORPHAN.
       CALL ORPHAN(-1,ACT,O1,PREP,J)    
C ORPHAN THE WORLD.
       RETURN
C
C 7000--       TOO MANY OBJECTS.
C
7000       IF(VBFLAG) CALL RSPEAK(617)
       RETURN
C
C 8000--       RANDOMNESS FOR "OF" WORDS
C
8000   IF(PPTR.EQ.1)OOQQ=O1
       IF(PPTR.EQ.2)OOQQ=O2    
       IF(OOQQ.EQ.OBJ) GO TO 700  
C IGNORE IF OK.
       IF(VBFLAG) CALL RSPEAK(601)
       RETURN
C
C 9000--       NO ACTION, PUNT
C
9000       IF(O1.EQ.0) GO TO 10000 
C ANY DIRECT OBJECT?
       IF(VBFLAG) CALL RSPSUB(621,ODESC2(O1))  
C WHAT TO DO?
       CALL ORPHAN(-1,0,O1,0,0)
       RETURN
C
C 10000--       TOTAL CHOMP
C
10000       IF(VBFLAG) CALL RSPEAK(622)    
C HUH?
       RETURN
C
C 11000--       ORPHAN PREPOSITION.  CONDITIONS ARE
C              O1.NE.0, O2=0, PREP=0, ACT=OACT
C
11000       IF(OSLOT.NE.0) GO TO 11500    
C ORPHAN OBJECT?
       P1=OPREP   
C NO, JUST USE PREP.
       GO TO 1750
C
11500       O2=O1
C YES, USE AS DIRECT OBJ.
       P2=OPREP
       O1=OSLOT
       P1=0
       GO TO 1750
C
C 12000--       TRUE HANGING PREPOSITION.
C              ORPHAN FOR LATER.
C
12000       CALL ORPHAN(-1,ACT,0,PREP,0)    
C ORPHAN PREP.
       GO TO 1750
C
       END
C GETOBJ--       FIND OBJ DESCRIBED BY ADJ, NAME PAIR
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
C THIS ROUTINE DETAILS ON BIT 3 OF PRSFLG
C
       INTEGER FUNCTION GETOBJ(OIDX,AIDX,SPCOBJ)
       IMPLICIT INTEGER(A-Z)
       LOGICAL THISIT,GHERE,LIT,CHOMP,DFLAG
C
       COMMON /OBJFLG/ VABIT,VRBIT,VTBIT,VCBIT,VEBIT,VFBIT,VPMASK
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C MISCELLANEOUS VARIABLES
C
       COMMON /STAR/ MBASE,STRBIT
       COMMON /DEBUG/ DBGFLG,PRSFLG,GDTFLG
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
C VOCABULARIES
C
       COMMON /OBJVOC/ OVOC(1021)
C GETOBJ, PAGE 2
C
       CHOMP=.FALSE.
       AV=AVEHIC(WINNER)
       OBJ=0
C ASSUME DARK.
       IF(.NOT.LIT(HERE)) GO TO 200    
C LIT?
C
       OBJ=SCHLST(OIDX,AIDX,HERE,0,0,SPCOBJ)  
C SEARCH ROOM.
       IF(OBJ) 1000,200,100 
C TEST RESULT.
100       IF((AV.EQ.0).OR.(AV.EQ.OBJ).OR.
     1       (ZAND(OFLAG2(OBJ),FINDBT).NE.0)) GO TO 200
       IF(OCAN(OBJ).EQ.AV) GO TO 200    
C TEST IF REACHABLE.
       CHOMP=.TRUE.   
C PROBABLY NOT.
C
200       IF(AV.EQ.0) GO TO 400 
C IN VEHICLE?
       NOBJ=SCHLST(OIDX,AIDX,0,AV,0,SPCOBJ)  
C SEARCH VEHICLE.
       IF(NOBJ) 1100,400,300 
C TEST RESULT.
300       CHOMP=.FALSE.   
C REACHABLE.
       IF(OBJ.EQ.NOBJ) GO TO 400    
C SAME AS BEFORE?
       IF(OBJ.NE.0) NOBJ=-NOBJ 
C AMB RESULT?
       OBJ=NOBJ
C
400       NOBJ=SCHLST(OIDX,AIDX,0,0,WINNER,SPCOBJ)  
C SEARCH ADVENTURER.
       IF(NOBJ) 1100,600,500 
C TEST RESULT
500       IF(OBJ.NE.0) NOBJ=-NOBJ 
C AMB RESULT?
1100       OBJ=NOBJ   
C RETURN NEW OBJECT.
600       IF(CHOMP) OBJ=-10000 
C UNREACHABLE.
1000       GETOBJ=OBJ
C
       IF(GETOBJ.NE.0) GO TO 1500    
C GOT SOMETHING?
       DO 1200 I=STRBIT+1,OLNT 
C NO, SEARCH GLOBALS.
         IF(.NOT.THISIT(OIDX,AIDX,I,SPCOBJ)) GO TO 1200
         IF(.NOT.GHERE(I,HERE)) GO TO 1200  
C CAN IT BE HERE?
         IF(GETOBJ.NE.0) GETOBJ=-I    
C AMB MATCH?
         IF(GETOBJ.EQ.0) GETOBJ=I
1200       CONTINUE
C
1500       CONTINUE   
C END OF SEARCH.
       RETURN
       END
C SCHLST--       SEARCH FOR OBJECT
C
C DECLARATIONS
C
       INTEGER FUNCTION SCHLST(OIDX,AIDX,RM,CN,AD,SPCOBJ)
       IMPLICIT INTEGER(A-Z)
       LOGICAL THISIT,QHERE,NOTRAN,NOVIS
C
       COMMON /STAR/ MBASE,STRBIT
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
C FUNCTIONS AND DATA
C
       NOTRAN(O)=(ZAND(OFLAG1(O),TRANBT).EQ.0).AND.
     1       (ZAND(OFLAG2(O),OPENBT).EQ.0)
       NOVIS(O)=(ZAND(OFLAG1(O),VISIBT).EQ.0)
C
       SCHLST=0
C NO RESULT.
       DO 1000 I=1,OLNT 
C SEARCH OBJECTS.
         IF(NOVIS(I).OR.
     1       (((RM.EQ.0).OR.(.NOT.QHERE(I,RM))).AND.
     2        ((CN.EQ.0).OR.(OCAN(I).NE.CN)).AND.
     3        ((AD.EQ.0).OR.(OADV(I).NE.AD)))) GO TO 1000
         IF(.NOT.THISIT(OIDX,AIDX,I,SPCOBJ)) GO TO 200
         IF(SCHLST.NE.0) GO TO 2000    
C GOT ONE ALREADY?
         SCHLST=I
C NO.
C
C IF OPEN OR TRANSPARENT, SEARCH THE OBJECT ITSELF.
C
200         IF(NOTRAN(I)) GO TO 1000
C
C SEARCH IS CONDUCTED IN REVERSE.  ALL OBJECTS ARE CHECKED TO
C SEE IF THEY ARE AT SOME LEVEL OF CONTAINMENT INSIDE OBJECT 'I'.
C IF THEY ARE AT LEVEL 1, OR IF ALL LINKS IN THE CONTAINMENT
C CHAIN ARE OPEN, VISIBLE, AND HAVE SEARCHME SET, THEY CAN QUALIFY
C AS A POTENTIAL MATCH.
C
         DO 500 J=1,OLNT 
C SEARCH OBJECTS.
           IF(NOVIS(J).OR. (.NOT.THISIT(OIDX,AIDX,J,SPCOBJ)))
     1       GO TO 500 
C VISIBLE & MATCH?
           X=OCAN(J)   
C GET CONTAINER.
300           IF(X.EQ.I) GO TO 400    
C INSIDE TARGET?
           IF(X.EQ.0) GO TO 500    
C INSIDE ANYTHING?
           IF(NOVIS(X).OR.NOTRAN(X).OR.
     1       (ZAND(OFLAG2(X),SCHBT).EQ.0)) GO TO 500
           X=OCAN(X)   
C GO ANOTHER LEVEL.
           GO TO 300
C
400           IF(SCHLST.NE.0) GO TO 2000    
C ALREADY GOT ONE?
           SCHLST=J   
C NO.
500         CONTINUE
C
1000       CONTINUE
       RETURN
C
2000       SCHLST=-SCHLST   
C AMB RETURN.
       RETURN
C
       END
C THISIT--       VALIDATE OBJECT VS DESCRIPTION
C
C DECLARATIONS
C
       LOGICAL FUNCTION THISIT(OIDX,AIDX,OBJ,SPCOBJ)
       IMPLICIT INTEGER(A-Z)
       LOGICAL NOTEST
C
C VOCABULARIES
C
       COMMON /OBJVOC/ OVOC(1021)
       COMMON /ADJVOC/ AVOC(405)
C
C FUNCTIONS AND DATA
C
       NOTEST(O)=(O.LE.0).OR.(O.GE.R50MIN)
       DATA R50MIN/1600/
C
       THISIT=.FALSE.   
C ASSUME NO MATCH.
       IF((SPCOBJ.NE.0).AND.(OBJ.EQ.SPCOBJ)) GO TO 500
C
C CHECK FOR OBJECT NAMES
C
       I=OIDX+1
100       I=I+1
       IF(NOTEST(OVOC(I))) RETURN    
C IF DONE, LOSE.
       IF(OVOC(I).NE.OBJ) GO TO 100    
C IF FAIL, CONT.
C
       IF(AIDX.EQ.0) GO TO 500 
C ANY ADJ?
       I=AIDX+1
200       I=I+1
       IF(NOTEST(AVOC(I))) RETURN    
C IF DONE, LOSE.
       IF(AVOC(I).NE.OBJ) GO TO 200    
C IF FAIL, CONT.
C
500       THISIT=.TRUE.
       RETURN
       END
C SYNMCH--       SYNTAX MATCHER
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
C THIS ROUTINE DETAILS ON BIT 4 OF PRSFLG
C
       LOGICAL FUNCTION SYNMCH()
       IMPLICIT INTEGER(A-Z)
       LOGICAL SYNEQL,TAKEIT,DFLAG
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
       COMMON /DEBUG/ DBGFLG,PRSFLG,GDTFLG
C
       COMMON /ORPHS/ OFLAG,OACT,OSLOT,OPREP,ONAME
       COMMON /PV/ ACT,O1,O2,P1,P2
       COMMON /SYNTAX/VFLAG,DOBJ,DFL1,DFL2,DFW1,DFW2,
     1       IOBJ,IFL1,IFL2,IFW1,IFW2
       COMMON /VRBVOC/ VVOC(935)
       COMMON /SYNFLG/ SDIR,SIND,SSTD,SFLIP,SDRIV,SVMASK
       COMMON /OBJFLG/ VABIT,VRBIT,VTBIT,VCBIT,VEBIT,VFBIT,VPMASK
       DATA R50MIN/1600/
C
       SYNMCH=.FALSE.
       J=ACT
C SET UP PTR TO SYNTAX.
       DRIVE=0
C NO DEFAULT.
       DFORCE=0   
C NO FORCED DEFAULT.
       QPREP=ZAND(OFLAG,OPREP) 
C VALID ORPHAN PREP FLAG.
100       J=J+2
C FIND START OF SYNTAX.
       IF((VVOC(J).LE.0).OR.(VVOC(J).GE.R50MIN)) GO TO 100
       LIMIT=J+VVOC(J)+1 
C COMPUTE LIMIT.
       J=J+1
C ADVANCE TO NEXT.
C
200       CALL UNPACK(J,NEWJ) 
C UNPACK SYNTAX.
       SPREP=ZAND(DOBJ,VPMASK) 
C SAVE EXPECTED PREP.
       IF(.NOT.SYNEQL(P1,O1,DOBJ,DFL1,DFL2)) GO TO 1000
       SPREP=ZAND(IOBJ,VPMASK) 
C SAVE EXPECTED PREP.
       IF(SYNEQL(P2,O2,IOBJ,IFL1,IFL2)) GO TO 6000
C
C SYNTAX MATCH FAILS, TRY NEXT ONE.
C
       IF(O2) 3000,500,3000 
C IF O2=0, SET DFLT.
1000       IF(O1) 3000,500,3000 
C IF O1=0, SET DFLT.
500       IF((QPREP.EQ.0).OR.(QPREP.EQ.SPREP)) DFORCE=J   
C IF PREP MCH.
       IF(ZAND(VFLAG,SDRIV).NE.0) DRIVE=J  
C IF DRIVER, RECORD.
3000       J=NEWJ
       IF(J.LT.LIMIT) GO TO 200    
C MORE TO DO?
C SYNMCH, PAGE 2
C
C MATCH HAS FAILED.  IF DEFAULT SYNTAX EXISTS, TRY TO SNARF
C ORPHANS OR GWIMS, OR MAKE NEW ORPHANS.
C
       IF(DRIVE.EQ.0) DRIVE=DFORCE    
C NO DRIVER? USE FORCE.
       IF(DRIVE.EQ.0) GO TO 10000    
C ANY DRIVER?
       CALL UNPACK(DRIVE,DFORCE)    
C UNPACK DFLT SYNTAX.
C
C TRY TO FILL DIRECT OBJECT SLOT IF THAT WAS THE PROBLEM.
C
       IF((ZAND(VFLAG,SDIR).EQ.0).OR.(O1.NE.0)) GO TO 4000
C
C FIRST TRY TO SNARF ORPHAN OBJECT.
C
       O1=ZAND(OFLAG,OSLOT)
       IF(O1.EQ.0) GO TO 3500 
C ANY ORPHAN?
       IF(SYNEQL(P1,O1,DOBJ,DFL1,DFL2)) GO TO 4000
C
C ORPHAN FAILS, TRY GWIM.
C
3500       O1=GWIM(DOBJ,DFW1,DFW2) 
C GET GWIM.
       IF(O1.GT.0) GO TO 4000    
C TEST RESULT.
       CALL ORPHAN(-1,ACT,0,ZAND(DOBJ,VPMASK),0)  
C FAILS, ORPHAN.
       CALL RSPEAK(623)
       RETURN
C
C TRY TO FILL INDIRECT OBJECT SLOT IF THAT WAS THE PROBLEM.
C
4000       IF((ZAND(VFLAG,SIND).EQ.0).OR.(O2.NE.0)) GO TO 6000
       O2=GWIM(IOBJ,IFW1,IFW2) 
C GWIM.
       IF(O2.GT.0) GO TO 6000
       IF(O1.EQ.0) O1=ZAND(OFLAG,OSLOT)
       CALL ORPHAN(-1,ACT,O1,ZAND(DOBJ,VPMASK),0)
       CALL RSPEAK(624)
       RETURN
C
C TOTAL CHOMP
C
10000       CALL RSPEAK(601) 
C CANT DO ANYTHING.
       RETURN
C SYNMCH, PAGE 3
C
C NOW TRY TO TAKE INDIVIDUAL OBJECTS AND
C IN GENERAL CLEAN UP THE PARSE VECTOR.
C
6000       IF(ZAND(VFLAG,SFLIP).EQ.0) GO TO 5000  
C FLIP?
       J=O1
C YES.
       O1=O2
       O2=J
C
5000       PRSA=ZAND(VFLAG,SVMASK) 
C GET VERB.
       PRSO=O1
C GET DIR OBJ.
       PRSI=O2
C GET IND OBJ.
       IF(.NOT.TAKEIT(PRSO,DOBJ)) RETURN  
C TRY TAKE.
       IF(.NOT.TAKEIT(PRSI,IOBJ)) RETURN  
C TRY TAKE.
       SYNMCH=.TRUE.
       RETURN
C
       END
C UNPACK-       UNPACK SYNTAX SPECIFICATION, ADV POINTER
C
C DECLARATIONS
C
       SUBROUTINE UNPACK(OLDJ,J)
       IMPLICIT INTEGER(A-Z)
C
       COMMON /VRBVOC/ VVOC(935)
C
       COMMON /SYNFLG/ SDIR,SIND,SSTD,SFLIP,SDRIV,SVMASK
       COMMON /OBJFLG/ VABIT,VRBIT,VTBIT,VCBIT,VEBIT,VFBIT,VPMASK
       COMMON /SYNTAX/ VFLAG,DOBJ,DFL1,DFL2,DFW1,DFW2,
     1       IOBJ,IFL1,IFL2,IFW1,IFW2
       INTEGER SYN(11)
       EQUIVALENCE (SYN(1),VFLAG)
C
       DO 10 I=1,11   
C CLEAR SYNTAX.
         SYN(I)=0
10       CONTINUE
C
       VFLAG=VVOC(OLDJ)
       J=OLDJ+1
       IF(ZAND(VFLAG,SDIR).EQ.0) RETURN  
C DIR OBJECT?
       DFL1=-1
C ASSUME STD.
       DFL2=-1
       IF(ZAND(VFLAG,SSTD).EQ.0) GO TO 100  
C STD OBJECT?
       DFW1=-1
C YES.
       DFW2=-1
       DOBJ=VABIT+VRBIT+VFBIT
       GO TO 200
C
100       DOBJ=VVOC(J)   
C NOT STD.
       DFW1=VVOC(J+1)
       DFW2=VVOC(J+2)
       J=J+3
       IF(ZAND(DOBJ,VEBIT).EQ.0) GO TO 200  
C VBIT = VFWIM?
       DFL1=DFW1   
C YES.
       DFL2=DFW2
C
200       IF(ZAND(VFLAG,SIND).EQ.0) RETURN  
C IND OBJECT?
       IFL1=-1
C ASSUME STD.
       IFL2=-1
       IOBJ=VVOC(J)
       IFW1=VVOC(J+1)
       IFW2=VVOC(J+2)
       J=J+3
       IF(ZAND(IOBJ,VEBIT).EQ.0) RETURN  
C VBIT = VFWIM?
       IFL1=IFW1   
C YES.
       IFL2=IFW2
       RETURN
C
       END
C SYNEQL-       TEST FOR SYNTAX EQUALITY
C
C DECLARATIONS
C
       LOGICAL FUNCTION SYNEQL(PREP,OBJ,SPREP,SFL1,SFL2)
       IMPLICIT INTEGER(A-Z)
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OBJFLG/ VABIT,VRBIT,VTBIT,VCBIT,VEBIT,VFBIT,VPMASK
C
       IF(OBJ.EQ.0) GO TO 100 
C ANY OBJECT?
       SYNEQL=(PREP.EQ.ZAND(SPREP,VPMASK)).AND.
     1       ((ZOR(ZAND(SFL1,OFLAG1(OBJ)),
     2         ZAND(SFL2,OFLAG2(OBJ)))).NE.0)
       RETURN
C
100       SYNEQL=(PREP.EQ.0).AND.(SFL1.EQ.0).AND.(SFL2.EQ.0)
       RETURN
C
       END
C TAKEIT-       PARSER BASED TAKE OF OBJECT
C
C DECLARATIONS
C
       LOGICAL FUNCTION TAKEIT(OBJ,SFLAG)
       IMPLICIT INTEGER(A-Z)
C
       COMMON /OBJFLG/ VABIT,VRBIT,VTBIT,VCBIT,VEBIT,VFBIT,VPMASK
       COMMON /STAR/ MBASE,STRBIT
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C TAKEIT, PAGE 2
C
       TAKEIT=.FALSE.   
C ASSUME LOSES.
       IF((OBJ.EQ.0).OR.(OBJ.GT.STRBIT)) GO TO 4000  
C NULL/STARS WIN.
       ODO2=ODESC2(OBJ) 
C GET DESC.
       X=OCAN(OBJ)   
C GET CONTAINER.
       IF((X.EQ.0).OR.(ZAND(SFLAG,VFBIT).EQ.0)) GO TO 500
       IF(ZAND(OFLAG2(X),OPENBT).NE.0) GO TO 500
       CALL RSPSUB(566,ODO2) 
C CANT REACH.
       RETURN
C
500       IF(ZAND(SFLAG,VRBIT).EQ.0) GO TO 1000  
C SHLD BE IN ROOM?
       IF(ZAND(SFLAG,VTBIT).EQ.0) GO TO 2000  
C CAN BE TAKEN?
C
C SHOULD BE IN ROOM (VRBIT NE 0) AND CAN BE TAKEN (VTBIT NE 0)
C
       IF(SCHLST(0,0,HERE,0,0,OBJ).LE.0) GO TO 4000 
C IF NOT, OK.
C
C ITS IN THE ROOM AND CAN BE TAKEN.
C
       IF((ZAND(OFLAG1(OBJ),TAKEBT).NE.0).AND.
     1       (ZAND(OFLAG2(OBJ),TRYBT).EQ.0)) GO TO 3000
C
C NOT TAKEABLE.  IF WE CARE, FAIL.
C
       IF(ZAND(SFLAG,VCBIT).EQ.0) GO TO 4000  
C IF NO CARE, RETURN.
       CALL RSPSUB(445,ODO2)
       RETURN
C
C 1000--       IT SHOULD NOT BE IN THE ROOM.
C 2000--       IT CANT BE TAKEN.
C
2000       IF(ZAND(SFLAG,VCBIT).EQ.0) GO TO 4000  
C IF NO CARE, RETURN
1000       IF(SCHLST(0,0,HERE,0,0,OBJ).LE.0) GO TO 4000
       CALL RSPSUB(665,ODO2)
       RETURN
C TAKEIT, PAGE 3
C
C OBJECT IS IN THE ROOM, CAN BE TAKEN BY THE PARSER,
C AND IS TAKEABLE IN GENERAL.  IT IS NOT A STAR.
C TAKING IT SHOULD NOT HAVE SIDE AFFECTS.
C IF IT IS INSIDE SOMETHING, THE CONTAINER IS OPEN.
C THE FOLLOWING CODE IS LIFTED FROM SUBROUTINE TAKE.
C
3000       IF(OBJ.NE.AVEHIC(WINNER)) GO TO 3500  
C TAKE VEHICLE?
       CALL RSPEAK(672)
       RETURN
C
3500       IF(((X.NE.0).AND.(OADV(X).EQ.WINNER)).OR.
     1 ((WEIGHT(0,OBJ,WINNER)+OSIZE(OBJ)).LE.MXLOAD))
     2 GO TO 3700
       CALL RSPEAK(558) 
C TOO BIG.
       RETURN
C
3700       CALL NEWSTA(OBJ,559,0,0,WINNER)    
C DO TAKE.
       OFLAG2(OBJ)=ZOR(OFLAG2(OBJ),TCHBT)
C TOUCHED.
       CALL SCRUPD(OFVAL(OBJ))
       OFVAL(OBJ)=0
C
4000       TAKEIT=.TRUE.   
C SUCCESS.
       RETURN
C
       END
C GWIM- GET WHAT I MEAN IN AMBIGOUS SITUATIONS
C
C DECLARATIONS
C
       INTEGER FUNCTION GWIM(SFLAG,SFW1,SFW2)
       IMPLICIT INTEGER(A-Z)
       LOGICAL TAKEIT,NOCARE
C
       COMMON /OBJFLG/ VABIT,VRBIT,VTBIT,VCBIT,VEBIT,VFBIT,VPMASK
       COMMON /STAR/ MBASE,STRBIT
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C GWIM, PAGE 2
C
       GWIM=-1
C ASSUME LOSE.
       AV=AVEHIC(WINNER)
       NOBJ=0
       NOCARE=ZAND(SFLAG,VCBIT).EQ.0
C
C FIRST SEARCH ADVENTURER
C
       IF(ZAND(SFLAG,VABIT).NE.0)
     1       NOBJ=FWIM(SFW1,SFW2,0,0,WINNER,NOCARE)
       IF(ZAND(SFLAG,VRBIT).NE.0) GO TO 100
50       GWIM=NOBJ
       RETURN
C
C ALSO SEARCH ROOM
C
100       ROBJ=FWIM(SFW1,SFW2,HERE,0,0,NOCARE)
       IF(ROBJ) 500,50,200 
C TEST RESULT.
C
C ROBJ > 0
C
200       IF((AV.EQ.0).OR.(ROBJ.EQ.AV).OR.
     1       (ZAND(OFLAG2(ROBJ),FINDBT).NE.0)) GO TO 300
       IF(OCAN(ROBJ).NE.AV) GO TO 50    
C UNREACHABLE? TRY NOBJ
300       IF(NOBJ.NE.0) RETURN 
C IF AMBIGUOUS, RETURN.
       IF(.NOT.TAKEIT(ROBJ,SFLAG)) RETURN  
C IF UNTAKEABLE, RETURN
       GWIM=ROBJ
500       RETURN
C
       END
C RDLINE-       READ INPUT LINE
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       SUBROUTINE RDLINE(INBUF,INLNT,WHO)
       IMPLICIT INTEGER(A-Z)
       CHARACTER INBUF(78)
       CHARACTER*20 INFMTX
       COMMON /XINFMT/ INFMTX 
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
       COMMON /CHAN/ INPCH,OUTCH,DBCH,ZRECL
C
5       GO TO (90,10),WHO+1 
C SEE WHO TO PROMPT FOR.
10       WRITE(OUTCH,INFMTX)   
C PROMPT FOR GAME.
C50       FORMAT(' >',$)
C
90       READ(INPCH,100) INBUF 
C GET INPUT.
100       FORMAT(78A1)
C
       DO 200 INLNT=78,1,-1
         IF(INBUF(INLNT).NE.' ') GO TO 300  
C NOT BLANK?
200       CONTINUE
       GO TO 5
C TRY AGAIN.
C
300       DO 400 I=1,INLNT 
C CONVERT TO UPPER CASE.
         IF((INBUF(I).GE.'a').AND.(INBUF(I).LE.'z'))
     1       INBUF(I)=CHAR(ICHAR(INBUF(I))-32)
400       CONTINUE
       PRSCON=1   
C RESTART LEX SCAN.
       RETURN
       END
C PARSE-       TOP LEVEL PARSE ROUTINE
C
C DECLARATIONS
C
C THIS ROUTINE DETAILS ON BIT 0 OF PRSFLG
C
       LOGICAL FUNCTION PARSE(INBUF,INLNT,VBFLAG)
       IMPLICIT INTEGER(A-Z)
       CHARACTER INBUF(78)
       LOGICAL LEX,SYNMCH,DFLAG,VBFLAG
       INTEGER OUTBUF(40)
       COMMON /DEBUG/ DBGFLG,PRSFLG,GDTFLG
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
       COMMON /LAST/ LASTIT
       COMMON /XSRCH/ XMIN,XMAX,XDOWN,XUP,
     1       XNORTH,XSOUTH,XENTER,XEXIT,XEAST,XWEST
C
       PARSE=.FALSE.   
C ASSUME FAILS.
       PRSA=0
C ZERO OUTPUTS.
       PRSI=0
       PRSO=0
C
       IF(.NOT.LEX(INBUF,INLNT,OUTBUF,OUTLNT,VBFLAG)) GO TO 100
       IF(SPARSE(OUTBUF,OUTLNT,VBFLAG)) 100,200,300  
C DO SYN SCAN.
C
C PARSE REQUIRES VALIDATION
C
200       IF(.NOT.VBFLAG) GO TO 350    
C ECHO MODE, FORCE FAIL.
       IF(.NOT.SYNMCH()) GO TO 100    
C DO SYN MATCH.
       IF((PRSO.GT.0).AND.(PRSO.LT.XMIN)) LASTIT=PRSO
C
C SUCCESSFUL PARSE OR SUCCESSFUL VALIDATION
C
300       PARSE=.TRUE.
350       CALL ORPHAN(0,0,0,0,0) 
C CLEAR ORPHANS.
       RETURN
C
C PARSE FAILS, DISALLOW CONTINUATION
C
100       PRSCON=1
       RETURN
C
       END
C ORPHAN- SET UP NEW ORPHANS
C
C DECLARATIONS
C
       SUBROUTINE ORPHAN(O1,O2,O3,O4,O5)
       IMPLICIT INTEGER(A-Z)
       COMMON /ORPHS/ A,B,C,D,E
C
       A=O1
C SET UP NEW ORPHANS.
       B=O2
       C=O3
       D=O4
       E=O5
       RETURN
       END
C LEX-       LEXICAL ANALYZER
C
C DECLARATIONS
C
C THIS ROUTINE DETAILS ON BIT 1 OF PRSFLAG
C
       LOGICAL FUNCTION LEX(INBUF,INLNT,OUTBUF,OP,VBFLAG)
       IMPLICIT INTEGER(A-Z)
       CHARACTER INBUF(78),J,DLIMIT(9)
       INTEGER OUTBUF(40)
       LOGICAL DFLAG,VBFLAG
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
       COMMON /DEBUG/ DBGFLG,PRSFLG,GDTFLG
C
       DATA DLIMIT/'A','Z',' ','1','9',' ','-','-',' '/
       DLIMIT(3) = CHAR(64)
       DLIMIT(6) = CHAR(18)
       DLIMIT(9) = CHAR(18)
C
       DO 100 I=1,40   
C CLEAR OUTPUT BUF.
         OUTBUF(I)=0
100       CONTINUE
C
       LEX=.FALSE.   
C ASSUME LEX FAILS.
       OP=-1
C OUTPUT PTR.
50       OP=OP+2
C ADV OUTPUT PTR.
       CP=0
C CHAR PTR=0.
C
200       IF(PRSCON.GT.INLNT) GO TO 1000    
C END OF INPUT?
       J=INBUF(PRSCON)   
C NO, GET CHARACTER,
       PRSCON=PRSCON+1   
C ADVANCE PTR.
       IF(J.EQ.'.') GO TO 1000 
C END OF COMMAND?
       IF(J.EQ.',') GO TO 1000 
C END OF COMMAND?
       IF(J.EQ.' ') GO TO 6000 
C SPACE?
       DO 500 I=1,9,3   
C SCH FOR CHAR.
         IF((J.GE.DLIMIT(I)).AND.(J.LE.DLIMIT(I+1)))
     1       GO TO 4000
500       CONTINUE
C
       IF(VBFLAG) CALL RSPEAK(601)    
C GREEK TO ME, FAIL.
       RETURN
C
C END OF INPUT, SEE IF PARTIAL WORD AVAILABLE.
C
1000       IF(PRSCON.GT.INLNT) PRSCON=1    
C FORCE PARSE RESTART.
       IF((CP.EQ.0).AND.(OP.EQ.1)) RETURN  
C ANY RESULTS?
       IF(CP.EQ.0) OP=OP-2 
C ANY LAST WORD?
       LEX=.TRUE.
       RETURN
C
C LEGITIMATE CHARACTERS: LETTER, DIGIT, OR HYPHEN.
C
4000    J1=ICHAR(J)-ICHAR(DLIMIT(I+2)) 
C CVT TO R50.
       IF(CP.GE.6) GO TO 200 
C IGNORE IF TOO MANY CHAR.
       K=OP+(CP/3)   
C COMPUTE WORD INDEX.
        ZZZ=OUTBUF(K)    
C BY JDM,FOR VAX
       GO TO (4100,4200,4300),(MOD(CP,3)+1)  
C BRANCH ON CHAR.
4100       J2=J1*780   
C CHAR 1... *780
C       OUTBUF(K)=OUTBUF(K)+J2+J2    
C *1560 (40 ADDED BELOW).
          ZZZ=ZZZ+J2+J2
C4200       OUTBUF(K)=OUTBUF(K)+(J1*39)    
C *39 (1 ADDED BELOW).
4200    ZZZ=ZZZ+J1*39
C4300       OUTBUF(K)=OUTBUF(K)+J1 
C *1.
4300       ZZZ=ZZZ+J1
        OUTBUF(K)=ZOR(ZZZ,0)
       CP=CP+1
       GO TO 200   
C GET NEXT CHAR.
C
C SPACE
C
6000       IF(CP.EQ.0) GO TO 200 
C ANY WORD YET?
       GO TO 50   
C YES, ADV OP.
C
       END

C TROLLP-      TROLL FUNCTION
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
      LOGICAL FUNCTION TROLLP(ARG)
      IMPLICIT INTEGER (A-Z)
      LOGICAL QHERE,PROB
C
C PARSER OUTPUT
C
      LOGICAL PRSWON
      COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
      LOGICAL TELFLG
      COMMON /PLAY/ WINNER,HERE,TELFLG
C
C OBJECTS
C
      COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1      OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2      OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3      OADV(220),OCAN(220),OREAD(220)
C
      COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1      NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2      TOOLBT,TURNBT,ONBT
      COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1      WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2      TCHBT,VEHBT,SCHBT
C
      COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
      COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
      COMMON /OINDEX/      LEAVE,TROLL,AXE
      COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
      COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
      COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
      COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
      COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
      COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
      COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
      COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
      COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
      COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
      COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
      COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
      COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
      COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
      COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
      COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
      COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
      COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
      COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C VERBS
C
      COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
      COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
      COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
      COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
      COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
      COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
      COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
      COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
      COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
      COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
      COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
      COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
      COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
      LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
      LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
      LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
      LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
      LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
      LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
      LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
      LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
      COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1      DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2      MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3      EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4      GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5      GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6      MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7      FOLLWF,SPELLF,CPOUTF,CPUSHF
      COMMON /FINDEX/ BTIEF,BINFF
      COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
      COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
      COMMON /FINDEX/ MDIR,MLOC,POLEUF
      COMMON /FINDEX/ QUESNO,NQATT,CORRCT
      COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C TROLLP, PAGE 2
C
      I=ARG
      TROLLP=.TRUE.    
C ASSUME WINS.
      IF(PRSA.NE.FIGHTW) GO TO 1100    
C FIGHT?
      IF(OCAN(AXE).EQ.TROLL) GO TO 10    
C GOT AXE?  NOTHING.
      I=433  
C ASSUME CANT GET.
      IF(.NOT.QHERE(AXE,HERE)) GO TO 1050  
C HERE?
      I=434  
C YES, RECOVER.
      CALL NEWSTA(AXE,0,0,TROLL,0)
1050      IF(QHERE(TROLL,HERE)) CALL RSPEAK(I)  
C IF PLAYER HERE.
      RETURN
C
1100      IF(PRSA.NE.DEADXW) GO TO 1200    
C DEAD?
      TROLLF=.TRUE.    
C PERMIT EXITS.
      RETURN
C
1200      IF(PRSA.NE.OUTXW) GO TO 1300    
C OUT?
      TROLLF=.TRUE.    
C PERMIT EXITS.
      OFLAG1(AXE)=ZAND(OFLAG1(AXE),ZNOT(VISIBT))
      ODESC1(TROLL)=435  
C TROLL OUT.
      RETURN
C
1300      IF(PRSA.NE.INXW) GO TO 1400    
C WAKE UP?
      TROLLF=.FALSE.    
C FORBID EXITS.
      OFLAG1(AXE)=ZOR(OFLAG1(AXE),VISIBT)
      ODESC1(TROLL)=436  
C TROLL IN.
      IF(QHERE(TROLL,HERE)) CALL RSPEAK(437)
      RETURN
C
1400      IF(PRSA.NE.FRSTQW) GO TO 1500    
C FIRST ENCOUNTER?
      TROLLP=PROB(33,66)    
C 33% TRUE UNLESS BADLK.
      RETURN
C
1500      IF((PRSA.NE.MOVEW).AND.(PRSA.NE.TAKEW).AND.(PRSA.NE.MUNGW)
     1      .AND.(PRSA.NE.THROWW).AND.(PRSA.NE.GIVEW)) GO TO 2000
      IF(OCAPAC(TROLL).GE.0) GO TO 1550  
C TROLL OUT?
      OCAPAC(TROLL)=-OCAPAC(TROLL)    
C YES, WAKE HIM.
      OFLAG1(AXE)=ZOR(OFLAG1(AXE),VISIBT)
      TROLLF=.FALSE.
      ODESC1(TROLL)=436
      CALL RSPEAK(437)
C
1550      IF((PRSA.NE.TAKEW).AND.(PRSA.NE.MOVEW)) GO TO 1600
      CALL RSPEAK(438)  
C JOKE.
      RETURN
C
1600      IF(PRSA.NE.MUNGW) GO TO 1700    
C MUNG?
      CALL RSPEAK(439)  
C JOKE.
      RETURN
C
1700      IF(PRSO.EQ.0) GO TO 10  
C NO OBJECT?
      I=440  
C ASSUME THROW.
      IF(PRSA.EQ.GIVEW) I=441  
C GIVE?
      CALL RSPSUB(I,ODESC2(PRSO))    
C TROLL TAKES.
      IF(PRSO.EQ.KNIFE) GO TO 1900    
C OBJ KNIFE?
      CALL NEWSTA(PRSO,442,0,0,0)    
C NO, EATS IT.
      RETURN
C
1900      CALL RSPEAK(443)  
C KNIFE, THROWS IT BACK
      OFLAG2(TROLL)=ZOR(OFLAG2(TROLL),FITEBT)  
C AND GETS MAD.
      RETURN
C
2000      IF(.NOT.TROLLF.OR.(PRSA.NE.HELLOW)) GO TO 10
      CALL RSPEAK(366)  
C TROLL OUT.
      RETURN
C
10      TROLLP=.FALSE.    
C COULDNT HANDLE IT.
      RETURN
      END
C CYCLOP-      CYCLOPS FUNCTION
C
C DECLARATIONS
C
      LOGICAL FUNCTION CYCLOP(ARG)
      IMPLICIT INTEGER (A-Z)
C
C PARSER OUTPUT
C
      LOGICAL PRSWON
      COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
      LOGICAL TELFLG
      COMMON /PLAY/ WINNER,HERE,TELFLG
C
C OBJECTS
C
      COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1      OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2      OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3      OADV(220),OCAN(220),OREAD(220)
C
      COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1      NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2      TOOLBT,TURNBT,ONBT
      COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1      WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2      TCHBT,VEHBT,SCHBT
C
      COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
      COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
      COMMON /OINDEX/      LEAVE,TROLL,AXE
      COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
      COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
      COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
      COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
      COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
      COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
      COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
      COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
      COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
      COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
      COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
      COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
      COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
      COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
      COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
      COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
      COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
      COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
      COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C VERBS
C
      COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
      COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
      COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
      COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
      COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
      COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
      COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
      COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
      COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
      COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
      COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
      COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
      COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
      LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
      LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
      LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
      LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
      LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
      LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
      LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
      LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
      COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1      DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2      MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3      EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4      GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5      GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6      MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7      FOLLWF,SPELLF,CPOUTF,CPUSHF
      COMMON /FINDEX/ BTIEF,BINFF
      COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
      COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
      COMMON /FINDEX/ MDIR,MLOC,POLEUF
      COMMON /FINDEX/ QUESNO,NQATT,CORRCT
      COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C CYCLOP, PAGE 2
C
      I=ARG
      CYCLOP=.TRUE.    
C ASSUME WINS.
      IF(.NOT.CYCLOF) GO TO 100    
C ASLEEP?
      IF((PRSA.NE.ALARMW).AND.(PRSA.NE.MUNGW).AND.(PRSA.NE.HELLOW).AND.
     1      (PRSA.NE.BURNW).AND.(PRSA.NE.KILLW).AND.(PRSA.NE.ATTACW))
     2       GO TO 10
      CYCLOF=.FALSE.  
C WAKE CYCLOPS.
      CALL RSPEAK(187)  
C DESCRIBE.
      RVCYC=IABS(RVCYC)
      OFLAG2(CYCLO)=ZAND(ZOR(OFLAG2(CYCLO),FITEBT),ZNOT(SLEPBT))
      RETURN
C
100      IF((PRSA.EQ.FIGHTW).OR.(PRSA.EQ.FRSTQW)) GO TO 10
      IF(IABS(RVCYC).LE.5) GO TO 200    
C ANNOYED TOO MUCH?
      RVCYC=0  
C RESTART COUNT.
      CALL JIGSUP(188)  
C YES, EATS PLAYER.
      RETURN
C
200      IF(PRSA.NE.GIVEW) GO TO 500    
C GIVE?
      IF((PRSO.NE.FOOD).OR.(RVCYC.LT.0)) GO TO 300 
C FOOD WHEN HUNGRY?
      CALL NEWSTA(FOOD,189,0,0,0)    
C EATS PEPPERS.
      RVCYC=MIN0(-1,-RVCYC)  
C GETS THIRSTY.
      RETURN
C
300      IF(PRSO.NE.WATER) GO TO 400    
C DRINK WHEN THIRSTY?
      IF(RVCYC.GE.0) GO TO 350
      CALL NEWSTA(PRSO,190,0,0,0)    
C DRINKS AND
      CYCLOF=.TRUE.    
C FALLS ASLEEP.
      OFLAG2(CYCLO)=ZAND(ZOR(OFLAG2(CYCLO),SLEPBT),ZNOT(FITEBT))
      RETURN
C
350      CALL RSPEAK(191)  
C NOT THIRSTY.
10      CYCLOP=.FALSE.    
C FAILS.
      RETURN
C
400      I=192  
C ASSUME INEDIBLE.
      IF(PRSO.EQ.GARLI) I=193  
C GARLIC IS JOKE.
450      CALL RSPEAK(I)    
C DISDAIN IT.
      IF(RVCYC.LT.0) RVCYC=RVCYC-1
      IF(RVCYC.GE.0) RVCYC=RVCYC+1
      IF(.NOT.CYCLOF) CALL RSPEAK(193+IABS(RVCYC))
      RETURN
C
500      I=0  
C ASSUME NOT HANDLED.
      IF(PRSA.EQ.HELLOW) GO TO 450    
C HELLO IS NO GO.
      IF((PRSA.EQ.THROWW).OR.(PRSA.EQ.MUNGW)) I=200+ZRND(2)
      IF(PRSA.EQ.TAKEW) I=202
      IF(PRSA.EQ.TIEW) I=203
      IF(I) 10,10,450  
C SEE IF HANDLED.
C
      END
C THIEFP-      THIEF FUNCTION
C
C DECLARATIONS
C
      LOGICAL FUNCTION THIEFP(ARG)
      IMPLICIT INTEGER (A-Z)
      LOGICAL QHERE,PROB
C
C PARSER OUTPUT
C
      LOGICAL PRSWON
      COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
      LOGICAL TELFLG
      COMMON /PLAY/ WINNER,HERE,TELFLG
C
C ROOMS
C
      COMMON /RINDEX/ WHOUS,LROOM,CELLA
      COMMON /RINDEX/ MTROL,MAZE1  
      COMMON /RINDEX/ MGRAT,MAZ15  
      COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
      COMMON /RINDEX/ STREA,EGYPT,ECHOR
      COMMON /RINDEX/ TSHAF  
      COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
      COMMON /RINDEX/ CAROU  
      COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
      COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
      COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
      COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
      COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
      COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
      COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
      COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
      COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
      COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
      COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
      COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C OBJECTS
C
      COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1      OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2      OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3      OADV(220),OCAN(220),OREAD(220)
C
      COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1      NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2      TOOLBT,TURNBT,ONBT
      COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1      WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2      TCHBT,VEHBT,SCHBT
C
      COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
      COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
      COMMON /OINDEX/      LEAVE,TROLL,AXE
      COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
      COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
      COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
      COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
      COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
      COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
      COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
      COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
      COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
      COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
      COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
      COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
      COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
      COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
      COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
      COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
      COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
      COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
      COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C CLOCK INTERRUPTS
C
      LOGICAL CFLAG
      COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
      COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1      CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2      CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3      CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     5      CEVMRS,CEVPIN,CEVINQ,CEVFOL
 
C
C VILLAINS AND DEMONS
C
      LOGICAL THFFLG,SWDACT,THFACT
      COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
C
C VERBS
C
      COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
      COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
      COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
      COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
      COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
      COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
      COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
      COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
      COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
      COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
      COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
      COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
      COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
      LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
      LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
      LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
      LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
      LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
      LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
      LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
      LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
      COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1      DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2      MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3      EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4      GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5      GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6      MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7      FOLLWF,SPELLF,CPOUTF,CPUSHF
      COMMON /FINDEX/ BTIEF,BINFF
      COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
      COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
      COMMON /FINDEX/ MDIR,MLOC,POLEUF
      COMMON /FINDEX/ QUESNO,NQATT,CORRCT
      COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C THIEFP, PAGE 2
C
      I=ARG
      THIEFP=.TRUE.    
C ASSUME WINS.
      IF(PRSA.NE.FIGHTW) GO TO 100    
C FIGHT?
      IF(OCAN(STILL).EQ.THIEF) GO TO 10  
C GOT STILLETTO?  F.
      IF(QHERE(STILL,THFPOS)) GO TO 50  
C CAN HE RECOVER IT?
      CALL NEWSTA(THIEF,0,0,0,0)    
C NO, VANISH.
      IF(QHERE(THIEF,HERE)) CALL RSPEAK(498)  
C IF HERO, TELL.
      RETURN
C
50      CALL NEWSTA(STILL,0,0,THIEF,0)    
C YES, RECOVER.
      IF(QHERE(THIEF,HERE)) CALL RSPEAK(499)  
C IF HERO, TELL.
      RETURN
C
100      IF(PRSA.NE.DEADXW) GO TO 200    
C DEAD?
      THFACT=.FALSE.    
C DISABLE DEMON.
      OFLAG1(CHALI)=ZOR(OFLAG1(CHALI),TAKEBT)
      J=0
      DO 125 I=1,OLNT    
C CARRYING ANYTHING?
125        IF(OADV(I).EQ.-THIEF) J=500
      CALL RSPEAK(J)    
C TELL IF BOOTY REAPPEARS.
C
      J=501
      DO 150 I=1,OLNT  
C LOOP.
        IF((I.EQ.CHALI).OR.(I.EQ.THIEF).OR.(HERE.NE.TREAS)
     1      .OR. .NOT.QHERE(I,HERE)) GO TO 135
        OFLAG1(I)=ZOR(OFLAG1(I),VISIBT)    
C REMATERIALIZE OBJECTS.
        CALL RSPSUB(J,ODESC2(I))    
C DESCRIBE.
        J=502
        GO TO 150
C
135        IF(OADV(I).EQ.-THIEF) CALL NEWSTA(I,0,HERE,0,0)
150      CONTINUE
      RETURN
C
200      IF(PRSA.NE.FRSTQW) GO TO 250    
C FIRST ENCOUNTER?
      THIEFP=PROB(20,75)
      RETURN
C
250      IF((PRSA.NE.HELLOW).OR.(ODESC1(THIEF).NE.504))
     1      GO TO 300  
C HELLO TO OUT THIEF?
      CALL RSPEAK(626)
      RETURN
C
300      IF(PRSA.NE.OUTXW) GO TO 400    
C OUT?
      THFACT=.FALSE.    
C DISABLE DEMON.
      ODESC1(THIEF)=504  
C CHANGE DESCRIPTION.
      OFLAG1(STILL)=ZAND(OFLAG1(STILL),ZNOT(VISIBT))
      OFLAG1(CHALI)=ZOR(OFLAG1(CHALI),TAKEBT)
      RETURN
C
400      IF(PRSA.NE.INXW) GO TO 500    
C IN?
      IF(QHERE(THIEF,HERE)) CALL RSPEAK(505)  
C CAN HERO SEE?
      THFACT=.TRUE.    
C ENABLE DEMON.
      ODESC1(THIEF)=503  
C CHANGE DESCRIPTION.
      OFLAG1(STILL)=ZOR(OFLAG1(STILL),VISIBT)
      IF((HERE.EQ.TREAS).AND.QHERE(CHALI,HERE))
     1      OFLAG1(CHALI)=ZAND(OFLAG1(CHALI),ZNOT(TAKEBT))
      RETURN
C
500      IF(PRSA.NE.TAKEW) GO TO 600    
C TAKE?
      CALL RSPEAK(506)  
C JOKE.
      RETURN
C
600      IF((PRSA.NE.THROWW).OR.(PRSO.NE.KNIFE).OR.
     1      (ZAND(OFLAG2(THIEF),FITEBT).NE.0)) GO TO 700
C?????????????????????JDM  NEXT LINE WAS PROB(10)
      IF(PROB(10,90)) GO TO 650  
C THREW KNIFE, 10%?
      CALL RSPEAK(507)  
C NO, JUST MAKES
      OFLAG2(THIEF)=ZOR(OFLAG2(THIEF),FITEBT)  
C THIEF MAD.
      RETURN
C
650      J=508  
C THIEF DROPS STUFF.
      DO 675 I=1,OLNT
        IF(OADV(I).NE.-THIEF) GO TO 675  
C THIEF CARRYING?
        J=509
        CALL NEWSTA(I,0,HERE,0,0)
675      CONTINUE
      CALL NEWSTA(THIEF,J,0,0,0)    
C THIEF VANISHES.
      RETURN
C
700      IF(((PRSA.NE.THROWW).AND.(PRSA.NE.GIVEW)).OR.(PRSO.EQ.0).OR.
     1      (PRSO.EQ.THIEF)) GO TO 10  
C THRO/GIVE TO THIEF?
      IF(OCAPAC(THIEF).GE.0) GO TO 750  
C WAKE HIM UP.
      OCAPAC(THIEF)=-OCAPAC(THIEF)
      THFACT=.TRUE.
      OFLAG1(STILL)=ZOR(OFLAG1(STILL),VISIBT)
      ODESC1(THIEF)=503
      CALL RSPEAK(510)
C
750      IF((PRSO.NE.BRICK).OR.(OCAN(FUSE).NE.BRICK).OR.
     1      (CTICK(CEVFUS).EQ.0)) GO TO 800
      CALL RSPEAK(511)  
C THIEF REFUSES BOMB.
      RETURN
C
800      CALL NEWSTA(PRSO,0,0,0,-THIEF)    
C THIEF TAKES GIFT.
      IF(OTVAL(PRSO).GT.0) GO TO 900    
C A TREASURE?
      CALL RSPSUB(512,ODESC2(PRSO))
      RETURN
C
900      CALL RSPSUB(627,ODESC2(PRSO))    
C THIEF ENGROSSED.
      THFENF=.TRUE.
      RETURN
C
10      THIEFP=.FALSE.
      RETURN
      END

C AAPPLI- APPLICABLES FOR ADVENTURERS
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       LOGICAL FUNCTION AAPPLI(RI)
       IMPLICIT INTEGER (A-Z)
       LOGICAL F,MOVETO
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1         RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1         RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1
       COMMON /RINDEX/ MGRAT,MAZ15
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C EXITS
C
       COMMON /XSRCH/ XMIN,XMAX,XDOWN,XUP,
     &         XNORTH,XSOUTH,XENTER,XEXIT,XEAST,XWEST
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1         OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2         OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3         OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1         NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2         TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1         WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2         TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/ LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1         CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2         CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3         CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     4         CEVMRS,CEVPIN,CEVINQ,CEVFOL
     5
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1         AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1         DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2         MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3         EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4         GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5         GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6         MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7         FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C AAPPLI, PAGE 2
C
       IF(RI.EQ.0) GO TO 10 
C IF ZERO, NO APP.
       AAPPLI=.TRUE.   
C ASSUME WINS.
       GO TO (1000,2000),RI 
C BRANCH ON ADV.
       CALL BUG(11,RI)
C
C COMMON FALSE RETURN.
C
10      AAPPLI=.FALSE.
       RETURN
C
C A1--  ROBOT.  PROCESS MOST COMMANDS GIVEN TO ROBOT.
C
1000    IF((PRSA.NE.RAISEW).OR.(PRSO.NE.RCAGE)) GO TO 1200
       CFLAG(CEVSPH)=.FALSE.    
C ROBOT RAISED CAGE.
       WINNER=PLAYER   
C RESET FOR PLAYER.
       F=MOVETO(CAGER,WINNER)   
C MOVE TO NEW ROOM.
       CALL NEWSTA(CAGE,567,CAGER,0,0)   
C INSTALL CAGE IN ROO
       CALL NEWSTA(ROBOT,0,CAGER,0,0)    
C INSTALL ROBOT IN RO
       AROOM(AROBOT)=CAGER  
C ALSO MOVE ROBOT/ADV
       CAGESF=.TRUE.   
C CAGE SOLVED.
       OFLAG1(ROBOT)=ZAND(OFLAG1(ROBOT),ZNOT(NDSCBT))
       OFLAG1(SPHER)=ZOR(OFLAG1(SPHER),TAKEBT)  
C RESET FLAGS.
       RETURN
C
1200    IF((PRSA.NE.DRINKW).AND.(PRSA.NE.EATW)) GO TO 1300
       CALL RSPEAK(568) 
C EAT OR DRINK, JOKE.
       RETURN
C
1300    IF(PRSA.NE.READW) GO TO 1400  
C READ,
       CALL RSPEAK(569) 
C JOKE.
       RETURN
C
1400    IF((PRSA.EQ.WALKW).OR.(PRSA.EQ.TAKEW).OR.(PRSA.EQ.DROPW)
     1   .OR.(PRSA.EQ.PUTW).OR.(PRSA.EQ.PUSHW).OR.(PRSA.EQ.THROWW)
     2    .OR.(PRSA.EQ.TURNW).OR.(PRSA.EQ.LEAPW)) GO TO 10
       CALL RSPEAK(570) 
C JOKE.
       RETURN
C AAPPLI, PAGE 3
C
C A2--  MASTER.  PROCESS MOST COMMANDS GIVEN TO MASTER.
C
2000    IF(ZAND(OFLAG2(QDOOR),OPENBT).NE.0) GO TO 2100
       CALL RSPEAK(783) 
C NO MASTER YET.
       RETURN
C
2100    IF(PRSA.NE.WALKW) GO TO 2200  
C WALK?
       I=784  
C ASSUME WONT.
       IF(((HERE.EQ.SCORR).AND.
     1         ((PRSO.EQ.XNORTH).OR.(PRSO.EQ.XENTER))).OR.
     2     ((HERE.EQ.NCORR).AND.
     3         ((PRSO.EQ.XSOUTH).OR.(PRSO.EQ.XENTER))))
     4         I=785   
C IF PRISON, CANT.
       CALL RSPEAK(I)
       RETURN
C
2200    IF((PRSA.EQ.TAKEW).OR.(PRSA.EQ.DROPW).OR.(PRSA.EQ.PUTW).OR.
     1     (PRSA.EQ.THROWW).OR.(PRSA.EQ.PUSHW).OR.(PRSA.EQ.TURNW).OR.
     2     (PRSA.EQ.SPINW).OR.(PRSA.EQ.TRNTOW).OR.(PRSA.EQ.FOLLOW).OR.
     3     (PRSA.EQ.STAYW).OR.(PRSA.EQ.OPENW).OR.(PRSA.EQ.CLOSEW).OR.
     4     (PRSA.EQ.KILLW)) GO TO 10  
C MASTER CAN DO.
       CALL RSPEAK(786) 
C MASTER CANT DO IT.
       RETURN
C
       END
C THIEFD-       INTERMOVE THIEF DEMON
C
C DECLARATIONS
C
       SUBROUTINE THIEFD
       IMPLICIT INTEGER (A-Z)
       LOGICAL DFLAG,ONCE,PROB,QHERE,QSTILL,LIT,WINNIN
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
       COMMON /DEBUG/ DBGFLG,PRSFLG,GDTFLG
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1         RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1         RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1
       COMMON /RINDEX/ MGRAT,MAZ15
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     &         OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     &         OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     &         OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     &         NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     &         TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     &         WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     &         TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/ LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C VILLAINS AND DEMONS
C
       LOGICAL THFFLG,SWDACT,THFACT
       COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1         DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2         MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3         EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4         GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5         GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6         MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7         FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
C FUNCTIONS AND DATA
C
       QSTILL(R)=(QHERE(STILL,R).OR.(OADV(STILL).EQ.-THIEF))
C THIEFD, PAGE 2
C "100000 OCTAL BELOW
       DFLAG=ZAND(PRSFLG,Q16384+16384).NE.0   
       Q16384=16384   
C SET UP DETAIL FLAG.
       ONCE=.FALSE.    
C INIT FLAG.
1025    RHERE=OROOM(THIEF)   
C VISIBLE POS.
       IF(RHERE.NE.0) THFPOS=RHERE
C
       IF(THFPOS.EQ.HERE) GO TO 1100 
C THIEF IN WIN RM?
       IF(THFPOS.NE.TREAS) GO TO 1400    
C THIEF NOT IN TREAS?
C
C THIEF IS IN TREASURE ROOM, AND WINNER IS NOT.
C
       IF(RHERE.EQ.0) GO TO 1050 
C VISIBLE?
       CALL NEWSTA(THIEF,0,0,0,0)    
C YES, VANISH.
       RHERE=0
       IF(QSTILL(TREAS)) CALL NEWSTA(STILL,0,0,THIEF,0)
1050    I=ROBADV(-THIEF,THFPOS,0,0)  
C DROP VALUAB
       IF(QHERE(EGG,THFPOS)) OFLAG2(EGG)=ZOR(OFLAG2(EGG),OPENBT)
       GO TO 1700
C
C THIEF AND WINNER IN SAME ROOM.
C
1100    IF(THFPOS.EQ.TREAS) GO TO 1700    
C IF TREAS ROOM, NOTH
       IF(ZAND(RFLAG(THFPOS),RLIGHT).NE.0) GO TO 1400
C NOT IF LIGHT
       IF(THFFLG) GO TO 1300    
C THIEF ANNOUNCED?
       IF((RHERE.NE.0).OR.PROB(70,70)) GO TO 1150
C IF INVIS AND 30%
       IF(OCAN(STILL).NE.THIEF) GO TO 1700    
C ABORT IF NO STILLET
       CALL NEWSTA(THIEF,583,THFPOS,0,0)  
C INSERT THIEF INTO R
       THFFLG=.TRUE.   
C THIEF IS ANNOUNCED.
       RETURN
C
1150    IF((RHERE.EQ.0).OR.(ZAND(OFLAG2(THIEF),FITEBT).EQ.0))
     1         GO TO 1200   
C IF VISIBLE AND FIGH
       IF(WINNIN(THIEF,WINNER)) GO TO 1175    
C WINNING?
       CALL NEWSTA(THIEF,584,0,0,0)  
C NO, VANISH THIEF.
       OFLAG2(THIEF)=ZAND(OFLAG2(THIEF),ZNOT(FITEBT))
       IF(QSTILL(THFPOS)) CALL NEWSTA(STILL,0,0,THIEF,0)
       RETURN
C
1175    IF(PROB(90,90)) GO TO 1700    
C 90% CHANCE TO STAY.
C
1200    IF((RHERE.EQ.0).OR.PROB(70,70)) GO TO 1250
C IF VISIBLE AND 3
       CALL NEWSTA(THIEF,585,0,0,0)  
C VANISH THIEF.
       IF(QSTILL(THFPOS)) CALL NEWSTA(STILL,0,0,THIEF,0)
       RETURN
C
1300    IF(RHERE.EQ.0) GO TO 1700 
C ANNOUNCED.  VISIBLE
1250    IF(PROB(70,70)) RETURN   
C 70% CHANCE TO DO NO
       THFFLG=.TRUE.
       NR=ROBRM(THFPOS,100,0,0,-THIEF)+ROBADV(WINNER,0,0,-THIEF)
       I=586  
C ROBBED EM.
       IF(RHERE.NE.0) I=588 
C WAS HE VISIBLE?
       IF(NR.NE.0) I=I+1    
C DID HE GET ANYTHING
       CALL NEWSTA(THIEF,I,0,0,0)    
C VANISH THIEF.
       IF(QSTILL(THFPOS))
     1         CALL NEWSTA(STILL,0,0,THIEF,0) 
C RECLAIM STILLETTO.
       IF((NR.NE.0).AND..NOT.LIT(THFPOS)) CALL RSPEAK(406)
       RHERE=0
       GO TO 1700  
C ONWARD.
C
C NOT IN ADVENTURERS ROOM.
C
1400    CALL NEWSTA(THIEF,0,0,0,0)    
C VANISH.
       RHERE=0
       IF(QSTILL(THFPOS))
     1         CALL NEWSTA(STILL,0,0,THIEF,0)
       IF(ZAND(RFLAG(THFPOS),RSEEN).EQ.0) GO TO 1700  
C CANT ROB UN
       I=ROBRM(THFPOS,75,0,0,-THIEF) 
C ROB ROOM 75%.
       IF((THFPOS.LT.MAZE1).OR.(THFPOS.GT.MAZ15).OR.
     1         (HERE.LT.MAZE1).OR.(HERE.GT.MAZ15)) GO TO 1500
       DO 1450 I=1,OLNT 
C BOTH IN MAZE.
         IF(.NOT.QHERE(I,THFPOS).OR.PROB(60,60).OR.
     2         (ZAND(OFLAG1(I),(VISIBT+TAKEBT)).NE.(VISIBT+TAKEBT)))
     3         GO TO 1450
         CALL RSPSUB(590,ODESC2(I))  
C TAKE OBJECT.
         IF(PROB(40,20)) GO TO 1700
         CALL NEWSTA(I,0,0,0,-THIEF) 
C MOST OF THE TIME.
         OFLAG2(I)=ZOR(OFLAG2(I),TCHBT)
         GO TO 1700
1450    CONTINUE
       GO TO 1700
C
1500    DO 1550 I=1,OLNT 
C NOT IN MAZE.
         IF(.NOT.QHERE(I,THFPOS).OR.(OTVAL(I).NE.0).OR.PROB(80,60).OR.
     1         (ZAND(OFLAG1(I),(VISIBT+TAKEBT)).NE.(VISIBT+TAKEBT)))
     2         GO TO 1550
         CALL NEWSTA(I,0,0,0,-THIEF)
         OFLAG2(I)=ZOR(OFLAG2(I),TCHBT)
         GO TO 1700
1550    CONTINUE
C
C NOW MOVE TO NEW ROOM.
C
1700    IF(OADV(ROPE).EQ.-THIEF) DOMEF=.FALSE.
       IF(ONCE) GO TO 1800
       ONCE=.NOT.ONCE
1750    THFPOS=THFPOS-1  
C NEXT ROOM.
       IF(THFPOS.LE.0) THFPOS=RLNT
       IF(ZAND(RFLAG(THFPOS),(RLAND+RSACRD+REND)).NE.RLAND)
     1         GO TO 1750   
C MUST BE LAND, PROFA
       THFFLG=.FALSE.  
C NOT ANNOUNCED.
       GO TO 1025  
C ONCE MORE.
C
C ALL DONE.
C
1800    IF(THFPOS.EQ.TREAS) RETURN   
C IN TREASURE
       J=591  
C NO, DROP STUFF.
       IF(THFPOS.NE.HERE) J=0
       DO 1850 I=1,OLNT
         IF((OADV(I).NE.-THIEF).OR.PROB(70,70).OR.
     1         (OTVAL(I).GT.0)) GO TO 1850
         CALL NEWSTA(I,J,THFPOS,0,0)
         J=0
1850    CONTINUE
       RETURN
C
       END

C BALLOP-       BALLOON FUNCTION
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       LOGICAL FUNCTION BALLOP(ARG)
       IMPLICIT INTEGER (A-Z)
       LOGICAL FINDXT,QEMPTY
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1         LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1         RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1         RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
C EXITS
C
       COMMON /CURXT/ XTYPE,XROOM1,XSTRNG,XACTIO,XOBJ
C
       COMMON /XPARS/ XRMASK,XDMASK,XFMASK,XFSHFT,XASHFT,
     1         XELNT(4),XNORM,XNO,XCOND,XDOOR,XLFLAG
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1         OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2         OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3         OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1         NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2         TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1         WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2         TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/ LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1         CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2         CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3         CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     4         CEVMRS,CEVPIN,CEVINQ,CEVFOL
     
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C BALLOP, PAGE 2
C
       BALLOP=.TRUE.       
C ASSUME WINS.
       IF(ARG.NE.2) GO TO 200       
C READOUT?
       IF(PRSA.NE.LOOKW) GO TO 10    
C ONLY PROCESS LOOK.
       IF(BINFF.NE.0) GO TO 50      
C INFLATED?
       CALL RSPEAK(543)     
C NO.
       GO TO 100
50      CALL RSPSUB(544,ODESC2(BINFF))        
C YES.
100     IF(BTIEF.NE.0) CALL RSPEAK(545)       
C HOOKED?
       RETURN
C
200     IF(ARG.NE.1) GO TO 500       
C READIN?
       IF(PRSA.NE.WALKW) GO TO 300   
C WALK?
       IF(FINDXT(PRSO,HERE)) GO TO 250       
C VALID EXIT?
       CALL RSPEAK(546)     
C NO, JOKE.
       RETURN
C
250     IF(BTIEF.EQ.0) GO TO 275      
C TIED UP?
       CALL RSPEAK(547)     
C YES, JOKE.
       RETURN
C
275     IF(XTYPE.NE.XNORM) GO TO 10   
C NORMAL EXIT?
       IF(ZAND(RFLAG(XROOM1),RMUNG).EQ.0) BLOC=XROOM1
10      BALLOP=.FALSE.
       RETURN
C
300     IF((PRSA.NE.TAKEW).OR.(PRSO.NE.BINFF)) GO TO 350
       CALL RSPSUB(548,ODESC2(BINFF))        
C RECEP CONT TOO HOT.
       RETURN
C
350     IF((PRSA.NE.PUTW).OR.(PRSI.NE.RECEP).OR.QEMPTY(RECEP))
     1         GO TO 10     
C RECEP ALREADY FULL.
       CALL RSPEAK(549)
       RETURN
C
500     IF((PRSA.NE.UNBOAW).OR.(ZAND(RFLAG(HERE),RLAND).EQ.0))
     1         GO TO 600    
C DISEMBARK ON LAND?
       IF(BINFF.NE.0) CTICK(CEVBAL)=3        
C HE GOT OUT, START B
       GO TO 10
C
600     IF((PRSA.NE.BURNW).OR.(OCAN(PRSO).NE.RECEP)) GO TO 700
       CALL RSPSUB(550,ODESC2(PRSO)) 
C LIGHT FIRE IN RECEP
       CTICK(CEVBRN)=OSIZE(PRSO)*20
       OFLAG1(PRSO)=ZAND(ZOR(OFLAG1(PRSO),(ONBT+FLAMBT+LITEBT)),
     1         ZNOT(TAKEBT+READBT))  
C BURN IT.
       IF(BINFF.NE.0) RETURN   
C ALREADY INFLATED?
       IF(.NOT.BLABF) CALL NEWSTA(BLABE,0,0,BALLO,0)  
C INSERT LABE
       BLABF=.TRUE.        
C ONLY ONCE.
       BINFF=PRSO
       CTICK(CEVBAL)=3     
C START COUNTDOWN.
       CALL RSPEAK(551)
       RETURN
C
700     IF((PRSA.EQ.UNBOAW).AND.(BINFF.NE.0).AND.
     1         (ZAND(RFLAG(HERE),RLAND).NE.0))
     1         CTICK(CEVBAL)=3
       GO TO 10
C
       END
C
C LIGHTP-       LIGHT PROCESSOR
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       LOGICAL FUNCTION LIGHTP(OBJ)
       IMPLICIT INTEGER (A-Z)
       LOGICAL QON
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1       CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2       CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3       CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     5       CEVMRS,CEVPIN,CEVINQ,CEVFOL
 
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
C FUNCTIONS AND DATA
C
       QON(R)=ZAND(OFLAG1(R),ONBT).NE.0
C LIGHTP, PAGE 2
C
       LIGHTP=.TRUE.
C ASSUME WINS
       FLOBTS=FLAMBT+LITEBT+ONBT
       IF(OBJ.NE.CANDL) GO TO 20000
C CANDLE?
       IF(ORCAND.NE.0) GO TO 19100
C FIRST REF?
       ORCAND=1
C YES, CANDLES ARE
       CTICK(CEVCND)=50
C BURNING WHEN SEEN.
C
19100       IF(PRSI.EQ.CANDL) GO TO 10
C IGNORE IND REFS.
       IF(PRSA.NE.TRNOFW) GO TO 19200
C TURN OFF?
       I=513
C ASSUME OFF.
       IF(QON(CANDL)) I=514
C IF ON, DIFFERENT.
       CFLAG(CEVCND)=.FALSE.
C DISABLE COUNTDOWN.
       OFLAG1(CANDL)=ZAND(OFLAG1(CANDL), ZNOT(ONBT))
       CALL RSPEAK(I)
       RETURN
C
19200       IF((PRSA.NE.BURNW).AND.(PRSA.NE.TRNONW)) GO TO 10
       IF(ZAND(OFLAG1(CANDL),LITEBT).NE.0) GO TO 19300
       CALL RSPEAK(515)
C CANDLES TOO SHORT.
       RETURN
C
19300       IF(PRSI.NE.0) GO TO 19400
C ANY FLAME?
       CALL RSPEAK(516)
C NO, LOSE.
       PRSWON=.FALSE.
       RETURN
C
19400       IF((PRSI.NE.MATCH).OR. .NOT.QON(MATCH)) GO TO 19500
       I=517
C ASSUME OFF.
       IF(QON(CANDL)) I=518
C IF ON, JOKE.
       OFLAG1(CANDL)=ZOR(OFLAG1(CANDL),ONBT)
C LITE CANDLES.
       CFLAG(CEVCND)=.TRUE.
C RESUME COUNTDOWN.
       CALL RSPEAK(I)
       RETURN
C
19500       IF((PRSI.NE.TORCH).OR. .NOT.QON(TORCH)) GO TO 19600
       IF(QON(CANDL)) GO TO 19700
C ALREADY ON?
       CALL NEWSTA(CANDL,521,0,0,0)
C NO, VAPORIZE.
       RETURN
C
19600       CALL RSPEAK(519)
C CANT LIGHT WITH THAT.
       RETURN
C
19700       CALL RSPEAK(520)
C ALREADY ON.
       RETURN
C
20000       IF(OBJ.NE.MATCH) CALL BUG(6,OBJ)
       IF((PRSA.NE.TRNONW).OR.(PRSO.NE.MATCH)) GO TO 20500
       IF(ORMTCH.NE.0) GO TO 20100
C ANY MATCHES LEFT?
       CALL RSPEAK(183)
C NO, LOSE.
       RETURN
C
20100       ORMTCH=ORMTCH-1
C DECREMENT NO MATCHES.
       OFLAG1(MATCH)=ZOR(OFLAG1(MATCH),FLOBTS)
       CTICK(CEVMAT)=2
C COUNTDOWN.
       CALL RSPEAK(184)
       RETURN
C
20500       IF((PRSA.NE.TRNOFW).OR.(ZAND(OFLAG1(MATCH),ONBT).EQ.0))
     1       GO TO 10
C EXTINGUISH?
       OFLAG1(MATCH)=ZAND(OFLAG1(MATCH), ZNOT(FLOBTS))
       CTICK(CEVMAT)=0
       CALL RSPEAK(185)
       RETURN
C
C HERE FOR FALSE RETURN
C
10       LIGHTP=.FALSE.
       RETURN
       END

C GDT- GAME DEBUGGING TOOL
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       SUBROUTINE GDT
       IMPLICIT INTEGER (A-Z)
       CHARACTER*2 DBGCMD(38), CMD
       INTEGER ARGTYP(38)
       LOGICAL VALID1,VALID2,VALID3
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C PARSER STATE
C
       COMMON /ORPHS/ ORP(5)
       COMMON /LAST/ LASTIT
       COMMON /PV/ PVEC(5)
       COMMON /SYNTAX/ SYN(11)
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C SCREEN OF LIGHT
C
       COMMON /SCREEN/ FROMDR,SCOLRM,SCOLAC
       COMMON /SCREEN/ SCOLDR(8),SCOLWL(12)
C
C PUZZLE ROOM
C
       COMMON /PUZZLE/ CPDR(16),CPWL(8),CPVEC(64)
C
C MISCELLANEOUS VARIABLES
C
       COMMON /STAR/ MBASE,STRBIT
       COMMON /CHAN/ INPCH,OUTCH,DBCH,ZRECL
C
C MESSAGE INDEX
C
       COMMON /RMSG/ MLNT,RTEXT(1050)
C
       COMMON /DEBUG/ DBGFLG,PRSFLG,GDTFLG
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,EQR(200,5)
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1
       COMMON /RINDEX/ MGRAT,MAZ15
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
       COMMON /OROOM2/ R2LNT,O2(20),R2(20)
C
C EXITS
C
       COMMON /EXITS/ XLNT,TRAVEL(900)
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,EQO(220,14)
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,EQC(25,2),CFLAG(25)
C
C VILLAINS AND DEMONS
C
       LOGICAL THFFLG,SWDACT,THFACT
       COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
       COMMON /VILL/ VLNT,EQV(4,5)
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,EQA(4,7)
C
C FLAGS
C
       LOGICAL FLAGS(46)
       INTEGER SWITCH(22)
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ SWITCH
       EQUIVALENCE (FLAGS(1),TROLLF)
       CHARACTER*2 GDTCOD(2)
C
C FUNCTIONS AND DATA
C
       VALID1(A1,L1)=(A1.GT.0).AND.(A1.LE.L1)
       VALID2(A1,A2,L1)=VALID1(A1,L1).AND.VALID1(A2,L1).AND.
     1       (A1.LE.A2)
       VALID3(A1,L1,A2,L2)=VALID1(A1,L1).AND.VALID1(A2,L2)
       DATA CMDMAX/38/
       DATA DBGCMD/'DR','DO','DA','DC','DX','DH','DL','DV','DF','DS',
     1       'AF','HE','NR','NT','NC','ND','RR','RT','RC','RD',
     2       'TK','EX','AR','AO','AA','AC','AX','AV','D2','DN',
     3       'AN','DM','DT','AH','DP','PD','DZ','AZ'/
       DATA ARGTYP/  2 ,  2 ,  2 ,  2 ,  2 ,  0 ,  0 ,  2 ,  2 ,  0 ,
     1         1 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,
     2         1 ,  0 ,  3 ,  3 ,  3 ,  3 ,  1 ,  3 ,  2 ,  2 ,
     3         1 ,  2 ,  1 ,  0 ,  0 ,  0 ,  0 ,  1 /
C GDT, PAGE 2
C
C FIRST, VALIDATE THAT THE CALLER IS AN IMPLEMENTER.
C
       FMAX=46
C SET ARRAY LIMITS.
       SMAX=22
C
       WRITE(OUTCH,8000)
       READ(INPCH,8001)GDTCOD
8000       FORMAT(1X,'CODE?')
8001       FORMAT(2A2)
       IF(GDTCOD(1).NE.'BE'.OR.GDTCOD(2).NE.'AR')RETURN
c GDT, PAGE 2A
C
C HERE TO GET NEXT COMMAND
C
2000       WRITE(OUTCH,200)
C OUTPUT PROMPT.
       READ(INPCH,210) CMD
C GET COMMAND.
       IF(CMD.EQ.'  ') GO TO 2000
C IGNORE BLANKS.
       DO 2100 I=1,CMDMAX
C LOOK IT UP.
         IF(CMD.EQ.DBGCMD(I)) GO TO 2300
C FOUND?
2100       CONTINUE
2200       WRITE(OUTCH,220)
C NO, LOSE.
       GO TO 2000
C
200       FORMAT(' GDT:')
210       FORMAT(A2)
220       FORMAT(' ?')
230       FORMAT(2I6)
240       FORMAT(I6)
225       FORMAT(' Limits:   ')
235       FORMAT(' Entry:    ')
245       FORMAT(' Idx,Ary:  ')
c
2300       GO TO (2400,2500,2600,2700),ARGTYP(I)+1
C BRANCH ON ARG TYPE.
       GO TO 2200
C ILLEGAL TYPE.
C
2700       WRITE(OUTCH,245)
C TYPE 3, REQUEST ARRAY COORDS.
       READ(INPCH,230) J,K
       GO TO 2400
C
2600       WRITE(OUTCH,225)
C TYPE 2, READ BOUNDS.
       READ(INPCH,230) J,K
       IF(K.EQ.0) K=J
       GO TO 2400
C
2500       WRITE(OUTCH,235)
C TYPE 1, READ ENTRY NO.
       READ(INPCH,240) J
2400       GO TO (10000,11000,12000,13000,14000,15000,16000,17000,18000,
     1 19000,20000,21000,22000,23000,24000,25000,26000,27000,28000,
     2 29000,30000,31000,32000,33000,34000,35000,36000,37000,38000,
     3 39000,40000,41000,42000,43000,44000,45000,46000,47000),I
       GO TO 2200
C WHAT???
C GDT, PAGE 3
C
C DR-- DISPLAY ROOMS
C
10000       IF(.NOT.VALID2(J,K,RLNT)) GO TO 2200
C ARGS VALID?
       WRITE(OUTCH,300)
C COL HDRS.
       DO 10100 I=J,K
         WRITE(OUTCH,310) I,(EQR(I,L),L=1,5)
10100       CONTINUE
       GO TO 2000
C
300       FORMAT(' RM#  DESC1  EXITS ACTION  VALUE  FLAGS')
310       FORMAT(1X,I3,4(1X,I6),1X,Z6)
C
C DO-- DISPLAY OBJECTS
C
11000       IF(.NOT.VALID2(J,K,OLNT)) GO TO 2200
C ARGS VALID?
       WRITE(OUTCH,320)
C COL HDRS
       DO 11100 I=J,K
         WRITE(OUTCH,330) I,(EQO(I,L),L=1,14)
11100       CONTINUE
       GO TO 2000
C
320       FORMAT(' OB# DESC1 DESC2 DESCO ACT FLAGS1 FLAGS2 FVL TVL
     1  SIZE CAPAC ROOM ADV CON  READ')
330       FORMAT(1X,I3,3I6,I4,2Z7,2I4,2I6,1X,3I4,I6)
C
C DA-- DISPLAY ADVENTURERS
C
12000       IF(.NOT.VALID2(J,K,ALNT)) GO TO 2200
C ARGS VALID?
       WRITE(OUTCH,340)
       DO 12100 I=J,K
         WRITE(OUTCH,350) I,(EQA(I,L),L=1,7)
12100       CONTINUE
       GO TO 2000
C
340    FORMAT(' AD#   ROOM  SCORE  VEHIC OBJECT ACTION  STREN  FLAGS')
350       FORMAT(1X,I3,6(1X,I6),1X,Z6)
C
C DC-- DISPLAY CLOCK EVENTS
C
13000       IF(.NOT.VALID2(J,K,CLNT)) GO TO 2200
C ARGS VALID?
       WRITE(OUTCH,360)
       DO 13100 I=J,K
         WRITE(OUTCH,370) I,(EQC(I,L),L=1,2),CFLAG(I)
13100       CONTINUE
       GO TO 2000
C
360       FORMAT(' CL#   TICK ACTION  FLAG')
370       FORMAT(1X,I3,1X,I6,1X,I6,5X,L1)
C
C DX-- DISPLAY EXITS
C
14000       IF(.NOT.VALID2(J,K,XLNT)) GO TO 2200
C ARGS VALID?
       WRITE(OUTCH,380)
C COL HDRS.
       DO 14100 I=J,K,10
C TEN PER LINE.
         L=MIN0(I+9,K)
C COMPUTE END OF LINE.
         WRITE(OUTCH,390) I,L,(TRAVEL(L1),L1=I,L)
14100       CONTINUE
       GO TO 2000
C
380       FORMAT('   RANGE   CONTENTS')
390       FORMAT(1X,I3,'-',I3,3X,10Z7)
C
C DH-- DISPLAY HACKS
C
15000       WRITE(OUTCH,400) THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
       GO TO 2000
C
400       FORMAT(' THFPOS=',I6,', THFFLG=',L2,',THFACT=',L2/
     1' SWDACT=',L2,', SWDSTA=',I2)
C
C DL-- DISPLAY LENGTHS
C
16000       WRITE(OUTCH,410) RLNT,XLNT,OLNT,CLNT,VLNT,ALNT,MLNT,R2LNT,
     1       MBASE,STRBIT
       GO TO 2000
C
410       FORMAT(' R=',I6,', X=',I6,', O=',I6,', C=',I6/
     1' V=',I6,', A=',I6,', M=',I6,', R2=',I5/
     2' MBASE=',I6,', STRBIT=',I6)
C
C DV-- DISPLAY VILLAINS
C
17000       IF(.NOT.VALID2(J,K,VLNT)) GO TO 2200
C ARGS VALID?
       WRITE(OUTCH,420)
C COL HDRS
       DO 17100 I=J,K
         WRITE(OUTCH,430) I,(EQV(I,L),L=1,5)
17100       CONTINUE
       GO TO 2000
C
420       FORMAT(' VL# OBJECT   PROB   OPPS   BEST  MELEE')
430       FORMAT(1X,I3,5(1X,I6))
C
C DF-- DISPLAY FLAGS
C
18000       IF(.NOT.VALID2(J,K,FMAX)) GO TO 2200
C ARGS VALID?
       DO 18100 I=J,K
         WRITE(OUTCH,440) I,FLAGS(I)
18100       CONTINUE
       GO TO 2000
C
440       FORMAT(' Flag #',I2,' = ',L1)
C
C DS-- DISPLAY STATE
C
19000       WRITE(OUTCH,450) PRSA,PRSO,PRSI,PRSWON,PRSCON
       WRITE(OUTCH,460) WINNER,HERE,TELFLG
       WRITE(OUTCH,470) MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,LTSHFT,BLOC,
     1       MUNGRM,HS,EGSCOR,EGMXSC
       WRITE(OUTCH,475) FROMDR,SCOLRM,SCOLAC
       GO TO 2000
C
450       FORMAT(' Parse vector=',3(1X,I6),1X,L6,1X,I6)
460       FORMAT(' Play vector= ',2(1X,I6),1X,L6)
470       FORMAT(' State vector=',9(1X,I6)/14X,2(1X,I6))
475       FORMAT(' Scol vector= ',1X,Z6,2(1X,I6))
C GDT, PAGE 4
C
C AF-- ALTER FLAGS
C
20000       IF(.NOT.VALID1(J,FMAX)) GO TO 2200
C ENTRY NO VALID?
       WRITE(OUTCH,480) FLAGS(J)
C TYPE OLD, GET NEW.
       READ(INPCH,490) FLAGS(J)
       GO TO 2000
C
480       FORMAT(' Old=',L2,6X,'New: ')
490       FORMAT(L1)
C
C 21000-- HELP
C
21000       WRITE(OUTCH,900)
       GO TO 2000
C
900       FORMAT(' Valid commands are:'/' AA- Alter ADVS'/
     1' AC- Alter CEVENT'/' AF- Alter FINDEX'/' AH- Alter HERE'/
     2' AN- Alter switches'/' AO- Alter OBJCTS'/' AR- Alter ROOMS'/
     3' AV- Alter VILLS'/' AX- Alter EXITS'/
     3' AZ- Alter PUZZLE'/' DA- Display ADVS'/
     4' DC- Display CEVENT'/' DF- Display FINDEX'/' DH- Display HACKS'/
     5' DL- Display lengths'/' DM- Display RTEXT'/
     6' DN- Display switches'/
     6' DO- Display OBJCTS'/' DP- Display parser'/
     6' DR- Display ROOMS'/' DS- Display state'/' DT- Display text'/
     7' DV- Display VILLS'/' DX- Display EXITS'/' DZ- Display PUZZLE'/
     8' D2- Display ROOM2'/' EX- Exit'/' HE- Type this message'/
     9' NC- No cyclops'/' ND- No deaths'/' NR- No robber'/
     1' NT- No troll'/' PD- Program detail'/
     1' RC- Restore cyclops'/' RD- Restore deaths'/
     2' RR- Restore robber'/' RT- Restore troll'/' TK- Take.')
C
C NR-- NO ROBBER
C
22000       THFFLG=.FALSE.
C DISABLE ROBBER.
       THFACT=.FALSE.
       CALL NEWSTA(THIEF,0,0,0,0)
C VANISH THIEF.
       WRITE(OUTCH,500)
       GO TO 2000
C
500       FORMAT(' No robber.')
C
C NT-- NO TROLL
C
23000       TROLLF=.TRUE.
       CALL NEWSTA(TROLL,0,0,0,0)
       WRITE(OUTCH,510)
       GO TO 2000
C
510       FORMAT(' No troll.')
C
C NC-- NO CYCLOPS
C
24000       CYCLOF=.TRUE.
       CALL NEWSTA(CYCLO,0,0,0,0)
       WRITE(OUTCH,520)
       GO TO 2000
C
520       FORMAT(' No cyclops.')
C
C ND-- IMMORTALITY MODE
C
25000       DBGFLG=1
       WRITE(OUTCH,530)
       GO TO 2000
C
530       FORMAT(' No deaths.')
C
C RR-- RESTORE ROBBER
C
26000       THFACT=.TRUE.
       WRITE(OUTCH,540)
       GO TO 2000
C
540       FORMAT(' Restored robber.')
C
C RT-- RESTORE TROLL
C
27000       TROLLF=.FALSE.
       CALL NEWSTA(TROLL,0,MTROL,0,0)
       WRITE(OUTCH,550)
       GO TO 2000
C
550       FORMAT(' Restored troll.')
C
C RC-- RESTORE CYCLOPS
C
28000       CYCLOF=.FALSE.
       MAGICF=.FALSE.
       CALL NEWSTA(CYCLO,0,MCYCL,0,0)
       WRITE(OUTCH,560)
       GO TO 2000
C
560       FORMAT(' Restored cyclops.')
C
C RD-- MORTAL MODE
C
29000       DBGFLG=0
       WRITE(OUTCH,570)
       GO TO 2000
C
570       FORMAT(' Restored deaths.')
C GDT, PAGE 5
C
C TK-- TAKE
C
30000       IF(.NOT.VALID1(J,OLNT)) GO TO 2200
C VALID OBJECT?
       CALL NEWSTA(J,0,0,0,WINNER)
C YES, TAKE OBJECT.
       WRITE(OUTCH,580)
C TELL.
       GO TO 2000
C
580       FORMAT(' Taken.')
C
C EX-- GOODBYE
C
31000       PRSCON=1
       RETURN
C
C AR--       ALTER ROOM ENTRY
C
32000       IF(.NOT.VALID3(J,RLNT,K,5)) GO TO 2200
C INDICES VALID?
       WRITE(OUTCH,590) EQR(J,K)
C TYPE OLD, GET NEW.
       READ(INPCH,600) EQR(J,K)
       GO TO 2000
C
590       FORMAT(' Old= ',I6,6X,'New: ')
600       FORMAT(I6)
C
C AO-- ALTER OBJECT ENTRY
C
33000       IF(.NOT.VALID3(J,OLNT,K,14)) GO TO 2200
C INDICES VALID?
       WRITE(OUTCH,590) EQO(J,K)
       READ(INPCH,600) EQO(J,K)
       GO TO 2000
C
C AA-- ALTER ADVS ENTRY
C
34000       IF(.NOT.VALID3(J,ALNT,K,7)) GO TO 2200
C INDICES VALID?
       WRITE(OUTCH,590) EQA(J,K)
       READ(INPCH,600) EQA(J,K)
       GO TO 2000
C
C AC-- ALTER CLOCK EVENTS
C
35000       IF(.NOT.VALID3(J,CLNT,K,3)) GO TO 2200
C INDICES VALID?
       IF(K.EQ.3) GO TO 35500
C FLAGS ENTRY?
       WRITE(OUTCH,590) EQC(J,K)
       READ(INPCH,600) EQC(J,K)
       GO TO 2000
C
35500       WRITE(OUTCH,480) CFLAG(J)
       READ(INPCH,490) CFLAG(J)
       GO TO 2000
C GDT, PAGE 6
C
C AX-- ALTER EXITS
C
36000       IF(.NOT.VALID1(J,XLNT)) GO TO 2200
C ENTRY NO VALID?
       WRITE(OUTCH,610) TRAVEL(J)
       READ(INPCH,620) TRAVEL(J)
       GO TO 2000
C
610       FORMAT(' Old= ',Z6,6X,'New: ')
620       FORMAT(Z6)
C
C AV-- ALTER VILLAINS
C
37000       IF(.NOT.VALID3(J,VLNT,K,5)) GO TO 2200
C INDICES VALID?
       WRITE(OUTCH,590) EQV(J,K)
       READ(INPCH,600) EQV(J,K)
       GO TO 2000
C
C D2-- DISPLAY ROOM2 LIST
C
38000       IF(.NOT.VALID2(J,K,R2LNT)) GO TO 2200
       DO 38100 I=J,K
         WRITE(OUTCH,630) I,R2(I),O2(I)
38100       CONTINUE
       GO TO 2000
C
630       FORMAT(' #',I2,'   Room=',I6,'   Obj=',I6)
C
C DN-- DISPLAY SWITCHES
C
39000       IF(.NOT.VALID2(J,K,SMAX)) GO TO 2200
C VALID?
       DO 39100 I=J,K
         WRITE(OUTCH,640) I,SWITCH(I)
39100       CONTINUE
       GO TO 2000
C
640       FORMAT(' Switch #',I2,' = ',I6)
C
C AN-- ALTER SWITCHES
C
40000       IF(.NOT.VALID1(J,SMAX)) GO TO 2200
C VALID ENTRY?
       WRITE(OUTCH,590) SWITCH(J)
       READ(INPCH,600) SWITCH(J)
       GO TO 2000
C
C DM-- DISPLAY MESSAGES
C
41000       IF(.NOT.VALID2(J,K,MLNT)) GO TO 2200
C VALID LIMITS?
       WRITE(OUTCH,380)
       DO 41100 I=J,K,10
         L=MIN0(I+9,K)
         WRITE(OUTCH,650) I,L,(RTEXT(L1),L1=I,L)
41100       CONTINUE
       GO TO 2000
C
650       FORMAT(1X,I3,'-',I3,3X,10(1X,I6))
C
C DT-- DISPLAY TEXT
C
42000       CALL RSPEAK(J)
       GO TO 2000
C
C AH--       ALTER HERE
C
43000       WRITE(OUTCH,590) HERE
       READ(INPCH,600) HERE
       EQA(1,1)=HERE
       GO TO 2000
C
C DP--       DISPLAY PARSER STATE
C
44000       WRITE(OUTCH,660) ORP,LASTIT,PVEC,SYN
       GO TO 2000
C
660       FORMAT(' ORPHS= ',I7,Z7,4I7/
     1' PV=    ',Z7,4I7/' SYN=   ',6Z7/15X,5Z7)
C
C PD--       PROGRAM DETAIL DEBUG
C
45000       WRITE(OUTCH,610) PRSFLG
C TYPE OLD, GET NEW.
       READ(INPCH,620) PRSFLG
       GO TO 2000
C
C DZ--       DISPLAY PUZZLE ROOM
C
46000       DO 46100 I=1,64,8
C DISPLAY PUZZLE
         WRITE(OUTCH,670) (CPVEC(J),J=I,I+7)
46100       CONTINUE
       GO TO 2000
C
670       FORMAT(2X,8I3)
C
C AZ--       ALTER PUZZLE ROOM
C
47000       IF(.NOT.VALID1(J,64)) GO TO 2200
C VALID ENTRY?
       WRITE(OUTCH,590) CPVEC(J)
C OUTPUT OLD,
       READ(OUTCH,600) CPVEC(J)
C GET NEW.
       GO TO 2000
C
       END

C RESIDENT SUBROUTINES FOR DUNGEON
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C RSPEAK-- OUTPUT RANDOM MESSAGE ROUTINE
C
C CALLED BY--
C
C       CALL RSPEAK(MSGNUM)
C
       SUBROUTINE RSPEAK(N)
       IMPLICIT INTEGER(A-Z)
C
       CALL RSPSB2(N,0,0)
       RETURN
       END
C RSPSUB-- OUTPUT RANDOM MESSAGE WITH SUBSTITUTABLE ARGUMENT
C
C CALLED BY--
C
C       CALL RSPSUB(MSGNUM,SUBNUM)
C
       SUBROUTINE RSPSUB(N,S1)
       IMPLICIT INTEGER(A-Z)
C
       CALL RSPSB2(N,S1,0)
       RETURN
       END
C RSPSB2-- OUTPUT RANDOM MESSAGE WITH SUBSTITUTABLE ARGUMENTS
C
C CALLED BY--
C
C       CALL RSPSB2(MSGNUM,S1,S2)
C
       SUBROUTINE RSPSB2(A,B,C)
       IMPLICIT INTEGER(A-Z)
       CHARACTER B1(74),B2(74)
C
C DECLARATIONS
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
       COMMON /RMSG/ MLNT,RTEXT(1050)
       COMMON /CHAN/ INPCH,OUTCH,DBCH,ZRECL
C
C CONVERT ALL ARGUMENTS FROM DICTIONARY NUMBERS (IF POSITIVE)
C TO ABSOLUTE RECORD NUMBERS.
C
       X=A
C SET UP WORK VARIABLES.
       Y=B
       Z=C
       IF(X.GT.0) X=RTEXT(X)
C IF >0, LOOK UP IN RTEXT.
       IF(Y.GT.0) Y=RTEXT(Y)
       IF(Z.GT.0) Z=RTEXT(Z)
       X=IABS(X)
C TAKE ABS VALUE.
       Y=IABS(Y)
       Z=IABS(Z)
       IF(X.EQ.0) RETURN
C ANYTHING TO DO?
       TELFLG=.TRUE.
C SAID SOMETHING.
C
       READ(DBCH,REC=X) OLDREC,B1
C READ FIRST LINE.
100       DO 150 I=1,74
c         X1=ZAND(X,31)+I
        b1(i)=char( zxor(ichar(b1(i)),10) )
CJDM????????         B1(I)=CHAR(ZXOR(ICHAR(B1(I)),X1))
150       CONTINUE
C
200       IF(Y.EQ.0) GO TO 400
C ANY SUBSTITUTABLE?
       DO 300 I=1,74
C YES, LOOK FOR #.
         IF(B1(I).EQ.'#') GO TO 1000
300       CONTINUE
C
400       DO 500 I=74,1,-1
C BACKSCAN FOR BLANKS.
         IF(B1(I).NE.' ') GO TO 600
500       CONTINUE
C
600       WRITE(OUTCH,650) (B1(J),J=1,I)
C OUTPUT LINE.
650       FORMAT(1X,74A1)
       X=X+1
C ON TO NEXT RECORD.
       READ(DBCH,REC=X) NEWREC,B1
C READ NEXT RECORD.
       IF(OLDREC.EQ.NEWREC) GO TO 100
C CONTINUATION?
       RETURN
C NO, EXIT.
C
C SUBSTITUTION WITH SUBSTITUTABLE AVAILABLE.
C I IS INDEX OF # IN B1.
C Y IS NUMBER OF RECORD TO SUBSTITUTE.
C
C PROCEDURE:
C   1) COPY REST OF B1 TO B2
C   2) READ SUBSTITUTABLE OVER B1
C   3) RESTORE TAIL OF ORIGINAL B1
C
C THE IMPLICIT ASSUMPTION HERE IS THAT THE SUBSTITUTABLE STRING
C IS VERY SHORT.
C
1000       K2=1
C TO
       DO 1100 K1=I+1,74
C COPY REST OF B1.
         B2(K2)=B1(K1)
         K2=K2+1
1100       CONTINUE
C
       READ(DBCH,REC=Y) J,(B1(K1),K1=I,74)
C READ SUB RECORD.
       DO 1150 K1=I,74
        b1(k1)=char( zxor(ichar(b1(k1)),10) )
c         X1=ZAND(Y,31)+K1-I+1
CJDM?????????????         B1(K1)=CHAR(ZXOR(ICHAR(B1(K1)),X1))
1150       CONTINUE
C
       DO 1200 J=74,1,-1
C ELIM TRAILING BLANKS.
         IF(B1(J).NE.' ') GO TO 1300
1200       CONTINUE
C
1300       K1=1
C FROM
       DO 1400 K2=J+1,74
C COPY REST OF B1 BACK.
         B1(K2)=B2(K1)
         K1=K1+1
1400       CONTINUE
C
       Y=Z
C SET UP FOR NEXT
       Z=0
C SUBSTITUTION AND
       GO TO 200
C RECHECK LINE.
C
       END
C OBJACT-- APPLY OBJECTS FROM PARSE VECTOR
C
C DECLARATIONS
C
       LOGICAL FUNCTION OBJACT()
       IMPLICIT INTEGER (A-Z)
       LOGICAL OAPPLI
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       OBJACT=.TRUE.
C ASSUME WINS.
       IF(PRSI.EQ.0) GO TO 100
C IND OBJECT?
       IF(OAPPLI(OACTIO(PRSI),0)) RETURN
C YES, LET IT HANDLE.
C
100       IF(PRSO.EQ.0) GO TO 200
C DIR OBJECT?
       IF(OAPPLI(OACTIO(PRSO),0)) RETURN
C YES, LET IT HANDLE.
C
200       OBJACT=.FALSE.
C LOSES.
       RETURN
       END
C BUG-- REPORT FATAL SYSTEM ERROR
C
C CALLED BY--
C
C       CALL BUG(NO,PAR)
C
       SUBROUTINE BUG(A,B)
       IMPLICIT INTEGER(A-Z)
C
       COMMON /DEBUG/ DBGFLG,PRSFLG,GDTFLG
C
       WRITE(*, 100)A,B
       IF(DBGFLG.NE.0) RETURN
       CALL EXIT
C
100       FORMAT(' PROGRAM ERROR ',I2,', PARAMETER=',I6)
       END
C NEWSTA-- SET NEW STATUS FOR OBJECT
C
C CALLED BY--
C
C       CALL NEWSTA(OBJECT,STRING,NEWROOM,NEWCON,NEWADV)
C
       SUBROUTINE NEWSTA(O,R,RM,CN,AD)
       IMPLICIT INTEGER(A-Z)
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       CALL RSPEAK(R)
       OROOM(O)=RM
       OCAN(O)=CN
       OADV(O)=AD
       RETURN
       END
C QHERE-- TEST FOR OBJECT IN ROOM
C
C DECLARATIONS
C
       LOGICAL FUNCTION QHERE(OBJ,RM)
       IMPLICIT INTEGER (A-Z)
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OROOM2/ R2LNT,O2(20),R2(20)
C
       QHERE=.TRUE.
       IF(OROOM(OBJ).EQ.RM) RETURN
C IN ROOM?
       DO 100 I=1,R2LNT
C NO, SCH ROOM2.
         IF((O2(I).EQ.OBJ).AND.(R2(I).EQ.RM)) RETURN
100       CONTINUE
       QHERE=.FALSE.
C NOT PRESENT.
       RETURN
       END
C QEMPTY-- TEST FOR OBJECT EMPTY
C
C DECLARATIONS
C
       LOGICAL FUNCTION QEMPTY(OBJ)
       IMPLICIT INTEGER (A-Z)
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       QEMPTY=.FALSE.
C ASSUME LOSE.
       DO 100 I=1,OLNT
         IF(OCAN(I).EQ.OBJ) RETURN
C INSIDE TARGET?
100       CONTINUE
       QEMPTY=.TRUE.
       RETURN
       END
C JIGSUP- YOU ARE DEAD
C
C DECLARATIONS
C
       SUBROUTINE JIGSUP(DESC)
       IMPLICIT INTEGER (A-Z)
       LOGICAL YESNO,MOVETO,QHERE,F
       INTEGER RLIST(9)
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
       COMMON /CHAN/ INPCH,OUTCH,DBCH,ZRECL
       COMMON /DEBUG/ DBGFLG,PRSFLG,GDTFLG
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1
       COMMON /RINDEX/ MGRAT,MAZ15
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
C FUNCTIONS AND DATA
C
       DATA RLIST/8,6,36,35,34,4,34,6,5/
C JIGSUP, PAGE 2
C
       CALL RSPEAK(DESC)
C DESCRIBE SAD STATE.
       PRSCON=1
C STOP PARSER.
       IF(DBGFLG.NE.0) RETURN
C IF DBG, EXIT.
       AVEHIC(WINNER)=0
C GET RID OF VEHICLE.
       IF(WINNER.EQ.PLAYER) GO TO 100
C HIMSELF?
       CALL RSPSUB(432,ODESC2(AOBJ(WINNER)))
C NO, SAY WHO DIED.
       CALL NEWSTA(AOBJ(WINNER),0,0,0,0)
C SEND TO HYPER SPACE.
       RETURN
C
100       IF(ENDGMF) GO TO 900
C NO RECOVERY IN END GAME.
       IF(DEATHS.GE.2) GO TO 1000
C DEAD TWICE? KICK HIM OFF.
       IF(.NOT.YESNO(10,9,8)) GO TO 1100
C CONTINUE?
C
       DO 50 J=1,OLNT
C TURN OFF FIGHTING.
         IF(QHERE(J,HERE)) OFLAG2(J)=ZAND(OFLAG2(J),ZNOT(FITEBT))
50       CONTINUE
C
       DEATHS=DEATHS+1
       CALL SCRUPD(-10)
C CHARGE TEN POINTS.
       F=MOVETO(FORE1,WINNER)
C REPOSITION HIM.
       EGYPTF=.TRUE.
C RESTORE COFFIN.
       IF(OADV(COFFI).EQ.WINNER) CALL NEWSTA(COFFI,0,EGYPT,0,0)
       OFLAG2(DOOR)=ZAND(OFLAG2(DOOR), ZNOT(TCHBT)) 
C RESTORE DOOR.
       OFLAG1(ROBOT)=ZAND(ZOR(OFLAG1(ROBOT),VISIBT), ZNOT(NDSCBT))
       IF((OROOM(LAMP).NE.0).OR.(OADV(LAMP).EQ.WINNER))
     1       CALL NEWSTA(LAMP,0,LROOM,0,0)
C RESTORE LAMP.
C
C NOW REDISTRIBUTE HIS VALUABLES AND OTHER BELONGINGS.
C
C THE LAMP HAS BEEN PLACED IN THE LIVING ROOM.
C THE FIRST 8 NON-VALUABLES ARE PLACED IN LOCATIONS AROUND THE HOUSE.
C HIS VALUABLES ARE PLACED AT THE END OF THE MAZE.
C REMAINING NON-VALUABLES ARE PLACED AT THE END OF THE MAZE.
C
       I=1
       DO 200 J=1,OLNT
C LOOP THRU OBJECTS.
         IF((OADV(J).NE.WINNER).OR.(OTVAL(J).NE.0))
     1       GO TO 200
C GET HIS NON-VAL OBJS.
         I=I+1
         IF(I.GT.9) GO TO 400
C MOVE TO RANDOM LOCATIONS.
         CALL NEWSTA(J,0,RLIST(I),0,0)
200       CONTINUE
C
400       I=RLNT+1
C NOW MOVE VALUABLES.
       NONOFL=RAIR+RWATER+RSACRD+REND
C DONT MOVE HERE.
       DO 300 J=1,OLNT
         IF((OADV(J).NE.WINNER).OR.(OTVAL(J).EQ.0))
     1       GO TO 300
C ON ADV AND VALUABLE?
250         I=I-1
C FIND NEXT ROOM.
         IF(ZAND(RFLAG(I),NONOFL).NE.0) GO TO 250
C SKIP IF NONO.
         CALL NEWSTA(J,0,I,0,0)
C YES, MOVE.
300       CONTINUE
C
       DO 500 J=1,OLNT
C NOW GET RID OF REMAINDER.
         IF(OADV(J).NE.WINNER) GO TO 500
450         I=I-1
C FIND NEXT ROOM.
         IF(ZAND(RFLAG(I),NONOFL).NE.0) GO TO 450
C SKIP IF NONO.
         CALL NEWSTA(J,0,I,0,0)
500       CONTINUE
       RETURN
C
C CANT OR WONT CONTINUE, CLEAN UP AND EXIT.
C
900       CALL RSPEAK(625)
C IN ENDGAME, LOSE.
       GO TO 1100
C
1000       CALL RSPEAK(7)
C INVOLUNTARY EXIT.
1100       CALL SCORE(.FALSE.)
C TELL SCORE.
       CLOSE (UNIT=DBCH)
       CALL EXIT
C
       END
C OACTOR-       GET ACTOR ASSOCIATED WITH OBJECT
C
C DECLARATIONS
C
       INTEGER FUNCTION OACTOR(OBJ)
       IMPLICIT INTEGER(A-Z)
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       DO 100 I=1,ALNT
C LOOP THRU ACTORS.
         OACTOR=I
C ASSUME FOUND.
         IF(AOBJ(I).EQ.OBJ) RETURN
C FOUND IT?
100       CONTINUE
       CALL BUG(40,OBJ)
C NO, DIE.
       RETURN
       END
C PROB-              COMPUTE PROBABILITY
C
C DECLARATIONS
C
       LOGICAL FUNCTION PROB(G,B)
       IMPLICIT INTEGER(A-Z)
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
       I=G
C ASSUME GOOD LUCK.
       IF(BADLKF) I=B
C IF BAD, TOO BAD.
       PROB=ZRND(100).LT.I
C COMPUTE.
       RETURN
       END
C RMDESC-- PRINT ROOM DESCRIPTION
C
C RMDESC PRINTS A DESCRIPTION OF THE CURRENT ROOM.
C IT IS ALSO THE PROCESSOR FOR VERBS 'LOOK' AND 'EXAMINE'.
C
       LOGICAL FUNCTION RMDESC(FULL)
C
C FULL=       0/1/2/3=       SHORT/OBJ/ROOM/FULL
C
C DECLARATIONS
C
       IMPLICIT INTEGER (A-Z)
       LOGICAL PROB,LIT,RAPPLI
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C SCREEN OF LIGHT
C
       COMMON /SCREEN/ FROMDR,SCOLRM,SCOLAC
       COMMON /SCREEN/ SCOLDR(8),SCOLWL(12)
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /XSRCH/ XMIN,XMAX,XDOWN,XUP,
     1       XNORTH,XSOUTH,XENTER,XEXIT,XEAST,XWEST
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C RMDESC, PAGE 2
C
       RMDESC=.TRUE.
C ASSUME WINS.
       IF(PRSO.LT.XMIN) GO TO 50
C IF DIRECTION,
       FROMDR=PRSO
C SAVE AND
       PRSO=0
C CLEAR.
50       IF(HERE.EQ.AROOM(PLAYER)) GO TO 100
C PLAYER JUST MOVE?
       CALL RSPEAK(2)
C NO, JUST SAY DONE.
       PRSA=WALKIW
C SET UP WALK IN ACTION.
       RETURN
C
100       IF(LIT(HERE)) GO TO 300
C LIT?
       CALL RSPEAK(430)
C WARN OF GRUE.
       RMDESC=.FALSE.
       RETURN
C
300       RA=RACTIO(HERE)
C GET ROOM ACTION.
       IF(FULL.EQ.1) GO TO 600
C OBJ ONLY?
       I=RDESC2-HERE
C ASSUME SHORT DESC.
       IF((FULL.EQ.0)
     1       .AND. (SUPERF.OR.((ZAND(RFLAG(HERE),RSEEN).NE.0)
     1       .AND. (BRIEFF.OR.PROB(80,80))))) GO TO 400
       I=RDESC1(HERE)
C USE LONG.
       IF((I.NE.0).OR.(RA.EQ.0)) GO TO 400
C IF GOT DESC, SKIP.
       PRSA=LOOKW
C PRETEND LOOK AROUND.
       IF(.NOT.RAPPLI(RA)) GO TO 100
C ROOM HANDLES, NEW DESC?
       PRSA=FOOW
C NOP PARSER.
       GO TO 500
C
400       CALL RSPEAK(I)
C OUTPUT DESCRIPTION.
500    IF(AVEHIC(WINNER).NE.0) CALL RSPSUB(431,ODESC2(AVEHIC(WINNER)))
C
600       IF(FULL.NE.2) CALL PRINCR(FULL.NE.0,HERE)
       RFLAG(HERE)=ZOR(RFLAG(HERE),RSEEN)
C INDICATE ROOM SEEN.
       IF((FULL.NE.0).OR.(RA.EQ.0)) RETURN
C ANYTHING MORE?
       PRSA=WALKIW
C GIVE HIM A SURPISE.
       IF(.NOT.RAPPLI(RA)) GO TO 100
C ROOM HANDLES, NEW DESC?
       PRSA=FOOW
       RETURN
C
       END
C RAPPLI-       ROUTING ROUTINE FOR ROOM APPLICABLES
C
C DECLARATIONS
C
       LOGICAL FUNCTION RAPPLI(RI)
       IMPLICIT INTEGER(A-Z)
       LOGICAL RAPPL1,RAPPL2
       DATA NEWRMS/38/
C
       RAPPLI=.TRUE.
C ASSUME WINS.
       IF(RI.EQ.0) RETURN
C IF ZERO, WIN.
       IF(RI.LT.NEWRMS) RAPPLI=RAPPL1(RI)
C IF OLD, PROCESSOR 1.
       IF(RI.GE.NEWRMS) RAPPLI=RAPPL2(RI)
C IF NEW, PROCESSOR 2.
       RETURN
       END

C SAVE- SAVE GAME STATE
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       SUBROUTINE SAVEGM
       IMPLICIT INTEGER (A-Z)
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C SCREEN OF LIGHT
C
       COMMON /SCREEN/ FROMDR,SCOLRM,SCOLAC
C
C PUZZLE ROOM
C
       COMMON /PUZZLE/ CPDR(16),CPWL(8),CPVEC(64)
C
C MISCELLANEOUS VARIABLES
C
       COMMON /VERS/ VMAJ,VMIN,VEDIT
       COMMON /TIME/ PLTIME,SHOUR,SMIN,SSEC
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
C EXITS
C
       COMMON /EXITS/ XLNT,TRAVEL(900)
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
C
C VILLAINS AND DEMONS
C
       LOGICAL THFFLG,SWDACT,THFACT
       COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
       COMMON /VILL/ VLNT,VILLNS(4),VPROB(4),VOPPS(4),VBEST(4),VMELEE(4)
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
C FLAGS
C
       LOGICAL FLAGS(46)
       INTEGER SWITCH(22)
       COMMON /FINDEX/ FLAGS,SWITCH
C
       PRSWON=.FALSE. 
C DISABLE GAME.
       OPEN (UNIT=11,FILE='DSAVE.DAT',ACCESS='SEQUENTIAL',
     1       STATUS='UNKNOWN',FORM='UNFORMATTED',ERR=100)
C
       CALL GTTIME(I) 
C GET TIME.
       WRITE(11) VMAJ,VMIN,VEDIT
       WRITE(11) WINNER,HERE,THFPOS,TELFLG,THFFLG,THFACT,
     1       SWDACT,SWDSTA,CPVEC
       WRITE(11) I,MOVES,DEATHS,RWSCOR,EGSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,FROMDR,SCOLRM,SCOLAC
       WRITE(11) ODESC1,ODESC2,OFLAG1,OFLAG2,OFVAL,OTVAL,
     1       OSIZE,OCAPAC,OROOM,OADV,OCAN
       WRITE(11) RVAL,RFLAG
       WRITE(11) AROOM,ASCORE,AVEHIC,ASTREN,AFLAG
       WRITE(11) FLAGS,SWITCH,VPROB,CFLAG,CTICK
C
       CLOSE(UNIT=11)
       CALL RSPEAK(597)
       RETURN
C
100       CALL RSPEAK(598)  
C CANT DO IT.
       RETURN
       END
C RESTORE- RESTORE GAME STATE
C
C DECLARATIONS
C
       SUBROUTINE RSTRGM
       IMPLICIT INTEGER (A-Z)
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C SCREEN OF LIGHT
C
       COMMON /SCREEN/ FROMDR,SCOLRM,SCOLAC
C
C PUZZLE ROOM
C
       COMMON /PUZZLE/ CPDR(16),CPWL(8),CPVEC(64)
C
C MISCELLANEOUS VARIABLES
C
       COMMON /VERS/ VMAJ,VMIN,VEDIT
       COMMON /TIME/ PLTIME,SHOUR,SMIN,SSEC
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
C EXITS
C
       COMMON /EXITS/ XLNT,TRAVEL(900)
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
C
C VILLAINS AND DEMONS
C
       LOGICAL THFFLG,SWDACT,THFACT
       COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
       COMMON /VILL/ VLNT,VILLNS(4),VPROB(4),VOPPS(4),VBEST(4),VMELEE(4)
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
C FLAGS
C
       LOGICAL FLAGS(46)
       INTEGER SWITCH(22)
       COMMON /FINDEX/ FLAGS,SWITCH
C
       PRSWON=.FALSE.  
C DISABLE GAME.
       OPEN (UNIT=11,FILE='DSAVE.DAT',ACCESS='SEQUENTIAL',
     1       STATUS='OLD',FORM='UNFORMATTED',ERR=100)
C
       READ(11) I,J,K
       IF((I.NE.VMAJ).OR.(J.NE.VMIN)) GO TO 200
C
       READ(11) WINNER,HERE,THFPOS,TELFLG,THFFLG,THFACT,
     1       SWDACT,SWDSTA,CPVEC
       READ(11) PLTIME,MOVES,DEATHS,RWSCOR,EGSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,FROMDR,SCOLRM,SCOLAC
       READ(11) ODESC1,ODESC2,OFLAG1,OFLAG2,OFVAL,OTVAL,
     1       OSIZE,OCAPAC,OROOM,OADV,OCAN
       READ(11) RVAL,RFLAG
       READ(11) AROOM,ASCORE,AVEHIC,ASTREN,AFLAG
       READ(11) FLAGS,SWITCH,VPROB,CFLAG,CTICK
C
       CLOSE(UNIT=11)
       CALL RSPEAK(599)
       RETURN
C
100       CALL RSPEAK(598)  
C CANT DO IT.
       RETURN
C
200       CALL RSPEAK(600)  
C OBSOLETE VERSION
       CLOSE (UNIT=1)
       RETURN
       END
C WALK- MOVE IN SPECIFIED DIRECTION
C
C DECLARATIONS
C
       LOGICAL FUNCTION WALK()
       IMPLICIT INTEGER(A-Z)
       LOGICAL FINDXT,QOPEN,LIT,PROB,MOVETO,RMDESC
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
C EXITS
C
       COMMON /CURXT/ XTYPE,XROOM1,XSTRNG,XACTIO,XOBJ
C
       COMMON /XSRCH/ XMIN,XMAX,XDOWN,XUP,
     1       XNORTH,XSOUTH,XENTER,XEXIT,XEAST,XWEST
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1       CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2       CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3       CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     5       CEVMRS,CEVPIN,CEVINQ,CEVFOL
 
C
C VILLAINS AND DEMONS
C
       LOGICAL THFFLG,SWDACT,THFACT
       COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
       COMMON /VILL/ VLNT,VILLNS(4),VPROB(4),VOPPS(4),VBEST(4),VMELEE(4)
C
C ADVENTURERS
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C FLAGS
C
       LOGICAL FLAGS(46)
       EQUIVALENCE (FLAGS(1),TROLLF)
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
C FUNCTIONS AND DATA
C
       QOPEN(O)=ZAND(OFLAG2(O),OPENBT).NE.0
C WALK, PAGE 2
C
       WALK=.TRUE. 
C ASSUME WINS.
       IF((WINNER.NE.PLAYER).OR.LIT(HERE).OR.PROB(25,25))
     1       GO TO 500
       IF(.NOT.FINDXT(PRSO,HERE)) GO TO 450 
C INVALID EXIT? GRUE
C 
       GO TO (400,200,100,300),XTYPE   
C DECODE EXIT TYPE.
       CALL BUG(9,XTYPE)
C
100       IF(CXAPPL(XACTIO).NE.0) GO TO 400 
C CEXIT... RETURNED ROOM?
       IF(FLAGS(XOBJ)) GO TO 400   
C NO, FLAG ON?
200       CALL JIGSUP(523)  
C BAD EXIT, GRUE
C 
       RETURN
C
300       IF(CXAPPL(XACTIO).NE.0) GO TO 400 
C DOOR... RETURNED ROOM?
       IF(QOPEN(XOBJ)) GO TO 400   
C NO, DOOR OPEN?
       CALL JIGSUP(523)  
C BAD EXIT, GRUE
C 
       RETURN
C
400       IF(LIT(XROOM1)) GO TO 900   
C VALID ROOM, IS IT LIT?
450       CALL JIGSUP(522)  
C NO, GRUE
C 
       RETURN
C
C ROOM IS LIT, OR WINNER IS NOT PLAYER (NO GRUE).
C
500       IF(FINDXT(PRSO,HERE)) GO TO 550   
C EXIT EXIST?
525       XSTRNG=678 
C ASSUME WALL.
       IF(PRSO.EQ.XUP) XSTRNG=679   
C IF UP, CANT.
       IF(PRSO.EQ.XDOWN) XSTRNG=680   
C IF DOWN, CANT.
       IF(ZAND(RFLAG(HERE),RNWALL).NE.0) XSTRNG=524
       CALL RSPEAK(XSTRNG)
       PRSCON=1 
C STOP CMD STREAM.
       RETURN
C
550       GO TO (900,600,700,800),XTYPE 
C BRANCH ON EXIT TYPE.
       CALL BUG(9,XTYPE)
C
700       IF(CXAPPL(XACTIO).NE.0) GO TO 900 
C CEXIT... RETURNED ROOM?
       IF(FLAGS(XOBJ)) GO TO 900   
C NO, FLAG ON?
600       IF(XSTRNG.EQ.0) GO TO 525   
C IF NO REASON, USE STD.
       CALL RSPEAK(XSTRNG)  
C DENY EXIT.
       PRSCON=1 
C STOP CMD STREAM.
       RETURN
C
800       IF(CXAPPL(XACTIO).NE.0) GO TO 900 
C DOOR... RETURNED ROOM?
       IF(QOPEN(XOBJ)) GO TO 900   
C NO, DOOR OPEN?
       IF(XSTRNG.EQ.0) XSTRNG=525   
C IF NO REASON, USE STD.
       CALL RSPSUB(XSTRNG,ODESC2(XOBJ))
       PRSCON=1 
C STOP CMD STREAM.
       RETURN
C
900       WALK=MOVETO(XROOM1,WINNER)   
C MOVE TO ROOM.
       IF(WALK) WALK=RMDESC(0)  
C DESCRIBE ROOM.
       RETURN
       END
C CXAPPL- CONDITIONAL EXIT PROCESSORS
C
C DECLARATIONS
C
       INTEGER FUNCTION CXAPPL(RI)
       IMPLICIT INTEGER (A-Z)
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C PUZZLE ROOM
C
       COMMON /PUZZLE/ CPDR(16),CPWL(8),CPVEC(64)
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1
       COMMON /RINDEX/ MGRAT,MAZ15
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C EXITS
C
       COMMON /EXITS/ XLNT,TRAVEL(900)
C
       COMMON /CURXT/ XTYPE,XROOM1,XSTRNG,XACTIO,XOBJ
C
       COMMON /XPARS/ XRMASK,XDMASK,XFMASK,XFSHFT,XASHFT,
     1       XELNT(4),XNORM,XNO,XCOND,XDOOR,XLFLAG
C
       COMMON /XSRCH/ XMIN,XMAX,XDOWN,XUP,
     1       XNORTH,XSOUTH,XENTER,XEXIT,XEAST,XWEST
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C CXAPPL, PAGE 2
C
       CXAPPL=0 
C NO RETURN.
       IF(RI.EQ.0) RETURN  
C IF NO ACTION, DONE.
       GO TO (1000,2000,3000,4000,5000,6000,7000,
     1       8000,9000,10000,11000,12000,13000,14000),RI
       CALL BUG(5,RI)
C
C C1- COFFIN-CURE
C
1000       EGYPTF=OADV(COFFI).NE.WINNER   
C T IF NO COFFIN.
       RETURN
C
C C2- CAROUSEL EXIT
C C5- CAROUSEL OUT
C
2000       IF(CAROFF) RETURN  
C IF FLIPPED, NOTHING.
2500       CALL RSPEAK(121)  
C SPIN THE COMPASS.
5000       I=XELNT(XCOND)*ZRND(8)  
C CHOOSE RANDOM EXIT.
       XROOM1=ZAND((TRAVEL(REXIT(HERE)+I)),XRMASK)
       CXAPPL=XROOM1 
C RETURN EXIT.
       RETURN
C
C C3- CHIMNEY FUNCTION
C
3000       LITLDF=.FALSE.  
C ASSUME HEAVY LOAD.
       J=0
       DO 3100 I=1,OLNT  
C COUNT OBJECTS.
         IF(OADV(I).EQ.WINNER) J=J+1
3100       CONTINUE
C
       IF(J.GT.2) RETURN  
C CARRYING TOO MUCH?
       XSTRNG=446 
C ASSUME NO LAMP.
       IF(OADV(LAMP).NE.WINNER) RETURN   
C NO LAMP?
       LITLDF=.TRUE. 
C HE CAN DO IT.
       IF(ZAND(OFLAG2(DOOR),OPENBT).EQ.0)
     1       OFLAG2(DOOR)=ZAND(OFLAG2(DOOR),ZNOT(TCHBT))
       RETURN
C
C C4-       FROBOZZ FLAG (MAGNET ROOM, FAKE EXIT)
C C6-       FROBOZZ FLAG (MAGNET ROOM, REAL EXIT)
C
4000       IF(CAROFF) GO TO 2500  
C IF FLIPPED, GO SPIN.
       FROBZF=.FALSE. 
C OTHERWISE, NOT AN EXIT.
       RETURN
C
6000       IF(CAROFF) GO TO 2500  
C IF FLIPPED, GO SPIN.
       FROBZF=.TRUE. 
C OTHERWISE, AN EXIT.
       RETURN
C
C C7-       FROBOZZ FLAG (BANK ALARM)
C
7000       FROBZF=(OROOM(BILLS).NE.0).AND.(OROOM(PORTR).NE.0)
       RETURN
C CXAPPL, PAGE 3
C
C C8-       FROBOZZ FLAG (MRGO)
C
8000       FROBZF=.FALSE. 
C ASSUME CANT MOVE.
       IF(MLOC.NE.XROOM1) GO TO 8100   
C MIRROR IN WAY?
       IF((PRSO.EQ.XNORTH).OR.(PRSO.EQ.XSOUTH)) GO TO 8200
       IF(MOD(MDIR,180).NE.0) GO TO 8300 
C MIRROR MUST BE N-S.
       XROOM1=((XROOM1-MRA)*2)+MRAE   
C CALC EAST ROOM.
       IF(PRSO.GT.XSOUTH) XROOM1=XROOM1+1 
C IF SW/NW, CALC WEST.
8100       CXAPPL=XROOM1
       RETURN
C
8200       XSTRNG=814 
C ASSUME STRUC BLOCKS.
       IF(MOD(MDIR,180).EQ.0) RETURN   
C IF MIRROR N-S, DONE.
8300       LDIR=MDIR 
C SEE WHICH MIRROR.
       IF(PRSO.EQ.XSOUTH) LDIR=180
       XSTRNG=815 
C MIRROR BLOCKS.
       IF(((LDIR.GT.180).AND..NOT.MR1F).OR.
     1  ((LDIR.LT.180).AND..NOT.MR2F)) XSTRNG=816 
C MIRROR BROKEN.
       RETURN
C
C C9-       FROBOZZ FLAG (MIRIN)
C
9000       IF(MRHERE(HERE).NE.1) GO TO 9100 
C MIRROR 1 HERE?
       IF(MR1F) XSTRNG=805  
C SEE IF BROKEN.
       FROBZF=MROPNF 
C ENTER IF OPEN.
       RETURN
C
9100       FROBZF=.FALSE. 
C NOT HERE,
       XSTRNG=817 
C LOSE.
       RETURN
C CXAPPL, PAGE 4
C
C C10-       FROBOZZ FLAG (MIRROR EXIT)
C
10000       FROBZF=.FALSE. 
C ASSUME CANT.
       LDIR=((PRSO-XNORTH)/XNORTH)*45   
C XLATE DIR TO DEGREES.
       IF(.NOT.MROPNF .OR.
     1       ((MOD(MDIR+270,360).NE.LDIR).AND.(PRSO.NE.XEXIT)))
     2       GO TO 10200  
C EXIT VIA MIRROR?
       XROOM1=((MLOC-MRA)*2)+MRAE+1-(MDIR/180) 
C ASSUME E-W EXIT.
       IF(MOD(MDIR,180).EQ.0) GO TO 10100 
C IF N-S, OK.
       XROOM1=MLOC+1 
C ASSUME N EXIT.
       IF(MDIR.GT.180) XROOM1=MLOC-1   
C IF SOUTH.
10100       CXAPPL=XROOM1
       RETURN
C
10200       IF(.NOT.WDOPNF .OR.
     1       ((MOD(MDIR+180,360).NE.LDIR).AND.(PRSO.NE.XEXIT)))
     2       RETURN 
C EXIT VIA OPEN DOOR?
       XROOM1=MLOC+1 
C ASSUME N.
       IF(MDIR.EQ.0) XROOM1=MLOC-1   
C IF S.
       CALL RSPEAK(818)  
C CLOSE DOOR.
       WDOPNF=.FALSE.
       CXAPPL=XROOM1
       RETURN
C
C C11-       MAYBE DOOR.  NORMAL MESSAGE IS THAT DOOR IS CLOSED.
C       BUT IF LCELL.NE.4, DOOR ISNT THERE.
C
11000       IF(LCELL.NE.4) XSTRNG=678   
C SET UP MSG.
       RETURN
C
C C12-       FROBZF (PUZZLE ROOM MAIN ENTRANCE)
C
12000       FROBZF=.TRUE. 
C ALWAYS ENTER.
       CPHERE=10 
C SET SUBSTATE.
       RETURN
C
C C13-       CPOUTF (PUZZLE ROOM SIZE ENTRANCE)
C
13000       CPHERE=52 
C SET SUBSTATE.
       RETURN
C CXAPPL, PAGE 5
C
C C14-       FROBZF (PUZZLE ROOM TRANSITIONS)
C
14000       FROBZF=.FALSE. 
C ASSSUME LOSE.
       IF(PRSO.NE.XUP) GO TO 14100   
C UP?
       IF(CPHERE.NE.10) RETURN  
C AT EXIT?
       XSTRNG=881 
C ASSUME NO LADDER.
       IF(CPVEC(CPHERE+1).NE.-2) RETURN 
C LADDER HERE?
       CALL RSPEAK(882)  
C YOU WIN.
       FROBZF=.TRUE. 
C LET HIM OUT.
       RETURN
C
14100       IF((CPHERE.NE.52).OR.(PRSO.NE.XWEST).OR..NOT.CPOUTF)
     1       GO TO 14200  
C W EXIT AT DOOR?
       FROBZF=.TRUE. 
C YES, LET HIM OUT.
       RETURN
C
14200       DO 14300 I=1,16,2  
C LOCATE EXIT.
         IF(PRSO.EQ.CPDR(I)) GO TO 14400
14300       CONTINUE
       RETURN   
C NO SUCH EXIT.
C
14400       J=CPDR(I+1) 
C GET DIRECTIONAL OFFSET.
       NXT=CPHERE+J 
C GET NEXT STATE.
       K=8   
C GET ORTHOGONAL DIR.
       IF(J.LT.0) K=-8
       IF((((IABS(J).EQ.1).OR.(IABS(J).EQ.8)).OR.
     1   ((CPVEC(CPHERE+K).EQ.0).OR.(CPVEC(NXT-K).EQ.0))).AND.
     2    (CPVEC(NXT).EQ.0)) GO TO 14500 
C CANT DO IT?
       RETURN
C
14500       CALL CPGOTO(NXT)  
C MOVE TO STATE.
       XROOM1=CPUZZ 
C STAY IN ROOM.
       CXAPPL=XROOM1
       RETURN
C
       END

C OAPPLI- OBJECT SPECIAL ACTION ROUTINES
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       LOGICAL FUNCTION OAPPLI(RI,ARG)
       IMPLICIT INTEGER (A-Z)
       LOGICAL SOBJS,NOBJS
       LOGICAL QOPEN,QON,LIT
       LOGICAL MOVETO,RMDESC,CLOCKD
       LOGICAL THIEFP,CYCLOP,TROLLP,BALLOP,LIGHTP
       LOGICAL QEMPTY,QHERE,F,OPNCLS
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
       COMMON /BATS/ BATDRP(9)
C
C PUZZLE ROOM
C
       COMMON /PUZZLE/ CPDR(16),CPWL(8),CPVEC(64)
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1
       COMMON /RINDEX/ MGRAT,MAZ15
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1       CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2       CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3       CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     5       CEVMRS,CEVPIN,CEVINQ,CEVFOL
 
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
C FUNCTIONS AND DATA
C
       QOPEN(R)=ZAND(OFLAG2(R),OPENBT).NE.0
       QON(R)=ZAND(OFLAG1(R),ONBT).NE.0
       DATA MXSMP/99/
C OAPPLI, PAGE 2
C
       IF(RI.EQ.0) GO TO 10
C ZERO IS FALSE APP.
       IF(RI.LE.MXSMP) GO TO 100
C SIMPLE OBJECT?
       IF(PRSO.NE.0) ODO2=ODESC2(PRSO)
       IF(PRSI.NE.0) ODI2=ODESC2(PRSI)
       AV=AVEHIC(WINNER)
       FLOBTS=FLAMBT+LITEBT+ONBT
       OAPPLI=.TRUE.
C
       GO TO (2000,5000,10000,11000,12000,15000,18000,
     1 19000,20000,22000,25000,26000,32000,35000,39000,40000,
     2 45000,47000,48000,49000,50000,51000,52000,54000,55000,
     3 56000,57000,58000,59000,60000,61000,62000),
     3       (RI-MXSMP)
       CALL BUG(6,RI)
C
C RETURN HERE TO DECLARE FALSE RESULT
C
10       OAPPLI=.FALSE.
       RETURN
C
C SIMPLE OBJECTS, PROCESSED EXTERNALLY.
C
100       IF(RI.LT.32) OAPPLI=SOBJS(RI,ARG)
       IF(RI.GE.32) OAPPLI=NOBJS(RI,ARG)
       RETURN
C OAPPLI, PAGE 3
C
C O100--       MACHINE FUNCTION
C
2000       IF(HERE.NE.MMACH) GO TO 10
C NOT HERE? F
       OAPPLI=OPNCLS(MACHI,123,124)
C HANDLE OPN/CLS.
       RETURN
C
C O101--       WATER FUNCTION
C
5000       IF(PRSA.NE.FILLW) GO TO 5050
C FILL X WITH Y IS
       PRSA=PUTW
C MADE INTO
       I=PRSI
       PRSI=PRSO
       PRSO=I
C PUT Y IN X.
       I=ODI2
       ODI2=ODO2
       ODO2=I
5050       IF((PRSO.EQ.WATER).OR.(PRSO.EQ.GWATE)) GO TO 5100
       CALL RSPEAK(561)
C WATER IS IND OBJ,
       RETURN
C PUNT.
C
5100       IF(PRSA.NE.TAKEW) GO TO 5400
C TAKE WATER?
       IF((OADV(BOTTL).EQ.WINNER).AND.(OCAN(PRSO).NE.BOTTL))
     1       GO TO 5500
C TAKE, NOT IN BOTTLE.
       IF(OCAN(PRSO).EQ.0) GO TO 5200
C INSIDE ANYTHING?
       IF(QOPEN(OCAN(PRSO))) GO TO 5200
C YES, OPEN?
C ????????????????????????JDM
       CALL RSPSUB(525,ODESC2(OCAN(PRSO)))
C INSIDE, CLOSED, PUNT.
       RETURN
C
5200       CALL RSPEAK(615)
C NOT INSIDE OR OPEN,
       RETURN
C SLIPS THRU FINGERS.
C
5400       IF(PRSA.NE.PUTW) GO TO 5700
C PUT WATER IN X?
       IF((AV.NE.0).AND.(PRSI.EQ.AV)) GO TO 5800
C IN VEH?
       IF(PRSI.EQ.BOTTL) GO TO 5500
C IN BOTTLE?
       CALL RSPSUB(297,ODI2)
C WONT GO ELSEWHERE.
       CALL NEWSTA(PRSO,0,0,0,0)
C VANISH WATER.
       RETURN
C
5500       IF(QOPEN(BOTTL)) GO TO 5550
C BOTTLE OPEN?
       CALL RSPEAK(612)
C NO, LOSE.
       RETURN
C
5550       IF(QEMPTY(BOTTL)) GO TO 5600
C OPEN, EMPTY?
       CALL RSPEAK(613)
C NO, ALREADY FULL.
       RETURN
C
5600       CALL NEWSTA(WATER,614,0,BOTTL,0)
C TAKE WATER TO BOTTLE.
       RETURN
C
5700       IF((PRSA.NE.DROPW).AND.(PRSA.NE.POURW).AND.
     1       (PRSA.NE.GIVEW)) GO TO 5900
C DROP, POUR, GIVE?
       IF(AV.NE.0) GO TO 5800
C INTO VEHICLE?
       CALL NEWSTA(PRSO,133,0,0,0)
C NO, VANISHES.
       RETURN
C
5800       CALL NEWSTA(WATER,0,0,AV,0)
C WATER INTO VEHICLE.
       CALL RSPSUB(296,ODESC2(AV))
C DESCRIBE.
       RETURN
C
5900       IF(PRSA.NE.THROWW) GO TO 10
C LAST CHANCE, THROW?
       CALL NEWSTA(PRSO,132,0,0,0)
C VANISHES.
       RETURN
C OAPPLI, PAGE 4
C
C O102--       LEAF PILE
C
10000       IF(PRSA.NE.BURNW) GO TO 10500
C BURN?
       IF(OROOM(PRSO).EQ.0) GO TO 10100
C WAS HE CARRYING?
       CALL NEWSTA(PRSO,158,0,0,0)
C NO, BURN IT.
       RETURN
C
10100       CALL NEWSTA(PRSO,0,HERE,0,0)
C DROP LEAVES.
       CALL JIGSUP(159)
C BURN HIM.
       RETURN
C
10500       IF(PRSA.NE.MOVEW) GO TO 10600
C MOVE?
       CALL RSPEAK(2)
C DONE.
       RETURN
C
10600       IF((PRSA.NE.LOOKUW).OR.(RVCLR.NE.0)) GO TO 10
       CALL RSPEAK(344)
C LOOK UNDER?
       RETURN
C
C O103--       TROLL, DONE EXTERNALLY.
C
11000       OAPPLI=TROLLP(ARG)
C TROLL PROCESSOR.
       RETURN
C
C O104--       RUSTY KNIFE.
C
12000       IF(PRSA.NE.TAKEW) GO TO 12100
C TAKE?
       IF(OADV(SWORD).EQ.WINNER) CALL RSPEAK(160) 
C PULSE SWORD.
       GO TO 10
C
12100       IF((((PRSA.NE.ATTACW).AND.(PRSA.NE.KILLW)).OR.
     1       (PRSI.NE.RKNIF)).AND.
     2  (((PRSA.NE.SWINGW).AND.(PRSA.NE.THROWW)).OR.
     3       (PRSO.NE.RKNIF))) GO TO 10
       CALL NEWSTA(RKNIF,0,0,0,0)
C KILL KNIFE.
       CALL JIGSUP(161)
C KILL HIM.
       RETURN
C OAPPLI, PAGE 5
C
C O105--       GLACIER
C
15000       IF(PRSA.NE.THROWW) GO TO 15500
C THROW?
       IF(PRSO.NE.TORCH) GO TO 15400
C TORCH?
       CALL NEWSTA(ICE,169,0,0,0)
C MELT ICE.
       ODESC1(TORCH)=174
C MUNG TORCH.
       ODESC2(TORCH)=173
       OFLAG1(TORCH)=ZAND(OFLAG1(TORCH),ZNOT(FLOBTS))
       CALL NEWSTA(TORCH,0,STREA,0,0)
C MOVE TORCH.
       GLACRF=.TRUE.
C GLACIER GONE.
       IF(.NOT.LIT(HERE)) CALL RSPEAK(170)
C IN DARK?
       RETURN
C
15400       CALL RSPEAK(171)
C JOKE IF NOT TORCH.
       RETURN
C
15500       IF((PRSA.NE.MELTW).OR.(PRSO.NE.ICE)) GO TO 10
       IF(ZAND(OFLAG1(PRSI),FLOBTS).EQ.FLOBTS) GO TO 15600
       CALL RSPSUB(298,ODI2)
C CANT MELT WITH THAT.
       RETURN
C
15600       GLACMF=.TRUE.
C PARTIAL MELT.
       IF(PRSI.NE.TORCH) GO TO 15700
C MELT WITH TORCH?
       ODESC1(TORCH)=174
C MUNG TORCH.
       ODESC2(TORCH)=173
       OFLAG1(TORCH)=ZAND(OFLAG1(TORCH),ZNOT(FLOBTS))
15700       CALL JIGSUP(172)
C DROWN.
       RETURN
C
C O106--       BLACK BOOK
C
18000       IF(PRSA.NE.OPENW) GO TO 18100
C OPEN?
       CALL RSPEAK(180)
C JOKE.
       RETURN
C
18100       IF(PRSA.NE.CLOSEW) GO TO 18200
C CLOSE?
       CALL RSPEAK(181)
       RETURN
C
18200       IF(PRSA.NE.BURNW) GO TO 10
C BURN?
       CALL NEWSTA(PRSO,0,0,0,0)
C FATAL JOKE.
       CALL JIGSUP(182)
       RETURN
C OAPPLI, PAGE 6
C
C O107--       CANDLES, PROCESSED EXTERNALLY
C
19000       OAPPLI=LIGHTP(CANDL)
       RETURN
C
C O108--       MATCHES, PROCESSED EXTERNALLY
C
20000       OAPPLI=LIGHTP(MATCH)
       RETURN
C
C O109--       CYCLOPS, PROCESSED EXTERNALLY.
C
22000       OAPPLI=CYCLOP(ARG)
C CYCLOPS
       RETURN
C
C O110--       THIEF, PROCESSED EXTERNALLY
C
25000       OAPPLI=THIEFP(ARG)
       RETURN
C
C O111--       WINDOW
C
26000       OAPPLI=OPNCLS(WINDO,208,209)
C OPEN/CLS WINDOW.
       RETURN
C
C O112--       PILE OF BODIES
C
32000       IF(PRSA.NE.TAKEW) GO TO 32500
C TAKE?
       CALL RSPEAK(228)
C CANT.
       RETURN
C
32500       IF((PRSA.NE.BURNW).AND.(PRSA.NE.MUNGW)) GO TO 10
       IF(ONPOLF) RETURN
C BURN OR MUNG?
       ONPOLF=.TRUE.
C SET HEAD ON POLE.
       CALL NEWSTA(HPOLE,0,LLD2,0,0)
       CALL JIGSUP(229)
C BEHEADED.
       RETURN
C
C O113--       VAMPIRE BAT
C
35000       CALL RSPEAK(50)
C TIME TO FLY, JACK.
       F=MOVETO(BATDRP(ZRND(9)+1),WINNER)
C SELECT RANDOM DEST.
       F=RMDESC(0)
       RETURN
C OAPPLI, PAGE 7
C
C O114--       STICK
C
39000       IF(PRSA.NE.WAVEW) GO TO 10
C WAVE?
       IF(HERE.EQ.MRAIN) GO TO 39500
C ON RAINBOW?
       IF((HERE.EQ.POG).OR.(HERE.EQ.FALLS)) GO TO 39200
       CALL RSPEAK(244)
C NOTHING HAPPENS.
       RETURN
C
39200       OFLAG1(POT)=ZOR(OFLAG1(POT),VISIBT)
C MAKE GOLD VISIBLE.
       RAINBF=.NOT. RAINBF
C COMPLEMENT RAINBOW.
       I=245
C ASSUME OFF.
       IF(RAINBF) I=246
C IF ON, SOLID.
       CALL RSPEAK(I)
C DESCRIBE.
       RETURN
C
39500       RAINBF=.FALSE.
C ON RAINBOW,
       CALL JIGSUP(247)
C TAKE A FALL.
       RETURN
C
C O115--       BALLOON, HANDLED EXTERNALLY
C
40000       OAPPLI=BALLOP(ARG)
       RETURN
C
C O116--       HEADS
C
45000       IF(PRSA.NE.HELLOW) GO TO 45100
C HELLO HEADS?
       CALL RSPEAK(633)
C TRULY BIZARRE.
       RETURN
C
45100       IF(PRSA.EQ.READW) GO TO 10
C READ IS OK.
       CALL NEWSTA(LCASE,260,LROOM,0,0)
C MAKE LARGE CASE.
       I=ROBADV(WINNER,0,LCASE,0)+ROBRM(HERE,100,0,LCASE,0)
       CALL JIGSUP(261)
C KILL HIM.
       RETURN
C OAPPLI, PAGE 8
C
C O117--       SPHERE
C
47000       IF(CAGESF.OR.(PRSA.NE.TAKEW)) GO TO 10
C TAKE?
       IF(WINNER.NE.PLAYER) GO TO 47500
C ROBOT TAKE?
       CALL RSPEAK(263)
C NO, DROP CAGE.
       IF(OROOM(ROBOT).NE.HERE) GO TO 47200
C ROBOT HERE?
       F=MOVETO(CAGED,WINNER)
C YES, MOVE INTO CAGE.
       CALL NEWSTA(ROBOT,0,CAGED,0,0)
C MOVE ROBOT.
       AROOM(AROBOT)=CAGED
       OFLAG1(ROBOT)=ZOR(OFLAG1(ROBOT),NDSCBT)
C DONT DESCRIBE ROBOT.
       CTICK(CEVSPH)=10
C GET OUT IN 10 OR ELSE.
       RETURN
C
47200       CALL NEWSTA(SPHER,0,0,0,0)
C YOURE DEAD.
       RFLAG(CAGER)=ZOR(RFLAG(CAGER),RMUNG)
C MUNG CAGE ROOM.
       RVAL(CAGER)=147
       CALL JIGSUP(148)
C MUNG PLAYER.
       RETURN
C
47500       CALL NEWSTA(SPHER,0,0,0,0)
C ROBOT TRIED,
       CALL NEWSTA(ROBOT,264,0,0,0)
C KILL HIM.
       CALL NEWSTA(CAGE,0,HERE,0,0)
C INSERT MANGLED CAGE.
       RETURN
C
C O118--       GEOMETRICAL BUTTONS
C
48000       IF(PRSA.NE.PUSHW) GO TO 10
C PUSH?
       I=PRSO-SQBUT+1
C GET BUTTON INDEX.
       IF((I.LE.0).OR.(I.GE.4)) GO TO 10
C A BUTTON?
       IF(WINNER.NE.PLAYER) GO TO (48100,48200,48300),I
       CALL JIGSUP(265)
C YOU PUSHED, YOU DIE.
       RETURN
C
48100       I=267
       IF(CAROZF) I=266
C SPEED UP?
       CAROZF=.TRUE.
       CALL RSPEAK(I)
       RETURN
C
48200       I=266
C ASSUME NO CHANGE.
       IF(CAROZF) I=268
       CAROZF=.FALSE.
       CALL RSPEAK(I)
       RETURN
C
48300       CAROFF=.NOT.CAROFF
C FLIP CAROUSEL.
       IF(.NOT.QHERE(IRBOX,CAROU)) RETURN
C IRON BOX IN CAROUSEL?
       CALL RSPEAK(269)
C YES, THUMP.
       OFLAG1(IRBOX)=ZXOR(OFLAG1(IRBOX),VISIBT)
C COMPLEMENT VISIBILITY.
       IF(CAROFF) RFLAG(CAROU)=ZAND(RFLAG(CAROU),ZNOT(RSEEN))
       RETURN
C
C O119--       FLASK FUNCTION
C
49000       IF(PRSA.EQ.OPENW) GO TO 49100
C OPEN?
       IF((PRSA.NE.MUNGW).AND.(PRSA.NE.THROWW)) GO TO 10
       CALL NEWSTA(FLASK,270,0,0,0)
C KILL FLASK.
49100       RFLAG(HERE)=ZOR(RFLAG(HERE),RMUNG)
C MUNG ROOM.
       RVAL(HERE)=271
       CALL JIGSUP(272)
C POISONED.
       RETURN
C
C O120--       BUCKET FUNCTION
C
50000       IF(ARG.NE.2) GO TO 10
C READOUT?
       IF((OCAN(WATER).NE.BUCKE).OR.BUCKTF) GO TO 50500
       BUCKTF=.TRUE.
C BUCKET AT TOP.
       CTICK(CEVBUC)=100
C START COUNTDOWN.
       CALL NEWSTA(BUCKE,290,TWELL,0,0)
C REPOSITION BUCKET.
       GO TO 50900
C FINISH UP.
C
50500       IF((OCAN(WATER).EQ.BUCKE).OR..NOT.BUCKTF) GO TO 10
       BUCKTF=.FALSE.
       CALL NEWSTA(BUCKE,291,BWELL,0,0)
C BUCKET AT BOTTOM.
50900       IF(AV.NE.BUCKE) RETURN
C IN BUCKET?
       F=MOVETO(OROOM(BUCKE),WINNER)
C MOVE ADVENTURER.
       F=RMDESC(0)
C DESCRIBE ROOM.
       RETURN
C OAPPLI, PAGE 9
C
C O121--       EATME CAKE
C
51000       IF((PRSA.NE.EATW).OR.(PRSO.NE.ECAKE).OR.
     1       (HERE.NE.ALICE)) GO TO 10
C EAT CAKE IN ALICEROOM?
       CALL NEWSTA(ECAKE,273,0,0,0)
C VANISH CAKE.
       OFLAG1(ROBOT)=ZAND(OFLAG1(ROBOT),ZNOT(VISIBT))
C VANISH ROBOT.
       DO 51100 I=1,OLNT
C MAKE OBJECTS BIG.
         IF((OROOM(I).NE.ALICE).OR.(OSIZE(I).EQ.10000))
     1       GO TO 51100
         OSIZE(I)=OSIZE(I)*64
         OROOM(I)=ALISM
51100       CONTINUE
       OAPPLI=MOVETO(ALISM,WINNER)
C MOVE TO ALICE SMALL.
       RETURN
C
C O122--       ICINGS
C
52000       IF(PRSA.NE.READW) GO TO 52200
C READ?
       I=274
C CANT READ.
       IF(PRSI.NE.0) I=275
C THROUGH SOMETHING?
       IF(PRSI.EQ.BOTTL) I=276
C THROUGH BOTTLE?
       IF(PRSI.EQ.FLASK) I=277+(PRSO-ORICE)
C THROUGH FLASK?
       CALL RSPEAK(I)
C READ FLASK.
       RETURN
C
52200       IF((PRSA.NE.THROWW).OR.(PRSO.NE.RDICE).OR.(PRSI.NE.POOL))
     1       GO TO 52300
C THROW RDICE AT POOL?
       CALL NEWSTA(POOL,280,0,0,0)
C VANISH POOL.
       OFLAG1(SAFFR)=ZOR(OFLAG1(SAFFR),VISIBT)
C MATERIALIZE SPICES.
       RETURN
C
52300       IF((HERE.NE.ALICE).AND.(HERE.NE.ALISM).AND.(HERE.NE.ALITR))
     1       GO TO 10
C IN WONDERLAND?
       IF(((PRSA.NE.EATW).AND.(PRSA.NE.THROWW)).OR.
     1       (PRSO.NE.ORICE)) GO TO 52400
C THROW ORANGE ICE?
       CALL NEWSTA(ORICE,0,0,0,0)
C VANISH ORANGE ICE.
       RFLAG(HERE)=ZOR(RFLAG(HERE),RMUNG)
C VANISH ROOM.
       RVAL(HERE)=281
       CALL JIGSUP(282)
C VANISH ADVENTURER.
       RETURN
C
52400       IF((PRSA.NE.EATW).OR.(PRSO.NE.BLICE))
     1       GO TO 10
C EAT BLUE ICE?
       CALL NEWSTA(BLICE,283,0,0,0)
C VANISH BLUE ICE.
       IF(HERE.NE.ALISM) GO TO 52500
C IN REDUCED ROOM?
       OFLAG1(ROBOT)=ZOR(OFLAG1(ROBOT),VISIBT)
C MATERIALIZE ROBOT.
       DO 52450 I=1,OLNT
C ENLARGE WORLD.
         IF((OROOM(I).NE.HERE).OR.(OSIZE(I).EQ.10000))
     1       GO TO 52450
         OROOM(I)=ALICE
         OSIZE(I)=OSIZE(I)/64
52450       CONTINUE
       OAPPLI=MOVETO(ALICE,WINNER)
C RETURN
       RETURN
C
52500       CALL JIGSUP(284)
C ENLARGED IN WRONG ROOM.
       RETURN
C
C O123--       BRICK
C
54000       IF(PRSA.NE.BURNW) GO TO 10
C BURN?
       CALL JIGSUP(150)
C BOOM
C 
       RETURN
C
C O124--       MYSELF
C
55000       IF(PRSA.NE.GIVEW) GO TO 55100
C GIVE?
       CALL NEWSTA(PRSO,2,0,0,PLAYER)
C DONE.
       RETURN
C
55100       IF(PRSA.NE.TAKEW) GO TO 55200
C TAKE?
       CALL RSPEAK(286)
C JOKE.
       RETURN
C
55200       IF((PRSA.NE.KILLW).AND.(PRSA.NE.MUNGW)) GO TO 10
       CALL JIGSUP(287)
C KILL, NO JOKE.
       RETURN
C OAPPLI, PAGE 10
C
C O125--       PANELS INSIDE MIRROR
C
56000       IF(PRSA.NE.PUSHW) GO TO 10
C PUSH?
       IF(POLEUF.NE.0) GO TO 56100
C SHORT POLE UP?
       I=731
C NO, WONT BUDGE.
       IF(MOD(MDIR,180).EQ.0) I=732
C DIFF MSG IF N-S.
       CALL RSPEAK(I)
C TELL WONT MOVE.
       RETURN
C
56100       IF(MLOC.NE.MRG) GO TO 56200
C IN GDN ROOM?
       CALL RSPEAK(733)
C YOU LOSE.
       CALL JIGSUP(685)
       RETURN
C
56200       I=831
C ROTATE L OR R.
       IF((PRSO.EQ.RDWAL).OR.(PRSO.EQ.YLWAL)) I=830
       CALL RSPEAK(I)
C TELL DIRECTION.
       MDIR=MOD(MDIR+45+(270*(I-830)),360)
C CALCULATE NEW DIR.
       CALL RSPSUB(734,695+(MDIR/45))
C TELL NEW DIR.
       IF(WDOPNF) CALL RSPEAK(730)
C IF PANEL OPEN, CLOSE.
       WDOPNF=.FALSE.
       RETURN
C DONE.
C
C O126--       ENDS INSIDE MIRROR
C
57000       IF(PRSA.NE.PUSHW) GO TO 10
C PUSH?
       IF(MOD(MDIR,180).EQ.0) GO TO 57100
C MIRROR N-S?
       CALL RSPEAK(735)
C NO, WONT BUDGE.
       RETURN
C
57100       IF(PRSO.NE.PINDR) GO TO 57300
C PUSH PINE WALL?
       IF(((MLOC.EQ.MRC).AND.(MDIR.EQ.180)).OR.
     1  ((MLOC.EQ.MRD).AND.(MDIR.EQ.0)).OR.
     2   (MLOC.EQ.MRG)) GO TO 57200
C IN VIEW OF GDN?
       CALL RSPEAK(736)
C NO, OPENS.
       WDOPNF=.TRUE.
C INDICATE OPEN.
       CFLAG(CEVPIN)=.TRUE.
C TIME OPENING.
       CTICK(CEVPIN)=5
       RETURN
C
57200       CALL RSPEAK(737)
C GDN SEES YOU, DIE.
       CALL JIGSUP(685)
       RETURN
C
57300       NLOC=MLOC-1
C NEW LOC IF SOUTH.
       IF(MDIR.EQ.0) NLOC=MLOC+1
C NEW LOC IF NORTH.
       IF((NLOC.GE.MRA).AND.(NLOC.LE.MRD)) GO TO 57400
       CALL RSPEAK(738)
C HAVE REACHED END.
       RETURN
C
57400       I=699
C ASSUME SOUTH.
       IF(MDIR.EQ.0) I=695
C NORTH.
       J=739
C ASSUME SMOOTH.
       IF(POLEUF.NE.0) J=740
C POLE UP, WOBBLES.
       CALL RSPSUB(J,I)
C DESCRIBE.
       MLOC=NLOC
       IF(MLOC.NE.MRG) RETURN
C NOW IN GDN ROOM?
C
       IF(POLEUF.NE.0) GO TO 57500
C POLE UP, GDN SEES.
       IF(MROPNF.OR.WDOPNF) GO TO 57600
C DOOR OPEN, GDN SEES.
       IF(MR1F.AND.MR2F) RETURN
C MIRRORS INTACT, OK.
       CALL RSPEAK(742)
C MIRRORS BROKEN, DIE.
       CALL JIGSUP(743)
       RETURN
C
57500       CALL RSPEAK(741)
C POLE UP, DIE.
       CALL JIGSUP(743)
       RETURN
C
57600       CALL RSPEAK(744)
C DOOR OPEN, DIE.
       CALL JIGSUP(743)
       RETURN
C OAPPLI, PAGE 11
C
C O127--       GLOBAL GUARDIANS
C
58000       IF((PRSA.NE.ATTACW).AND.(PRSA.NE.KILLW).AND.
     1  (PRSA.NE.MUNGW)) GO TO 58100
C AGGRESSIVE?
       CALL JIGSUP(745)
C LOSE.
       RETURN
C
58100       IF(PRSA.NE.HELLOW) GO TO 10
C HELLO?
       CALL RSPEAK(746)
C NO REPLY.
       RETURN
C
C O128--       GLOBAL MASTER
C
59000       IF((PRSA.NE.ATTACW).AND.(PRSA.NE.KILLW).AND.
     1  (PRSA.NE.MUNGW)) GO TO 59100
C AGGRESSIVE?
       CALL JIGSUP(747)
C BAD IDEA.
       RETURN
C
59100       IF(PRSA.NE.TAKEW) GO TO 10
C TAKE?
       CALL RSPEAK(748)
C JOKE.
       RETURN
C
C O129--       NUMERAL FIVE (FOR JOKE)
C
60000       IF(PRSA.NE.TAKEW) GO TO 10
C TAKE FIVE?
       CALL RSPEAK(419)
C TIME PASSES.
       DO 60100 I=1,3
C WAIT A WHILE.
         IF(CLOCKD(X)) RETURN
60100       CONTINUE
       RETURN
C
C O130--       CRYPT FUNCTION
C
61000       IF(.NOT.ENDGMF) GO TO 45000
C IF NOT EG, DIE.
       IF(PRSA.NE.OPENW) GO TO 61100
C OPEN?
       I=793
       IF(QOPEN(TOMB)) I=794
       CALL RSPEAK(I)
       OFLAG2(TOMB)=ZOR(OFLAG2(TOMB),OPENBT)
C NOW TOMB WITH VIEW.
       RETURN
C
61100       IF(PRSA.NE.CLOSEW) GO TO 45000
C CLOSE?
       I=795
       IF(QOPEN(TOMB)) I=796
       CALL RSPEAK(I)
       OFLAG2(TOMB)=ZAND(OFLAG2(TOMB),ZNOT(OPENBT))
       IF(HERE.EQ.CRYPT) CTICK(CEVSTE)=3
C IF IN CRYPT, START EG.
       RETURN
C OAPPLI, PAGE 12
C
C O131--       GLOBAL LADDER
C
62000       IF((CPVEC(CPHERE+1).EQ.-2).OR.(CPVEC(CPHERE-1).EQ.-3))
     1       GO TO 62100
C LADDER HERE?
       CALL RSPEAK(865)
C NO, LOSE.
       RETURN
C
62100       IF((PRSA.EQ.CLMBW).OR.(PRSA.EQ.CLMBUW)) GO TO 62200
       CALL RSPEAK(866)
C CLIMB IT?
       RETURN
C
62200       IF((CPHERE.EQ.10).AND.(CPVEC(CPHERE+1).EQ.-2))
     1       GO TO 62300
C AT EXIT?
       CALL RSPEAK(867)
C NO, HIT YOUR HEAD.
       RETURN
C
62300       F=MOVETO(CPANT,WINNER)
C TO ANTEROOM.
       F=RMDESC(3)
C DESCRIBE.
       RETURN
C
       END

C FIGHTD- INTERMOVE FIGHT DEMON
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       SUBROUTINE FIGHTD
       IMPLICIT INTEGER (A-Z)
       LOGICAL PROB,OAPPLI,F
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C VILLAINS AND DEMONS
C
       COMMON /VILL/ VLNT,VILLNS(4),VPROB(4),VOPPS(4),VBEST(4),VMELEE(4)
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AFLAGS/ ASTAG
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
C FUNCTIONS AND DATA
C
       DATA ROUT/1/
C FIGHTD, PAGE 2
C
       DO 2400 I=1,VLNT 
C LOOP THRU VILLAINS.
         VOPPS(I)=0 
C CLEAR OPPONENT SLOT.
         OBJ=VILLNS(I) 
C GET OBJECT NO.
         RA=OACTIO(OBJ) 
C GET HIS ACTION.
         IF(HERE.NE.OROOM(OBJ)) GO TO 2200 
C ADVENTURER STILL HERE?
         IF((OBJ.EQ.THIEF).AND.THFENF) GO TO 2400 
C THIEF ENGROSSED?
         IF(OCAPAC(OBJ).GE.0) GO TO 2050 
C YES, VILL AWAKE?
         IF((VPROB(I).EQ.0).OR..NOT.PROB(VPROB(I),VPROB(I)))
     1       GO TO 2025 
C NO, SEE IF WAKES UP.
         OCAPAC(OBJ)=IABS(OCAPAC(OBJ))
         VPROB(I)=0
         IF(RA.EQ.0) GO TO 2400 
C ANYTHING TO DO?
         PRSA=INXW 
C YES, WAKE HIM UP.
         F=OAPPLI(RA,0)
         GO TO 2400 
C NOTHING ELSE HAPPENS.
C
2025         VPROB(I)=VPROB(I)+10 
C INCREASE WAKEUP PROB.
         GO TO 2400 
C NOTHING ELSE.
C
2050         IF(ZAND(OFLAG2(OBJ),FITEBT).EQ.0) GO TO 2100
         VOPPS(I)=OBJ 
C FIGHTING, SET UP OPP.
         GO TO 2400
C
2100         IF(RA.EQ.0) GO TO 2400 
C NOT FIGHTING,
         PRSA=FRSTQW 
C SET UP PROBABILITY
         IF(.NOT.OAPPLI(RA,0)) GO TO 2400 
C OF FIGHTING.
         OFLAG2(OBJ)=ZOR(OFLAG2(OBJ),FITEBT)
         VOPPS(I)=OBJ 
C SET UP OPP.
         GO TO 2400
C
2200         IF((ZAND(OFLAG2(OBJ),FITEBT).EQ.0).OR.(RA.EQ.0))
     1       GO TO 2300 
C JOTHING TK DO.
         PRSA=FIGHTW 
C HAVE A FIGHT.
         F=OAPPLI(RA,0)
2300         IF(OBJ.EQ.THIEF) THFENF=.FALSE. 
C TURN OFF ENGROSSED.
         AFLAG(PLAYER)=ZAND(AFLAG(PLAYER),NOT(ASTAG))
         OFLAG2(OBJ)=ZAND(OFLAG2(OBJ), NOT(STAGBT+FITEBT))
         IF((OCAPAC(OBJ).GE.0).OR.(RA.EQ.0))
     1       GO TO 2400
         PRSA=INXW 
C WAKE HIM UP.
         F=OAPPLI(RA,0)
         OCAPAC(OBJ)=IABS(OCAPAC(OBJ))
2400       CONTINUE
C FIGHTD, PAGE 3
C
C NOW DO ACTUAL COUNTERBLOWS.
C
       OUT=0 
C ASSUME HERO OK.
2600       DO 2700 I=1,VLNT 
C LOOP THRU OPPS.
         J=VOPPS(I)
         IF(J.EQ.0) GO TO 2700 
C SLOT EMPTY?
         PRSCON=1 
C STOP CMD STREAM.
         RA=OACTIO(J)
         IF(RA.EQ.0) GO TO 2650 
C VILLAIN ACTION?
         PRSA=FIGHTW 
C SEE IF
         IF(OAPPLI(RA,0)) GO TO 2700 
C SPECIAL ACTION.
2650         RES=BLOW(PLAYER,J,VMELEE(I),.FALSE.,OUT) 
C STRIKE BLOW.
         IF(RES.LT.0) RETURN 
C IF HERO DEAD, EXIT.
         IF(RES.EQ.ROUT) OUT=2+ZRND(3) 
C IF HERO OUT, SET FLG.
2700       CONTINUE
       OUT=OUT-1 
C DECREMENT OUT COUNT.
       IF(OUT.GT.0) GO TO 2600 
C IF STILL OUT, GO AGAIN.
       RETURN
C
       END
C BLOW- STRIKE BLOW
C
C DECLARATIONS
C
       INTEGER FUNCTION BLOW(H,V,RMK,HFLG,OUT)
       IMPLICIT INTEGER (A-Z)
       LOGICAL HFLG,OAPPLI,PROB,F
       INTEGER DEF1R(3),DEF2R(4),DEF3R(5)
       INTEGER RVECTR(66),RSTATE(45)
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C PARSE VECTOR
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C MISCELLANEOUS VARIABLES
C
       COMMON /STAR/ MBASE,STRBIT
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1       CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2       CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3       CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     5       CEVMRS,CEVPIN,CEVINQ,CEVFOL
 
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AFLAGS/ ASTAG
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW

C
C FUNCTIONS AND DATA
C
       DATA RMISS/0/,ROUT/1/,RKILL/2/,RLIGHT/3/
       DATA RSER/4/,RSTAG/5/,RLOSE/6/,RHES/7/,RSIT/8/
       DATA DEF1R/1,2,3/
       DATA DEF2R/13,23,24,25/
       DATA DEF3R/35,36,46,47,57/
C
       DATA RVECTR/0,0,0,0,5,5,1,1,2,2,2,2,
     1       0,0,0,0,0,5,5,3,3,1,
     2       0,0,0,5,5,3,3,3,1,2,2,2,
     3       0,0,0,0,0,5,5,3,3,4,4,
     4       0,0,0,5,5,3,3,3,4,4,4,
     5       0,5,5,3,3,3,3,4,4,4/
       DATA RSTATE/5000,3005,3008,4011,3015,3018,1021,0,0,
     1       5022,3027,3030,4033,3037,3040,1043,0,0,
     2       4044,2048,4050,4054,5058,4063,4067,3071,1074,
     3       4075,1079,4080,4084,4088,4092,4096,4100,1104,
     4       4105,2109,4111,4115,4119,4123,4127,3131,3134/
C BLOW, PAGE 3
C
       RA=OACTIO(V) 
C GET VILLAIN ACTION,
       DV=ODESC2(V) 
C DESCRIPTION.
       BLOW=RMISS 
C ASSUME NO RESULT.
       IF(.NOT.HFLG) GO TO 1000 
C HERO STRIKING BLOW?
C
C HERO IS ATTACKER, VILLAIN IS DEFENDER.
C
       PBLOSE=10 
C BAD LK PROB.
       OFLAG2(V)=ZOR(OFLAG2(V),FITEBT) 
C YES, VILLAIN GETS MAD.
       IF(ZAND(AFLAG(H),ASTAG).EQ.0) GO TO 100 
C HERO STAG?
       CALL RSPEAK(591) 
C YES, CANT FIGHT.
       AFLAG(H)=ZAND(AFLAG(H), NOT(ASTAG))
       RETURN
C
100       ATT=FIGHTS(H,.TRUE.) 
C GET HIS STRENGTH.
       OA=ATT
       DEF=VILSTR(V) 
C GET VILL STRENGTH.
       OD=DEF
       DWEAP=0 
C ASSUME NO WEAPON.
       DO 200 I=1,OLNT 
C SEARCH VILLAIN.
         IF((OCAN(I).EQ.V).AND.(ZAND(OFLAG2(I),WEAPBT).NE.0))
     1       DWEAP=I
200       CONTINUE
       IF(V.EQ.AOBJ(PLAYER)) GO TO 300 
C KILLING SELF?
       IF(DEF.NE.0) GO TO 2000 
C DEFENDER ALIVE?
       CALL RSPSUB(592,DV) 
C VILLAIN DEAD.
       RETURN
C
300       CALL JIGSUP(593) 
C KILLING SELF.
       RETURN
C
C VILLAIN IS ATTACKER, HERO IS DEFENDER.
C
1000       PBLOSE=50 
C BAD LK PROB.
       AFLAG(H)=ZAND(AFLAG(H),NOT(ASTAG)) 
C VILL STRIKING.
       IF(ZAND(OFLAG2(V),STAGBT).EQ.0) GO TO 1200 
C VILL STAGGERED?
       OFLAG2(V)=ZAND(OFLAG2(V), NOT(STAGBT)) 
C MAKE HIM OK.
       CALL RSPSUB(594,DV) 
C DESCRIBE.
       RETURN
C
1200       ATT=VILSTR(V) 
C SET UP ATT, DEF.
       OA=ATT
       DEF=FIGHTS(H,.TRUE.)
       IF(DEF.LE.0) RETURN 
C DONT ALLOW DEAD DEF.
       OD=FIGHTS(H,.FALSE.)
       DWEAP=IABS(FWIM(0,WEAPBT,0,0,H,.TRUE.)) 
C FIND A WEAPON.
C BLOW, PAGE 4
C
C PARTIES ARE NOW EQUIPPED.  DEF CANNOT BE ZERO.
C ATT MUST BE > 0.
C
2000       CONTINUE
       IF(DEF.GT.0) GO TO 2100 
C DEF ALIVE?
       RES=RKILL
       IF(HFLG) CALL RSPSUB(595,DV) 
C DEADER.
       GO TO 3000
C
2100       IF(DEF-2) 2200,2300,2400 
C DEF <2,=2,>2
2200       ATT=MIN0(ATT,3) 
C SCALE ATT.
       TBL=DEF1R(ATT) 
C CHOOSE TABLE.
       GO TO 2500
C
2300       ATT=MIN0(ATT,4) 
C SCALE ATT.
       TBL=DEF2R(ATT) 
C CHOOSE TABLE.
       GO TO 2500
C
2400       ATT=ATT-DEF 
C SCALE ATT.
       ATT=MIN0(2,MAX0(-2,ATT))+3
       TBL=DEF3R(ATT)
C
2500       RES=RVECTR(TBL+ZRND(10)) 
C GET RESULT.
       IF(OUT.EQ.0) GO TO 2600 
C WAS HE OUT?
       IF(RES.EQ.RSTAG) GO TO 2550 
C YES, STAG--> HES.
       RES=RSIT 
C OTHERWISE, SITTING.
       GO TO 2600
2550       RES=RHES
2600       IF((RES.EQ.RSTAG).AND.(DWEAP.NE.0).AND.PROB(25,PBLOSE))
     1       RES=RLOSE 
C LOSE WEAPON.
C
       MI=RSTATE(((RMK-1)*9)+RES+1) 
C CHOOSE TABLE ENTRY.
       IF(MI.EQ.0) GO TO 3000
       I=(MOD(MI,1000)+ZRND(MI/1000))+MBASE+1
       J=DV
       IF(.NOT.HFLG .AND.(DWEAP.NE.0)) J=ODESC2(DWEAP)
       CALL RSPSUB(I,J) 
C PRESENT RESULT.
C BLOW, PAGE 5
C
C NOW APPLY RESULT
C
3000       GO TO (4000,3100,3200,3300,3400,3500,3600,4000,3200),RES+1
C
3100       IF(HFLG) DEF=-DEF 
C UNCONSCIOUS.
       GO TO 4000
C
3200       DEF=0 
C KILLED OR SITTING DUCK.
       GO TO 4000
C
3300       DEF=MAX0(0,DEF-1) 
C LIGHT WOUND.
       GO TO 4000
C
3400       DEF=MAX0(0,DEF-2) 
C SERIOUS WOUND.
       GO TO 4000
C
3500       IF(HFLG) GO TO 3550 
C STAGGERED.
       AFLAG(H)=ZOR(AFLAG(H),ASTAG)
       GO TO 4000
C
3550       OFLAG2(V)=ZOR(OFLAG2(V),STAGBT)
       GO TO 4000
C
3600       CALL NEWSTA(DWEAP,0,HERE,0,0) 
C LOSE WEAPON.
       DWEAP=0
       IF(HFLG) GO TO 4000 
C IF HERO, DONE.
       DWEAP=IABS(FWIM(0,WEAPBT,0,0,H,.TRUE.)) 
C GET NEW.
       IF(DWEAP.NE.0) CALL RSPSUB(605,ODESC2(DWEAP))
C BLOW, PAGE 6
C
4000       BLOW=RES 
C RETURN RESULT.
       IF(.NOT.HFLG) GO TO 4500 
C HERO?
       OCAPAC(V)=DEF 
C STORE NEW CAPACITY.
       IF(DEF.NE.0) GO TO 4100 
C DEAD?
       OFLAG2(V)=ZAND(OFLAG2(V), NOT(FITEBT)) 
C YES, NOT FIGHTING.
       CALL RSPSUB(572,DV) 
C HE DIES.
       CALL NEWSTA(V,0,0,0,0) 
C MAKE HIM DISAPPEAR.
       IF(RA.EQ.0) RETURN 
C IF NX TO DO, EXIT.
       PRSA=DEADXW 
C LET HIM KNOW.
       F=OAPPLI(RA,0)
       RETURN
C
4100       IF((RES.NE.ROUT).OR.(RA.EQ.0)) RETURN
       PRSA=OUTXW 
C LET HIM BE OUT.
       F=OAPPLI(RA,0)
       RETURN
C
4500       ASTREN(H)=-10000 
C ASSUME DEAD.
       IF(DEF.NE.0) ASTREN(H)=DEF-OD
       IF(DEF.GE.OD) GO TO 4600
       CTICK(CEVCUR)=30
       CFLAG(CEVCUR)=.TRUE.
4600       IF(FIGHTS(H,.TRUE.).GT.0) RETURN
       ASTREN(H)=1-FIGHTS(H,.FALSE.) 
C HE'S DEAD.
       CALL JIGSUP(596)
       BLOW=-1
       RETURN
C
       END
C SWORDD- SWORD INTERMOVE DEMON
C
C DECLARATIONS
C
       SUBROUTINE SWORDD
       IMPLICIT INTEGER(A-Z)
       LOGICAL INFEST,FINDXT
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C EXITS
C
       COMMON /CURXT/ XTYPE,XROOM1,XSTRNG,XACTIO,XOBJ
C
       COMMON /XSRCH/ XMIN,XMAX,XDOWN,XUP,
     1       XNORTH,XSOUTH,XENTER,XEXIT,XEAST,XWEST
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C VILLAINS AND DEMONS
C
       LOGICAL THFFLG,SWDACT,THFACT
       COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
C
C ADVENTURERS
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C SWORDD, PAGE 2
C
       IF(OADV(SWORD).NE.PLAYER) GO TO 500 
C HOLDING SWORD?
       NG=2 
C ASSUME VILL CLOSE.
       IF(INFEST(HERE)) GO TO 300 
C VILL HERE?
       NG=1
       DO 200 I=XMIN,XMAX,XMIN 
C NO, SEARCH ROOMS.
         IF(.NOT.FINDXT(I,HERE)) GO TO 200 
C ROOM THAT WAY?
         GO TO (50,200,50,50),XTYPE 
C SEE IF ROOM AT ALL.
50         IF(INFEST(XROOM1)) GO TO 300 
C CHECK ROOM.
200       CONTINUE
       NG=0 
C NO GLOW.
C
300       IF(NG.EQ.SWDSTA) RETURN 
C ANY STATE CHANGE?
       CALL RSPEAK(NG+495) 
C YES, TELL NEW STATE.
       SWDSTA=NG
       RETURN
C
500       SWDACT=.FALSE. 
C DROPPED SWORD,
       RETURN 
C DISABLE DEMON.
       END
C INFEST-       SUBROUTINE TO TEST FOR INFESTED ROOM
C
C DECLARATIONS
C
       LOGICAL FUNCTION INFEST(R)
       IMPLICIT INTEGER(A-Z)
C
C ROOMS
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1 
       COMMON /RINDEX/ MGRAT,MAZ15 
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF 
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU 
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C VILLAINS AND DEMONS
C
       LOGICAL THFFLG,SWDACT,THFACT
       COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
       IF(.NOT.ENDGMF) INFEST=(OROOM(CYCLO).EQ.R).OR.
     1       (OROOM(TROLL).EQ.R).OR.
     2       ((OROOM(THIEF).EQ.R).AND.THFACT)
       IF(ENDGMF) INFEST=(R.EQ.MRG).OR.(R.EQ.MRGE).OR.
     1       (R.EQ.MRGW).OR.
     2       ((R.EQ.INMIR).AND.(MLOC.EQ.MRG))
       RETURN
       END

C SVERBS-       SIMPLE VERBS PROCESSOR
C       ALL VERBS IN THIS ROUTINE MUST BE INDEPENDANT
C       OF OBJECT ACTIONS
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       LOGICAL FUNCTION SVERBS(RI)
       IMPLICIT INTEGER (A-Z)
       LOGICAL MOVETO,YESNO
       LOGICAL RMDESC
       LOGICAL QOPEN
       LOGICAL FINDXT,QHERE,F
       INTEGER JOKES(25)
       CHARACTER ANSSTR(78)
       CHARACTER P1(6),P2(6),CH(6)
       INTEGER ANSWER(28)
       CHARACTER*2 MMOVEZ
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C SCREEN OF LIGHT
C
       COMMON /SCREEN/ FROMDR,SCOLRM,SCOLAC
       COMMON /SCREEN/ SCOLDR(8),SCOLWL(12)
C
C MISCELLANEOUS VARIABLES
C
       CHARACTER INBUF
        COMMON /INPUTL/ INLNT
       COMMON /INPUT/ INBUF(78)
       COMMON /VERS/ VMAJ,VMIN,VEDIT
       COMMON /CHAN/ INPCH,OUTCH,DBCH,ZRECL
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1
       COMMON /RINDEX/ MGRAT,MAZ15
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C EXITS
C
       COMMON /EXITS/ XLNT,TRAVEL(900)
C
       COMMON /CURXT/ XTYPE,XROOM1,XSTRNG,XACTIO,XOBJ
C
       COMMON /XPARS/ XRMASK,XDMASK,XFMASK,XFSHFT,XASHFT,
     1       XELNT(4),XNORM,XNO,XCOND,XDOOR,XLFLAG
C
       COMMON /XSRCH/ XMIN,XMAX,XDOWN,XUP,
     1       XNORTH,XSOUTH,XENTER,XEXIT,XEAST,XWEST
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1       CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2       CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3       CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     5       CEVMRS,CEVPIN,CEVINQ,CEVFOL
 
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
       LOGICAL FLAGS(46)
       EQUIVALENCE (FLAGS(1),TROLLF)
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
C FUNCTIONS AND DATA
C
       QOPEN(R)=ZAND(OFLAG2(R),OPENBT).NE.0
       DATA MXNOP/39/,MXJOKE/64/
       DATA JOKES/4,5,3,304,305,306,307,308,309,310,311,312,
     1       313,5314,5319,324,325,883,884,120,120,0,0,0,0/
       DATA ANSWER/0,6,1,6,2,5,3,5,4,3,4,6,4,6,4,5,
     1       5,5,5,4,5,6,6,10,7,4,7,6/
       DATA ANSSTR/'T','E','M','P','L','E',
     1       'F','O','R','E','S','T',
     2       '3','0','0','0','3',
     3       'F','L','A','S','K',
     4       'R','U','B',
     5       'F','O','N','D','L','E',
     6       'C','A','R','R','E','S',
     7       'T','O','U','C','H',
     8       'B','O','N','E','S',
     9       'B','O','D','Y',
     1       'S','K','E','L','E','T',
     2       'R','U','S','T','Y','K','N','I','F','E',
     3       'N','O','N','E',
     4       'N','O','W','H','E','R',' '/
C SVERBS, PAGE 2
C
       ANSSTR(78) = CHAR(0)
       SVERBS=.TRUE.
C ASSUME WINS.
       IF(PRSO.NE.0) ODO2=ODESC2(PRSO)
C SET UP DESCRIPTORS.
       IF(PRSI.NE.0) ODI2=ODESC2(PRSI)
C
       IF(RI.EQ.0) CALL BUG(7,RI)
C ZERO IS VERBOTEN.
       IF(RI.LE.MXNOP) RETURN
C NOP?
       IF(RI.LE.MXJOKE) GO TO 100
C JOKE?
       GO TO (65000,66000,67000,68000,69000,
     1 1000,2000,3000,4000,5000,6000,7000,8000,9000,10000,
     2 11000,12000,13000,14000,15000,16000,17000,18000,19000,20000,
     3 21000,22000,23000,24000,25000,26000,27000),
     8       (RI-MXJOKE)
       CALL BUG(7,RI)
C
C ALL VERB PROCESSORS RETURN HERE TO DECLARE FAILURE.
C
10       SVERBS=.FALSE.
C LOSE.
       RETURN
C
C JOKE PROCESSOR.
C FIND PROPER ENTRY IN JOKES, USE IT TO SELECT STRING TO PRINT.
C
100       I=JOKES(RI-MXNOP)
C GET TABLE ENTRY.
       J=I/1000
C ISOLATE # STRINGS.
       IF(J.NE.0) I=MOD(I,1000)+ZRND(J)
C IF RANDOM, CHOOSE.
       CALL RSPEAK(I)
C PRINT JOKE.
       RETURN
C SVERBS, PAGE 2A
C
C V65--       ROOM
C
65000       SVERBS=RMDESC(2)
C DESCRIBE ROOM ONLY.
       RETURN
C
C V66--       OBJECTS
C
66000       SVERBS=RMDESC(1)
C DESCRIBE OBJ ONLY.
       IF(.NOT.TELFLG) CALL RSPEAK(138)
C NO OBJECTS.
       RETURN
C
C V67--       RNAME
C
67000       CALL RSPEAK(RDESC2-HERE)
C SHORT ROOM NAME.
       RETURN
C
C V68--       RESERVED
C
68000       RETURN
C
C V69--       RESERVED
C
69000       RETURN
C SVERBS, PAGE 3
C
C V70--       BRIEF.  SET FLAG.
C
1000       BRIEFF=.TRUE.
C BRIEF DESCRIPTIONS.
       SUPERF=.FALSE.
       CALL RSPEAK(326)
       RETURN
C
C V71--       VERBOSE.  CLEAR FLAGS.
C
2000       BRIEFF=.FALSE.
C LONG DESCRIPTIONS.
       SUPERF=.FALSE.
       CALL RSPEAK(327)
       RETURN
C
C V72--       SUPERBRIEF.  SET FLAG.
C
3000       SUPERF=.TRUE.
       CALL RSPEAK(328)
       RETURN
C
C V73-- STAY (USED IN ENDGAME).
C
4000       IF(WINNER.NE.AMASTR) GO TO 4100
C TELL MASTER, STAY.
       CALL RSPEAK(781)
C HE DOES.
       CTICK(CEVFOL)=0
C NOT FOLLOWING.
       RETURN
C
4100       IF(WINNER.EQ.PLAYER) CALL RSPEAK(664)
C JOKE.
       RETURN
C
C V74--       VERSION.  PRINT INFO.
C
5000       WRITE(OUTCH,5010) VMAJ,VMIN,VEDIT
5010       FORMAT(' V',I1,'.',I2,I1)
       TELFLG=.TRUE.
       RETURN
C
C V75--       SWIM.  ALWAYS A JOKE.
C
6000       I=330
C ASSUME WATER.
       IF(ZAND(RFLAG(HERE),(RWATER+RFILL)).EQ.0)
     1       I=331+ZRND(3)
C IF NO WATER, JOKE.
       CALL RSPEAK(I)
       RETURN
C
C V76--       GERONIMO.  IF IN BARREL, FATAL, ELSE JOKE.
C
7000       IF(HERE.EQ.MBARR) GO TO 7100
C IN BARREL?
       CALL RSPEAK(334)
C NO, JOKE.
       RETURN
C
7100       CALL JIGSUP(335)
C OVER FALLS.
       RETURN
C
C V77--       SINBAD ET AL.  CHASE CYCLOPS, ELSE JOKE.
C
8000       IF((HERE.EQ.MCYCL).AND.QHERE(CYCLO,HERE)) GO TO 8100
       CALL RSPEAK(336)
C NOT HERE, JOKE.
       RETURN
C
8100       CALL NEWSTA(CYCLO,337,0,0,0)
C CYCLOPS FLEES.
       CYCLOF=.TRUE.
C SET ALL FLAGS.
       MAGICF=.TRUE.
       OFLAG2(CYCLO)=ZAND(OFLAG2(CYCLO),ZNOT(FITEBT))
       RETURN
C
C V78--       WELL.  OPEN DOOR, ELSE JOKE.
C
9000       IF(RIDDLF.OR.(HERE.NE.RIDDL)) GO TO 9100 
C IN RIDDLE ROOM?
       RIDDLF=.TRUE.
C YES, SOLVED IT.
       CALL RSPEAK(338)
       RETURN
C
9100       CALL RSPEAK(339)
C WELL, WHAT?
       RETURN
C
C V79--       PRAY.  IF IN TEMP2, POOF
C 
C
10000       IF(HERE.NE.TEMP2) GO TO 10050
C IN TEMPLE?
       IF(MOVETO(FORE1,WINNER)) GO TO 10100
C FORE1 STILL THERE?
10050       CALL RSPEAK(340)
C JOKE.
       RETURN
C
10100       F=RMDESC(3)
C MOVED, DESCRIBE.
       RETURN
C
C V80--       TREASURE.  IF IN TEMP1, POOF
C 
C
11000       IF(HERE.NE.TEMP1) GO TO 11050
C IN TEMPLE?
       IF(MOVETO(TREAS,WINNER)) GO TO 10100
C TREASURE ROOM THERE?
11050       CALL RSPEAK(341)
C NOTHING HAPPENS.
       RETURN
C
C V81--       TEMPLE.  IF IN TREAS, POOF
C 
C
12000       IF(HERE.NE.TREAS) GO TO 12050
C IN TREASURE?
       IF(MOVETO(TEMP1,WINNER)) GO TO 10100
C TEMP1 STILL THERE?
12050       CALL RSPEAK(341)
C NOTHING HAPPENS.
       RETURN
C
C V82--       BLAST.  USUALLY A JOKE.
C
13000       I=342
C DONT UNDERSTAND.
       IF(PRSO.EQ.SAFE) I=252
C JOKE FOR SAFE.
       CALL RSPEAK(I)
       RETURN
C
C V83--       SCORE.  PRINT SCORE.
C
14000       CALL SCORE(.FALSE.)
       RETURN
C
C V84--       QUIT.  FINISH OUT THE GAME.
C
15000       CALL SCORE(.TRUE.)
C TELLL SCORE.
       IF(.NOT.YESNO(343,0,0)) RETURN
C ASK FOR Y/N DECISION.
       CLOSE (UNIT=DBCH)
C CLEAN UP.
       CALL EXIT
C BYE.
C SVERBS, PAGE 4
C
C V85--       FOLLOW (USED IN ENDGAME)
C
16000       IF(WINNER.NE.AMASTR) RETURN
C TELL MASTER, FOLLOW.
       CALL RSPEAK(782)
       CTICK(CEVFOL)=-1
C STARTS FOLLOWING.
       RETURN
C
C V86--       WALK THROUGH
C
17000       IF((SCOLRM.EQ.0).OR.((PRSO.NE.SCOL).AND.
     1       ((PRSO.NE.WNORT).OR.(HERE.NE.BKBOX)))) GO TO 17100
       SCOLAC=SCOLRM
C WALKED THRU SCOL.
       PRSO=0
C FAKE OUT FROMDR.
       CTICK(CEVSCL)=6
C START ALARM.
       CALL RSPEAK(668)
C DISORIENT HIM.
       F=MOVETO(SCOLRM,WINNER)
C INTO ROOM.
       F=RMDESC(3)
C DESCRIBE.
       RETURN
C
17100       IF(HERE.NE.SCOLAC) GO TO 17300
C ON OTHER SIDE OF SCOL?
       DO 17200 I=1,12,3
C WALK THRU PROPER WALL?
         IF((SCOLWL(I).EQ.HERE).AND.(SCOLWL(I+1).EQ.PRSO))
     1       GO TO 17500
C IN SPECIFIED ROOM?
17200       CONTINUE
C
17300       IF(ZAND(OFLAG1(PRSO),TAKEBT).NE.0) GO TO 17400
C TKBLE?
       I=669
C NO, JOKE.
       IF(PRSO.EQ.SCOL) I=670
C SPECIAL JOKE FOR SCOL.
       CALL RSPSUB(I,ODO2)
       RETURN
C
17400       I=671
C JOKE.
       IF(OROOM(PRSO).NE.0) I=552+ZRND(5)
C SPECIAL JOKES IF CARRY.
       CALL RSPEAK(I)
       RETURN
C
17500       PRSO=SCOLWL(I+2)
C THRU SCOL WALL...
       DO 17600 I=1,8,2
C FIND MATCHING ROOM.
         IF(PRSO.EQ.SCOLDR(I)) SCOLRM=SCOLDR(I+1)
17600       CONTINUE
C DECLARE NEW SCOLRM.
       CTICK(CEVSCL)=0
C CANCEL ALARM.
       CALL RSPEAK(668)
C DISORIENT HIM.
       F=MOVETO(BKBOX,WINNER)
C BACK IN BOX ROOM.
       F=RMDESC(3)
       RETURN
C
C V87--       RING.  A JOKE.
C
18000       I=359
C CANT RING.
       IF(PRSO.EQ.BELL) I=360
C DING, DONG.
       CALL RSPEAK(I)
C JOKE.
       RETURN
C
C V88--       BRUSH.  JOKE WITH OBSCURE TRAP.
C
19000       IF(PRSO.EQ.TEETH) GO TO 19100
C BRUSH TEETH?
       CALL RSPEAK(362)
C NO, JOKE.
       RETURN
C
19100       IF(PRSI.NE.0) GO TO 19200
C WITH SOMETHING?
       CALL RSPEAK(363)
C NO, JOKE.
       RETURN
C
19200       IF((PRSI.EQ.PUTTY).AND.(OADV(PUTTY).EQ.WINNER))
     1       GO TO 19300
C WITH PUTTY?
       CALL RSPSUB(364,ODI2)
C NO, JOKE.
       RETURN
C
19300       CALL JIGSUP(365)
C YES, DEAD
C 
C 
C 
C 
C 
       RETURN
C SVERBS, PAGE 5
C
C V89--       DIG.  UNLESS SHOVEL, A JOKE.
C
20000       IF(PRSO.EQ.SHOVE) RETURN
C SHOVEL?
       I=392
C ASSUME TOOL.
       IF(ZAND(OFLAG1(PRSO),TOOLBT).EQ.0) I=393
       CALL RSPSUB(I,ODO2)
       RETURN
C
C V90--       TIME.  PRINT OUT DURATION OF GAME.
C
21000       CALL GTTIME(K)
C GET PLAY TIME.
       MMOVEZ = 's.'
       IF(K.EQ.1)MMOVEZ = '. '
       WRITE(OUTCH,21010)K, MMOVEZ
       TELFLG=.TRUE.
       RETURN
C
21010  FORMAT(' You have been playing Dungeon for',I5,' minute',A2)
C
C V91--       LEAP.  USUALLY A JOKE, WITH A CATCH.
C
22000       IF(PRSO.EQ.0) GO TO 22200
C OVER SOMETHING?
       IF(QHERE(PRSO,HERE)) GO TO 22100
C HERE?
       CALL RSPEAK(447)
C NO, JOKE.
       RETURN
C
22100       IF(ZAND(OFLAG2(PRSO),VILLBT).EQ.0) GO TO 22300
       CALL RSPSUB(448,ODO2)
C CANT JUMP VILLAIN.
       RETURN
C
22200       IF(.NOT.FINDXT(XDOWN,HERE)) GO TO 22300
C DOWN EXIT?
       IF((XTYPE.EQ.XNO).OR.((XTYPE.EQ.XCOND).AND.
     1       .NOT.FLAGS(XOBJ))) GO TO 22400
C BLOCKED OFF?
22300       CALL RSPEAK(314+ZRND(5))
C WHEEEE
C 
       RETURN
C
22400       CALL JIGSUP(449+ZRND(4))
C FATAL LEAP.
       RETURN
C SVERBS, PAGE 6
C
C V92--       LOCK.
C
23000       IF((PRSO.EQ.GRATE).AND.(HERE.EQ.MGRAT))
     1       GO TO 23200
23100       CALL RSPEAK(464)
C NOT LOCK GRATE.
       RETURN
C
23200       GRUNLF=.FALSE.
C GRATE NOW LOCKED.
       CALL RSPEAK(214)
       TRAVEL(REXIT(HERE)+1)=214
C CHANGE EXIT STATUS.
       RETURN
C
C V93--       UNLOCK
C
24000       IF((PRSO.NE.GRATE).OR.(HERE.NE.MGRAT))
     1       GO TO 23100
C NOT UNLOCK GRATE.
       IF(PRSI.EQ.KEYS) GO TO 24200
C GOT KEYS?
       CALL RSPSUB(465,ODI2)
C NO, JOKE.
       RETURN
C
24200       GRUNLF=.TRUE.
C UNLOCK GRATE.
       CALL RSPEAK(217)
       TRAVEL(REXIT(HERE)+1)=217
C CHANGE EXIT STATUS.
       RETURN
C
C V94--       DIAGNOSE.
C
25000       I=FIGHTS(WINNER,.FALSE.)
C GET FIGHTS STRENGTH.
       J=ASTREN(WINNER)
C GET HEALTH.
       K=MIN0(I+J,4)
C GET STATE.
       IF(.NOT.CFLAG(CEVCUR)) J=0
C IF NO WOUNDS.
       L=MIN0(4,IABS(J))
C SCALE.
       CALL RSPEAK(473+L)
C DESCRIBE HEALTH.
       I=(30*(-J-1))+CTICK(CEVCUR)
C COMPUTE WAIT.
       IF(J.NE.0) WRITE(OUTCH,25100) I
25100       FORMAT(' You will be cured after ',I3,' moves.')
       CALL RSPEAK(478+K)
C HOW MUCH MORE?
       IF(DEATHS.NE.0) CALL RSPEAK(482+DEATHS)
C HOW MANY DEATHS?
       RETURN
C SVERBS, PAGE 7
C
C V95--       INCANT
C
26000       DO 26100 I=1,6
C SET UP PARSE.
         P1(I)=' '
         P2(I)=' '
26100       CONTINUE
       WP=1
C WORD POINTER.
       CP=1
C CHAR POINTER.
       IF(PRSCON.LE.1) GO TO 26300
       DO 26200 I=PRSCON,INLNT
C PARSE INPUT
         IF(INBUF(I).EQ.',') GO TO 26300
C END OF PHRASE?
         IF(INBUF(I).NE.' ') GO TO 26150
C SPACE?
         IF(CP.NE.1) WP=WP+1
         CP=1
         GO TO 26200
26150         IF(WP.EQ.1) P1(CP)=INBUF(I)
C STUFF INTO HOLDER.
         IF(WP.EQ.2) P2(CP)=INBUF(I)
         CP=MIN0(CP+1,6)
26200       CONTINUE
C
26300       PRSCON=1
C KILL REST OF LINE.
       IF(P1(1).NE.' ') GO TO 26400
C ANY INPUT?
       CALL RSPEAK(856)
C NO, HO HUM.
       RETURN
C
26400       CALL ENCRYP(P1,CH)
C COMPUTE RESPONSE.
       IF(P2(1).NE.' ') GO TO 26600
C TWO PHRASES?
C
       IF(SPELLF) GO TO 26550
C HE'S TRYING TO LEARN.
       IF(ZAND(RFLAG(TSTRS),RSEEN).EQ.0) GO TO 26575
       SPELLF=.TRUE.
C TELL HIM.
       TELFLG=.TRUE.
       WRITE(OUTCH,26510) P1,CH
26510       FORMAT(' A hollow voice replies:  "',6A1,1X,6A1,'".')
       RETURN
C
26550       CALL RSPEAK(857)
C HE'S GOT ONE ALREADY.
       RETURN
C
26575       CALL RSPEAK(858)
C HE'S NOT IN ENDGAME.
       RETURN
C
26600       IF(ZAND(RFLAG(TSTRS),RSEEN).NE.0) GO TO 26800
       DO 26700 I=1,6
         IF(P2(I).NE.CH(I)) GO TO 26575
C WRONG.
26700       CONTINUE
       SPELLF=.TRUE.
C IT WORKS.
       CALL RSPEAK(859)
       CTICK(CEVSTE)=1
C FORCE START.
       RETURN
C
26800       CALL RSPEAK(855)
C TOO LATE.
       RETURN
C SVERBS, PAGE 8
C
C V96--       ANSWER
C
27000       IF((PRSCON.GT.1).AND.
     1       (HERE.EQ.FDOOR).AND.INQSTF)
     2       GO TO 27100
       CALL RSPEAK(799)
C NO ONE LISTENS.
       PRSCON=1
       RETURN
C
27100       K=1
C POINTER INTO ANSSTR.
       DO 27300 J=1,28,2
C CHECK ANSWERS.
         NEWK=K+ANSWER(J+1)
C COMPUTE NEXT K.
         IF(QUESNO.NE.ANSWER(J)) GO TO 27300
C ONLY CHECK PROPER ANS.
         I=PRSCON-1
C SCAN ANSWER.
         DO 27200 L=K,NEWK-1
27150           I=I+1
C SKIP INPUT BLANKS.
           IF(I.GT.INLNT) GO TO 27300
C END OF INPUT? LOSE.
           IF(INBUF(I).EQ.' ') GO TO 27150
           IF(INBUF(I).NE.ANSSTR(L)) GO TO 27300
27200         CONTINUE
         GO TO 27500
C RIGHT ANSWER.
27300       K=NEWK
C
       PRSCON=1
C KILL REST OF LINE.
       NQATT=NQATT+1
C WRONG, CRETIN.
       IF(NQATT.GE.5) GO TO 27400
C TOO MANY WRONG?
       CALL RSPEAK(800+NQATT)
C NO, TRY AGAIN.
       RETURN
C
27400       CALL RSPEAK(826)
C ALL OVER.
       CFLAG(CEVINQ)=.FALSE.
C LOSE.
       RETURN
C
27500       PRSCON=1
C KILL REST OF LINE.
       CORRCT=CORRCT+1
C GOT IT RIGHT.
       CALL RSPEAK(800)
C HOORAY.
       IF(CORRCT.GE.3) GO TO 27600
C WON TOTALLY?
       CTICK(CEVINQ)=2
C NO, START AGAIN.
       QUESNO=MOD(QUESNO+3,8)
       NQATT=0
       CALL RSPEAK(769)
C ASK NEXT QUESTION.
       CALL RSPEAK(770+QUESNO)
       RETURN
C
27600       CALL RSPEAK(827)
C QUIZ OVER,
       CFLAG(CEVINQ)=.FALSE.
       OFLAG2(QDOOR)=ZOR(OFLAG2(QDOOR),OPENBT)
C OPEN DOOR.
       RETURN
C
       END

C PRINCR- PRINT CONTENTS OF ROOM
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       SUBROUTINE PRINCR(FULL,RM)
       IMPLICIT INTEGER (A-Z)
       LOGICAL QEMPTY,QHERE,FULL, test
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,ENDGMF,FROBZF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,ENDGMF,FROBZF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVGUA,RVSND
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
*
*   Added to get full descriptions of egg and canary to print (as
*   they it once did).
*
*   The SAVE declaration is unneeded in most forms of Fortran,
*   because they default to static variables anyway.
*
*   "nest" refers to the birds nest, and is a hard-wired fix.

       save nest
       integer nest
       data nest /153/
C PRINCR, PAGE 2
C
       J=329    
C ASSUME SUPERBRIEF FORMAT.
       DO 500 I=1,OLNT 
C LOOP ON OBJECTS
         IF(.NOT.QHERE(I,RM).OR.(ZAND(OFLAG1(I),(VISIBT+NDSCBT)).NE.
     1       VISIBT).OR.(I.EQ.AVEHIC(WINNER))) GO TO 500
         IF(.NOT.FULL.AND.(SUPERF.OR.(BRIEFF.AND.
     1       (ZAND(RFLAG(HERE),RSEEN).NE.0)))) GO TO 200
C
C DO LONG DESCRIPTION OF OBJECT.
C
         K=ODESCO(I)    
C GET UNTOUCHED.
         IF((K.EQ.0).OR.(ZAND(OFLAG2(I),TCHBT).NE.0)) K=ODESC1(I)
         CALL RSPEAK(K) 
C DESCRIBE.
         GO TO 500
C DO SHORT DESCRIPTION OF OBJECT.
C
200         CALL RSPSUB(J,ODESC2(I))   
C YOU CAN SEE IT.
         J=502
C
500       CONTINUE
C
C NOW LOOP TO PRINT CONTENTS OF OBJECTS IN ROOM.
C
       DO 1000 I=1,OLNT 
C LOOP ON OBJECTS.
         IF(.NOT.QHERE(I,RM).OR.(ZAND(OFLAG1(I),(VISIBT+NDSCBT)).NE.
     1       VISIBT)) GO TO 1000
         IF(ZAND(OFLAG2(I),ACTRBT).NE.0) CALL INVENT(OACTOR(I))
         IF(((ZAND(OFLAG1(I),TRANBT).EQ.0).AND.(ZAND(OFLAG2(I),OPENBT)
     1       .EQ.0)).OR.QEMPTY(I)) GO TO 1000
C
C OBJECT IS NOT EMPTY AND IS OPEN OR TRANSPARENT.
C

* Lower case text reflects "fix" of egg's and canary's long
* description conditions.

* Includes a jump out of a structured IF to prevent a second
* (short) description of these special object's contents.

* Open egg with untouched canary inside?
      if (i .eq. egg) then
       test = zand(oflag2(canar),tchbt).eq.0 .and. (ocan(canar).eq.egg)
       if (test) then
         k = odesco(canar)
         call rspeak(k)
         go to 1000
       endif
      endif

* Open, broken egg with untouched, broken canary inside?
      if (i .eq. begg) then
       test = zand(oflag2(bcana),tchbt).eq.0.and. (ocan(bcana).eq.begg)
       if (test) then
         k = odesco(bcana)
         call rspeak(k)
         go to 1000
       endif
      endif

* Nest with untouched egg inside?
      if (i .eq. nest) then
       test = zand(oflag2(egg),tchbt) .eq. 0 .and. (ocan(egg).eq.nest)
       if (test) then
         k = odesco(egg)
         call rspeak(k)
         go to 1000
       endif
      endif
*
* End of modifications.
*
         J=573
         IF(I.NE.TCASE) GO TO 600  
C TROPHY CASE?
         J=574
         IF((BRIEFF.OR.SUPERF).AND. .NOT.FULL) GO TO 1000
600         CALL PRINCO(I,J) 
C PRINT CONTENTS.
C
1000       CONTINUE
       RETURN
C
       END
C INVENT- PRINT CONTENTS OF ADVENTURER
C
C DECLARATIONS
C
       SUBROUTINE INVENT(ADV)
       IMPLICIT INTEGER (A-Z)
       LOGICAL QEMPTY
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C INVENT, PAGE 2
C
       I=575   
C FIRST LINE.
       IF(ADV.NE.PLAYER) I=576 
C IF NOT ME.
       DO 10 J=1,OLNT    
C LOOP
         IF((OADV(J).NE.ADV).OR.(ZAND(OFLAG1(J),VISIBT).EQ.0))
     1       GO TO 10
         CALL RSPSUB(I,ODESC2(AOBJ(ADV)))
         I=0
         CALL RSPSUB(502,ODESC2(J))
10       CONTINUE
C
       IF(I.EQ.0) GO TO 25 
C ANY OBJECTS?
       IF(ADV.EQ.PLAYER) CALL RSPEAK(578)   
C NO, TELL HIM.
       RETURN
C
25       DO 100 J=1,OLNT    
C LOOP.
         IF((OADV(J).NE.ADV).OR.(ZAND(OFLAG1(J),VISIBT).EQ.0).OR.
     1       ((ZAND(OFLAG1(J),TRANBT).EQ.0).AND.
     2       (ZAND(OFLAG2(J),OPENBT).EQ.0))) GO TO 100
         IF(.NOT.QEMPTY(J)) CALL PRINCO(J,573)   
C IF NOT EMPTY, LIST.
100       CONTINUE
       RETURN
C
       END
C PRINCO-       PRINT CONTENTS OF OBJECT
C
C DECLARATIONS
C
       SUBROUTINE PRINCO(OBJ,DESC)
       IMPLICIT INTEGER(A-Z)
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       CALL RSPSUB(DESC,ODESC2(OBJ))  
C PRINT HEADER.
       DO 100 I=1,OLNT    
C LOOP THRU.
         IF(OCAN(I).EQ.OBJ) CALL RSPSUB(502,ODESC2(I))
100       CONTINUE
       RETURN
C
       END
C MOVETO- MOVE PLAYER TO NEW ROOM
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       LOGICAL FUNCTION MOVETO(NR,WHO)
       IMPLICIT INTEGER (A-Z)
       LOGICAL NLV,LHR,LNR
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C MOVETO, PAGE 2
C
       MOVETO=.FALSE.    
C ASSUME FAILS.
       LHR=ZAND(RFLAG(HERE),RLAND).NE.0   
C LAND  HERE FLAG.
       LNR=ZAND(RFLAG(NR),RLAND).NE.0  
C LAND THERE FLAG.
       J=AVEHIC(WHO) 
C HIS VEHICLE
C
       IF(J.NE.0) GO TO 100 
C IN VEHICLE?
       IF(LNR) GO TO 500 
C NO, GOING TO LAND?
       CALL RSPEAK(427) 
C CAN'T GO WITHOUT VEHICLE.
       RETURN
C
100       BITS=0   
C ASSUME NOWHERE.
       IF(J.EQ.RBOAT) BITS=RWATER  
C IN BOAT?
       IF(J.EQ.BALLO) BITS=RAIR  
C IN BALLOON?
       IF(J.EQ.BUCKE) BITS=RBUCK  
C IN BUCKET?
       NLV=ZAND(RFLAG(NR),BITS).EQ.0   
C GOT WRONG VEHICLE FLAG.
       IF((.NOT.LNR .AND.NLV) .OR.
     1       (LNR.AND.LHR.AND.NLV.AND.(BITS.NE.RLAND)))
     2       GO TO 800 
C GOT WRONG VEHICLE?
C
500       MOVETO=.TRUE.    
C MOVE SHOULD SUCCEED.
       IF(ZAND(RFLAG(NR),RMUNG).EQ.0) GO TO 600 
C ROOM MUNGED?
       CALL RSPEAK(RVAL(NR)) 
C YES, TELL HOW.
       RETURN
C
600       IF(WHO.NE.PLAYER) CALL NEWSTA(AOBJ(WHO),0,NR,0,0)
       IF(J.NE.0) CALL NEWSTA(J,0,NR,0,0)
       HERE=NR
       AROOM(WHO)=HERE
       CALL SCRUPD(RVAL(NR)) 
C SCORE ROOM
       RVAL(NR)=0
       RETURN
C
800       CALL RSPSUB(428,ODESC2(J))  
C WRONG VEHICLE.
       RETURN
       END
C SCORE-- PRINT OUT CURRENT SCORE
C
C DECLARATIONS
C
       SUBROUTINE SCORE(FLG)
       IMPLICIT INTEGER (A-Z)
       LOGICAL FLG
       INTEGER RANK(10),ERANK(5)
C
C GAME STATE
C
       LOGICAL TELFLG
       CHARACTER*2 MMOVE
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
       COMMON /CHAN/ INPCH,OUTCH,DBCH,ZRECL
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
C FUNCTIONS AND DATA
C
       DATA RANK/20,19,18,16,12,8,4,2,1,0/
       DATA ERANK/20,15,10,5,0/
C SCORE, PAGE 2
C
       IF(FLG)AS=0
C      STATEMENT ABOVE IS A DUMMY
       MMOVE = '. '
       IF(MOVES.NE.1)MMOVE = 's.'
       AS=ASCORE(WINNER)
       IF(ENDGMF) GO TO 60 
C ENDGAME?
       WRITE(OUTCH,120) AS,MXSCOR,MOVES,MMOVE
       DO 10 I=1,10
         IF((AS*20/MXSCOR).GE.RANK(I)) GO TO 50
10       CONTINUE
50       CALL RSPEAK(484+I)
       RETURN
C
60     WRITE(OUTCH,130) EGSCOR,EGMXSC,MOVES,MMOVE
       DO 70 I=1,5
         IF((EGSCOR*20/EGMXSC).GE.ERANK(I)) GO TO 80
70       CONTINUE
80       CALL RSPEAK(786+I)
       RETURN
C
120       FORMAT(' Your score is',I4,' [total of',I4,' points], in'
     1       ,I5,' move',A2)
130       FORMAT(' Your score in the endgame is',I4,' [total of',I4,
     1       ' points], in',I5,' move',A2)
C
       END
C SCRUPD- UPDATE WINNER'S SCORE
C
C DECLARATIONS
C
       SUBROUTINE SCRUPD(N)
       IMPLICIT INTEGER (A-Z)
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1       CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2       CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3       CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     5       CEVMRS,CEVPIN,CEVINQ,CEVFOL
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
       IF(ENDGMF) GO TO 100 
C ENDGAME?
       ASCORE(WINNER)=ASCORE(WINNER)+N  
C UPDATE SCORE
       RWSCOR=RWSCOR+N    
C UPDATE RAW SCORE
       IF(ASCORE(WINNER).LT.(MXSCOR-(10*DEATHS))) RETURN
       CFLAG(CEVEGH)=.TRUE. 
C TURN ON END GAME
       CTICK(CEVEGH)=15
       RETURN
C
100       EGSCOR=EGSCOR+N    
C UPDATE EG SCORE.
       RETURN
       END
C FINDXT- FIND EXIT FROM ROOM
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       LOGICAL FUNCTION FINDXT(DIR,RM)
       IMPLICIT INTEGER (A-Z)
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
C EXITS
C
       COMMON /EXITS/ XLNT,TRAVEL(900)
C
       COMMON /CURXT/ XTYPE,XROOM1,XSTRNG,XACTIO,XOBJ
C
       COMMON /XPARS/ XRMASK,XDMASK,XFMASK,XFSHFT,XASHFT,
     1       XELNT(4),XNORM,XNO,XCOND,XDOOR,XLFLAG
C
       FINDXT=.TRUE.    
C ASSUME WINS.
       XI=REXIT(RM)    
C FIND FIRST ENTRY.
       IF(XI.EQ.0) GO TO 1000 
C NO EXITS?
C
100       I=TRAVEL(XI)    
C GET ENTRY.
       XROOM1=ZAND(I,XRMASK) 
C ISOLATE ROOM.
       XTYPE=ZAND((ZAND(I,ZNOT(XLFLAG))/XFSHFT),XFMASK)+1
       GO TO (110,120,130,130),XTYPE  
C BRANCH ON ENTRY.
       CALL BUG(10,XTYPE)
C
130       XOBJ=ZAND(TRAVEL(XI+2),XRMASK)  
C DOOR/CEXIT- GET OBJ/FLAG.
       XACTIO=TRAVEL(XI+2)/XASHFT
120       XSTRNG=TRAVEL(XI+1) 
C DOOR/CEXIT/NEXIT - STRING.
110       XI=XI+XELNT(XTYPE) 
C ADVANCE TO NEXT ENTRY.
       IF(ZAND(I,XDMASK).EQ.DIR) RETURN   
C MATCH?
       IF(ZAND(I,XLFLAG).EQ.0) GO TO 100   
C LAST ENTRY?
1000       FINDXT=.FALSE.    
C YES, LOSE.
       RETURN
       END
C FWIM- FIND WHAT I MEAN
C
C DECLARATIONS
C
       INTEGER FUNCTION FWIM(F1,F2,RM,CON,ADV,NOCARE)
       IMPLICIT INTEGER (A-Z)
       LOGICAL NOCARE
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       FWIM=0   
C ASSUME NOTHING.
       DO 1000 I=1,OLNT 
C LOOP
         IF(((RM.EQ.0).OR.(OROOM(I).NE.RM)) .AND.
     1       ((ADV.EQ.0).OR.(OADV(I).NE.ADV)) .AND.
     2       ((CON.EQ.0).OR.(OCAN(I).NE.CON)))
     3       GO TO 1000
C
C OBJECT IS ON LIST... IS IT A MATCH?
C
         IF(ZAND(OFLAG1(I),VISIBT).EQ.0) GO TO 1000
         IF((.NOT.NOCARE .AND.(ZAND(OFLAG1(I),TAKEBT).EQ.0)) .OR.
     1       ((ZAND(OFLAG1(I),F1).EQ.0).AND.
     2        (ZAND(OFLAG2(I),F2).EQ.0))) GO TO 500
         IF(FWIM.EQ.0) GO TO 400 
C ALREADY GOT SOMETHING?
         FWIM=-FWIM    
C YES, AMBIGUOUS.
         RETURN
C
400         FWIM=I   
C NOTE MATCH.
C
C DOES OBJECT CONTAIN A MATCH?
C
500         IF(ZAND(OFLAG2(I),OPENBT).EQ.0) GO TO 1000 
C CLOSED?
         DO 700 J=1,OLNT    
C NO, SEARCH CONTENTS.
           IF((OCAN(J).NE.I).OR.(ZAND(OFLAG1(J),VISIBT).EQ.0) .OR.
     1       ((ZAND(OFLAG1(J),F1).EQ.0).AND.
     2        (ZAND(OFLAG2(J),F2).EQ.0))) GO TO 700
           IF(FWIM.EQ.0) GO TO 600
           FWIM=-FWIM
           RETURN
C
600           FWIM=J
700         CONTINUE
1000       CONTINUE
       RETURN
       END
C YESNO- OBTAIN YES/NO ANSWER
C
C CALLED BY-
C
C       YES-IS-TRUE=YESNO(QUESTION,YES-STRING,NO-STRING)
C
       LOGICAL FUNCTION YESNO(Q,Y,N)
       IMPLICIT INTEGER(A-Z)
       COMMON /CHAN/ INPCH,OUTCH,DBCH,ZRECL
       CHARACTER ANS
C
100       CALL RSPEAK(Q)    
C ASK
       READ(INPCH,110) ANS 
C GET ANSWER
110       FORMAT(A1)
       IF((ANS.EQ.'Y').OR.(ANS.EQ.'y')) GO TO 200
       IF((ANS.EQ.'N').OR.(ANS.EQ.'n')) GO TO 300
       CALL RSPEAK(6)    
C SCOLD.
       GO TO 100
C
200       YESNO=.TRUE.    
C YES,
       CALL RSPEAK(Y)    
C OUT WITH IT.
       RETURN
C
300       YESNO=.FALSE.    
C NO,
       CALL RSPEAK(N)    
C LIKEWISE.
       RETURN
C
       END
C ROBADV-- STEAL WINNER'S VALUABLES
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       INTEGER FUNCTION ROBADV(ADV,NR,NC,NA)
       IMPLICIT INTEGER (A-Z)
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       ROBADV=0    
C COUNT OBJECTS
       DO 100 I=1,OLNT
         IF((OADV(I).NE.ADV).OR.(OTVAL(I).LE.0).OR.
     1       (ZAND(OFLAG2(I),SCRDBT).NE.0)) GO TO 100
         CALL NEWSTA(I,0,NR,NC,NA)  
C STEAL OBJECT
         ROBADV=ROBADV+1
100       CONTINUE
       RETURN
       END
C ROBRM-- STEAL ROOM VALUABLES
C
C DECLARATIONS
C
       INTEGER FUNCTION ROBRM(RM,PR,NR,NC,NA)
       IMPLICIT INTEGER (A-Z)
       LOGICAL PROB,QHERE
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       ROBRM=0   
C COUNT OBJECTS
       DO 100 I=1,OLNT    
C LOOP ON OBJECTS.
         IF(.NOT. QHERE(I,RM)) GO TO 100
         IF((OTVAL(I).LE.0).OR.(ZAND(OFLAG2(I),SCRDBT).NE.0).OR.
     1       (ZAND(OFLAG1(I),VISIBT).EQ.0).OR.(.NOT.PROB(PR,PR)))
     2       GO TO 50
         CALL NEWSTA(I,0,NR,NC,NA)
         ROBRM=ROBRM+1
         OFLAG2(I)=ZOR(OFLAG2(I),TCHBT)
         GO TO 100
50         IF(ZAND(OFLAG2(I),ACTRBT).NE.0)
     1       ROBRM=ROBRM+ROBADV(OACTOR(I),NR,NC,NA)
100       CONTINUE
       RETURN
       END
C WINNIN-- SEE IF VILLAIN IS WINNING
C
C DECLARATIONS
C
       LOGICAL FUNCTION WINNIN(VL,HR)
       IMPLICIT INTEGER (A-Z)
       LOGICAL PROB
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       VS=OCAPAC(VL) 
C VILLAIN STRENGTH
       PS=VS-FIGHTS(HR,.TRUE.)  
C HIS MARGIN OVER HERO
       WINNIN=PROB(90,100)
       IF(PS.GT.3) RETURN  
C +3... 90% WINNING
       WINNIN=PROB(75,85)
       IF(PS.GT.0) RETURN  
C >0... 75% WINNING
       WINNIN=PROB(50,30)
       IF(PS.EQ.0) RETURN  
C =0... 50% WINNING
       WINNIN=PROB(25,25)
       IF(VS.GT.1) RETURN  
C ANY VILLAIN STRENGTH.
       WINNIN=PROB(10,0)
       RETURN
       END
C FIGHTS-- COMPUTE FIGHT STRENGTH
C
C DECLARATIONS
C
       INTEGER FUNCTION FIGHTS(H,FLG)
       IMPLICIT INTEGER (A-Z)
       LOGICAL FLG
C
C GAME STATE
C
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
C FUNCTIONS AND DATA
C
       DATA SMAX/7/,SMIN/2/
C
       FIGHTS=SMIN+((((SMAX-SMIN)*ASCORE(H))+(MXSCOR/2))/MXSCOR)
       IF(FLG) FIGHTS=FIGHTS+ASTREN(H)
       RETURN
       END
C VILSTR-       COMPUTE VILLAIN STRENGTH
C
C DECLARATIONS
C
       INTEGER FUNCTION VILSTR(V)
       IMPLICIT INTEGER (A-Z)
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
      COMMON /VILL/ VLNT,VILLNS(4),VPROB(4),VOPPS(4),VBEST(4),VMELEE(4)
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C VILSTR, PAGE 2
C
       VILSTR=OCAPAC(V)
       IF(VILSTR.LE.0) RETURN
       IF((V.NE.THIEF).OR..NOT.THFENF) GO TO 100
       THFENF=.FALSE.    
C THIEF UNENGROSSED.
       VILSTR=MIN0(VILSTR,2)  
C NO BETTER THAN 2.
C
100       DO 200 I=1,VLNT    
C SEE IF  BEST WEAPON.
         IF((VILLNS(I).EQ.V).AND.(PRSI.EQ.VBEST(I)))
     1       VILSTR=MAX0(1,VILSTR-1)
200       CONTINUE
       RETURN
       END
C GTTIME-- GET TOTAL TIME PLAYED
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       SUBROUTINE GTTIME(T)
       IMPLICIT INTEGER(A-Z)
C
       COMMON /TIME/ PLTIME,SHOUR,SMIN,SSEC
C
       CALL ITIME(H,M,S)
       T=((H*60)+M)-((SHOUR*60)+SMIN)
       IF(T.LT.0) T=T+1440
       T=T+PLTIME
       RETURN
       END
C OPNCLS-- PROCESS OPEN/CLOSE FOR DOORS
C
C DECLARATIONS
C
       LOGICAL FUNCTION OPNCLS(OBJ,SO,SC)
       IMPLICIT INTEGER (A-Z)
       LOGICAL QOPEN
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FUNCTIONS AND DATA
C
       QOPEN(O)=ZAND(OFLAG2(O),OPENBT).NE.0
C
       OPNCLS=.TRUE. 
C ASSUME WINS.
       IF(PRSA.EQ.CLOSEW) GO TO 100   
C CLOSE?
       IF(PRSA.EQ.OPENW) GO TO 50   
C OPEN?
       OPNCLS=.FALSE. 
C LOSE
       RETURN
C
50       IF(QOPEN(OBJ)) GO TO 200   
C OPEN... IS IT?
       CALL RSPEAK(SO)
       OFLAG2(OBJ)=ZOR(OFLAG2(OBJ),OPENBT)
       RETURN
C
100       IF(.NOT.QOPEN(OBJ)) GO TO 200   
C CLOSE... IS IT?
       CALL RSPEAK(SC)
       OFLAG2(OBJ)=ZAND(OFLAG2(OBJ),ZNOT(OPENBT))
       RETURN
C
200       CALL RSPEAK(125+ZRND(3))  
C DUMMY.
       RETURN
       END
C LIT-- IS ROOM LIT?
C
C DECLARATIONS
C
       LOGICAL FUNCTION LIT(RM)
       IMPLICIT INTEGER (A-Z)
       LOGICAL QHERE
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       LIT=.TRUE.    
C ASSUME WINS
       IF(ZAND(RFLAG(RM),RLIGHT).NE.0) RETURN   
C ROOM LIT?
C
       DO 1000 I=1,OLNT 
C LOOK FOR LIT OBJ
         IF(QHERE(I,RM)) GO TO 100  
C IN ROOM?
         OA=OADV(I)    
C NO
         IF(OA.LE.0) GO TO 1000  
C ON ADV?
         IF(AROOM(OA).NE.RM) GO TO 1000   
C ADV IN ROOM?
C
C OBJ IN ROOM OR ON ADV IN ROOM
C
100         IF(ZAND(OFLAG1(I),ONBT).NE.0) RETURN   
C LIT?
         IF((ZAND(OFLAG1(I),VISIBT).EQ.0).OR.
     1       ((ZAND(OFLAG1(I),TRANBT).EQ.0).AND.
     2       (ZAND(OFLAG2(I),OPENBT).EQ.0))) GO TO 1000
C
C OBJ IS VISIBLE AND OPEN OR TRANSPARENT
C
         DO 500 J=1,OLNT
           IF((OCAN(J).EQ.I).AND.(ZAND(OFLAG1(J),ONBT).NE.0))
     1       RETURN
500         CONTINUE
1000       CONTINUE
       LIT=.FALSE.
       RETURN
       END
C WEIGHT- RETURNS SUM OF WEIGHT OF QUALIFYING OBJECTS
C
C DECLARATIONS
C
       INTEGER FUNCTION WEIGHT(RM,CN,AD)
       IMPLICIT INTEGER (A-Z)
       LOGICAL QHERE
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       WEIGHT=0
       DO 100 I=1,OLNT    
C OMIT BIG FIXED ITEMS.
         IF(OSIZE(I).GE.10000) GO TO 100   
C IF FIXED, FORGET IT.
         IF((QHERE(I,RM).AND.(RM.NE.0)).OR.
     1       ((OADV(I).EQ.AD).AND.(AD.NE.0))) GO TO 50
         J=I   
C SEE IF CONTAINED.
25         J=OCAN(J)    
C GET NEXT LEVEL UP.
         IF(J.EQ.0) GO TO 100 
C END OF LIST?
         IF(J.NE.CN) GO TO 25
50         WEIGHT=WEIGHT+OSIZE(I)
100       CONTINUE
       RETURN
       END
C GHERE--       IS GLOBAL ACTUALLY IN THIS ROOM?
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       LOGICAL FUNCTION GHERE(OBJ,RM)
       IMPLICIT INTEGER(A-Z)
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1   
       COMMON /RINDEX/ MGRAT,MAZ15   
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF   
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU   
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
       COMMON /STAR/ MBASE,STRBIT
C GHERE, PAGE 2
C
       GHERE=.TRUE.    
C ASSUME WINS.
       GO TO (1000,1000,1000,1000,1000,1000,
     1     1000,1000,1000,1000,1000,
     2       2000,3000,4000,5000,5000,5000,6000,
     3       7000,8000,9000,9100,8000,10000,11000),OBJ-STRBIT
       CALL BUG(60,OBJ)
C
C 1000--       STARS ARE ALWAYS HERE
C
1000       RETURN
C
C 2000--       BIRD
C
2000       GHERE=((RM.GE.FORE1).AND.(RM.LT.CLEAR)).OR.(RM.EQ.MTREE)
       RETURN
C
C 3000--       TREE
C
3000       GHERE=((RM.GE.FORE1).AND.(RM.LT.CLEAR)).AND.(RM.NE.FORE3)
       RETURN
C
C 4000--       NORTH WALL
C
4000       GHERE=((RM.GE.BKVW).AND.(RM.LE.BKBOX)).OR.(RM.EQ.CPUZZ)
       RETURN
C
C 5000--       EAST, SOUTH, WEST WALLS
C
5000       GHERE=((RM.GE.BKVW).AND.(RM.LT.BKBOX)).OR.(RM.EQ.CPUZZ)
       RETURN
C
C 6000--       GLOBAL WATER
C
6000       GHERE=ZAND(RFLAG(RM),(RWATER+RFILL)).NE.0
       RETURN
C
C 7000--       GLOBAL GUARDIANS
C
7000       GHERE=((RM.GE.MRC).AND.(RM.LE.MRD)).OR.
     1       ((RM.GE.MRCE).AND.(RM.LE.MRDW)).OR.(RM.EQ.INMIR)
       RETURN
C
C 8000--       ROSE/CHANNEL
C
8000       GHERE=((RM.GE.MRA).AND.(RM.LE.MRD)).OR.(RM.EQ.INMIR)
       RETURN
C
C 9000--       MIRROR
C 9100              PANEL
C
9100       IF(RM.EQ.FDOOR) RETURN 
C PANEL AT FDOOR.
9000       GHERE=((RM.GE.MRA).AND.(RM.LE.MRC)).OR.
     1       ((RM.GE.MRAE).AND.(RM.LE.MRCW))
       RETURN
C
C 10000--       MASTER
C
10000       GHERE=(RM.EQ.FDOOR).OR.(RM.EQ.NCORR).OR.(RM.EQ.PARAP).OR.
     1       (RM.EQ.CELL)
       RETURN
C
C 11000--       LADDER
C
11000       GHERE=(RM.EQ.CPUZZ)
       RETURN
C
       END
C MRHERE--       IS MIRROR HERE?
C
C DECLARATIONS
C
       INTEGER FUNCTION MRHERE(RM)
       IMPLICIT INTEGER(A-Z)
C
C ROOMS
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1   
       COMMON /RINDEX/ MGRAT,MAZ15   
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF   
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU   
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C MRHERE, PAGE 2
C
       IF((RM.LT.MRAE).OR.(RM.GT.MRDW)) GO TO 100
C
C RM IS AN E-W ROOM, MIRROR MUST BE N-S (MDIR= 0 OR 180)
C
       MRHERE=1 
C ASSUME MIRROR 1 HERE.
       IF(MOD(RM-MRAE,2).EQ.(MDIR/180)) MRHERE=2
       RETURN
C
C RM IS NORTH OR SOUTH OF MIRROR.  IF MIRROR IS N-S OR NOT
C WITHIN ONE ROOM OF RM, LOSE.
C
100       MRHERE=0
       IF((IABS(MLOC-RM).NE.1).OR.(MOD(MDIR,180).EQ.0)) RETURN
C
C RM IS WITHIN ONE OF MLOC, AND MDIR IS E-W
C
       MRHERE=1
       IF(((RM.LT.MLOC).AND.(MDIR.LT.180)).OR.
     1  ((RM.GT.MLOC).AND.(MDIR.GT.180))) MRHERE=2
       RETURN
       END
C ENCRYP--       ENCRYPT PASSWORD
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       SUBROUTINE ENCRYP(INW,OUTW)
       IMPLICIT INTEGER(A-Z)
       CHARACTER INW(6),OUTW(6),KEYW(6)
       CHARACTER UINW(6),UKEYW(6)
       DATA KEYW/'E','C','O','R','M','S'/
C
       UINWS=0   
C UNBIASED INW SUM.
       UKEYWS=0    
C UNBIASED KEYW SUM.
       J=1   
C POINTER IN KEYWORD.
       DO 100 I=1,6    
C UNBIAS, COMPUTE SUMS.
         UKEYW(I)=CHAR(ICHAR(KEYW(I))-64)   
C STRIP ASCII.
         IF(ICHAR(INW(J)).LE.64) J=1   
C RECYCLE ON BAD.
         UINW(I)=CHAR(ICHAR(INW(J))-64)
         UKEYWS=UKEYWS+ICHAR(UKEYW(I))
         UINWS=UINWS+ICHAR(UINW(I))
         J=J+1
100       CONTINUE
C
       USUM=MOD(UINWS,8)+(8*MOD(UKEYWS,8))   
C COMPUTE MASK.
       DO 200 I=1,6
         J=ZAND( ZXOR(ZXOR(ICHAR(UINW(I)),ICHAR(UKEYW(I))),USUM) ,31)
         USUM=MOD(USUM+1,32)
         IF(J.GT.26) J=MOD(J,26)
         OUTW(I)=CHAR(MAX0(1,J)+64)
200       CONTINUE
       RETURN
C
       END
C CPGOTO--       MOVE TO NEXT STATE IN PUZZLE ROOM
C
C DECLARATIONS
C
       SUBROUTINE CPGOTO(ST)
       IMPLICIT INTEGER(A-Z)
C
       COMMON /HYPER/ HFACTR
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1   
       COMMON /RINDEX/ MGRAT,MAZ15   
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF   
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU   
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C CPGOTO, PAGE 2
C
       RFLAG(CPUZZ)=ZAND(RFLAG(CPUZZ),ZNOT(RSEEN))
       DO 100 I=1,OLNT    
C RELOCATE OBJECTS.
         IF((OROOM(I).EQ.CPUZZ).AND.
     1       (ZAND(OFLAG2(I),(ACTRBT+VILLBT)).EQ.0))
     2       CALL NEWSTA(I,0,CPHERE*HFACTR,0,0)
         IF(OROOM(I).EQ.(ST*HFACTR))
     1       CALL NEWSTA(I,0,CPUZZ,0,0)
100       CONTINUE
       CPHERE=ST
       RETURN
C
       END
C CPINFO--       DESCRIBE PUZZLE ROOM
C
C DECLARATIONS
C
       SUBROUTINE CPINFO(RMK,ST)
       IMPLICIT INTEGER(A-Z)
       INTEGER DGMOFT(8)
       CHARACTER*2 DGM(8),PICT(5),QMK
C
       COMMON /CHAN/ INPCH,OUTCH,DBCH,ZRECL
C
C PUZZLE ROOM
C
       COMMON /PUZZLE/ CPDR(16),CPWL(8),CPVEC(64)
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
C FUNCTIONS AND LOCAL DATA
C
       DATA DGMOFT/-9,-8,-7,-1,1,7,8,9/
       DATA PICT/'SS','SS','SS','  ','MM'/
       DATA QMK/'??'/
C CPINFO, PAGE 2
C
       CALL RSPEAK(RMK)
       DO 100 I=1,8
         J=DGMOFT(I)
         DGM(I)=PICT(CPVEC(ST+J)+4)  
C GET PICTURE ELEMENT.
         IF((IABS(J).EQ.1).OR.(IABS(J).EQ.8)) GO TO 100
         K=8
         IF(J.LT.0) K=-8 
C GET ORTHO DIR.
         L=J-K
         IF((CPVEC(ST+K).NE.0).AND.(CPVEC(ST+L).NE.0))
     1       DGM(I)=QMK
100       CONTINUE
       WRITE(OUTCH,10) DGM
C
       IF(ST.EQ.10) CALL RSPEAK(870)  
C AT HOLE?
       IF(ST.EQ.37) CALL RSPEAK(871)  
C AT NICHE?
       I=872   
C DOOR OPEN?
       IF(CPOUTF) I=873
       IF(ST.EQ.52) CALL RSPEAK(I)  
C AT DOOR?
       IF(CPVEC(ST+1).EQ.-2) CALL RSPEAK(874)   
C EAST LADDER?
       IF(CPVEC(ST-1).EQ.-3) CALL RSPEAK(875)   
C WEST LADDER?
       RETURN
C
10       FORMAT('       |',A2,1X,A2,1X,A2,'|'/,
     1 ' West  |',A2,' .. ',A2,'|  East',/
     2'       |',A2,1X,A2,1X,A2,'|')
C
       END

C***************************************************C
C                                                   C
C  ALL THESE 'AND'S WITH 65535 ARE IMPORTANT        C
C  LEAVE THEM IN                                    C
C                                                   C
C***************************************************C
C                                                   C
C  FOR THE PC, VAX/VMS AND MY MIPS 120, THESE       C
C      WORK AS-IS.                                  C
C  FOR MANY UNIX MACHINES IAND -> AND, IOR -> OR    C
C      IEOR -> XOR                                  C
C***************************************************C
        INTEGER FUNCTION ZAND(I,J)
	IMPLICIT INTEGER(A-Z)
        ZAND = AND(AND(I,J),65535)
        RETURN
        END
        INTEGER FUNCTION ZOR(I,J)
	IMPLICIT INTEGER(A-Z)
        ZOR = AND(OR(I,J),65535)
        RETURN
        END
        INTEGER FUNCTION ZXOR(I,J)
	IMPLICIT INTEGER(A-Z)
        ZXOR = AND(XOR(I,J),65535)
        RETURN
        END
        INTEGER FUNCTION ZNOT(I)
	IMPLICIT INTEGER(A-Z)
        ZNOT = AND(XOR(I,-1),65535)
        RETURN
        END
        SUBROUTINE EXIT()
        STOP
        END
C***************************************************C
C                                                   C
C       FOR THESE TWO, YOU ARE ON YOUR OWN          C
C       ONLY ITIME REALLY MATTERS                   C
C                                                   C
C***************************************************C
	SUBROUTINE ITIME(H,M,S)
	IMPLICIT INTEGER(A-Z)
c       CALL GETTIM(H,M,S,TK)
	call gettim( h, m, s )
	RETURN
	END
        SUBROUTINE KDATE(I,J,K)
	IMPLICIT INTEGER(A-Z)
c       CALL GETDAT(I,J,K)
	i=11
	j=11
	k=11
        RETURN
        END
C***************************************************C
C                                                   C
C       THESE SHOULD BE PORTABLE                    C
C                                                   C
C***************************************************C
        SUBROUTINE INIRND(I)
	IMPLICIT INTEGER(A-Z)
        COMMON /RANSEED/J
        SAVE
        J = I
        RETURN
        END
        INTEGER FUNCTION ZRND(IRANGE)
	IMPLICIT INTEGER(A-Z)
        COMMON /RANSEED/ISEED
        SAVE
        ISEED = ISEED*69069+1
C***************************************************C
C                                                   C
C   THE ABOVE LINE IS SUPPOSED TO GENERATE          C
C   INTEGER OVERFLOWS. THEREFORE, ON VMS YOU MUST   C
C   COMPILE THIS FILE WITH /CHECK=NOOVER            C
C                                                   C
C***************************************************C
        I = 16384/IRANGE
        J = IABS(ISEED)/I
        ZRND = MOD(J,IRANGE)
        RETURN
        END
        SUBROUTINE MACHDV
        IMPLICIT INTEGER(A-Z)
        CHARACTER*20 INFMTX
        COMMON /XINFMT/ INFMTX 
        COMMON /CHAN/ INPCH,OUTCH,DBCH,ZRECL
C***************************************************C
C                                                   C
C       THE FOLLOWING 4 NUMBERS ARE FOR THE IBM-PC  C
C       AND MICROSOFT FORTRAN                       C
C                                                   C
C       FOR VAX/VMS  OR  MIPS F77 TRY 5 6 2 20      C
C       FOR F2C CONVERSIONS TRY 5 6 2 78            C
C                                                   C
C       SEE ALSO TEXTCNV.FOR                        C
C                                                   C
C***************************************************C
        INPCH = 5
        OUTCH = 6
        DBCH = 2
C       NONE OF THE ABOVE CAN BE 11, AS THAT IS USED FOR THE SAVE FILE
        ZRECL = 78
C       RECORD LENGTH FOR DIRECT ACCESS OF DTEXT.DAT        
C***************************************************C
C                                                   C
C       THE FOLLOWING WORKS FOR MOST COMPUTERS      C
C       AND F2C. SOME MACHINES MAY NEED TO HAVE     C
C       IT CHANGED TO                               C
C                                                   C
C       INFMTX='('' >''              )'
C                                                   C
C       WHILE ON SOME OTHER YOU MAY GET THE         C
C       DESIRED EFFECT BY SOME TOTALLY DIFFERENT    C
C       METHOD                                      C
C                                                   C
C***************************************************C
        INFMTX='('' >'',$            )'
C       PLEASE NOTE THAT A DOUBLE QUOTE ('') IN A STRING IS REALLY
C       A SINGLE QUOTE (')
        RETURN
        END

C TAKE-- BASIC TAKE SEQUENCE
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C TAKE AN OBJECT (FOR VERBS TAKE, PUT, DROP, READ, ETC.)
C
       LOGICAL FUNCTION TAKE(FLG)
C
C DECLARATIONS
C
       IMPLICIT INTEGER (A-Z)
       LOGICAL FLG,OBJACT,OAPPLI,QOPEN,QHERE
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
       COMMON /STAR/ MBASE,STRBIT
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C FUNCTIONS AND DATA
C
       QOPEN(O)=ZAND(OFLAG2(O),OPENBT).NE.0
C TAKE, PAGE 2
C
       TAKE=.FALSE.                            
C ASSUME LOSES.
       OA=OACTIO(PRSO)                            
C GET OBJECT ACTION.
       IF(PRSO.LE.STRBIT) GO TO 100       
C STAR?
       TAKE=OBJACT()                     
C YES, LET IT HANDLE.
       RETURN
C
100       X=OCAN(PRSO)                            
C INSIDE?
       IF(PRSO.NE.AVEHIC(WINNER)) GO TO 400       
C HIS VEHICLE?
       CALL RSPEAK(672)                     
C DUMMY.
       RETURN
C
400       IF(ZAND(OFLAG1(PRSO),TAKEBT).NE.0) GO TO 500 
C TAKEABLE?
       IF(.NOT.OAPPLI(OA,0)) CALL RSPEAK(552+ZRND(5))
       RETURN
C
C OBJECT IS TAKEABLE AND IN POSITION TO BE TAKEN.
C
500       IF((X.NE.0).OR. QHERE(PRSO,HERE)) GO TO 600
       IF(OADV(PRSO).EQ.WINNER) CALL RSPEAK(557)       
C ALREADY GOT IT?
       RETURN
C
600       IF(((X.NE.0).AND.(OADV(X).EQ.WINNER)).OR.
     1       ((WEIGHT(0,PRSO,WINNER)+OSIZE(PRSO)).LE.MXLOAD))
     2       GO TO 700
       CALL RSPEAK(558)                     
C TOO MUCH WEIGHT.
       RETURN
C
700       TAKE=.TRUE.                            
C AT LAST.
       IF(OAPPLI(OA,0)) RETURN                     
C DID IT HANDLE?
       CALL NEWSTA(PRSO,0,0,0,WINNER)              
C TAKE OBJECT FOR WINNER.
       OFLAG2(PRSO)=ZOR(OFLAG2(PRSO),TCHBT)       
C HAS BEEN TOUCHED.
       CALL SCRUPD(OFVAL(PRSO))              
C UPDATE SCORE.
       OFVAL(PRSO)=0                            
C CANT BE SCORED AGAIN.
       IF(FLG) CALL RSPEAK(559)              
C TELL TAKEN.
       RETURN
C
       END
C DROP- DROP VERB PROCESSOR
C
C DECLARATIONS
C
       LOGICAL FUNCTION DROP()
       IMPLICIT INTEGER (A-Z)
       LOGICAL F,PUT,OBJACT
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C ROOMS
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1
       COMMON /RINDEX/ MGRAT,MAZ15
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C DROP, PAGE 2
C
       DROP=.TRUE.                            
C ASSUME WINS.
       X=OCAN(PRSO)                            
C GET CONTAINER.
       IF(X.EQ.0) GO TO 200                     
C IS IT INSIDE?
       IF(OADV(X).NE.WINNER) GO TO 1000       
C IS HE CARRYING CON?
       IF(ZAND(OFLAG2(X),OPENBT).NE.0) GO TO 300 
C IS IT OPEN?
       CALL RSPSUB(525,ODESC2(X))              
C CANT REACH.
       RETURN
C
200       IF(OADV(PRSO).NE.WINNER) GO TO 1000       
C IS HE CARRYING OBJ?
300       IF(AVEHIC(WINNER).EQ.0) GO TO 400       
C IS HE IN VEHICLE?
       PRSI=AVEHIC(WINNER)                     
C YES,
       F=PUT()                            
C DROP INTO VEHICLE.
       PRSI=0                                   
C DISARM PARSER.
       RETURN                                   
C DONE.
C
400       CALL NEWSTA(PRSO,0,HERE,0,0)              
C DROP INTO ROOM.
       IF(HERE.EQ.MTREE) CALL NEWSTA(PRSO,0,FORE3,0,0)
       CALL SCRUPD(OFVAL(PRSO))              
C SCORE OBJECT.
       OFVAL(PRSO)=0                            
C CANT BE SCORED AGAIN.
       OFLAG2(PRSO)=ZOR(OFLAG2(PRSO),TCHBT)       
C HAS BEEN TOUCHED.
C
       IF(OBJACT()) RETURN                     
C DID IT HANDLE?
       I=0                                   
C ASSUME NOTHING TO SAY.
       IF(PRSA.EQ.DROPW) I=528
       IF(PRSA.EQ.THROWW) I=529
       IF((I.NE.0).AND.(HERE.EQ.MTREE)) I=659
       CALL RSPSUB(I,ODESC2(PRSO))
       RETURN
C
1000       CALL RSPEAK(527)                     
C DONT HAVE IT.
       RETURN
C
       END
C PUT- PUT VERB PROCESSOR
C
C DECLARATIONS
C
       LOGICAL FUNCTION PUT()
       IMPLICIT INTEGER (A-Z)
       LOGICAL QOPEN,QHERE,OBJACT,TAKE
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C MISCELLANEOUS VARIABLES
C
       COMMON /STAR/ MBASE,STRBIT
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FUNCTIONS AND DATA
C
       QOPEN(R)=ZAND(OFLAG2(R),OPENBT).NE.0
C PUT, PAGE 2
C
       PUT=.FALSE.
       IF((PRSO.LE.STRBIT).AND.(PRSI.LE.STRBIT)) GO TO 200
       IF(.NOT.OBJACT()) CALL RSPEAK(560)              
C STAR
       PUT=.TRUE.
       RETURN
C
200       IF(QOPEN(PRSI).OR.(ZAND(OFLAG1(PRSI),(DOORBT+CONTBT)).NE.0)
     1       .OR.(ZAND(OFLAG2(PRSI),VEHBT).NE.0)) GO TO 300
       CALL RSPEAK(561)                     
C CANT PUT IN THAT.
       RETURN
C
300       IF(QOPEN(PRSI)) GO TO 400              
C IS IT OPEN?
       CALL RSPEAK(562)                     
C NO, JOKE
       RETURN
C
400       IF(PRSO.NE.PRSI) GO TO 500              
C INTO ITSELF?
       CALL RSPEAK(563)                     
C YES, JOKE.
       RETURN
C
500       IF(OCAN(PRSO).NE.PRSI) GO TO 600       
C ALREADY INSIDE.
       CALL RSPSB2(564,ODESC2(PRSO),ODESC2(PRSI))
       PUT=.TRUE.
       RETURN
C
600       IF((WEIGHT(0,PRSO,0)+WEIGHT(0,PRSI,0)+OSIZE(PRSO))
     1       .LE.OCAPAC(PRSI)) GO TO 700       
C NOT TOO FULL?
       CALL RSPEAK(565)                     
C THEN CANT DO IT.
       RETURN
C
C NOW SEE IF OBJECT (OR ITS CONTAINER) IS IN ROOM
C
700       J=PRSO                                   
C START SEARCH.
725       IF(QHERE(J,HERE)) GO TO 750              
C IS IT HERE?
       J=OCAN(J)
       IF(J.NE.0) GO TO 725                     
C MORE TO DO?
       GO TO 800                            
C NO, SCH FAILS.
C
750       SVO=PRSO                            
C SAVE PARSER.
       SVI=PRSI
       PRSA=TAKEW
       PRSI=0
       IF(.NOT.TAKE(.FALSE.)) RETURN              
C TAKE OBJECT.
       PRSA=PUTW
       PRSO=SVO
       PRSI=SVI
       GO TO 1000
C
C NOW SEE IF OBJECT IS ON PERSON.
C
800       IF(OCAN(PRSO).EQ.0) GO TO 1000              
C INSIDE?
       IF(QOPEN(OCAN(PRSO))) GO TO 900              
C OPEN?
       CALL RSPSUB(566,ODESC2(PRSO))              
C LOSE.
       RETURN
C
900       CALL SCRUPD(OFVAL(PRSO))              
C SCORE OBJECT.
       OFVAL(PRSO)=0
       OFLAG2(PRSO)=ZOR(OFLAG2(PRSO),TCHBT)       
C HAS BEEN TOUCHED.
       CALL NEWSTA(PRSO,0,0,0,WINNER)              
C TEMPORARILY ON WINNER.
C
1000       IF(OBJACT()) RETURN                     
C NO, GIVE OBJECT A SHOT.
       CALL NEWSTA(PRSO,2,0,PRSI,0)              
C CONTAINED INSIDE.
       PUT=.TRUE.
       RETURN
C
       END
C VALUAC- HANDLES VALUABLES/EVERYTHING
C
C DECLARATIONS
C
       SUBROUTINE VALUAC(V)
       IMPLICIT INTEGER (A-Z)
       LOGICAL LIT,F,F1,TAKE,PUT,DROP,NOTVAL,QHERE
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FUNCTIONS AND DATA
C
       NOTVAL(R)=(SAVEP.EQ.V).AND.(OTVAL(R).LE.0)
C VALUAC, PAGE 2
C
       F=.TRUE.                            
C ASSUME NO ACTIONS.
       I=579                                   
C ASSUME NOT LIT.
       IF(.NOT.LIT(HERE)) GO TO 4000              
C IF NOT LIT, PUNT.
       I=677                                   
C ASSUME WRONG VERB.
       SAVEP=PRSO                            
C SAVE PRSO.
       SAVEH=HERE                            
C SAVE HERE.
C
100       IF(PRSA.NE.TAKEW) GO TO 1000              
C TAKE EVERY/VALUA?
       DO 500 PRSO=1,OLNT                     
C LOOP THRU OBJECTS.
         IF(.NOT.QHERE(PRSO,HERE).OR.
     1       (ZAND(OFLAG1(PRSO),VISIBT).EQ.0).OR.
     2       (ZAND(OFLAG2(PRSO),ACTRBT).NE.0).OR.
     3       NOTVAL(PRSO)) GO TO 500
         IF((ZAND(OFLAG1(PRSO),TAKEBT).EQ.0).AND.
     1       (ZAND(OFLAG2(PRSO),TRYBT).EQ.0)) GO TO 500
         F=.FALSE.
         CALL RSPSUB(580,ODESC2(PRSO))
         F1=TAKE(.TRUE.)
         IF(SAVEH.NE.HERE) RETURN
500       CONTINUE
       GO TO 3000
C
1000       IF(PRSA.NE.DROPW) GO TO 2000              
C DROP EVERY/VALUA?
       DO 1500 PRSO=1,OLNT
         IF((OADV(PRSO).NE.WINNER).OR.NOTVAL(PRSO))
     1       GO TO 1500
         F=.FALSE.
         CALL RSPSUB(580,ODESC2(PRSO))
         F1=DROP()
         IF(SAVEH.NE.HERE) RETURN
1500       CONTINUE
       GO TO 3000
C
2000       IF(PRSA.NE.PUTW) GO TO 3000              
C PUT EVERY/VALUA?
       DO 2500 PRSO=1,OLNT                     
C LOOP THRU OBJECTS.
         IF((OADV(PRSO).NE.WINNER)
     1       .OR.(PRSO.EQ.PRSI).OR.NOTVAL(PRSO).OR.
     2       (ZAND(OFLAG1(PRSO),VISIBT).EQ.0)) GO TO 2500
         F=.FALSE.
         CALL RSPSUB(580,ODESC2(PRSO))
         F1=PUT()
         IF(SAVEH.NE.HERE) RETURN
2500       CONTINUE
C
3000       I=581
       IF(SAVEP.EQ.V) I=582                     
C CHOOSE MESSAGE.
4000       IF(F) CALL RSPEAK(I)                     
C IF NOTHING, REPORT.
       RETURN
       END

C NOBJS-       NEW OBJECTS PROCESSOR
C       OBJECTS IN THIS MODULE CANNOT CALL RMINFO, JIGSUP,
C       MAJOR VERBS, OR OTHER NON-RESIDENT SUBROUTINES
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       LOGICAL FUNCTION NOBJS(RI,ARG)
       IMPLICIT INTEGER (A-Z)
       LOGICAL QOPEN,MOVETO,F
       LOGICAL QHERE,OPNCLS,MIRPAN
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C SCREEN OF LIGHT
C
       COMMON /SCREEN/ FROMDR,SCOLRM,SCOLAC
       COMMON /SCREEN/ SCOLDR(8),SCOLWL(12)
C
C PUZZLE ROOM
C
       COMMON /PUZZLE/ CPDR(16),CPWL(8),CPVEC(64)
C
C MISCELLANEOUS VARIABLES
C
       COMMON /HYPER/ HFACTR
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1
       COMMON /RINDEX/ MGRAT,MAZ15
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1       CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2       CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3       CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     5       CEVMRS,CEVPIN,CEVINQ,CEVFOL
 
C
C VILLAINS AND DEMONS
C
       LOGICAL THFFLG,SWDACT,THFACT
       COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
C FUNCTIONS AND DATA
C
       QOPEN(R)=ZAND(OFLAG2(R),OPENBT).NE.0
       I=ARG       
C NOBJS, PAGE 2
C
       IF(PRSO.NE.0) ODO2=ODESC2(PRSO)
       IF(PRSI.NE.0) ODI2=ODESC2(PRSI)
       AV=AVEHIC(WINNER)
       NOBJS=.TRUE.
C
       GO TO (1000,2000,3000,4000,5000,6000,7000,8000,9000,
     1 10000,11000,12000,13000,14000,15000,16000,17000,
     2 18000,19000,20000,21000),
     3       (RI-31)
       CALL BUG(6,RI)
C
C RETURN HERE TO DECLARE FALSE RESULT
C
10       NOBJS=.FALSE.
       RETURN
C
C O32--       BILLS
C
1000       IF(PRSA.NE.EATW) GO TO 1100
C EAT?
       CALL RSPEAK(639)
C JOKE.
       RETURN
C
1100       IF(PRSA.EQ.BURNW) CALL RSPEAK(640)
C BURN?  JOKE.
       GO TO 10
C LET IT BE HANDLED.
C NOBJS, PAGE 3
C
C O33--       SCREEN OF LIGHT
C
2000       TARGET=SCOL
C TARGET IS SCOL.
2100       IF(PRSO.NE.TARGET) GO TO 2400
C PRSO EQ TARGET?
       IF((PRSA.NE.PUSHW).AND.(PRSA.NE.MOVEW).AND.
     1       (PRSA.NE.TAKEW).AND.(PRSA.NE.RUBW)) GO TO 2200
       CALL RSPEAK(673)
C HAND PASSES THRU.
       RETURN
C
2200       IF((PRSA.NE.KILLW).AND.(PRSA.NE.ATTACW).AND.
     1       (PRSA.NE.MUNGW)) GO TO 2400
C AGGRESSIVE?
       CALL RSPSUB(674,ODI2)
C PASSES THRU.
       RETURN
C
2400       IF((PRSA.NE.THROWW).OR.(PRSI.NE.TARGET)) GO TO 10
       IF(HERE.EQ.BKBOX) GO TO 2600
C THRU SCOL?
       CALL NEWSTA(PRSO,0,BKBOX,0,0)
C NO, THRU WALL.
       CALL RSPSUB(675,ODO2)
C ENDS UP IN BOX ROOM.
       CTICK(CEVSCL)=0
C CANCEL ALARM.
       SCOLRM=0
C RESET SCOL ROOM.
       RETURN
C
2600       IF(SCOLRM.EQ.0) GO TO 2900
C TRIED TO GO THRU?
       CALL NEWSTA(PRSO,0,SCOLRM,0,0)
C SUCCESS.
       CALL RSPSUB(676,ODO2)
C ENDS UP SOMEWHERE.
       CTICK(CEVSCL)=0
C CANCEL ALARM.
       SCOLRM=0
C RESET SCOL ROOM.
       RETURN
C
2900       CALL RSPEAK(213)
C CANT DO IT.
       RETURN
C NOBJS, PAGE 4
C
C O34--       GNOME OF ZURICH
C
3000       IF((PRSA.NE.GIVEW).AND.(PRSA.NE.THROWW)) GO TO 3200
       IF(OTVAL(PRSO).NE.0) GO TO 3100
C THROW A TREASURE?
       CALL NEWSTA(PRSO,641,0,0,0)
C NO, GO POP.
       RETURN
C
3100       CALL NEWSTA(PRSO,0,0,0,0)
C YES, BYE BYE TREASURE.
       CALL RSPSUB(642,ODO2)
       CALL NEWSTA(ZGNOM,0,0,0,0)
C BYE BYE GNOME.
       CTICK(CEVZGO)=0
C CANCEL EXIT.
       F=MOVETO(BKENT,WINNER)
C NOW IN BANK ENTRANCE.
       RETURN
C
3200       IF((PRSA.NE.ATTACW).AND.(PRSA.NE.KILLW).AND.
     1       (PRSA.NE.MUNGW)) GO TO 3300
C AGGRESSIVE?
       CALL NEWSTA(ZGNOM,643,0,0,0)
C VANISH GNOME.
       CTICK(CEVZGO)=0
C CANCEL EXIT.
       RETURN
C
3300       CALL RSPEAK(644)
C GNOME IS IMPATIENT.
       RETURN
C
C O35--       EGG
C
4000       IF((PRSA.NE.OPENW).OR.(PRSO.NE.EGG)) GO TO 4500
       IF(.NOT.QOPEN(EGG)) GO TO 4100
C OPEN ALREADY?
       CALL RSPEAK(649)
C YES.
       RETURN
C
4100       IF(PRSI.NE.0) GO TO 4200
C WITH SOMETHING?
       CALL RSPEAK(650)
C NO, CANT.
       RETURN
C
4200       IF(PRSI.NE.HANDS) GO TO 4300
C WITH HANDS?
       CALL RSPEAK(651)
C NOT RECOMMENDED.
       RETURN
C
4300       I=652
C MUNG MESSAGE.
       IF((ZAND(OFLAG1(PRSI),TOOLBT).NE.0).OR.
     1       (ZAND(OFLAG2(PRSI),WEAPBT).NE.0)) GO TO 4600
       I=653
C NOVELTY 1.
       IF(ZAND(OFLAG2(PRSO),FITEBT).NE.0) I=654 
C NOVELTY 2.
       OFLAG2(PRSO)=ZOR(OFLAG2(PRSO),FITEBT)
       CALL RSPSUB(I,ODI2)
       RETURN
C
4500       IF((PRSA.NE.OPENW).AND.(PRSA.NE.MUNGW)) GO TO 4800
       I=655
C YOU BLEW IT.
4600       CALL NEWSTA(BEGG,I,OROOM(EGG),OCAN(EGG),OADV(EGG))
       CALL NEWSTA(EGG,0,0,0,0)
C VANISH EGG.
       OTVAL(BEGG)=2
C BAD EGG HAS VALUE.
       IF(OCAN(CANAR).NE.EGG) GO TO 4700
C WAS CANARY INSIDE?
       CALL RSPEAK(ODESCO(BCANA))
C YES, DESCRIBE RESULT.
       OTVAL(BCANA)=1
       RETURN
C
4700       CALL NEWSTA(BCANA,0,0,0,0)
C NO, VANISH IT.
       RETURN
C
4800       IF((PRSA.NE.DROPW).OR.(HERE.NE.MTREE)) GO TO 10
       CALL NEWSTA(BEGG,658,FORE3,0,0)
C DROPPED EGG.
       CALL NEWSTA(EGG,0,0,0,0)
       OTVAL(BEGG)=2
       IF(OCAN(CANAR).NE.EGG) GO TO 4700
       OTVAL(BCANA)=1
C BAD CANARY.
       RETURN
C NOBJS, PAGE 5
C
C O36--       CANARIES, GOOD AND BAD
C
5000       IF(PRSA.NE.WINDW) GO TO 10
C WIND EM UP?
       IF(PRSO.EQ.CANAR) GO TO 5100
C RIGHT ONE?
       CALL RSPEAK(645)
C NO, BAD NEWS.
       RETURN
C
5100       IF(.NOT.SINGSF.AND.((HERE.EQ.MTREE).OR.
     1       ((HERE.GE.FORE1).AND.(HERE.LT.CLEAR))))
     2       GO TO 5200
C FIRST SONG IN FOR?
       CALL RSPEAK(646)
C NO, MEDIOCRE NEWS.
       RETURN
C
5200       SINGSF=.TRUE.
C SANG SONG.
       I=HERE
       IF(I.EQ.MTREE) I=FORE3
C PLACE BAUBLE.
       CALL NEWSTA(BAUBL,647,I,0,0)
       RETURN
C
C O37--       WHITE CLIFFS
C
6000       IF((PRSA.NE.CLMBW).AND.(PRSA.NE.CLMBUW).AND.
     1       (PRSA.NE.CLMBDW)) GO TO 10
C CLIMB?
       CALL RSPEAK(648)
C OH YEAH?
       RETURN
C
C O38--       WALL 
C
7000       IF((IABS(HERE-MLOC).NE.1).OR.(MRHERE(HERE).NE.0).OR.
     1       (PRSA.NE.PUSHW)) GO TO 7100
       CALL RSPEAK(860)
C PUSHED MIRROR WALL.
       RETURN
C
7100       IF(ZAND(RFLAG(HERE),RNWALL).EQ.0) GO TO 10
       CALL RSPEAK(662)
C NO WALL.
       RETURN
C NOBJS, PAGE 6
C
C O39--       SONG BIRD GLOBAL
C
8000       IF(PRSA.NE.FINDW) GO TO 8100
C FIND?
       CALL RSPEAK(666)
       RETURN
C
8100       IF(PRSA.NE.EXAMIW) GO TO 10
C EXAMINE?
       CALL RSPEAK(667)
       RETURN
C
C O40--       PUZZLE/SCOL WALLS
C
9000       IF(HERE.NE.CPUZZ) GO TO 9500
C PUZZLE WALLS?
       IF(PRSA.NE.PUSHW) GO TO 10
C PUSH?
       DO 9100 I=1,8,2
C LOCATE WALL.
         IF(PRSO.EQ.CPWL(I)) GO TO 9200
9100       CONTINUE
       CALL BUG(80,PRSO)
C WHAT?
C
9200       J=CPWL(I+1)
C GET DIRECTIONAL OFFSET.
       NXT=CPHERE+J
C GET NEXT STATE.
       WL=CPVEC(NXT)
C GET C(NEXT STATE).
       GO TO (9300,9300,9300,9250,9350),(WL+4)
C PROCESS.
C
9250       CALL RSPEAK(876)
C CLEAR CORRIDOR.
       RETURN
C
9300       IF(CPVEC(NXT+J).EQ.0) GO TO 9400
C MOVABLE, ROOM TO MOVE?
9350       CALL RSPEAK(877)
C IMMOVABLE, NO ROOM.
       RETURN
C
9400       I=878
C ASSUME FIRST PUSH.
       IF(CPUSHF) I=879
C NOT?
       CPUSHF=.TRUE.
       CPVEC(NXT+J)=WL
C MOVE WALL.
       CPVEC(NXT)=0
C VACATE NEXT STATE.
       CALL CPGOTO(NXT)
C ONWARD.
       CALL CPINFO(I,NXT)
C DESCRIBE.
       CALL PRINCR(.TRUE.,HERE)
C PRINT ROOMS CONTENTS.
       RFLAG(HERE)=ZOR(RFLAG(HERE),RSEEN)
       RETURN
C
9500       IF(HERE.NE.SCOLAC) GO TO 9700
C IN SCOL ACTIVE ROOM?
       DO 9600 I=1,12,3
         TARGET=SCOLWL(I+1)
C ASSUME TARGET.
         IF(SCOLWL(I).EQ.HERE) GO TO 2100
C TREAT IF FOUND.
9600       CONTINUE
C
9700       IF(HERE.NE.BKBOX) GO TO 10
C IN BOX ROOM?
       TARGET=WNORT
       GO TO 2100
C NOBJS, PAGE 7
C
C O41--       SHORT POLE
C
10000       IF(PRSA.NE.RAISEW) GO TO 10100
C LIFT?
       I=749
C ASSUME UP.
       IF(POLEUF.EQ.2) I=750
C ALREADY UP?
       CALL RSPEAK(I)
       POLEUF=2
C POLE IS RAISED.
       RETURN
C
10100       IF((PRSA.NE.LOWERW).AND.(PRSA.NE.PUSHW)) GO TO 10
       IF(POLEUF.NE.0) GO TO 10200
C ALREADY LOWERED?
       CALL RSPEAK(751)
C CANT DO IT.
       RETURN
C
10200       IF(MOD(MDIR,180).NE.0) GO TO 10300
C MIRROR N-S?
       POLEUF=0
C YES, LOWER INTO
       CALL RSPEAK(752)
C CHANNEL.
       RETURN
C
10300       IF((MDIR.NE.270).OR.(MLOC.NE.MRB)) GO TO 10400
       POLEUF=0
C LOWER INTO HOLE.
       CALL RSPEAK(753)
       RETURN
C
10400       CALL RSPEAK(753+POLEUF)
C POLEUF = 1 OR 2.
       POLEUF=1
C NOW ON FLOOR.
       RETURN
C
C O42--       MIRROR SWITCH
C
11000       IF(PRSA.NE.PUSHW) GO TO 10
C PUSH?
       IF(MRPSHF) GO TO 11300
C ALREADY PUSHED?
       CALL RSPEAK(756)
C BUTTON GOES IN.
       DO 11100 I=1,OLNT
C BLOCKED?
         IF(QHERE(I,MREYE).AND.(I.NE.RBEAM)) GO TO 11200
11100       CONTINUE
       CALL RSPEAK(757)
C NOTHING IN BEAM.
       RETURN
C
11200       CFLAG(CEVMRS)=.TRUE.
C MIRROR OPENS.
       CTICK(CEVMRS)=7
       MRPSHF=.TRUE.
       MROPNF=.TRUE.
       RETURN
C
11300       CALL RSPEAK(758)
C MIRROR ALREADYOPEN.
       RETURN
C NOBJS, PAGE 8
C
C O43--       BEAM FUNCTION
C
12000       IF((PRSA.NE.TAKEW).OR.(PRSO.NE.RBEAM)) GO TO 12100
       CALL RSPEAK(759)
C TAKE BEAM, JOKE.
       RETURN
C
12100       I=PRSO
C ASSUME BLK WITH DIROBJ.
       IF((PRSA.EQ.PUTW).AND.(PRSI.EQ.RBEAM)) GO TO 12200
       IF((PRSA.NE.MUNGW).OR.(PRSO.NE.RBEAM).OR.
     1       (PRSI.EQ.0)) GO TO 10
C BREAK BEAM WITH X?
       I=PRSI
12200       IF(OADV(I).NE.WINNER) GO TO 12300
C CARRYING?
       CALL NEWSTA(I,0,HERE,0,0)
C DROP OBJ.
       CALL RSPSUB(760,ODESC2(I))
       RETURN
C
12300       J=761
C ASSUME NOT IN ROOM.
       IF(QHERE(J,HERE)) I=762
C IN ROOM?
       CALL RSPSUB(J,ODESC2(I))
C DESCRIBE.
       RETURN
C
C O44--       BRONZE DOOR
C
13000       IF((HERE.EQ.NCELL).OR.((LCELL.EQ.4).AND.
     1       ((HERE.EQ.CELL).OR.(HERE.EQ.SCORR))))
     2       GO TO 13100
       CALL RSPEAK(763)
C DOOR NOT THERE.
       RETURN
C
13100       IF(.NOT.OPNCLS(ODOOR,764,765)) GO TO 10
C OPEN/CLOSE?
       IF((HERE.EQ.NCELL).AND.QOPEN(ODOOR))
     1       CALL RSPEAK(766)
C DESCR VIEW.
       RETURN
C
C O45--       QUIZ DOOR
C
14000       IF((PRSA.NE.OPENW).AND.(PRSA.NE.CLOSEW)) GO TO 14100
       CALL RSPEAK(767)
C DOOR WONT MOVE.
       RETURN
C
14100       IF(PRSA.NE.KNOCKW) GO TO 10
C KNOCK?
       IF(INQSTF) GO TO 14200
C TRIED IT ALREADY?
       INQSTF=.TRUE.
C START INQUISITION.
       CFLAG(CEVINQ)=.TRUE.
       CTICK(CEVINQ)=2
       QUESNO=ZRND(8)
C SELECT QUESTION.
       NQATT=0
       CORRCT=0
       CALL RSPEAK(768)
C ANNOUNCE RULES.
       CALL RSPEAK(769)
       CALL RSPEAK(770+QUESNO)
C ASK QUESTION.
       RETURN
C
14200       CALL RSPEAK(798)
C NO REPLY.
       RETURN
C
C O46--       LOCKED DOOR
C
15000       IF(PRSA.NE.OPENW) GO TO 10
C OPEN?
       CALL RSPEAK(778)
C CANT.
       RETURN
C
C O47--       CELL DOOR
C
16000       NOBJS=OPNCLS(CDOOR,779,780)
C OPEN/CLOSE?
       RETURN
C NOBJS, PAGE 9
C
C O48--       DIALBUTTON
C
17000       IF(PRSA.NE.PUSHW) GO TO 10
C PUSH?
       CALL RSPEAK(809)
C CLICK.
       IF(QOPEN(CDOOR)) CALL RSPEAK(810)
C CLOSE CELL DOOR.
C
       DO 17100 I=1,OLNT
C RELOCATE OLD TO HYPER.
         IF((OROOM(I).EQ.CELL).AND.(ZAND(OFLAG1(I),DOORBT).EQ.0))
     1       CALL NEWSTA(I,0,LCELL*HFACTR,0,0)
         IF(OROOM(I).EQ.(PNUMB*HFACTR))
     1       CALL NEWSTA(I,0,CELL,0,0)
C MOVE IN NEW HYPER.
17100       CONTINUE
C
       OFLAG2(ODOOR)=ZAND(OFLAG2(ODOOR),ZNOT(OPENBT))
       OFLAG2(CDOOR)=ZAND(OFLAG2(CDOOR),ZNOT(OPENBT))
       OFLAG1(ODOOR)=ZAND(OFLAG1(ODOOR),ZNOT(VISIBT))
       IF(PNUMB.EQ.4) OFLAG1(ODOOR)=ZOR(OFLAG1(ODOOR),VISIBT)
C
       IF(AROOM(PLAYER).NE.CELL) GO TO 17400
C PLAYER IN CELL?
       IF(LCELL.NE.4) GO TO 17200
C IN RIGHT CELL?
       OFLAG1(ODOOR)=ZOR(OFLAG1(ODOOR), VISIBT)
       F=MOVETO(NCELL,PLAYER)
C YES, MOVETO NCELL.
       GO TO 17400
17200       F=MOVETO(PCELL,PLAYER)
C NO, MOVETO PCELL.
C
17400       LCELL=PNUMB
       RETURN
C NOBJS, PAGE 10
C
C O49--       DIAL INDICATOR
C
18000       IF(PRSA.NE.SPINW) GO TO 18100
C SPIN?
       PNUMB=ZRND(8)+1
C WHEE
C 
       CALL RSPSUB(797,712+PNUMB)
       RETURN
C
18100       IF((PRSA.NE.MOVEW).AND.(PRSA.NE.PUTW).AND.
     1       (PRSA.NE.TRNTOW)) GO TO 10
       IF(PRSI.NE.0) GO TO 18200
C TURN DIAL TO X?
       CALL RSPEAK(806)
C MUST SPECIFY.
       RETURN
C
18200       IF((PRSI.GE.NUM1).AND.(PRSI.LE.NUM8)) GO TO 18300
       CALL RSPEAK(807)
C MUST BE DIGIT.
       RETURN
C
18300       PNUMB=PRSI-NUM1+1
C SET UP NEW.
       CALL RSPSUB(808,712+PNUMB)
       RETURN
C
C O50--       GLOBAL MIRROR
C
19000       NOBJS=MIRPAN(832,.FALSE.)
       RETURN
C
C O51--       GLOBAL PANEL
C
20000       IF(HERE.NE.FDOOR) GO TO 20100
C AT FRONT DOOR?
       IF((PRSA.NE.OPENW).AND.(PRSA.NE.CLOSEW)) GO TO 10
       CALL RSPEAK(843)
C PANEL IN DOOR, NOGO.
       RETURN
C
20100       NOBJS=MIRPAN(838,.TRUE.)
       RETURN
C
C O52--       PUZZLE ROOM SLIT
C
21000       IF((PRSA.NE.PUTW).OR.(PRSI.NE.CSLIT)) GO TO 10
       IF(PRSO.NE.GCARD) GO TO 21100
C PUT CARD IN SLIT?
       CALL NEWSTA(PRSO,863,0,0,0)
C KILL CARD.
       CPOUTF=.TRUE.
C OPEN DOOR.
       OFLAG1(STLDR)=ZAND(OFLAG1(STLDR),ZNOT(VISIBT))
C VANISH DOOR.
       RETURN
C
21100       IF((ZAND(OFLAG1(PRSO),VICTBT).EQ.0).AND.
     1  (ZAND(OFLAG2(PRSO),VILLBT).EQ.0)) GO TO 21200
       CALL RSPEAK(ZRND(5)+552)
C JOKE FOR VILL, VICT.
       RETURN
C
21200       CALL NEWSTA(PRSO,0,0,0,0)
C KILL OBJECT.
       CALL RSPSUB(864,ODO2)
C DESCRIBE.
       RETURN
C
       END
C MIRPAN--       PROCESSOR FOR GLOBAL MIRROR/PANEL
C
C DECLARATIONS
C
       LOGICAL FUNCTION MIRPAN(ST,PNF)
       IMPLICIT INTEGER(A-Z)
       LOGICAL PNF
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C MIRPAN, PAGE 2
C
       MIRPAN=.TRUE.
       NUM=MRHERE(HERE)
C GET MIRROR NUM.
       IF(NUM.NE.0) GO TO 100
C ANY HERE?
       CALL RSPEAK(ST)
C NO, LOSE.
       RETURN
C
100       MRBF=0
C ASSUME MIRROR OK.
       IF(((NUM.EQ.1).AND..NOT.MR1F).OR.
     1  ((NUM.EQ.2).AND..NOT.MR2F)) MRBF=1
       IF((PRSA.NE.MOVEW).AND.(PRSA.NE.OPENW)) GO TO 200
       CALL RSPEAK(ST+1)
C CANT OPEN OR MOVE.
       RETURN
C
200       IF(PNF.OR.((PRSA.NE.LOOKIW).AND.(PRSA.NE.EXAMIW).AND.
     1       (PRSA.NE.LOOKW))) GO TO 300
       CALL RSPEAK(844+MRBF)
C LOOK IN MIRROR.
       RETURN
C
300       IF(PRSA.NE.MUNGW) GO TO 400
C BREAK?
       CALL RSPEAK(ST+2+MRBF)
C DO IT.
       IF((NUM.EQ.1).AND..NOT.PNF) MR1F=.FALSE.
       IF((NUM.EQ.2).AND..NOT.PNF) MR2F=.FALSE.
       RETURN
C
400       IF(PNF.OR.(MRBF.EQ.0)) GO TO 500
C BROKEN MIRROR?
       CALL RSPEAK(846)
       RETURN
C
500       IF(PRSA.NE.PUSHW) GO TO 600
C PUSH?
       CALL RSPEAK(ST+3+NUM)
       RETURN
C
600       MIRPAN=.FALSE.
C CANT HANDLE IT.
       RETURN
C
       END
C SOBJS-       SIMPLE OBJECTS PROCESSOR
C       OBJECTS IN THIS MODULE CANNOT CALL RMINFO, JIGSUP,
C       MAJOR VERBS, OR OTHER NON-RESIDENT SUBROUTINES
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       LOGICAL FUNCTION SOBJS(RI,ARG)
       IMPLICIT INTEGER (A-Z)
       LOGICAL QOPEN
       LOGICAL MOVETO,OPNCLS,LIT
       LOGICAL QHERE,F
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1
       COMMON /RINDEX/ MGRAT,MAZ15
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1       CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2       CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3       CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     5       CEVMRS,CEVPIN,CEVINQ,CEVFOL
 
C
C VILLAINS AND DEMONS
C
       LOGICAL THFFLG,SWDACT,THFACT
       COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
C FUNCTIONS AND DATA
C
       QOPEN(R)=ZAND(OFLAG2(R),OPENBT).NE.0
C SOBJS, PAGE 2
C
       IF(PRSO.NE.0) ODO2=ODESC2(PRSO)
       IF(PRSI.NE.0) ODI2=ODESC2(PRSI)
       AV=AVEHIC(WINNER)
       SOBJS=.TRUE.
C
       GO TO (1000,3000,4000,6000,7000,8000,9000,
     1 13000,14000,16000,17000,
     2 21000,23000,24000,27000,28000,29000,30000,
     3 31000,33000,34000,36000,37000,38000,
     4 41000,42000,43000,44000,46000,
     5 53000,56000)
     6       RI
       CALL BUG(6,RI)
C
C RETURN HERE TO DECLARE FALSE RESULT
C
10       SOBJS=.FALSE.
       RETURN
C SOBJS, PAGE 3
C
C O1--       GUNK FUNCTION
C
1000       IF(OCAN(GUNK).EQ.0) GO TO 10
C NOT INSIDE? F
       CALL NEWSTA(GUNK,122,0,0,0)
C FALLS APART.
       RETURN
C
C O2--       TROPHY CASE
C
3000       IF(PRSA.NE.TAKEW) GO TO 10
C TAKE?
       CALL RSPEAK(128)
C CANT.
       RETURN
C
C O3--       BOTTLE FUNCTION
C
4000       IF(PRSA.NE.THROWW) GO TO 4100
C THROW?
       CALL NEWSTA(PRSO,129,0,0,0)
C BREAKS.
       RETURN
C
4100       IF(PRSA.NE.MUNGW) GO TO 10
C MUNG?
       CALL NEWSTA(PRSO,131,0,0,0)
C BREAKS.
       RETURN
C SOBJS, PAGE 4
C
C O4--       ROPE FUNCTION
C
6000       IF(HERE.EQ.DOME) GO TO 6100
C IN DOME?
       DOMEF=.FALSE.
C NO,
       IF(PRSA.NE.UNTIEW) GO TO 6050
C UNTIE?
       CALL RSPEAK(134)
C CANT
       RETURN
C
6050       IF(PRSA.NE.TIEW) GO TO 10
C TIE?
       CALL RSPEAK(135)
C CANT TIE
       RETURN
C
6100       IF((PRSA.NE.TIEW).OR.(PRSI.NE.RAILI)) GO TO 6200
       IF(DOMEF) GO TO 6150
C ALREADY TIED?
       DOMEF=.TRUE.
C NO, TIE IT.
       OFLAG1(ROPE)=ZOR(OFLAG1(ROPE),NDSCBT)
       OFLAG2(ROPE)=ZOR(OFLAG2(ROPE),CLMBBT)
       CALL NEWSTA(ROPE,137,DOME,0,0)
       RETURN
C
6150       CALL RSPEAK(136)
C DUMMY.
       RETURN
C
6200       IF(PRSA.NE.UNTIEW) GO TO 6300
C UNTIE?
       IF(DOMEF) GO TO 6250
C TIED?
       CALL RSPEAK(134)
C NO, DUMMY.
       RETURN
C
6250       DOMEF=.FALSE.
C YES, UNTIE IT.
       OFLAG1(ROPE)=ZAND(OFLAG1(ROPE),ZNOT(NDSCBT))
       OFLAG2(ROPE)=ZAND(OFLAG2(ROPE),ZNOT(CLMBBT))
       CALL RSPEAK(139)
       RETURN
C
6300       IF(DOMEF.OR.(PRSA.NE.DROPW)) GO TO 6400
C DROP & UNTIED?
       CALL NEWSTA(ROPE,140,MTORC,0,0)
C YES, DROP.
       RETURN
C
6400       IF((PRSA.NE.TAKEW).OR. .NOT.DOMEF) GO TO 10
       CALL RSPEAK(141)
C TAKE & TIED.
       RETURN
C
C O5--       SWORD FUNCTION
C
7000       IF((PRSA.EQ.TAKEW).AND.(WINNER.EQ.PLAYER))
     1       SWDACT=.TRUE.
C TURN ON DEMON.
       GO TO 10
C
C O6--       LANTERN
C
8000       IF(PRSA.NE.THROWW) GO TO 8100
C THROW?
       CALL NEWSTA(LAMP,0,0,0,0)
C KILL LAMP,
       CALL NEWSTA(BLAMP,142,HERE,0,0)
C REPLACE WITH BROKEN.
       RETURN
C
8100       IF(PRSA.EQ.TRNONW) CFLAG(CEVLNT)=.TRUE.
       IF(PRSA.EQ.TRNOFW) CFLAG(CEVLNT)=.FALSE.
       GO TO 10
C
C O7--       RUG FUNCTION
C
9000       IF(PRSA.NE.RAISEW) GO TO 9100
C RAISE?
       CALL RSPEAK(143)
C CANT
       RETURN
C
9100       IF(PRSA.NE.TAKEW) GO TO 9200
C TAKE?
       CALL RSPEAK(144)
C CANT
       RETURN
C
9200       IF(PRSA.NE.MOVEW) GO TO 9300
C MOVE?
       CALL RSPEAK(145+ORRUG)
       ORRUG=1
       OFLAG1(DOOR)=ZOR(OFLAG1(DOOR),VISIBT)
C REVEAL DOOR.
       RETURN
C
9300       IF((PRSA.NE.LOOKUW).OR.(ORRUG.NE.0).OR.
     1       QOPEN(DOOR)) GO TO 10
C LOOK UNDER RUG?
       CALL RSPEAK(345)
       RETURN
C SOBJS, PAGE 5
C
C O8--       SKELETON
C
13000       I=ROBRM(HERE,100,LLD2,0,0)+ROBADV(WINNER,LLD2,0,0)
       IF(I.NE.0) CALL RSPEAK(162)
C IF ROBBED, SAY SO.
       RETURN
C
C O9--       MIRROR
C
14000       IF(MIRRMF.OR.(PRSA.NE.RUBW)) GO TO 14500
       MROOM=ZXOR(HERE,1)
C CALCULATE NEW RM.
       DO 14100 I=1,OLNT
C INTERCHANGE OBJS.
         IF(OROOM(I).EQ.HERE) OROOM(I)=-1
         IF(OROOM(I).EQ.MROOM) OROOM(I)=HERE
         IF(OROOM(I).EQ.-1) OROOM(I)=MROOM
14100       CONTINUE
       F=MOVETO(MROOM,WINNER)
       CALL RSPEAK(163)
C SHAKE WORLD.
       RETURN
C
14500       IF((PRSA.NE.LOOKW).AND.(PRSA.NE.LOOKIW).AND.
     1       (PRSA.NE.EXAMIW)) GO TO 14600
       I=164
C MIRROR OK.
       IF(MIRRMF) I=165
C MIRROR DEAD.
       CALL RSPEAK(I)
       RETURN
C
14600       IF(PRSA.NE.TAKEW) GO TO 14700
C TAKE?
       CALL RSPEAK(166)
C JOKE.
       RETURN
C
14700       IF((PRSA.NE.MUNGW).AND.(PRSA.NE.THROWW)) GO TO 10
       I=167
C MIRROR BREAKS.
       IF(MIRRMF) I=168
C MIRROR ALREADY BROKEN.
       MIRRMF=.TRUE.
       BADLKF=.TRUE.
       CALL RSPEAK(I)
       RETURN
C SOBJS, PAGE 6
C
C O10--       DUMBWAITER
C
16000       IF(PRSA.NE.RAISEW) GO TO 16100
C RAISE?
       IF(CAGETF) GO TO 16400
C ALREADY AT TOP?
       CALL NEWSTA(TBASK,175,TSHAF,0,0)
C NO, RAISE BASKET.
       CALL NEWSTA(FBASK,0,BSHAF,0,0)
       CAGETF=.TRUE.
C AT TOP.
       RETURN
C
16100       IF(PRSA.NE.LOWERW) GO TO 16200
C LOWER?
       IF(.NOT.CAGETF) GO TO 16400
C ALREADY AT BOTTOM?
       CALL NEWSTA(TBASK,176,BSHAF,0,0)
C NO, LOWER BASKET.
       CALL NEWSTA(FBASK,0,TSHAF,0,0)
       CAGETF=.FALSE.
       IF(.NOT.LIT(HERE)) CALL RSPEAK(406)
C IF DARK, DIE.
       RETURN
C
16200       IF((PRSO.NE.FBASK).AND.(PRSI.NE.FBASK)) GO TO 16300
       CALL RSPEAK(130)
C WRONG BASKET.
       RETURN
C
16300       IF(PRSA.NE.TAKEW) GO TO 10
C TAKE?
       CALL RSPEAK(177)
C JOKE.
       RETURN
C
16400       CALL RSPEAK(125+ZRND(3))
C DUMMY.
       RETURN
C
C O11--       GHOST FUNCTION
C
17000       I=178
C ASSUME DIRECT.
       IF(PRSO.NE.GHOST) I=179
C IF NOT, INDIRECT.
       CALL RSPEAK(I)
       RETURN
C SPEAK AND EXIT.
C SOBJS, PAGE 7
C
C O12--       TUBE
C
21000       IF((PRSA.NE.PUTW).OR.(PRSI.NE.TUBE)) GO TO 10
       CALL RSPEAK(186)
C CANT PUT BACK IN.
       RETURN
C
C O13--       CHALICE
C
23000       IF((PRSA.NE.TAKEW).OR.(OCAN(PRSO).NE.0).OR.
     1       (OROOM(PRSO).NE.TREAS).OR.(OROOM(THIEF).NE.TREAS).OR.
     2       (ZAND(OFLAG2(THIEF),FITEBT).EQ.0).OR.
     3       .NOT. THFACT) GO TO 10
       CALL RSPEAK(204)
C CANT TAKE.
       RETURN
C
C O14--       PAINTING
C
24000       IF(PRSA.NE.MUNGW) GO TO 10
C MUNG?
       CALL RSPEAK(205)
C DESTROY PAINTING.
       OFVAL(PRSO)=0
       OTVAL(PRSO)=0
       ODESC1(PRSO)=207
       ODESC2(PRSO)=206
       RETURN
C SOBJS, PAGE 8
C
C O15--       BOLT
C
27000       IF(PRSA.NE.TURNW) GO TO 10
C TURN BOLT?
       IF(PRSI.NE.WRENC) GO TO 27500
C WITH WRENCH?
       IF(GATEF) GO TO 27100
C PROPER BUTTON PUSHED?
       CALL RSPEAK(210)
C NO, LOSE.
       RETURN
C
27100       IF(LWTIDF) GO TO 27200
C LOW TIDE NOW?
       LWTIDF=.TRUE.
C NO, EMPTY DAM.
       CALL RSPEAK(211)
       OFLAG2(COFFI)=ZAND(OFLAG2(COFFI),ZNOT(SCRDBT))
       OFLAG1(TRUNK)=ZOR(OFLAG1(TRUNK),VISIBT)
C MATERIALIZE TRUNK.
       RFLAG(RESER)=ZAND(ZOR(RFLAG(RESER),RLAND),
     1       ZNOT(RWATER+RSEEN))
C KEEP THIEF AWAY.
       RETURN
C
27200       LWTIDF=.FALSE.
C YES, FILL DAM.
       CALL RSPEAK(212)
       IF(QHERE(TRUNK,RESER)) OFLAG1(TRUNK)=ZAND(OFLAG1(TRUNK)
     1       ,ZNOT(VISIBT))
       RFLAG(RESER)=ZAND(ZOR(RFLAG(RESER),RWATER) ,ZNOT(RLAND))
       RETURN
C
27500       CALL RSPSUB(299,ODI2)
C NOT WITH THAT.
       RETURN
C
C O16--       GRATING
C
28000       IF((PRSA.NE.OPENW).AND.(PRSA.NE.CLOSEW)) GO TO 10
       IF(GRUNLF) GO TO 28200
C UNLOCKED?
       CALL RSPEAK(214)
C NO, LOCKED.
       RETURN
C
28200       I=215
C UNLOCKED, VIEW FRM CLR.
       IF(HERE.NE.CLEAR) I=216
C VIEW FROM BELOW.
       SOBJS=OPNCLS(GRATE,I,885)
C OPEN/CLOSE.
       RFLAG(MGRAT)=ZAND(RFLAG(MGRAT),ZNOT(RLIGHT))
C SET LIGHT/DARK.
       IF(QOPEN(GRATE)) RFLAG(MGRAT)=ZOR(RFLAG(MGRAT),RLIGHT)
       IF(.NOT.LIT(HERE)) CALL RSPEAK(406)
C IF DARK, DIE.
       RETURN
C
C O17--       TRAP DOOR
C
29000       IF(HERE.NE.LROOM) GO TO 29100
C FROM LIVING ROOM?
       SOBJS=OPNCLS(DOOR,218,219)
C OPEN/CLOSE.
       RETURN
C
29100       IF(HERE.NE.CELLA) GO TO 10
C FROM CELLAR?
       IF((PRSA.NE.OPENW).OR.QOPEN(DOOR)) GO TO 29200
       CALL RSPEAK(220)
C CANT OPEN CLOSED DOOR.
       RETURN
C
29200       SOBJS=OPNCLS(DOOR,0,22)
C NORMAL OPEN/CLOSE.
       RETURN
C
C O18--       DURABLE DOOR
C
30000       I=0
C ASSUME NO APPL.
       IF(PRSA.EQ.OPENW) I=221
C OPEN?
       IF(PRSA.EQ.BURNW) I=222
C BURN?
       IF(PRSA.EQ.MUNGW) I=223+ZRND(3)
C MUNG?
       IF(I.EQ.0) GO TO 10
       CALL RSPEAK(I)
       RETURN
C
C O19--       MASTER SWITCH
C
31000       IF(PRSA.NE.TURNW) GO TO 10
C TURN?
       IF(PRSI.NE.SCREW) GO TO 31500
C WITH SCREWDRIVER?
       IF(QOPEN(MACHI)) GO TO 31600
C LID UP?
       CALL RSPEAK(226)
C NO, ACTIVATE.
       IF(OCAN(COAL).NE.MACHI) GO TO 31400
C COAL INSIDE?
       CALL NEWSTA(COAL,0,0,0,0)
C KILL COAL,
       CALL NEWSTA(DIAMO,0,0,MACHI,0)
C REPLACE WITH DIAMOND.
       RETURN
C
31400       DO 31450 I=1,OLNT
C KILL NONCOAL OBJECTS.
         IF(OCAN(I).NE.MACHI) GO TO 31450
C INSIDE MACHINE?
         CALL NEWSTA(I,0,0,0,0)
C KILL OBJECT AND CONTENTS.
         CALL NEWSTA(GUNK,0,0,MACHI,0)
C REDUCE TO GUNK.
31450       CONTINUE
       RETURN
C
31500       CALL RSPSUB(300,ODI2)
C CANT TURN WITH THAT.
       RETURN
C
31600       CALL RSPEAK(227)
C LID IS UP.
       RETURN
C SOBJS, PAGE 9
C
C O20--       LEAK
C
33000       IF((PRSO.NE.LEAK).OR.(PRSA.NE.PLUGW).OR.(RVMNT.LE.0))
     1       GO TO 10
C PLUG ACTIVE LEAK?
       IF(PRSI.NE.PUTTY) GO TO 33100
C WITH PUTTY?
       RVMNT=-1
C DISABLE LEAK.
       CTICK(CEVMNT)=0
       CALL RSPEAK(577)
       RETURN
C
33100       CALL RSPSUB(301,ODI2)
C CANT WITH THAT.
       RETURN
C
C O21--       DROWNING BUTTONS
C
34000       IF(PRSA.NE.PUSHW) GO TO 10
C PUSH?
       GO TO (34100,34200,34300,34400),(PRSO-RBUTT+1)
       GO TO 10
C NOT A BUTTON.
C
34100       RFLAG(HERE)=ZXOR(RFLAG(HERE),RLIGHT)
C RED, ZAP LIGHTS.
       I=230
       IF(ZAND(RFLAG(HERE),RLIGHT).NE.0) I=231
       CALL RSPEAK(I)
       RETURN
C
34200       GATEF=.TRUE.
C RELEASE GATE.
       CALL RSPEAK(232)
       RETURN
C
34300       GATEF=.FALSE.
C INTERLOCK GATE.
       CALL RSPEAK(232)
       RETURN
C
34400       IF(RVMNT.NE.0) GO TO 34500
C LEAK ALREADY STARTED?
       CALL RSPEAK(233)
C NO, START LEAK.
       RVMNT=1
       CTICK(CEVMNT)=-1
       RETURN
C
34500       CALL RSPEAK(234)
C BUTTON JAMMED.
       RETURN
C
C O22--       INFLATABLE BOAT
C
36000       IF(PRSA.NE.INFLAW) GO TO 10
C INFLATE?
       IF(OROOM(IBOAT).NE.0) GO TO 36100
C IN ROOM?
       CALL RSPEAK(235)
C NO, JOKE.
       RETURN
C
36100       IF(PRSI.NE.PUMP) GO TO 36200
C WITH PUMP?
       CALL NEWSTA(IBOAT,0,0,0,0)
C KILL DEFL BOAT,
       CALL NEWSTA(RBOAT,236,HERE,0,0)
C REPL WITH INF.
       DEFLAF=.FALSE.
       RETURN
C
36200       I=237
C JOKES.
       IF(PRSI.NE.LUNGS) I=303
       CALL RSPSUB(I,ODI2)
       RETURN
C
C O23--       DEFLATED BOAT
C
37000       IF(PRSA.NE.INFLAW) GO TO 37100
C INFLATE?
       CALL RSPEAK(238)
C JOKE.
       RETURN
C
37100       IF(PRSA.NE.PLUGW) GO TO 10
C PLUG?
       IF(PRSI.NE.PUTTY) GO TO 33100
C WITH PUTTY?
       CALL NEWSTA(IBOAT,239,OROOM(DBOAT),OCAN(DBOAT),OADV(DBOAT))
       CALL NEWSTA(DBOAT,0,0,0,0)
C KILL DEFL BOAT, REPL.
       RETURN
C SOBJS, PAGE 10
C
C O24--       RUBBER BOAT
C
38000       IF(ARG.NE.0) GO TO 10
C DISMISS READIN, OUT.
       IF((PRSA.NE.BOARDW).OR.(OADV(STICK).NE.WINNER)) GO TO 38100
       CALL NEWSTA(RBOAT,0,0,0,0)
C KILL INFL BOAT,
       CALL NEWSTA(DBOAT,240,HERE,0,0)
C REPL WITH DEAD.
       DEFLAF=.TRUE.
       RETURN
C
38100       IF(PRSA.NE.INFLAW) GO TO 38200
C INFLATE?
       CALL RSPEAK(367)
C YES, JOKE.
       RETURN
C
38200       IF(PRSA.NE.DEFLAW) GO TO 10
C DEFLATE?
       IF(AV.EQ.RBOAT) GO TO 38300
C IN BOAT?
       IF(OROOM(RBOAT).EQ.0) GO TO 38400
C ON GROUND?
       CALL NEWSTA(RBOAT,0,0,0,0)
C KILL INFL BOAT,
       CALL NEWSTA(IBOAT,241,HERE,0,0)
C REPL WITH DEFL.
       DEFLAF=.TRUE.
       RETURN
C
38300       CALL RSPEAK(242)
C IN BOAT.
       RETURN
C
38400       CALL RSPEAK(243)
C NOT ON GROUND.
       RETURN
C
C O25--       BRAIDED ROPE
C
41000       IF((PRSA.NE.TIEW).OR.(PRSO.NE.BROPE).OR.
     1       ((PRSI.NE.HOOK1).AND.(PRSI.NE.HOOK2)))
     2       GO TO 41500
C TIE TO HOOK?
       BTIEF=PRSI
C RECORD LOCATION.
       CFLAG(CEVBAL)=.FALSE.
C STALL ASCENT.
       CALL RSPEAK(248)
       RETURN
C
41500       IF((PRSA.NE.UNTIEW).OR.(PRSO.NE.BROPE)) GO TO 10
       IF(BTIEF.NE.0) GO TO 41600
C TIED UP?
       CALL RSPEAK(249)
C NO, JOKE.
       RETURN
C
41600       CALL RSPEAK(250)
       BTIEF=0
C UNTIE.
       CTICK(CEVBAL)=3
C RESTART CLOCK.
       CFLAG(CEVBAL)=.TRUE.
       RETURN
C
C O26--       SAFE
C
42000       I=0
C ASSUME UNPROCESSED.
       IF(PRSA.EQ.TAKEW) I=251
C TAKE?
       IF((PRSA.EQ.OPENW).AND.SAFEF) I=253
C OPEN AFTER BLAST?
       IF((PRSA.EQ.OPENW).AND..NOT.SAFEF) I=254 
C OPEN BEFORE BLAST?
       IF((PRSA.EQ.CLOSEW).AND.SAFEF) I=253
C CLOSE AFTER?
       IF((PRSA.EQ.CLOSEW).AND..NOT.SAFEF) I=255
       IF(I.EQ.0) GO TO 10
       CALL RSPEAK(I)
       RETURN
C
C O27--       FUSE
C
43000       IF(PRSA.NE.BURNW) GO TO 10
C BURN?
       CALL RSPEAK(256)
       CTICK(CEVFUS)=2
C START COUNTDOWN.
       RETURN
C
C O28--       GNOME
C
44000       IF((PRSA.NE.GIVEW).AND.(PRSA.NE.THROWW)) GO TO 44500
       IF(OTVAL(PRSO).EQ.0) GO TO 44100
C TREASURE?
       CALL RSPSUB(257,ODO2)
C YES, GET DOOR.
       CALL NEWSTA(PRSO,0,0,0,0)
       CALL NEWSTA(GNOME,0,0,0,0)
C VANISH GNOME.
       GNODRF=.TRUE.
       RETURN
C
44100       CALL RSPSUB(258,ODO2)
C NO, LOSE OBJECT.
       CALL NEWSTA(PRSO,0,0,0,0)
       RETURN
C
44500       CALL RSPEAK(259)
C NERVOUS GNOME.
       IF(.NOT.GNOMEF) CTICK(CEVGNO)=5
C SCHEDULE BYEBYE.
       GNOMEF=.TRUE.
       RETURN
C
C O29--       COKE BOTTLES
C
46000       IF((PRSA.NE.THROWW).AND.(PRSA.NE.MUNGW)) GO TO 10
       CALL NEWSTA(PRSO,262,0,0,0)
C MUNG BOTTLES.
       RETURN
C SOBJS, PAGE 11
C
C
C O30--       ROBOT
C
53000       IF(PRSA.NE.GIVEW) GO TO 53200
C GIVE?
       CALL NEWSTA(PRSO,0,0,0,AROBOT)
C PUT ON ROBOT.
       CALL RSPSUB(302,ODO2)
       RETURN
C
53200       IF((PRSA.NE.MUNGW).AND.(PRSA.NE.THROWW)) GO TO 10
       CALL NEWSTA(ROBOT,285,0,0,0)
C KILL ROBOT.
       RETURN
C
C O31--       GRUE
C
56000       IF(PRSA.NE.EXAMIW) GO TO 56100
C EXAMINE?
       CALL RSPEAK(288)
       RETURN
C
56100       IF(PRSA.NE.FINDW) GO TO 10
C FIND?
       CALL RSPEAK(289)
       RETURN
C
       END

C GAME- MAIN COMMAND LOOP FOR DUNGEON
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       SUBROUTINE GAME
       IMPLICIT INTEGER (A-Z)
       LOGICAL RMDESC,VAPPLI,RAPPLI,AAPPLI
       LOGICAL F,PARSE,FINDXT,XVEHIC,LIT
       CHARACTER SECHO(4),GDTSTR(3)
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C MISCELLANEOUS VARIABLES
C
       CHARACTER INLINE
       COMMON /INPUTL/ INLNT
       COMMON /INPUT/ INLINE(78)
       COMMON /CHAN/ INPCH,OUTCH,DBCH,ZRECL
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1     
       COMMON /RINDEX/ MGRAT,MAZ15     
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF     
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU     
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
C FUNCTIONS AND DATA
C
       DATA SECHO/'E','C','H','O'/
       DATA GDTSTR/'G','D','T'/
C GAME, PAGE 2
C
C START UP, DESCRIBE CURRENT LOCATION.
C
       CALL RSPEAK(1)   
C WELCOME ABOARD.
       F=RMDESC(3)   
C START GAME.
C
C NOW LOOP, READING AND EXECUTING COMMANDS.
C
100       WINNER=PLAYER   
C PLAYER MOVING.
       TELFLG=.FALSE.   
C ASSUME NOTHING TOLD.
       IF(PRSCON.LE.1) CALL RDLINE(INLINE,INLNT,1) 
C READ COMMAND.
C
       DO 150 I=1,3
C CALL ON GDT?
         IF(INLINE(I+PRSCON-1).NE.GDTSTR(I)) GO TO 200
150       CONTINUE
       CALL GDT   
C YES, INVOKE.
       GO TO 100   
C ONWARD.
C
200       MOVES=MOVES+1
       PRSWON=PARSE(INLINE,INLNT,.TRUE.)     
C PARSE INPUT, NORMAL MODE.
       IF(.NOT.PRSWON) GO TO 400    
C PARSE LOSES?
       IF(XVEHIC(1)) GO TO 400   
C VEHICLE HANDLE?
C
       IF(PRSA.EQ.TELLW) GO TO 2000    
C TELL?
300       IF((PRSO.EQ.VALUA).OR.(PRSO.EQ.EVERY)) GO TO 900
       IF(.NOT.VAPPLI(PRSA)) GO TO 400    
C VERB OK?
350       IF(.NOT.ECHOF.AND.(HERE.EQ.ECHOR)) GO TO 1000
       F=RAPPLI(RACTIO(HERE))
C
400       CALL XENDMV(TELFLG)   
C DO END OF MOVE.
       IF(.NOT.LIT(HERE)) PRSCON=1
       GO TO 100
C
900       CALL VALUAC(VALUA)
       GO TO 350
C GAME, PAGE 3
C
C SPECIAL CASE-- ECHO ROOM.
C IF INPUT IS NOT 'ECHO' OR A DIRECTION, JUST ECHO.
C
1000       CALL RDLINE(INLINE,INLNT,0)    
C READ LINE.
       MOVES=MOVES+1   
C CHARGE FOR MOVES.
       DO 1100 I=1,4   
C INPUT = ECHO?
         IF(INLINE(I).NE.SECHO(I)) GO TO 1300
1100       CONTINUE
C
       DO 1200 I=5,78   
C REST BLANK?
         IF(INLINE(I).NE.' ') GO TO 1300
1200       CONTINUE
C
       CALL RSPEAK(571)   
C KILL THE ECHO.
       ECHOF=.TRUE.
       OFLAG2(BAR)=ZAND(OFLAG2(BAR),ZNOT(SCRDBT)) 
C LET THIEF STEAL BAR.
       PRSWON=.TRUE.   
C FAKE OUT PARSER.
       PRSCON=1   
C FORCE NEW INPUT.
       GO TO 400
C
1300       PRSWON=PARSE(INLINE,INLNT,.FALSE.)     
C PARSE INPUT, ECHO MODE.
       IF(.NOT.PRSWON .OR. (PRSA.NE.WALKW))
     1       GO TO 1400   
C WALK?
       IF(FINDXT(PRSO,HERE)) GO TO 300    
C VALID EXIT?
C
1400       WRITE(OUTCH,1410) (INLINE(J),J=1,INLNT)     
C ECHO INPUT.
1410       FORMAT(1X,78A1)
       TELFLG=.TRUE.   
C INDICATE OUTPUT.
       GO TO 1000   
C MORE ECHO ROOM.
C GAME, PAGE 4
C
C SPECIAL CASE-- TELL <ACTOR>, NEW COMMAND
C NOTE THAT WE CANNOT BE IN THE ECHO ROOM.
C
2000       IF(ZAND(OFLAG2(PRSO),ACTRBT).NE.0) GO TO 2100 
C ACTOR?
       CALL RSPEAK(602)   
C CANT DO IT.
       GO TO 350   
C VAPPLI SUCCEEDS.
C
2100       WINNER=OACTOR(PRSO)   
C NEW PLAYER.
       HERE=AROOM(WINNER)   
C NEW LOCATION.
       IF(PRSCON.LE.1) GO TO 2700    
C ANY INPUT?
       IF(PARSE(INLINE,INLNT,.TRUE.)) GO TO 2150     
C PARSE COMMAND.
2700       I=341   
C FAILS.
       IF(TELFLG) I=604   
C GIVE RESPONSE.
       CALL RSPEAK(I)
2600       WINNER=PLAYER   
C RESTORE STATE.
       HERE=AROOM(WINNER)
       GO TO 350
C
2150       IF(AAPPLI(AACTIO(WINNER))) GO TO 2400     
C ACTOR HANDLE?
       IF(XVEHIC(1)) GO TO 2400    
C VEHICLE HANDLE?
       IF((PRSO.EQ.VALUA).OR.(PRSO.EQ.EVERY)) GO TO 2900
       IF(.NOT.VAPPLI(PRSA)) GO TO 2400     
C VERB HANDLE?
2350       F=RAPPLI(RACTIO(HERE))
C
2400       CALL XENDMV(TELFLG)   
C DO END OF MOVE.
       GO TO 2600   
C DONE.
C
2900       CALL VALUAC(VALUA)   
C ALL OR VALUABLES.
       GO TO 350
C
       END
C XENDMV-       EXECUTE END OF MOVE FUNCTIONS.
C
C DECLARATIONS
C
       SUBROUTINE XENDMV(FLAG)
       IMPLICIT INTEGER(A-Z)
       LOGICAL F,CLOCKD,FLAG,XVEHIC
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSO,PRSI,PRSWON,PRSCON
C
C VILLAINS AND DEMONS
C
       LOGICAL THFFLG,SWDACT,THFACT
       COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
C
       IF(.NOT.FLAG) CALL RSPEAK(341)    
C DEFAULT REMARK.
       IF(THFACT) CALL THIEFD   
C THIEF DEMON.
       IF(PRSWON) CALL FIGHTD   
C FIGHT DEMON.
       IF(SWDACT) CALL SWORDD   
C SWORD DEMON.
       IF(PRSWON) F=CLOCKD(X)   
C CLOCK DEMON.
       IF(PRSWON) F=XVEHIC(2)   
C VEHICLE READOUT.
       RETURN
       END
C XVEHIC- EXECUTE VEHICLE FUNCTION
C
C DECLARATIONS
C
       LOGICAL FUNCTION XVEHIC(N)
       IMPLICIT INTEGER(A-Z)
       LOGICAL OAPPLI
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       XVEHIC=.FALSE.   
C ASSUME LOSES.
       AV=AVEHIC(WINNER)   
C GET VEHICLE.
       IF(AV.NE.0) XVEHIC=OAPPLI(OACTIO(AV),N)
       RETURN
       END
C
C INIT-- DUNGEON INITIALIZATION SUBROUTINE
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       LOGICAL FUNCTION INIT()
       IMPLICIT INTEGER (A-Z)
       LOGICAL PROTCT
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C PARSER STATE
C
       COMMON /ORPHS/ OFLAG,OACT,OSLOT,OPREP,ONAME
       COMMON /LAST/ LASTIT
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C SCREEN OF LIGHT
C
       COMMON /SCREEN/ FROMDR,SCOLRM,SCOLAC
       COMMON /SCREEN/ SCOLDR(8),SCOLWL(12)
C
C MESSAGE INDEX
C
       COMMON /RMSG/ MLNT,RTEXT(1050)
C
C MISCELLANEOUS VARIABLES
C
       COMMON /STAR/ MBASE,STRBIT
       COMMON /VERS/ VMAJ,VMIN,VEDIT
       COMMON /TIME/ PLTIME,SHOUR,SMIN,SSEC
       COMMON /CHAN/ INPCH,OUTCH,DBCH,ZRECL
       COMMON /DEBUG/ DBGFLG,PRSFLG,GDTFLG
       COMMON /HYPER/ HFACTR
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1 
       COMMON /RINDEX/ MGRAT,MAZ15 
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF 
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU 
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C EXITS
C
       COMMON /EXITS/ XLNT,TRAVEL(900)
C
       COMMON /CURXT/ XTYPE,XROOM1,XSTRNG,XACTIO,XOBJ
C
       COMMON /XPARS/ XRMASK,XDMASK,XFMASK,XFSHFT,XASHFT,
     1       XELNT(4),XNORM,XNO,XCOND,XDOOR,XLFLAG
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OROOM2/ R2LNT,O2(20),R2(20)
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
C VILLAINS AND DEMONS
C
       LOGICAL THFFLG,SWDACT,THFACT
       COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
       COMMON /VILL/ VLNT,VILLNS(4),VPROB(4),VOPPS(4),VBEST(4),VMELEE(4)
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
       LOGICAL FLAGS(46)
       INTEGER SWITCH(22)
       EQUIVALENCE (FLAGS(1),TROLLF)
       EQUIVALENCE (SWITCH(1),BTIEF)
C INIT, PAGE 2
C
C
C
C NOW START INITIALIZATION PROPER
C
10000       INIT=.FALSE.  
C ASSUME INIT FAILS.
       MMAX=1050  
C SET UP ARRAY LIMITS.
       OMAX=220
       RMAX=200
       VMAX=4
       AMAX=4
       CMAX=25
       FMAX=46
       SMAX=22
       XMAX=900
       R2MAX=20
       DIRMAX=15
C
       MLNT=0 
C INIT ARRAY COUNTERS.
       OLNT=0
       RLNT=0
       VLNT=0
       ALNT=0
       CLNT=0
       XLNT=1
       R2LNT=0
C
       LTSHFT=10  
C SET UP STATE VARIABLES.
       MXSCOR=LTSHFT
       EGSCOR=0
       EGMXSC=0
       MXLOAD=100
       RWSCOR=0
       DEATHS=0
       MOVES=0
       PLTIME=0
       MUNGRM=0
       HS=0
       PRSA=0 
C CLEAR PARSE VECTOR.
       PRSI=0
       PRSO=0
       PRSCON=1
       OFLAG=0 
C CLEAR ORPHANS.
       OACT=0
       OSLOT=0
       OPREP=0
       ONAME=0
       THFFLG=.FALSE.  
C THIEF NOT INTRODUCED BUT
       THFACT=.TRUE.  
C IS ACTIVE.
       SWDACT=.FALSE.  
C SWORD IS INACTIVE.
       SWDSTA=0  
C SWORD IS OFF.
C
       RECNO=1 
C INIT DB FILE POINTER.
       MBASE=0 
C INIT MELEE BASE.
       CALL MACHDV
C      INITIALIZE FILE STUFF
C INIT, PAGE 3
C
C INIT ALL ARRAYS.
C
       DO 5 I=1,CMAX  
C CLEAR CLOCK EVENTS
         CFLAG(I)=.FALSE.
         CTICK(I)=0
         CACTIO(I)=0
5       CONTINUE
C
       DO 10 I=1,FMAX  
C CLEAR FLAGS.
         FLAGS(I)=.FALSE.
10       CONTINUE
       BUOYF=.TRUE.  
C SOME START AS TRUE.
       EGYPTF=.TRUE.
       CAGETF=.TRUE.
       MR1F=.TRUE.
       MR2F=.TRUE.
       FOLLWF=.TRUE.
       DO 12 I=1,SMAX  
C CLEAR SWITCHES.
         SWITCH(I)=0
12       CONTINUE
       ORMTCH=4  
C NUMBER OF MATCHES.
       LCELL=1
       PNUMB=1
       MDIR=270
       MLOC=MRB
       CPHERE=10
C
       DO 15 I=1,R2MAX 
C CLEAR ROOM 2 ARRAY.
         R2(I)=0
         O2(I)=0
15       CONTINUE
C
       DO 20 I=1,XMAX 
C CLEAR TRAVEL ARRAY.
         TRAVEL(I)=0
20       CONTINUE
C
       DO 30 I=1,VMAX  
C CLEAR VILLAINS ARRAYS.
         VOPPS(I)=0
         VPROB(I)=0
         VILLNS(I)=0
         VBEST(I)=0
         VMELEE(I)=0
30       CONTINUE
C
       DO 40 I=1,OMAX  
C CLEAR OBJECT ARRAYS.
         ODESC1(I)=0
         ODESC2(I)=0
         ODESCO(I)=0
         OREAD(I)=0
         OACTIO(I)=0
         OFLAG1(I)=0
         OFLAG2(I)=0
         OFVAL(I)=0
         OTVAL(I)=0
         OSIZE(I)=0
         OCAPAC(I)=0
         OCAN(I)=0
         OADV(I)=0
         OROOM(I)=0
40       CONTINUE
C
       RDESC2=0  
C CLEAR DESC BASE PTR.
       DO 50 I=1,RMAX  
C CLEAR ROOM ARRAYS.
         RDESC1(I)=0
         RACTIO(I)=0
         RFLAG(I)=0
         RVAL(I)=0
         REXIT(I)=0
50       CONTINUE
C
       DO 60 I=1,MMAX  
C CLEAR MESSAGE DIRECTORY.
         RTEXT(I)=0
60       CONTINUE
C
       DO 70 I=1,AMAX  
C CLEAR ADVENTURER'S ARRAYS.
         AROOM(I)=0
         ASCORE(I)=0
         AVEHIC(I)=0
         AOBJ(I)=0
         AACTIO(I)=0
         ASTREN(I)=0
         AFLAG(I)=0
70       CONTINUE
C
       DBGFLG=0
       PRSFLG=0
       GDTFLG=0
C
       FROMDR=0  
C INIT SCOL GOODIES.
       SCOLRM=0
       SCOLAC=0
C INIT, PAGE 4
C
C NOW RESTORE FROM EXISTING INDEX FILE.
C
       OPEN(UNIT=11,FILE='DINDX.DAT',STATUS='OLD',ERR=1900)
       READ(11,130) I,J,K 
C GET VERSION.
       IF((I.NE.VMAJ).OR.(J.NE.VMIN))
     1       GO TO 1925 
C MATCH TO OURS?
 
       READ(11,130) MXSCOR,STRBIT,EGMXSC
       READ(11,130) RLNT,RDESC2,RDESC1,REXIT,RACTIO,RVAL,RFLAG
       READ(11,130) XLNT,TRAVEL
       READ(11,130) OLNT,ODESC1,ODESC2,ODESCO,OACTIO,OFLAG1,OFLAG2,
     1       OFVAL,OTVAL,OSIZE,OCAPAC,OROOM,OADV,OCAN,
     2       OREAD
       READ(11,130) R2LNT,O2,R2
       READ(11,130) CLNT,CTICK,CACTIO
       READ(11,135) CFLAG
       READ(11,130) VLNT,VILLNS,VPROB,VOPPS,VBEST,VMELEE
       READ(11,130) ALNT,AROOM,ASCORE,AVEHIC,AOBJ,AACTIO,ASTREN,AFLAG
       READ(11,130) MBASE,MLNT,RTEXT
C

       CLOSE(UNIT=11)
 
       OPEN(UNIT=DBCH,FILE='DTEXT.DAT',STATUS='OLD',
     1       FORM='UNFORMATTED',ACCESS='DIRECT',
     2       RECL=ZRECL,ERR=1950)
       GO TO 1025  
C INIT DONE.
C
130       FORMAT(I8)
135       FORMAT(L4)
C INIT, PAGE 5
C
C THE INTERNAL DATA BASE IS NOW ESTABLISHED.
C SET UP TO PLAY THE GAME.
C
1025       CALL ITIME(SHOUR,SMIN,SSEC)  
C GET TIME AND DATE.
       CALL KDATE(I,J,K)
       CALL INIRND(ZOR(ZOR(I,J),K),ZOR(ZOR(SHOUR,SMIN),SSEC))
C
       WINNER=PLAYER
       THFPOS=OROOM(THIEF)
       BLOC=OROOM(BALLO)
       HERE=AROOM(WINNER)
       LASTIT=AOBJ(PLAYER)
       INIT=.TRUE.
C
C
       RETURN
C INIT, PAGE 6
C
C ERRORS-- INIT FAILS.
C
1900   WRITE(*, 910)  
C DINDX.DAT OPEN ERR
       WRITE(*,980)
       RETURN
1925   WRITE(*,920)I,J,K,VMAJ,VMIN,VEDIT  
C WRONG DINDX.DAT VER
       WRITE(*, 980)
       RETURN
1950   write(*, 960)  
C DTEXT.DAT OPEN ERR
       WRITE(*,980)
       RETURN
910       FORMAT(' I can''t open "DINDX.DAT".')
920       FORMAT(' "DINDX.DAT" is version ',I1,'.',I1,A1,'.'/
     1       ' I require version ',I1,'.',I1,A1,'.')
960       FORMAT(' I can''t open "DTEXT.DAT".')
980       FORMAT(
     1 ' Suddenly a sinister, wraithlike figure appears before you',
     1 /' seeming to float in the air.  In a low, sorrowful voice ',
     2 'he says,'/' "Alas, the very nature of the world has changed, '
     3 'and the dungeon'/' cannot be found.  All must now pass away."',
     4 '  Raising his oaken staff'/' in farewell, he fades into the ',
     5 'spreading darkness.  In his place'/' appears a tastefully ',
     6 'lettered sign reading:'//23X,'INITIALIZATION FAILURE'//
     7' The darkness becomes all encompassing, and your vision fails.')
C
       END

C CEVAPP- CLOCK EVENT APPLICABLES
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       SUBROUTINE CEVAPP(RI)
       IMPLICIT INTEGER (A-Z)
       INTEGER CNDTCK(10),LMPTCK(12)
       LOGICAL FINDXT,LIT,RMDESC,QOPEN,MOVETO
       LOGICAL F,QLEDGE,QVAIR,QHERE,PROB
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1   
       COMMON /RINDEX/ MGRAT,MAZ15   
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF   
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU   
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1       CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2       CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3       CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     5       CEVMRS,CEVPIN,CEVINQ,CEVFOL
C
C EXITS
C
       COMMON /CURXT/ XTYPE,XROOM1,XSTRNG,XACTIO,XOBJ
C
       COMMON /XSRCH/ XMIN,XMAX,XDOWN,XUP,
     1       XNORTH,XSOUTH,XENTER,XEXIT,XEAST,XWEST
C
C VILLAINS AND DEMONS
C
       LOGICAL THFFLG,SWDACT,THFACT
       COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
C FUNCTIONS AND DATA
C
       QOPEN(R)=(ZAND(OFLAG2(R),OPENBT)).NE.0
       QLEDGE(R)=(R.EQ.LEDG2).OR.(R.EQ.LEDG3).OR.(R.EQ.LEDG4).OR.
     1       (R.EQ.VLBOT)
       QVAIR(R)=(R.EQ.VAIR1).OR.(R.EQ.VAIR2).OR.(R.EQ.VAIR3).OR.
     1        (R.EQ.VAIR4)
       DATA CNDTCK/50,20,10,5,0,156,156,156,157,0/
       DATA LMPTCK/50,30,20,10,4,0,154,154,154,154,155,0/
C CEVAPP, PAGE 2
C
       IF(RI.EQ.0) RETURN 
C IGNORE DISABLED.
       GO TO (1000,2000,3000,4000,5000,6000,7000,8000,9000,10000,
     1 11000,12000,13000,14000,15000,16000,17000,18000,19000,
     2 20000,21000,22000,23000,24000),RI
       CALL BUG(3,RI)
C
C CEV1--       CURE CLOCK.  LET PLAYER SLOWLY RECOVER.
C
1000       ASTREN(PLAYER)=MIN0(0,ASTREN(PLAYER)+1)  
C RECOVER.
       IF(ASTREN(PLAYER).GE.0) RETURN  
C FULLY RECOVERED?
       CTICK(CEVCUR)=30 
C NO, WAIT SOME MORE.
       RETURN
C
C CEV2--       MAINT-ROOM WITH LEAK.  RAISE THE WATER LEVEL.
C
2000       IF(HERE.EQ.MAINT) CALL RSPEAK(71+(RVMNT/2)) 
C DESCRIBE.
       RVMNT=RVMNT+1    
C RAISE WATER LEVEL.
       IF(RVMNT.LE.16) RETURN 
C IF NOT FULL, EXIT.
       CTICK(CEVMNT)=0    
C FULL, DISABLE CLOCK.
       RFLAG(MAINT)=ZOR(RFLAG(MAINT),RMUNG)   
C MUNG ROOM.
       RVAL(MAINT)=80    
C SAY IT IS FULL OF WATER.
       IF(HERE.EQ.MAINT) CALL JIGSUP(81)   
C DROWN HIM IF PRESENT.
       RETURN
C
C CEV3--       LANTERN.  DESCRIBE GROWING DIMNESS.
C
3000       CALL LITINT(LAMP,ORLAMP,CEVLNT,LMPTCK,12) 
C DO LIGHT INTERRUPT.
       RETURN
C
C CEV4--       MATCH.  OUT IT GOES.
C
4000       CALL RSPEAK(153) 
C MATCH IS OUT.
       OFLAG1(MATCH)=ZAND(OFLAG1(MATCH), ZNOT(ONBT))
       RETURN
C
C CEV5--       CANDLE.  DESCRIBE GROWING DIMNESS.
C
5000       CALL LITINT(CANDL,ORCAND,CEVCND,CNDTCK,10) 
C DO CANDLE INTERRUPT.
       RETURN
C CEVAPP, PAGE 3
C
C CEV6--       BALLOON
C
6000       CTICK(CEVBAL)=3    
C RESCHEDULE INTERRUPT.
       F=AVEHIC(WINNER).EQ.BALLO  
C SEE IF IN BALLOON.
       IF(BLOC.EQ.VLBOT) GO TO 6800  
C AT BOTTOM?
       IF(QLEDGE(BLOC)) GO TO 6700  
C ON LEDGE?
       IF(QOPEN(RECEP).AND.(BINFF.NE.0))
     1       GO TO 6500 
C INFLATED AND RECEP OPEN?.
C
C BALLOON IS IN MIDAIR AND IS DEFLATED (OR HAS RECEPTACLE CLOSED).
C FALL TO NEXT ROOM.
C
       IF(BLOC.NE.VAIR1) GO TO 6300  
C IN VAIR1?
       BLOC=VLBOT    
C YES, NOW AT VLBOT.
       CALL NEWSTA(BALLO,0,BLOC,0,0)
       IF(F) GO TO 6200 
C IN BALLOON?
       IF(QLEDGE(HERE)) CALL RSPEAK(530)   
C ON LEDGE, DESCRIBE.
       RETURN
C
6200       F=MOVETO(BLOC,WINNER) 
C MOVE HIM.
       IF(BINFF.EQ.0) GO TO 6250  
C IN BALLOON.  INFLATED?
       CALL RSPEAK(531) 
C YES, LANDED.
       F=RMDESC(0)    
C DESCRIBE.
       RETURN
C
6250       CALL NEWSTA(BALLO,532,0,0,0)  
C NO, BALLOON & CONTENTS DIE.
       CALL NEWSTA(DBALL,0,BLOC,0,0)  
C INSERT DEAD BALLOON.
       AVEHIC(WINNER)=0 
C NOT IN VEHICLE.
       CFLAG(CEVBAL)=.FALSE. 
C DISABLE INTERRUPTS.
       CFLAG(CEVBRN)=.FALSE.
       BINFF=0
       BTIEF=0
       RETURN
C
6300       BLOC=BLOC-1    
C NOT IN VAIR1, DESCEND.
       CALL NEWSTA(BALLO,0,BLOC,0,0)
       IF(F) GO TO 6400 
C IS HE IN BALLOON?
       IF(QLEDGE(HERE)) CALL RSPEAK(533)   
C IF ON LEDGE, DESCRIBE.
       RETURN
C
6400       F=MOVETO(BLOC,WINNER) 
C IN BALLOON, MOVE HIM.
       CALL RSPEAK(534) 
C DESCRIBE.
       F=RMDESC(0)
       RETURN
C
C BALLOON IS IN MIDAIR AND IS INFLATED, UP-UP-AND-AWAY
C 
C
6500       IF(BLOC.NE.VAIR4) GO TO 6600  
C AT VAIR4?
       CTICK(CEVBRN)=0 
C DISABLE INTERRUPTS.
       CTICK(CEVBAL)=0
       BINFF=0
       BTIEF=0
       BLOC=VLBOT    
C FALL TO BOTTOM.
       CALL NEWSTA(BALLO,0,0,0,0)  
C BALLOON & CONTENTS DIE.
       CALL NEWSTA(DBALL,0,BLOC,0,0)  
C SUBSTITUTE DEAD BALLOON.
       IF(F) GO TO 6550 
C WAS HE IN IT?
       IF(QLEDGE(HERE)) CALL RSPEAK(535)   
C IF HE CAN SEE, DESCRIBE.
       RETURN
C
6550       CALL JIGSUP(536) 
C IN BALLOON AT CRASH, DIE.
       RETURN
C
6600       BLOC=BLOC+1    
C NOT AT VAIR4, GO UP.
       CALL NEWSTA(BALLO,0,BLOC,0,0)
       IF(F) GO TO 6650 
C IN BALLOON?
       IF(QLEDGE(HERE)) CALL RSPEAK(537)   
C CAN HE SEE IT?
       RETURN
C
6650       F=MOVETO(BLOC,WINNER) 
C MOVE PLAYER.
       CALL RSPEAK(538) 
C DESCRIBE.
       F=RMDESC(0)
       RETURN
C
C ON LEDGE, GOES TO MIDAIR ROOM WHETHER INFLATED OR NOT.
C
6700       BLOC=BLOC+(VAIR2-LEDG2) 
C MOVE TO MIDAIR.
       CALL NEWSTA(BALLO,0,BLOC,0,0)
       IF(F) GO TO 6750 
C IN BALLOON?
       IF(QLEDGE(HERE)) CALL RSPEAK(539)   
C NO, STRANDED.
       CTICK(CEVVLG)=10 
C MATERIALIZE GNOME.
       RETURN
C
6750       F=MOVETO(BLOC,WINNER) 
C MOVE TO NEW ROOM.
       CALL RSPEAK(540) 
C DESCRIBE.
       F=RMDESC(0)
       RETURN
C
C AT BOTTOM, GO UP IF INFLATED, DO NOTHING IF DEFLATED.
C
6800       IF((BINFF.EQ.0).OR..NOT.QOPEN(RECEP)) RETURN
       BLOC=VAIR1    
C INFLATED AND OPEN,
       CALL NEWSTA(BALLO,0,BLOC,0,0)  
C GO UP TO VAIR1.
       IF(F) GO TO 6850 
C IN BALLOON?
       IF(QLEDGE(HERE)) CALL RSPEAK(541)   
C IF CAN SEE, DESCRIBE.
       RETURN
C
6850       F=MOVETO(BLOC,WINNER) 
C MOVE PLAYER.
       CALL RSPEAK(542)
       F=RMDESC(0)
       RETURN
C CEVAPP, PAGE 4
C
C CEV7--       BALLOON BURNUP
C
7000       DO 7100 I=1,OLNT 
C FIND BURNING OBJECT
         IF((RECEP.EQ.OCAN(I)).AND.(ZAND(OFLAG1(I),FLAMBT).NE.0))
     1       GO TO 7200 
C IN RECEPTACLE.
7100       CONTINUE
       CALL BUG(4,0)
C
7200       CALL NEWSTA(I,0,0,0,0)  
C VANISH OBJECT.
       BINFF=0   
C UNINFLATED.
       IF(HERE.EQ.BLOC) CALL RSPSUB(292,ODESC2(I))   
C DESCRIBE.
       RETURN
C
C CEV8--       FUSE FUNCTION
C
8000       IF(OCAN(FUSE).NE.BRICK) GO TO 8500   
C IGNITED BRICK?
       BR=OROOM(BRICK)    
C GET BRICK ROOM.
       BC=OCAN(BRICK)    
C GET CONTAINER.
       IF((BR.EQ.0).AND.(BC.NE.0)) BR=OROOM(BC)
       CALL NEWSTA(FUSE,0,0,0,0)  
C KILL FUSE.
       CALL NEWSTA(BRICK,0,0,0,0)  
C KILL BRICK.
       IF((BR.NE.0).AND.(BR.NE.HERE)) GO TO 8100 
C BRICK ELSEWHERE?
C
       RFLAG(HERE)=ZOR(RFLAG(HERE),RMUNG)   
C BLEW SELF.
       RVAL(HERE)=114    
C MUNG ROOM.
       CALL JIGSUP(150) 
C DEAD.
       RETURN
C
8100       CALL RSPEAK(151) 
C BOOM.
       MUNGRM=BR    
C SAVE ROOM THAT BLEW.
       CTICK(CEVSAF)=5    
C SET SAFE INTERRUPT.
       IF(BR.NE.MSAFE) GO TO 8200  
C BLEW SAFE ROOM?
       IF(BC.NE.SSLOT) RETURN 
C WAS BRICK IN SAFE?
       CALL NEWSTA(SSLOT,0,0,0,0)  
C KILL SLOT.
       OFLAG2(SAFE)=ZOR(OFLAG2(SAFE),OPENBT)   
C OPEN SAFE.
       SAFEF=.TRUE.    
C INDICATE SAFE BLOWN.
       RETURN
C
8200       DO 8250 I=1,OLNT 
C BLEW WRONG ROOM.
         IF(QHERE(I,BR) .AND. (ZAND(OFLAG1(I),TAKEBT).NE.0))
     1       CALL NEWSTA(I,0,0,0,0)  
C VANISH CONTENTS.
8250       CONTINUE
       IF(BR.NE.LROOM) RETURN 
C BLEW LIVING ROOM?
       DO 8300 I=1,OLNT
         IF(OCAN(I).EQ.TCASE) CALL NEWSTA(I,0,0,0,0) 
C KILL TROPHY CASE.
8300       CONTINUE
       RETURN
C
8500       IF(QHERE(FUSE,HERE).OR.(OADV(FUSE).EQ.WINNER))
     1       CALL RSPEAK(152)
       CALL NEWSTA(FUSE,0,0,0,0)  
C KILL FUSE.
       RETURN
C CEVAPP, PAGE 5
C
C CEV9--       LEDGE MUNGE.
C
9000       RFLAG(LEDG4)=ZOR(RFLAG(LEDG4),RMUNG)   
C LEDGE COLLAPSES.
       RVAL(LEDG4)=109
       IF(HERE.EQ.LEDG4) GO TO 9100  
C WAS HE THERE?
       CALL RSPEAK(110) 
C NO, NARROW ESCAPE.
       RETURN
C
9100       IF(AVEHIC(WINNER).NE.0) GO TO 9200   
C IN VEHICLE?
       CALL JIGSUP(111) 
C NO, DEAD.
       RETURN
C
9200       IF(BTIEF.NE.0) GO TO 9300  
C TIED TO LEDGE?
       CALL RSPEAK(112) 
C NO, NO PLACE TO LAND.
       RETURN
C
9300       BLOC=VLBOT    
C YES, CRASH BALLOON.
       CALL NEWSTA(BALLO,0,0,0,0)  
C BALLOON & CONTENTS DIE.
       CALL NEWSTA(DBALL,0,BLOC,0,0)  
C INSERT DEAD BALLOON.
       BTIEF=0
       BINFF=0
       CFLAG(CEVBAL)=.FALSE.
       CFLAG(CEVBRN)=.FALSE.
       CALL JIGSUP(113) 
C DEAD
       RETURN
C
C CEV10--       SAFE MUNG.
C
10000       RFLAG(MUNGRM)=ZOR(RFLAG(MUNGRM),RMUNG)   
C MUNG TARGET.
       RVAL(MUNGRM)=114
       IF(HERE.EQ.MUNGRM) GO TO 10100  
C IS HE PRESENT?
       CALL RSPEAK(115) 
C LET HIM KNOW.
       IF(MUNGRM.EQ.MSAFE) CTICK(CEVLED)=8   
C START LEDGE CLOCK.
       RETURN
C
10100       I=116   
C HE'S DEAD,
       IF(ZAND(RFLAG(HERE),RHOUSE).NE.0) I=117   
C ONE WAY OR ANOTHER.
       CALL JIGSUP(I)    
C LET HIM KNOW.
       RETURN
C CEVAPP, PAGE 6
C
C CEV11--       VOLCANO GNOME
C
11000       IF(QLEDGE(HERE)) GO TO 11100  
C IS HE ON LEDGE?
       CTICK(CEVVLG)=1    
C NO, WAIT A WHILE.
       RETURN
C
11100       CALL NEWSTA(GNOME,118,HERE,0,0)  
C YES, MATERIALIZE GNOME.
       RETURN
C
C CEV12--       VOLCANO GNOME DISAPPEARS
C
12000       CALL NEWSTA(GNOME,149,0,0,0)  
C DISAPPEAR THE GNOME.
       RETURN
C
C CEV13--       BUCKET.
C
13000       IF(OCAN(WATER).EQ.BUCKE)
     1       CALL NEWSTA(WATER,0,0,0,0)   
C WATER LEAKS OUT.
       RETURN
C
C CEV14--       SPHERE.  IF EXPIRES, HE'S TRAPPED.
C
14000       RFLAG(CAGER)=ZOR(RFLAG(CAGER),RMUNG)   
C MUNG ROOM.
       RVAL(CAGER)=147
       CALL JIGSUP(148) 
C MUNG PLAYER.
       RETURN
C
C CEV15--       END GAME HERALD.
C
15000       ENDGMF=.TRUE.    
C WE'RE IN ENDGAME.
       CALL RSPEAK(119) 
C INFORM OF ENDGAME.
       RETURN
C CEVAPP, PAGE 7
C
C CEV16--       FOREST MURMURS
C
16000       CFLAG(CEVFOR)=(HERE.EQ.MTREE).OR.
     1       ((HERE.GE.FORE1).AND.(HERE.LT.CLEAR))
       IF(CFLAG(CEVFOR).AND.PROB(10,10)) CALL RSPEAK(635)
       RETURN
C
C CEV17--       SCOL ALARM
C
17000       IF(HERE.EQ.BKTWI) CFLAG(CEVZGI)=.TRUE.   
C IF IN TWI, GNOME.
       IF(HERE.EQ.BKVAU) CALL JIGSUP(636)   
C IF IN VAU, DEAD.
       RETURN
C
C CEV18--       ENTER GNOME OF ZURICH
C
18000       CFLAG(CEVZGO)=.TRUE. 
C EXITS, TOO.
       CALL NEWSTA(ZGNOM,0,BKTWI,0,0)  
C PLACE IN TWI.
       IF(HERE.EQ.BKTWI) CALL RSPEAK(637)   
C ANNOUNCE.
       RETURN
C
C CEV19--       EXIT GNOME
C
19000       CALL NEWSTA(ZGNOM,0,0,0,0)  
C VANISH.
       IF(HERE.EQ.BKTWI) CALL RSPEAK(638)   
C ANNOUNCE.
       RETURN
C CEVAPP, PAGE 8
C
C CEV20--       START OF ENDGAME
C
20000       IF(SPELLF) GO TO 20200 
C SPELL HIS WAY IN?
       IF(HERE.NE.CRYPT) RETURN  
C NO, STILL IN TOMB?
       IF(.NOT.LIT(HERE)) GO TO 20100  
C LIGHTS OFF?
       CTICK(CEVSTE)=3    
C RESCHEDULE.
       RETURN
C
20100       CALL RSPEAK(727) 
C ANNOUNCE.
20200       DO 20300 I=1,OLNT 
C STRIP HIM OF OBJS.
         CALL NEWSTA(I,0,OROOM(I),OCAN(I),0)
20300       CONTINUE
       CALL NEWSTA(LAMP,0,0,0,PLAYER)  
C GIVE HIM LAMP.
       CALL NEWSTA(SWORD,0,0,0,PLAYER)  
C GIVE HIM SWORD.
C
       OFLAG1(LAMP)=ZAND(ZOR(OFLAG1(LAMP),LITEBT), ZNOT(ONBT))
       OFLAG2(LAMP)=ZOR(OFLAG2(LAMP),TCHBT)
       CFLAG(CEVLNT)=.FALSE. 
C LAMP IS GOOD AS NEW.
       CTICK(CEVLNT)=350
       ORLAMP=0
       OFLAG2(SWORD)=ZOR(OFLAG2(SWORD),TCHBT)   
C RECREATE SWORD.
       SWDACT=.TRUE.
       SWDSTA=0
C
       THFACT=.FALSE.    
C THIEF GONE.
       ENDGMF=.TRUE.    
C ENDGAME RUNNING.
       CFLAG(CEVMAT)=.FALSE. 
C MATCHES GONE,
       CFLAG(CEVCND)=.FALSE. 
C CANDLES GONE.
C
       CALL SCRUPD(RVAL(CRYPT))  
C SCORE CRYPT,
       RVAL(CRYPT)=0    
C BUT ONLY ONCE.
       F=MOVETO(TSTRS,WINNER) 
C TO TOP OF STAIRS,
       F=RMDESC(3)    
C AND DESCRIBE.
       RETURN   
C BAM
C 
C
C CEV21--       MIRROR CLOSES.
C
21000       MRPSHF=.FALSE. 
C BUTTON IS OUT.
       MROPNF=.FALSE.    
C MIRROR IS CLOSED.
       IF(HERE.EQ.MRANT) CALL RSPEAK(728)   
C DESCRIBE BUTTON.
       IF((HERE.EQ.INMIR).OR.(MRHERE(HERE).EQ.1))
     1       CALL RSPEAK(729)  
C DESCRIBE MIRROR.
       RETURN
C CEVAPP, PAGE 9
C
C CEV22--       DOOR CLOSES.
C
22000       IF(WDOPNF) CALL RSPEAK(730)  
C DESCRIBE.
       WDOPNF=.FALSE.    
C CLOSED.
       RETURN
C
C CEV23--       INQUISITOR'S QUESTION
C
23000       IF(AROOM(PLAYER).NE.FDOOR) RETURN   
C IF PLAYER LEFT, DIE.
       CALL RSPEAK(769)
       CALL RSPEAK(770+QUESNO)
       CTICK(CEVINQ)=2
       RETURN
C
C CEV24--       MASTER FOLLOWS
C
24000       IF(AROOM(AMASTR).EQ.HERE) RETURN   
C NO MOVEMENT, DONE.
       IF((HERE.NE.CELL).AND.(HERE.NE.PCELL)) GO TO 24100
       IF(FOLLWF) CALL RSPEAK(811)  
C WONT GO TO CELLS.
       FOLLWF=.FALSE.
       RETURN
C
24100       FOLLWF=.TRUE.    
C FOLLOWING.
       I=812   
C ASSUME CATCHES UP.
       DO 24200 J=XMIN,XMAX,XMIN
         IF(FINDXT(J,AROOM(AMASTR)).AND.(XROOM1.EQ.HERE))
     1       I=813    
C ASSUME FOLLOWS.
24200       CONTINUE
       CALL RSPEAK(I)
       CALL NEWSTA(MASTER,0,HERE,0,0)  
C MOVE MASTER OBJECT.
       AROOM(AMASTR)=HERE  
C MOVE MASTER PLAYER.
       RETURN
C
       END
C LITINT-       LIGHT INTERRUPT PROCESSOR
C
C DECLARATIONS
C
       SUBROUTINE LITINT(OBJ,CTR,CEV,TICKS,TICKLN)
       IMPLICIT INTEGER (A-Z)
       INTEGER TICKS(TICKLN)
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       CTR=CTR+1    
C ADVANCE STATE CNTR.
       CTICK(CEV)=TICKS(CTR)  
C RESET INTERRUPT.
       IF(CTICK(CEV).NE.0) GO TO 100  
C EXPIRED?
       OFLAG1(OBJ)=ZAND(OFLAG1(OBJ), ZNOT(LITEBT+FLAMBT+ONBT))
       IF((OROOM(OBJ).EQ.HERE).OR.(OADV(OBJ).EQ.WINNER))
     1       CALL RSPSUB(293,ODESC2(OBJ))
       RETURN
C
100       IF((OROOM(OBJ).EQ.HERE).OR.(OADV(OBJ).EQ.WINNER))
     1       CALL RSPEAK(TICKS(CTR+(TICKLN/2)))
       RETURN
C
       END

C RAPPL1- SPECIAL PURPOSE ROOM ROUTINES, PART 1
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       LOGICAL FUNCTION RAPPL1(RI)
       IMPLICIT INTEGER (A-Z)
       LOGICAL QOPEN,QON,QHERE,PROB,F
       LOGICAL MOVETO,LIT
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C SCREEN OF LIGHT
C
       COMMON /SCREEN/ FROMDR,SCOLRM,SCOLAC
       COMMON /SCREEN/ SCOLDR(8),SCOLWL(12)
C
C MISCELLANEOUS VARIABLES
C
       COMMON /BATS/ BATDRP(9)
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1
       COMMON /RINDEX/ MGRAT,MAZ15
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1       CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2       CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3       CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     5       CEVMRS,CEVPIN,CEVINQ,CEVFOL
 
C
       LOGICAL THFFLG,THFACT,SWDACT
       COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
C FUNCTIONS AND DATA
C
       QOPEN(R)=ZAND(OFLAG2(R),OPENBT).NE.0
       QON(R)=ZAND(OFLAG1(R),ONBT).NE.0
C RAPPL1, PAGE 2
C
       RAPPL1=.TRUE.
C USUALLY IGNORED.
       IF(RI.EQ.0) RETURN
C RETURN IF NAUGHT.
C
C SET TO FALSE FOR
C
C NEW DESC NEEDED.
       GO TO (1000,2000,3000,4000,5000,6000,7000,8000,9000,10000,
     1 11000,12000,13000,14000,15000,16000,17000,18000,19000,20000,
     2 21000,22000,23000,24000,25000,26000,27000,28000,29000,30000,
     3 31000,32000,33000,34000,35000,36000,37000),RI
       CALL BUG(1,RI)
C
C R1--       EAST OF HOUSE.  DESCRIPTION DEPENDS ON STATE OF WINDOW
C
1000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       I=13
C ASSUME CLOSED.
       IF(QOPEN(WINDO)) I=12
C IF OPEN, AJAR.
       CALL RSPSUB(11,I)
C DESCRIBE.
       RETURN
C
C R2--       KITCHEN.  SAME VIEW FROM INSIDE.
C
2000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       I=13
C ASSUME CLOSED.
       IF(QOPEN(WINDO)) I=12
C IF OPEN, AJAR.
       CALL RSPSUB(14,I)
C DESCRIBE.
       RETURN
C
C R3--       LIVING ROOM.  DESCRIPTION DEPENDS ON MAGICF (STATE OF
C       DOOR TO CYCLOPS ROOM), RUG (MOVED OR NOT), DOOR (OPEN OR CLOSED)
C
3000       IF(PRSA.NE.LOOKW) GO TO 3500
C LOOK?
       I=15
C ASSUME NO HOLE.
       IF(MAGICF) I=16
C IF MAGICF, CYCLOPS HOLE.
       CALL RSPEAK(I)
C DESCRIBE.
       I=17+ORRUG
C ASSUME INITIAL STATE.
       IF(QOPEN(DOOR)) I=I+2
C DOOR OPEN?
       CALL RSPEAK(I)
C DESCRIBE.
       RETURN
C
C       NOT A LOOK WORD.  REEVALUATE TROPHY CASE.
C
3500       IF((PRSA.NE.TAKEW).AND.((PRSA.NE.PUTW).OR.(PRSI.NE.TCASE)))
     1       RETURN
C IF NOT TAKE OR PUT.
       ASCORE(WINNER)=RWSCOR
C SCORE TROPHY CASE.
       DO 3600 I=1,OLNT
C RETAIN RAW SCORE AS WELL.
         J=I
C FIND OUT IF IN CASE.
3550         J=OCAN(J)
C TRACE OWNERSHIP.
         IF(J.EQ.0) GO TO 3600
         IF(J.NE.TCASE) GO TO 3550
C DO ALL LEVELS.
         ASCORE(WINNER)=ASCORE(WINNER)+OTVAL(I)
3600       CONTINUE
       CALL SCRUPD(0)
C SEE IF ENDGAME TRIG.
       RETURN
C RAPPL1, PAGE 3
C
C R4--       CELLAR.  SHUT DOOR AND BAR IT IF HE JUST WALKED IN.
C
4000       IF(PRSA.NE.LOOKW) GO TO 4500
C LOOK?
       CALL RSPEAK(21)
C DESCRIBE CELLAR.
       RETURN
C
4500       IF(PRSA.NE.WALKIW) RETURN
C WALKIN?
       IF(ZAND(OFLAG2(DOOR),(OPENBT+TCHBT)).NE.OPENBT) RETURN
       OFLAG2(DOOR)=ZAND(ZOR(OFLAG2(DOOR),TCHBT), ZNOT(OPENBT))
       CALL RSPEAK(22)
C SLAM AND BOLT DOOR.
       RETURN
C
C R5--       MAZE11.  DESCRIBE STATE OF GRATING.
C
5000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       CALL RSPEAK(23)
C DESCRIBE.
       I=24
C ASSUME LOCKED.
       IF(GRUNLF) I=26
C UNLOCKED?
       IF(QOPEN(GRATE)) I=25
C OPEN?
       CALL RSPEAK(I)
C DESCRIBE GRATE.
       RETURN
C
C R6--       CLEARING.  DESCRIBE CLEARING, MOVE LEAVES.
C
6000       IF(PRSA.NE.LOOKW) GO TO 6500
C LOOK?
       CALL RSPEAK(27)
C DESCRIBE.
       IF(RVCLR.EQ.0) RETURN
C LEAVES MOVED?
       I=28
C YES, ASSUME GRATE CLOSED.
       IF(QOPEN(GRATE)) I=29
C OPEN?
       CALL RSPEAK(I)
C DESCRIBE GRATE.
       RETURN
C
6500       IF((RVCLR.NE.0).OR.(QHERE(LEAVE,CLEAR).AND.
     1       ((PRSA.NE.MOVEW).OR.(PRSO.NE.LEAVE)))) RETURN
       CALL RSPEAK(30)
C MOVE LEAVES, REVEAL GRATE.
       RVCLR=1
C INDICATE LEAVES MOVED.
       RETURN
C RAPPL1, PAGE 4
C
C R7--       RESERVOIR SOUTH.  DESCRIPTION DEPENDS ON LOW TIDE FLAG.
C
7000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       I=31
C ASSUME FULL.
       IF(LWTIDF) I=32
C IF LOW TIDE, EMPTY.
       CALL RSPEAK(I)
C DESCRIBE.
       CALL RSPEAK(33)
C DESCRIBE EXITS.
       RETURN
C
C R8--       RESERVOIR.  STATE DEPENDS ON LOW TIDE FLAG.
C
8000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       I=34
C ASSUME FULL.
       IF(LWTIDF) I=35
C IF LOW TIDE, EMTPY.
       CALL RSPEAK(I)
C DESCRIBE.
       RETURN
C
C R9--       RESERVOIR NORTH.  ALSO DEPENDS ON LOW TIDE FLAG.
C
9000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       I=36
C YOU GET THE IDEA.
       IF(LWTIDF) I=37
       CALL RSPEAK(I)
       CALL RSPEAK(38)
       RETURN
C
C R10--       GLACIER ROOM.  STATE DEPENDS ON MELTED, VANISHED FLAGS.
C
10000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       CALL RSPEAK(39)
C BASIC DESCRIPTION.
       I=0
C ASSUME NO CHANGES.
       IF(GLACMF) I=40
C PARTIAL MELT?
       IF(GLACRF) I=41
C COMPLETE MELT?
       CALL RSPEAK(I)
C DESCRIBE.
       RETURN
C
C R11--       FOREST ROOM
C
11000       IF(PRSA.EQ.WALKIW) CFLAG(CEVFOR)=.TRUE.
C IF WALK IN, BIRDIE.
       RETURN
C
C R12--       MIRROR ROOM.  STATE DEPENDS ON MIRROR INTACT.
C
12000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       CALL RSPEAK(42)
C DESCRIBE.
       IF(MIRRMF) CALL RSPEAK(43)
C IF BROKEN, NASTY REMARK.
       RETURN
C RAPPL1, PAGE 5
C
C R13--       CAVE2 ROOM.  BLOW OUT CANDLES WITH 50% PROBABILITY.
C
13000       IF(PRSA.NE.WALKIW) RETURN
C WALKIN?
       IF(PROB(50,50).OR.(OADV(CANDL).NE.WINNER).OR.
     1       .NOT.QON(CANDL)) RETURN
C BLOW EM OUT?
       OFLAG1(CANDL)=ZAND(OFLAG1(CANDL),ZNOT( ONBT))
C YES.
       CALL RSPEAK(47)
C TELL OF WINDS.
       CFLAG(CEVCND)=.FALSE.
C HALT CANDLE COUNTDOWN.
       RETURN
C
C R14--       BOOM ROOM.  BLOW HIM UP IF CARRYING FLAMING OBJECT.
C
14000       J=ODESC2(CANDL)
C ASSUME CANDLE.
       IF((OADV(CANDL).EQ.WINNER).AND.QON(CANDL)) GO TO 14100
       J=ODESC2(TORCH)
C ASSUME TORCH.
       IF((OADV(TORCH).EQ.WINNER).AND.QON(TORCH)) GO TO 14100
       J=ODESC2(MATCH)
       IF((OADV(MATCH).EQ.WINNER).AND.QON(MATCH)) GO TO 14100
       RETURN
C SAFE
C
14100       IF(PRSA.NE.TRNONW) GO TO 14200
C TURN ON?
       CALL RSPSUB(294,J)
C BOOM
C 
       CALL JIGSUP(44)
       RETURN
C
14200       IF(PRSA.NE.WALKIW) RETURN
C WALKIN?
       CALL RSPSUB(295,J)
C BOOM
C 
       CALL JIGSUP(44)
       RETURN
C
C R15--       NO-OBJS.  SEE IF EMPTY HANDED, SCORE LIGHT SHAFT.
C
15000       EMPTHF=.TRUE.
C ASSUME TRUE.
       DO 15100 I=1,OLNT
C SEE IF CARRYING.
         IF(OADV(I).EQ.WINNER) EMPTHF=.FALSE.
15100       CONTINUE
C
       IF((HERE.NE.BSHAF).OR.(.NOT.LIT(HERE))) RETURN
       CALL SCRUPD(LTSHFT)
C SCORE LIGHT SHAFT.
       LTSHFT=0
C NEVER AGAIN.
       RETURN
C RAPPL1, PAGE 6
C
C R16--       MACHINE ROOM.  DESCRIBE MACHINE.
C
16000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       I=46
C ASSUME LID CLOSED.
       IF(QOPEN(MACHI)) I=12
C IF OPEN, OPEN.
       CALL RSPSUB(45,I)
C DESCRIBE.
       RETURN
C
C R17--       BAT ROOM.  UNLESS CARRYING GARLIC, FLY AWAY WITH ME...
C
17000       IF(PRSA.NE.LOOKW) GO TO 17500
C LOOK?
       CALL RSPEAK(48)
C DESCRIBE ROOM.
       IF(OADV(GARLI).EQ.WINNER) CALL RSPEAK(49) 
C BAT HOLDS NOSE.
       RETURN
C
17500       IF((PRSA.NE.WALKIW).OR.(OADV(GARLI).EQ.WINNER)) RETURN
       CALL RSPEAK(50)
C TIME TO FLY, JACK.
       F=MOVETO(BATDRP(ZRND(9)+1),WINNER)
C SELECT RANDOM DEST.
       RAPPL1=.FALSE.
C INDICATE NEW DESC NEEDED.
       RETURN
C
C R18--       DOME ROOM.  STATE DEPENDS ON WHETHER ROPE TIED TO RAILING.
C
18000       IF(PRSA.NE.LOOKW) GO TO 18500
C LOOK?
       CALL RSPEAK(51)
C DESCRIBE.
       IF(DOMEF) CALL RSPEAK(52)
C IF ROPE, DESCRIBE.
       RETURN
C
18500       IF(PRSA.EQ.LEAPW) CALL JIGSUP(53)
C DID HE JUMP???
       RETURN
C
C R19--       TORCH ROOM.  ALSO DEPENDS ON WHETHER ROPE TIED TO RAILING.
C
19000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       CALL RSPEAK(54)
C DESCRIBE.
       IF(DOMEF) CALL RSPEAK(55)
C IF ROPE, DESCRIBE.
       RETURN
C
C R20--       CAROUSEL ROOM.  SPIN HIM OR KILL HIM.
C
20000       IF(PRSA.NE.LOOKW) GO TO 20500
C LOOK?
       CALL RSPEAK(56)
C DESCRIBE.
       IF(.NOT.CAROFF) CALL RSPEAK(57)
C IF NOT FLIPPED, SPIN.
       RETURN
C
20500       IF((PRSA.EQ.WALKIW).AND.CAROZF) CALL JIGSUP(58)
C WALKED IN.
       RETURN
C RAPPL1, PAGE 7
C
C R21--       LLD ROOM.  HANDLE EXORCISE, DESCRIPTIONS.
C
21000       IF(PRSA.NE.LOOKW) GO TO 21500
C LOOK?
       CALL RSPEAK(59)
C DESCRIBE.
       IF(.NOT.LLDF) CALL RSPEAK(60)
C IF NOT VANISHED, GHOSTS.
       RETURN
C
21500       IF(PRSA.NE.EXORCW) RETURN
C EXORCISE?
       IF((OADV(BELL).EQ.WINNER).AND.(OADV(BOOK).EQ.WINNER).AND.
     1       (OADV(CANDL).EQ.WINNER).AND.QON(CANDL)) GO TO 21600
       CALL RSPEAK(62)
C NOT EQUIPPED.
       RETURN
C
21600       IF(QHERE(GHOST,HERE)) GO TO 21700
C GHOST HERE?
       CALL JIGSUP(61)
C NOPE, EXORCISE YOU.
       RETURN
C
21700       CALL NEWSTA(GHOST,63,0,0,0)
C VANISH GHOST.
       LLDF=.TRUE.
C OPEN GATE.
       RETURN
C
C R22--       LLD2-ROOM.  IS HIS HEAD ON A POLE?
C
22000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       CALL RSPEAK(64)
C DESCRIBE.
       IF(ONPOLF) CALL RSPEAK(65)
C ON POLE?
       RETURN
C
C R23--       DAM ROOM.  DESCRIBE RESERVOIR, PANEL.
C
23000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       CALL RSPEAK(66)
C DESCRIBE.
       I=67
       IF(LWTIDF) I=68
       CALL RSPEAK(I)
C DESCRIBE RESERVOIR.
       CALL RSPEAK(69)
C DESCRIBE PANEL.
       IF(GATEF) CALL RSPEAK(70)
C BUBBLE IS GLOWING.
       RETURN
C
C R24--       TREE ROOM
C
24000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       CALL RSPEAK(660)
C DESCRIBE.
       I=661
C SET FLAG FOR BELOW.
       DO 24200 J=1,OLNT
C DESCRIBE OBJ IN FORE3.
         IF(.NOT.QHERE(J,FORE3).OR.(J.EQ.FTREE)) GO TO 24200
         CALL RSPEAK(I)
C SET STAGE,
         I=0
         CALL RSPSUB(502,ODESC2(J))
C DESCRIBE.
24200       CONTINUE
       RETURN
C RAPPL1, PAGE 8
C
C R25--       CYCLOPS-ROOM.  DEPENDS ON CYCLOPS STATE, ASLEEP FLAG, MAGIC FLAG.
C
25000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       CALL RSPEAK(606)
C DESCRIBE.
       I=607
C ASSUME BASIC STATE.
       IF(RVCYC.GT.0) I=608
C >0?  HUNGRY.
       IF(RVCYC.LT.0) I=609
C <0?  THIRSTY.
       IF(CYCLOF) I=610
C ASLEEP?
       IF(MAGICF) I=611
C GONE?
       CALL RSPEAK(I)
C DESCRIBE.
       IF(.NOT.CYCLOF .AND.(RVCYC.NE.0))
     1       CALL RSPEAK(193+IABS(RVCYC))
C CYCLOPS IS ANNOYED.
       RETURN
C
C R26--       BANK BOX ROOM.
C
26000       IF(PRSA.NE.WALKIW) RETURN
C SURPRISE HIM.
       DO 26100 I=1,8,2
C SCOLRM DEPENDS ON
         IF(FROMDR.EQ.SCOLDR(I)) SCOLRM=SCOLDR(I+1)
26100       CONTINUE
C ENTRY DIRECTION.
       RETURN
C
C R27--       TREASURE ROOM.
C
27000       IF((PRSA.NE.WALKIW).OR. .NOT.THFACT)
     1       RETURN
C WALKIN, THIEF ACTIVE?
       IF(OROOM(THIEF).NE.HERE)
     1       CALL NEWSTA(THIEF,82,HERE,0,0)
C NO, MATERIALIZE HIM.
       THFPOS=HERE
C RESET SEARCH PATTERN.
       OFLAG2(THIEF)=ZOR(OFLAG2(THIEF),FITEBT)
C HE'S ANGRY.
       IF(OROOM(CHALI).EQ.HERE)
     1       OFLAG1(CHALI)=ZAND(OFLAG1(CHALI),ZNOT(TAKEBT))
C
C       VANISH EVERYTHING IN ROOM
C
       J=0
C ASSUME NOTHING TO VANISH.
       DO 27200 I=1,OLNT
         IF((I.EQ.CHALI).OR.(I.EQ.THIEF).OR..NOT.QHERE(I,HERE))
     1       GO TO 27200
C HERE?
         J=83
C FLAG BYEBYE.
         OFLAG1(I)=ZAND(OFLAG1(I),ZNOT(VISIBT))
C AWAY IT GOES.
27200       CONTINUE
       CALL RSPEAK(J)
C DESCRIBE.
       RETURN
C
C R28--       CLIFF FUNCTION.  SEE IF CARRYING INFLATED BOAT.
C
28000       DEFLAF=OADV(RBOAT).NE.WINNER
C TRUE IF NOT CARRYING.
       RETURN
C RAPPL1, PAGE 9
C
C R29--       RIVR4 ROOM.  PLAY WITH BUOY.
C
29000       IF(.NOT.BUOYF.OR.(OADV(BUOY).NE.WINNER)) RETURN
       CALL RSPEAK(84)
C GIVE HINT,
       BUOYF=.FALSE.
C THEN DISABLE.
       RETURN
C
C R30--       OVERFALLS.  DOOM.
C
30000       IF(PRSA.NE.LOOKW) CALL JIGSUP(85)
C OVER YOU GO.
       RETURN
C
C R31--       BEACH ROOM.  DIG A HOLE.
C
31000       IF((PRSA.NE.DIGW).OR.(PRSO.NE.SHOVE)) RETURN
       RVSND=RVSND+1
C INCREMENT DIG STATE.
       GO TO (31100,31100,31100,31400,31500),RVSND 
C PROCESS STATE.
       CALL BUG(2,RVSND)
C
31100       CALL RSPEAK(85+RVSND)
C 1-3... DISCOURAGE HIM.
       RETURN
C
31400       I=89
C ASSUME DISCOVERY.
       IF(ZAND(OFLAG1(STATU),VISIBT).NE.0) I=88 
C ALREADY DONE.
       CALL RSPEAK(I)
       OFLAG1(STATU)=ZOR(OFLAG1(STATU),VISIBT)
C MATERIALIZE STATUE.
       RETURN
C
31500       RVSND=0
C 5... SAND COLLAPSES
       CALL JIGSUP(90)
C AND SO DOES HE.
       RETURN
C
C R32--       TCAVE ROOM.  DIG A HOLE IN GUANO.
C
32000       IF((PRSA.NE.DIGW).OR.(PRSO.NE.SHOVE)) RETURN
       I=91
C ASSUME NO GUANO.
       IF(.NOT. QHERE(GUANO,HERE)) GO TO 32100
C IS IT HERE?
       RVGUA=MIN0(4,RVGUA+1)
C YES, SET NEW STATE.
       I=91+RVGUA
C GET NASTY REMARK.
32100       CALL RSPEAK(I)
C DESCRIBE.
       RETURN
C
C R33--       FALLS ROOM
C
33000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       CALL RSPEAK(96)
C DESCRIBE.
       I=97
C ASSUME NO RAINBOW.
       IF(RAINBF) I=98
C GOT ONE?
       CALL RSPEAK(I)
C DESCRIBE.
       RETURN
C RAPPL1, PAGE 10
C
C R34--       LEDGE FUNCTION.  LEDGE CAN COLLAPSE.
C
34000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       CALL RSPEAK(100)
C DESCRIBE.
       I=102
C ASSUME SAFE ROOM OK.
       IF(ZAND(RFLAG(MSAFE),RMUNG).NE.0) I=101
C IF MUNGED, ROOM GONE.
       CALL RSPEAK(I)
C DESCRIBE.
       RETURN
C
C R35--       SAFE ROOM.  STATE DEPENDS ON WHETHER SAFE BLOWN.
C
35000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       CALL RSPEAK(104)
C DESCRIBE.
       I=105
C ASSUME OK.
       IF(SAFEF) I=106
C BLOWN?
       CALL RSPEAK(I)
C DESCRIBE.
       RETURN
C
C R36--       MAGNET ROOM.  DESCRIBE, CHECK FOR SPINDIZZY DOOM.
C
36000       IF(PRSA.NE.LOOKW) GO TO 36500
C LOOK?
       CALL RSPEAK(107)
C DESCRIBE.
       RETURN
C
36500       IF((PRSA.NE.WALKIW).OR. .NOT.CAROFF) RETURN
C WALKIN ON FLIPPED?
       IF(CAROZF) GO TO 36600
C ZOOM?
       CALL RSPEAK(108)
C NO, SPIN HIS COMPASS.
       RETURN
C
36600       I=58
C SPIN HIS INSIDES.
       IF(WINNER.NE.PLAYER) I=99
C SPIN ROBOT.
       CALL JIGSUP(I)
C DEAD.
       RETURN
C
C R37--       CAGE ROOM.  IF SOLVED CAGE, MOVE TO OTHER CAGE ROOM.
C
37000       IF(CAGESF) F=MOVETO(CAGER,WINNER)
C IF SOLVED, MOVE.
       RETURN
C
       END
C RAPPL2- SPECIAL PURPOSE ROOM ROUTINES, PART 2
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       LOGICAL FUNCTION RAPPL2(RI)
       IMPLICIT INTEGER (A-Z)
       LOGICAL QOPEN,QHERE,F
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C MISCELLANEOUS VARIABLES
C
       COMMON /CHAN/ INPCH,OUTCH,DBCH,ZRECL
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1
       COMMON /RINDEX/ MGRAT,MAZ15
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C EXITS
C
       COMMON /XSRCH/ XMIN,XMAX,XDOWN,XUP,
     1       XNORTH,XSOUTH,XENTER,XEXIT,XEAST,XWEST
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1       CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2       CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3       CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     5       CEVMRS,CEVPIN,CEVINQ,CEVFOL
 
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C
C FUNCTIONS AND DATA
C
       QOPEN(R)=ZAND(OFLAG2(R),OPENBT).NE.0
       DATA NEWRMS/38/
C RAPPL2, PAGE 2
C
       RAPPL2=.TRUE.
       GO TO (38000,39000,40000,41000,42000,43000,44000,
     1       45000,46000,47000,48000,49000,50000,
     2       51000,52000,53000,54000,55000,56000,
     3       57000,58000,59000,60000),
     2       (RI-NEWRMS+1)
       CALL BUG(70,RI)
       RETURN
C
C R38--       MIRROR D ROOM
C
38000       IF(PRSA.EQ.LOOKW) CALL LOOKTO(FDOOR,MRG,0,682,681)
       RETURN
C
C R39--       MIRROR G ROOM
C
39000       IF(PRSA.EQ.WALKIW) CALL JIGSUP(685)
       RETURN
C
C R40--       MIRROR C ROOM
C
40000       IF(PRSA.EQ.LOOKW) CALL LOOKTO(MRG,MRB,683,0,681)
       RETURN
C
C R41--       MIRROR B ROOM
C
41000       IF(PRSA.EQ.LOOKW) CALL LOOKTO(MRC,MRA,0,0,681)
       RETURN
C
C R42--       MIRROR A ROOM
C
42000       IF(PRSA.EQ.LOOKW) CALL LOOKTO(MRB,0,0,684,681)
       RETURN
C RAPPL2, PAGE 3
C
C R43--       MIRROR C EAST/WEST
C
43000       IF(PRSA.EQ.LOOKW) CALL EWTELL(HERE,683)
       RETURN
C
C R44--       MIRROR B EAST/WEST
C
44000       IF(PRSA.EQ.LOOKW) CALL EWTELL(HERE,686)
       RETURN
C
C R45--       MIRROR A EAST/WEST
C
45000       IF(PRSA.EQ.LOOKW) CALL EWTELL(HERE,687)
       RETURN
C
C R46--       INSIDE MIRROR
C
46000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       CALL RSPEAK(688)
C DESCRIBE
C
C NOW DESCRIBE POLE STATE.
C
C CASES 1,2--       MDIR=270 & MLOC=MRB, POLE IS UP OR IN HOLE
C CASES 3,4--       MDIR=0 V MDIR=180, POLE IS UP OR IN CHANNEL
C CASE 5--       POLE IS UP
C
       I=689
C ASSUME CASE 5.
       IF((MDIR.EQ.270).AND.(MLOC.EQ.MRB))
     1       I=690+MIN0(POLEUF,1)
C CASES 1,2.
       IF(MOD(MDIR,180).EQ.0)
     1       I=692+MIN0(POLEUF,1)
C CASES 3,4.
       CALL RSPEAK(I)
C DESCRIBE POLE.
       CALL RSPSUB(694,695+(MDIR/45))
C DESCRIBE ARROW.
       RETURN
C RAPPL2, PAGE 4
C
C R47--       MIRROR EYE ROOM
C
47000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       I=704
C ASSUME BEAM STOP.
       DO 47100 J=1,OLNT
         IF(QHERE(J,HERE).AND.(J.NE.RBEAM)) GO TO 47200
47100       CONTINUE
       I=703
47200       CALL RSPSUB(I,ODESC2(J))
C DESCRIBE BEAM.
       CALL LOOKTO(MRA,0,0,0,0)
C LOOK NORTH.
       RETURN
C
C R48--       INSIDE CRYPT
C
48000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       I=46
C CRYPT IS OPEN/CLOSED.
       IF(QOPEN(TOMB)) I=12
       CALL RSPSUB(705,I)
       RETURN
C
C R49--       SOUTH CORRIDOR
C
49000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       CALL RSPEAK(706)
C DESCRIBE.
       I=46
C ODOOR IS OPEN/CLOSED.
       IF(QOPEN(ODOOR)) I=12
       IF(LCELL.EQ.4) CALL RSPSUB(707,I)
C DESCRIBE ODOOR IF THERE.
       RETURN
C
C R50--       BEHIND DOOR
C
50000       IF(PRSA.NE.WALKIW) GO TO 50100
C WALK IN?
       CFLAG(CEVFOL)=.TRUE.
C MASTER FOLLOWS.
       CTICK(CEVFOL)=-1
       RETURN
C
50100       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       I=46
C QDOOR IS OPEN/CLOSED.
       IF(QOPEN(QDOOR)) I=12
       CALL RSPSUB(708,I)
       RETURN
C RAPPL2, PAGE 5
C
C R51--       FRONT DOOR
C
51000       IF(PRSA.EQ.WALKIW) CTICK(CEVFOL)=0
C IF EXITS, KILL FOLLOW.
       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       CALL LOOKTO(0,MRD,709,0,0)
C DESCRIBE SOUTH.
       I=46
C PANEL IS OPEN/CLOSED.
       IF(INQSTF) I=12
C OPEN IF INQ STARTED.
       J=46
C QDOOR IS OPEN/CLOSED.
       IF(QOPEN(QDOOR)) J=12
       CALL RSPSB2(710,I,J)
       RETURN
C
C R52--       NORTH CORRIDOR
C
52000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       I=46
       IF(QOPEN(CDOOR)) I=12
C CDOOR IS OPEN/CLOSED.
       CALL RSPSUB(711,I)
       RETURN
C
C R53--       PARAPET
C
53000       IF(PRSA.EQ.LOOKW) CALL RSPSUB(712,712+PNUMB)
       RETURN
C
C R54--       CELL
C
54000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       I=721
C CDOOR IS OPEN/CLOSED.
       IF(QOPEN(CDOOR)) I=722
       CALL RSPEAK(I)
       I=46
C ODOOR IS OPEN/CLOSED.
       IF(QOPEN(ODOOR)) I=12
       IF(LCELL.EQ.4) CALL RSPSUB(723,I)
C DESCRIBE.
       RETURN
C
C R55--       PRISON CELL
C
55000       IF(PRSA.EQ.LOOKW) CALL RSPEAK(724)
C LOOK?
       RETURN
C
C R56--       NIRVANA CELL
C
56000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       I=46
C ODOOR IS OPEN/CLOSED.
       IF(QOPEN(ODOOR)) I=12
       CALL RSPSUB(725,I)
       RETURN
C RAPPL2, PAGE 6
C
C R57--       NIRVANA AND END OF GAME
C
57000       IF(PRSA.NE.WALKIW) RETURN
C WALKIN?
       CALL RSPEAK(726)
       CALL SCORE(.FALSE.)
       CLOSE(UNIT=DBCH)
       CALL EXIT
C
C R58--       TOMB ROOM
C
58000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       I=46
C TOMB IS OPEN/CLOSED.
       IF(QOPEN(TOMB)) I=12
       CALL RSPSUB(792,I)
       RETURN
C
C R59--       PUZZLE SIDE ROOM
C
59000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       I=861
C ASSUME DOOR CLOSED.
       IF(CPOUTF) I=862
C OPEN?
       CALL RSPEAK(I)
C DESCRIBE.
       RETURN
C
C R60--       PUZZLE ROOM
C
60000       IF(PRSA.NE.LOOKW) RETURN
C LOOK?
       IF(CPUSHF) GO TO 60100
C STARTED PUZZLE?
       CALL RSPEAK(868)
C NO, DESCRIBE.
       IF(ZAND(OFLAG2(WARNI),TCHBT).NE.0) CALL RSPEAK(869)
       RETURN
C
60100       CALL CPINFO(880,CPHERE)
C DESCRIBE ROOM.
       RETURN
C
       END
C LOOKTO--       DESCRIBE VIEW IN MIRROR HALLWAY
C
C DECLARATIONS
C
       SUBROUTINE LOOKTO(NRM,SRM,NT,ST,HT)
       IMPLICIT INTEGER(A-Z)
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C LOOKTO, PAGE 2
C
       CALL RSPEAK(HT)
C DESCRIBE HALL.
       CALL RSPEAK(NT)
C DESCRIBE NORTH VIEW.
       CALL RSPEAK(ST)
C DESCRIBE SOUTH VIEW.
       DIR=0
C ASSUME NO DIRECTION.
       IF(IABS(MLOC-HERE).NE.1) GO TO 200
C MIRROR TO N OR S?
       IF(MLOC.EQ.NRM) DIR=695
       IF(MLOC.EQ.SRM) DIR=699
C DIR=N/S.
       IF(MOD(MDIR,180).NE.0) GO TO 100
C MIRROR N-S?
       CALL RSPSUB(847,DIR)
C YES, HE SEES PANEL
       CALL RSPSB2(848,DIR,DIR)
C AND NARROW ROOMS.
       GO TO 200
C
100       M1=MRHERE(HERE)
C WHICH MIRROR?
       MRBF=0
C ASSUME INTACT.
       IF(((M1.EQ.1).AND..NOT.MR1F).OR.
     1  ((M1.EQ.2).AND..NOT.MR2F)) MRBF=1
C BROKEN?
       CALL RSPSUB(849+MRBF,DIR)
C DESCRIBE.
       IF((M1.EQ.1).AND.MROPNF) CALL RSPEAK(823+MRBF)
       IF(MRBF.NE.0) CALL RSPEAK(851)
C
200       I=0
C ASSUME NO MORE TO DO.
       IF((NT.EQ.0).AND.((DIR.EQ.0).OR.(DIR.EQ.699))) I=852
       IF((ST.EQ.0).AND.((DIR.EQ.0).OR.(DIR.EQ.695))) I=853
       IF((NT+ST+DIR).EQ.0) I=854
       IF(HT.NE.0) CALL RSPEAK(I)
C DESCRIBE HALLS.
       RETURN
C
       END
C EWTELL--       DESCRIBE E/W NARROW ROOMS
C
C DECLARATIONS
C
       SUBROUTINE EWTELL(RM,ST)
       IMPLICIT INTEGER(A-Z)
       LOGICAL M1
C
C ROOMS
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1
       COMMON /RINDEX/ MGRAT,MAZ15
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C EWTELL, PAGE 2
C
C NOTE THAT WE ARE EAST OR WEST OF MIRROR, AND
C MIRROR MUST BE N-S.
C
       M1=(MDIR+(MOD(RM-MRAE,2)*180)).EQ.180
       I=819+MOD(RM-MRAE,2)
C GET BASIC E/W STRING.
       IF((M1.AND..NOT.MR1F).OR.(.NOT.M1.AND..NOT.MR2F))
     1       I=I+2
C MIRROR BROKEN?
       CALL RSPEAK(I)
       IF(M1.AND.MROPNF) CALL RSPEAK(823+((I-819)/2))
       CALL RSPEAK(825)
       CALL RSPEAK(ST)
       RETURN
C
       END

       CHARACTER*74 BBB
       OPEN(UNIT=16,FILE='TEXTDATA.DAT',STATUS='OLD')

       OPEN(UNIT=17,FILE='DTEXT.DAT',STATUS='UNKNOWN',
     1       FORM='UNFORMATTED',ACCESS='DIRECT',
     2       RECL=78)
C        RECL SHOULD BE 78 FOR THE IBM-PC WITH MICROSOFT FORTRAN OR
C        CONVERSIONS USING F2C.
C
C        FOR VMS FORTRAN OR MIPS F77, TRY RECL = 20
C !!!!!       SEE ALSO MACHDEP.FOR    !!!!!!!!!!

       JREC = 1
1      CONTINUE
       DO 2 I=1,74
2      BBB(I:I) = ' '
       READ(16,100)IREC,BBB
100    FORMAT(I5,A74)
        do 3 i=1,74
        bbb(i:i) = char( xor( ichar(bbb(i:i)), 10 ) )
3       continue
       WRITE(17,REC=JREC)IREC,BBB
       JREC=JREC+1
       IF(IREC.NE.-1)GOTO 1
       CLOSE(16)
       CLOSE(17)
       END

C VAPPLI- MAIN VERB PROCESSING ROUTINE
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
C DECLARATIONS
C
       LOGICAL FUNCTION VAPPLI(RI)
       IMPLICIT INTEGER (A-Z)
       LOGICAL LIT,OBJACT
       LOGICAL QEMPTY,RMDESC,CLOCKD
       LOGICAL QOPEN,EDIBLE,DRKBLE
       LOGICAL TAKE,PUT,DROP,WALK
       LOGICAL QHERE,SVERBS,FINDXT,OAPPLI,F
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
       COMMON /STAR/ MBASE,STRBIT
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1
       COMMON /RINDEX/ MGRAT,MAZ15
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C EXITS
C
       COMMON /XSRCH/ XMIN,XMAX,XDOWN,XUP,
     1       XNORTH,XSOUTH,XENTER,XEXIT,XEAST,XWEST
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FUNCTIONS AND DATA
C
       QOPEN(R)=ZAND(OFLAG2(R),OPENBT).NE.0
       EDIBLE(R)=ZAND(OFLAG1(R),FOODBT).NE.0
       DRKBLE(R)=ZAND(OFLAG1(R),DRNKBT).NE.0
       DATA MXNOP/39/,MXSMP/99/
C VAPPLI, PAGE 2
C
       VAPPLI=.TRUE.
C ASSUME WINS.
C JDM ?????
       KPRSO=PRSO
       KPRSI=PRSI
       IF(KPRSO.LT.1)KPRSO=1
       IF(KPRSO.GT.220)KPRSO=220
       IF(KPRSI.LT.1)KPRSI=1
       IF(KPRSI.GT.220)KPRSI=220
C
       IF(PRSO.NE.0) ODO2=ODESC2(KPRSO)
C SET UP DESCRIPTORS.
       IF(PRSI.NE.0) ODI2=ODESC2(KPRSI)
       AV=AVEHIC(WINNER)
       RMK=372+ZRND(6)
C REMARK FOR HACK-HACKS.
C
       IF(RI.EQ.0) GO TO 10
C ZERO IS FALSE.
       IF(RI.LE.MXNOP) RETURN
C NOP?
       IF(RI.LE.MXSMP) GO TO 100
C SIMPLE VERB?
       GO TO (18000,20000,
     2       22000,23000,24000,25000,26000,27000,28000,29000,30000,
     3 31000,32000,33000,34000,35000,36000,      38000,39000,40000,
     4 41000,42000,43000,44000,45000,46000,47000,48000,49000,50000,
     5 51000,52000,53000,      55000,56000,      58000,59000,60000,
     6             63000,64000,65000,66000,      68000,69000,70000,
     7 71000,72000,73000,74000,            77000,78000,
     8 80000,81000,82000,83000,84000,85000,86000,87000,88000),
     8       (RI-MXSMP)
       CALL BUG(7,RI)
C
C ALL VERB PROCESSORS RETURN HERE TO DECLARE FAILURE.
C
10       VAPPLI=.FALSE.
C LOSE.
       RETURN
C
C SIMPLE VERBS ARE HANDLED EXTERNALLY.
C
100       VAPPLI=SVERBS(RI)
       RETURN
C VAPPLI, PAGE 3
C
C V100--       READ.  OUR FIRST REAL VERB.
C
18000       IF(LIT(HERE)) GO TO 18100
C ROOM LIT?
       CALL RSPEAK(356)
C NO, CANT READ.
       RETURN
C
18100       IF(PRSI.EQ.0) GO TO 18200
C READ THROUGH OBJ?
       IF(ZAND(OFLAG1(PRSI),TRANBT).NE.0) GO TO 18200
       CALL RSPSUB(357,ODI2)
C NOT TRANSPARENT.
       RETURN
C
18200       IF(ZAND(OFLAG1(PRSO),READBT).NE.0) GO TO 18300
       CALL RSPSUB(358,ODO2)
C NOT READABLE.
       RETURN
C
18300       IF(.NOT.OBJACT()) CALL RSPEAK(OREAD(PRSO))
       RETURN
C
C V101--       MELT.  UNLESS OBJECT HANDLES, JOKE.
C
20000       IF(.NOT.OBJACT()) CALL RSPSUB(361,ODO2)
       RETURN
C
C V102--       INFLATE.  WORKS ONLY WITH BOATS.
C
22000       IF(.NOT.OBJACT()) CALL RSPEAK(368)
C OBJ HANDLE?
       RETURN
C
C V103--       DEFLATE.
C
23000       IF(.NOT.OBJACT()) CALL RSPEAK(369)
C OBJ HANDLE?
       RETURN
C VAPPLI, PAGE 4
C
C V104--       ALARM.  IF SLEEPING, WAKE HIM UP.
C
24000       IF(ZAND(OFLAG2(PRSO),SLEPBT).EQ.0) GO TO 24100
       VAPPLI=OBJACT()
C SLEEPING, LET OBJ DO.
       RETURN
C
24100       CALL RSPSUB(370,ODO2)
C JOKE.
       RETURN
C
C V105--       EXORCISE.  OBJECTS HANDLE.
C
25000       F=OBJACT()
C OBJECTS HANDLE.
       RETURN
C
C V106--       PLUG.  LET OBJECTS HANDLE.
C
26000       IF(.NOT.OBJACT()) CALL RSPEAK(371)
       RETURN
C
C V107--       KICK.  IF OBJECT IGNORES, JOKE.
C
27000       IF(.NOT.OBJACT()) CALL RSPSB2(378,ODO2,RMK)
       RETURN
C
C V108--       WAVE.  SAME.
C
28000       IF(.NOT.OBJACT()) CALL RSPSB2(379,ODO2,RMK)
       RETURN
C
C V109,V110--       RAISE, LOWER.  SAME.
C
29000       CONTINUE
30000       IF(.NOT.OBJACT()) CALL RSPSB2(380,ODO2,RMK)
       RETURN
C
C V111--       RUB.  SAME.
C
31000       IF(.NOT.OBJACT()) CALL RSPSB2(381,ODO2,RMK)
       RETURN
C
C V112--       PUSH.  SAME.
C
32000       IF(.NOT.OBJACT()) CALL RSPSB2(382,ODO2,RMK)
       RETURN
C VAPPLI, PAGE 5
C
C V113--       UNTIE.  IF OBJECT IGNORES, JOKE.
C
33000       IF(OBJACT()) RETURN
C OBJECT HANDLE?
       I=383
C NO, NOT TIED.
       IF(ZAND(OFLAG2(PRSO),TIEBT).EQ.0) I=384
C NOT TIEABLE.
       CALL RSPEAK(I)
       RETURN
C
C V114--       TIE.  NEVER REALLY WORKS.
C
34000       IF(ZAND(OFLAG2(PRSO),TIEBT).NE.0) GO TO 34100
       CALL RSPEAK(385)
C NOT TIEABLE.
       RETURN
C
34100       IF(.NOT.OBJACT()) CALL RSPSUB(386,ODO2) 
C JOKE.
       RETURN
C
C V115--       TIE UP.  NEVER REALLY WORKS.
C
35000       IF(ZAND(OFLAG2(PRSI),TIEBT).NE.0) GO TO 35100
       CALL RSPSUB(387,ODO2)
C NOT TIEABLE.
       RETURN
C
35100       I=388
C ASSUME VILLAIN.
       IF(ZAND(OFLAG2(PRSO),VILLBT).EQ.0) I=389
       CALL RSPSUB(I,ODO2)
C JOKE.
       RETURN
C
C V116--       TURN.  OBJECT MUST HANDLE.
C
36000       IF(ZAND(OFLAG1(PRSO),TURNBT).NE.0) GO TO 36100
       CALL RSPEAK(390)
C NOT TURNABLE.
       RETURN
C
36100       IF(ZAND(OFLAG1(PRSI),TOOLBT).NE.0) GO TO 36200
       CALL RSPSUB(391,ODI2)
C NOT A TOOL.
       RETURN
C
36200       VAPPLI=OBJACT()
C LET OBJECT HANDLE.
       RETURN
C
C V117--       BREATHE.  BECOMES INFLATE WITH LUNGS.
C
38000       PRSA=INFLAW
       PRSI=LUNGS
       GO TO 22000
C HANDLE LIKE INFLATE.
C
C V118--       KNOCK.  MOSTLY JOKE.
C
39000       IF(OBJACT()) RETURN
C OBJ HANDLE?
       I=394
C JOKE FOR DOOR.
       IF(ZAND(OFLAG1(PRSO),DOORBT).EQ.0) I=395
       CALL RSPSUB(I,ODO2)
C JOKE FOR NONDOORS TOO.
       RETURN
C
C V119--       LOOK.
C
40000       IF(PRSO.NE.0) GO TO 41500
C SOMETHING TO LOOK AT?
       VAPPLI=RMDESC(3)
C HANDLED BY RMDESC.
       RETURN
C
C V120--       EXAMINE.
C
41000       IF(PRSO.NE.0) GO TO 41500
C SOMETHING TO EXAMINE?
       VAPPLI=RMDESC(0)
C HANDLED BY RMDESC.
       RETURN
C
41500       IF(OBJACT()) RETURN
C OBJ HANDLE?
       I=OREAD(PRSO)
C GET READING MATERIAL.
       IF(I.NE.0) CALL RSPEAK(I)
C OUTPUT IF THERE,
       IF(I.EQ.0) CALL RSPSUB(429,ODO2)
C OTHERWISE DEFAULT.
       PRSA=FOOW
C DEFUSE ROOM PROCESSORS.
       RETURN
C
C V121--       SHAKE.  IF HOLLOW OBJECT, SOME ACTION.
C
42000       IF(OBJACT()) RETURN
C OBJECT HANDLE?
       IF(ZAND(OFLAG2(PRSO),VILLBT).EQ.0) GO TO 42100
       CALL RSPEAK(371)
C JOKE FOR VILLAINS.
       RETURN
C
42100       IF(QEMPTY(PRSO).OR.(ZAND(OFLAG1(PRSO),TAKEBT).EQ.0))
     1       GO TO 10
C EMPTY OR NO TAKE?  FAILS.
       IF(QOPEN(PRSO)) GO TO 42300
C OPEN?  SPILL.
       CALL RSPSUB(396,ODO2)
C NO, DESCRIBE NOISE.
       RETURN
C
42300       CALL RSPSUB(397,ODO2)
C SPILL THE WORKS.
       DO 42500 I=1,OLNT
C SPILL CONTENTS.
         IF(OCAN(I).NE.PRSO) GO TO 42500
C INSIDE?
         OFLAG2(I)=ZOR(OFLAG2(I),TCHBT)
C TOUCH OBJECT.
         IF(AV.EQ.0) GO TO 42400
C IN VEHICLE?
         CALL NEWSTA(I,0,0,AV,0)
C YES, SPILL IN THERE.
         GO TO 42500
C
42400         CALL NEWSTA(I,0,HERE,0,0)
C NO, SPILL ON FLOOR,
         IF(I.EQ.WATER) CALL NEWSTA(I,133,0,0,0)
C BUT WATER DISAPPEARS.
42500       CONTINUE
       RETURN
C
C V122--       MOVE.  MOSTLY JOKES.
C
43000       IF(OBJACT()) RETURN
C OBJ HANDLE?
       I=398
C ASSUME NOT HERE.
       IF(QHERE(PRSO,HERE)) I=399
       CALL RSPSUB(I,ODO2)
C JOKE.
       RETURN
C VAPPLI, PAGE 6
C
C V123--       TURN ON.
C
44000       F=LIT(HERE)
C RECORD IF LIT.
       IF(OBJACT()) GO TO 44300
C OBJ HANDLE?
       IF((ZAND(OFLAG1(PRSO),LITEBT).NE.0).AND.
     1       (OADV(PRSO).EQ.WINNER)) GO TO 44100
       CALL RSPEAK(400)
C CANT DO IT.
       RETURN
C
44100       IF(ZAND(OFLAG1(PRSO),ONBT).EQ.0) GO TO 44200
       CALL RSPEAK(401)
C ALREADY ON.
       RETURN
C
44200       OFLAG1(PRSO)=ZOR(OFLAG1(PRSO),ONBT)
C TURN IT ON.
       CALL RSPSUB(404,ODO2)
44300       IF(.NOT.F .AND.LIT(HERE)) F=RMDESC(0)
C ROOM NEWLY LIT.
       RETURN
C
C V124--       TURN OFF.
C
45000       IF(OBJACT()) GO TO 45300
C OBJ HANDLE?
       IF((ZAND(OFLAG1(PRSO),LITEBT).NE.0).AND.
     1       (OADV(PRSO).EQ.WINNER)) GO TO 45100
       CALL RSPEAK(402)
C CANT DO IT.
       RETURN
C
45100       IF(ZAND(OFLAG1(PRSO),ONBT).NE.0) GO TO 45200
       CALL RSPEAK(403)
C ALREADY OFF.
       RETURN
C
45200       OFLAG1(PRSO)=ZAND(OFLAG1(PRSO),ZNOT(ONBT))
       CALL RSPSUB(405,ODO2)
45300       IF(.NOT.LIT(HERE)) CALL RSPEAK(406)
C MAY BE DARK.
       RETURN
C
C V125--       OPEN.  A FINE MESS.
C
46000       IF(OBJACT()) RETURN
C OBJ HANDLE?
       IF(ZAND(OFLAG1(PRSO),CONTBT).NE.0) GO TO 46100
46050       CALL RSPSUB(407,ODO2)
C NOT OPENABLE.
       RETURN
C
46100       IF(OCAPAC(PRSO).NE.0) GO TO 46200
       CALL RSPSUB(408,ODO2)
C NOT OPENABLE.
       RETURN
C
46200       IF(.NOT.QOPEN(PRSO)) GO TO 46225
       CALL RSPEAK(412)
C ALREADY OPEN.
       RETURN
C
46225       OFLAG2(PRSO)=ZOR(OFLAG2(PRSO),OPENBT)
C OPEN IT.
       IF((ZAND(OFLAG1(PRSO),TRANBT).NE.0).OR.QEMPTY(PRSO))
     1       GO TO 46300
       CALL PRINCO(PRSO,410)
C PRINT CONTENTS.
       RETURN
C
46300       CALL RSPEAK(409)
C DONE
       RETURN
C
C V126--       CLOSE.
C
47000       IF(OBJACT()) RETURN
C OBJ HANDLE?
       IF(ZAND(OFLAG1(PRSO),CONTBT).EQ.0) GO TO 46050
       IF(OCAPAC(PRSO).NE.0) GO TO 47100
       CALL RSPSUB(411,ODO2)
C NOT CLOSABLE.
       RETURN
C
47100       IF(QOPEN(PRSO)) GO TO 47200
C OPEN?
       CALL RSPEAK(413)
C NO, JOKE.
       RETURN
C
47200       OFLAG2(PRSO)=ZAND(OFLAG2(PRSO),ZNOT(OPENBT))
       CALL RSPEAK(414)
C DONE.
       RETURN
C VAPPLI, PAGE 7
C
C V127--       FIND.  BIG MEGILLA.
C
48000       IF(OBJACT()) RETURN
C OBJ HANDLE?
       I=415
C DEFAULT CASE.
       IF(QHERE(PRSO,HERE)) GO TO 48300
C IN ROOM?
       IF(OADV(PRSO).EQ.WINNER) GO TO 48200
C ON WINNER?
       J=OCAN(PRSO)
C DOWN ONE LEVEL.
       IF(J.EQ.0) GO TO 10
       IF(((ZAND(OFLAG1(J),TRANBT).EQ.0).AND.
     2 (.NOT.QOPEN(J).OR.(ZAND(OFLAG1(J),(DOORBT+CONTBT)).EQ.0))))
     3       GO TO 10
C IF NOT VISIBLE, PUNT.
       I=417
C ASSUME IN ROOM.
       IF(QHERE(J,HERE)) GO TO 48100
       IF(OADV(J).NE.WINNER) GO TO 10
C NOT HERE OR ON PERSON.
       I=418
48100       CALL RSPSUB(I,ODESC2(J))
C DESCRIBE FINDINGS.
       RETURN
C
48200       I=416
48300       CALL RSPSUB(I,ODO2)
C DESCRIBE FINDINGS.
       RETURN
C
C V128--       WAIT.  RUN CLOCK DEMON.
C
49000       CALL RSPEAK(419)
C TIME PASSES.
       DO 49100 I=1,3
         IF(CLOCKD(X)) RETURN
49100       CONTINUE
       RETURN
C
C V129--       SPIN.
C V159--       TURN TO.
C
50000       CONTINUE
88000       IF(.NOT.OBJACT()) CALL RSPEAK(663)
C IF NOT OBJ, JOKE.
       RETURN
C
C V130--       BOARD.  WORKS WITH VEHICLES.
C
51000       IF(ZAND(OFLAG2(PRSO),VEHBT).NE.0) GO TO 51100
       CALL RSPSUB(421,ODO2)
C NOT VEHICLE, JOKE.
       RETURN
C
51100       IF(QHERE(PRSO,HERE)) GO TO 51200
C HERE?
       CALL RSPSUB(420,ODO2)
C NO, JOKE.
       RETURN
C
51200       IF(AV.EQ.0) GO TO 51300
C ALREADY GOT ONE?
       CALL RSPSUB(422,ODO2)
C YES, JOKE.
       RETURN
C
51300       IF(OBJACT()) RETURN
C OBJ HANDLE?
       CALL RSPSUB(423,ODO2)
C DESCRIBE.
       AVEHIC(WINNER)=PRSO
       IF(WINNER.NE.PLAYER) OCAN(AOBJ(WINNER))=PRSO
       RETURN
C
C V131--       DISEMBARK.
C
52000       IF(AV.EQ.PRSO) GO TO 52100
C FROM VEHICLE?
       CALL RSPEAK(424)
C NO, JOKE.
       RETURN
C
52100       IF(OBJACT()) RETURN
C OBJ HANDLE?
       IF(ZAND(RFLAG(HERE),RLAND).NE.0) GO TO 52200
       CALL RSPEAK(425)
C NOT ON LAND.
       RETURN
C
52200       AVEHIC(WINNER)=0
       CALL RSPEAK(426)
       IF(WINNER.NE.PLAYER) CALL NEWSTA(AOBJ(WINNER),0,HERE,0,0)
       RETURN
C
C V132--       TAKE.  HANDLED EXTERNALLY.
C
53000       VAPPLI=TAKE(.TRUE.)
       RETURN
C
C V133--       INVENTORY.  PROCESSED EXTERNALLY.
C
55000       CALL INVENT(WINNER)
       RETURN
C VAPPLI, PAGE 8
C
C V134--       FILL.  STRANGE DOINGS WITH WATER.
C
56000       IF(PRSI.NE.0) GO TO 56050
C ANY OBJ SPECIFIED?
       IF(ZAND(RFLAG(HERE),(RWATER+RFILL)).NE.0) GO TO 56025
       CALL RSPEAK(516)
C NOTHING TO FILL WITH.
       PRSWON=.FALSE.
C YOU LOSE.
       RETURN
C
56025       PRSI=GWATE
C USE GLOBAL WATER.
56050       IF(OBJACT()) RETURN
C OBJ HANDLE?
       IF((PRSI.NE.GWATE).AND.(PRSI.NE.WATER))
     1       CALL RSPSB2(444,ODI2,ODO2)
C NO, JOKE.
       RETURN
C
C V135,V136--       EAT/DRINK
C
58000       CONTINUE
59000       IF(OBJACT()) RETURN
C OBJ HANDLE?
       IF(PRSO.EQ.GWATE) GO TO 59500
C DRINK GLOBAL WATER?
       IF(.NOT.EDIBLE(PRSO)) GO TO 59400
C EDIBLE?
       IF(OADV(PRSO).EQ.WINNER) GO TO 59200
C YES, ON WINNER?
59100       CALL RSPSUB(454,ODO2)
C NOT ACCESSIBLE.
       RETURN
C
59200       IF(PRSA.EQ.DRINKW) GO TO 59300
C DRINK FOOD?
       CALL NEWSTA(PRSO,455,0,0,0)
C NO, IT DISAPPEARS.
       RETURN
C
59300       CALL RSPEAK(456)
C YES, JOKE.
       RETURN
C
59400       IF(.NOT.DRKBLE(PRSO)) GO TO 59600
C DRINKABLE?
       IF(OCAN(PRSO).EQ.0) GO TO 59100
C YES, IN SOMETHING?
       IF(OADV(OCAN(PRSO)).NE.WINNER) GO TO 59100
       IF(QOPEN(OCAN(PRSO))) GO TO 59500
C CONT OPEN?
       CALL RSPEAK(457)
C NO, JOKE.
       RETURN
C
59500       CALL NEWSTA(PRSO,458,0,0,0)
C GONE.
       RETURN
C
59600       CALL RSPSUB(453,ODO2)
C NOT FOOD OR DRINK.
       RETURN
C
C V137--       BURN.  COMPLICATED.
C
60000       IF(ZAND(OFLAG1(PRSI),(FLAMBT+LITEBT+ONBT)).NE.
     1       (FLAMBT+LITEBT+ONBT)) GO TO 60400
       IF(OBJACT()) RETURN
C OBJ HANDLE?
       IF(OCAN(PRSO).NE.RECEP) GO TO 60050
C BALLOON?
       IF(OAPPLI(OACTIO(BALLO),0)) RETURN
C DID IT HANDLE?
60050       IF(ZAND(OFLAG1(PRSO),BURNBT).EQ.0) GO TO 60300
       IF(OADV(PRSO).NE.WINNER) GO TO 60100
C CARRYING IT?
       CALL RSPSUB(459,ODO2)
       CALL JIGSUP(460)
       RETURN
C
60100       J=OCAN(PRSO)
C GET CONTAINER.
       IF(QHERE(PRSO,HERE).OR. ((AV.NE.0).AND.(J.EQ.AV)))
     1       GO TO 60200
C REACHABLE?
       IF(J.EQ.0) GO TO 60150
C INSIDE?
       IF(.NOT.QOPEN(J)) GO TO 60150
C OPEN?
       IF(QHERE(J,HERE).OR.((AV.NE.0).AND.(OCAN(J).EQ.AV)))
     1       GO TO 60200
C REACHABLE?
60150       CALL RSPEAK(461)
C CANT REACH IT.
       RETURN
C
60200       CALL RSPSUB(462,ODO2)
C BURN IT.
       CALL NEWSTA(PRSO,0,0,0,0)
       RETURN
C
60300       CALL RSPSUB(463,ODO2)
C CANT BURN IT.
       RETURN
C
60400       CALL RSPSUB(301,ODI2)
C CANT BURN IT WITH THAT.
       RETURN
C VAPPLI, PAGE 9
C
C V138--       MUNG.  GO TO COMMON ATTACK CODE.
C
63000       I=466
C CHOOSE PHRASE.
       IF(ZAND(OFLAG2(PRSO),VILLBT).NE.0) GO TO 66100
       IF(.NOT.OBJACT()) CALL RSPSB2(466,ODO2,RMK)
       RETURN
C
C V139--       KILL.  GO TO COMMON ATTACK CODE.
C
64000       I=467
C CHOOSE PHRASE.
       GO TO 66100
C
C V140--       SWING.  INVERT OBJECTS, FALL THRU TO ATTACK.
C
65000       J=PRSO
C INVERT.
       PRSO=PRSI
       PRSI=J
       J=ODO2
       ODO2=ODI2
       ODI2=J
       PRSA=ATTACW
C FOR OBJACT.
C
C V141--       ATTACK.  FALL THRU TO ATTACK CODE.
C
66000       I=468
C
C COMMON MUNG/ATTACK/SWING/KILL CODE.
C
66100       IF(PRSO.NE.0) GO TO 66200
C ANYTHING?
       CALL RSPEAK(469)
C NO, JOKE.
       RETURN
C
66200       IF(OBJACT()) RETURN
C OBJ HANDLE?
       IF(ZAND(OFLAG2(PRSO),VILLBT).NE.0) GO TO 66300
       IF(ZAND(OFLAG1(PRSO),VICTBT).EQ.0)
     1       CALL RSPSUB(470,ODO2)
C NOT A VILLAIN.
       RETURN
C
66300       J=471
C ASSUME NO WEAPON.
       IF(PRSI.EQ.0) GO TO 66500
       IF(ZAND(OFLAG2(PRSI),WEAPBT).EQ.0) GO TO 66400
       MELEE=1
C ASSUME SWORD.
       IF(PRSI.NE.SWORD) MELEE=2
C MUST BE KNIFE.
       I=BLOW(PLAYER,PRSO,MELEE,.TRUE.,0)
C STRIKE BLOW.
       RETURN
C
66400       J=472
C NOT A WEAPON.
66500       CALL RSPSB2(I,ODO2,J)
C JOKE.
       RETURN
C VAPPLI, PAGE 10
C
C V142--       WALK.  PROCESSED EXTERNALLY.
C
68000       VAPPLI=WALK()
       RETURN
C
C V143--       TELL.  PROCESSED IN GAME.
C
69000       CALL RSPEAK(603)
       RETURN
C
C V144--       PUT.  PROCESSED EXTERNALLY.
C
70000       VAPPLI=PUT()
       RETURN
C
C V145,V146,V147,V148--       DROP/GIVE/POUR/THROW
C
71000       CONTINUE
72000       CONTINUE
73000       CONTINUE
74000       VAPPLI=DROP()
       RETURN
C
C V149--       SAVE
C
77000       IF(ZAND(RFLAG(TSTRS),RSEEN).EQ.0) GO TO 77100
       CALL RSPEAK(828)
C NO SAVES IN ENDGAME.
       RETURN
C
77100       CALL SAVEGM
       RETURN
C
C V150--       RESTORE
C
78000       IF(ZAND(RFLAG(TSTRS),RSEEN).EQ.0) GO TO 78100
       CALL RSPEAK(829)
C NO RESTORES IN ENDGAME.
       RETURN
C
78100       CALL RSTRGM
       RETURN
C VAPPLI, PAGE 11
C
C V151--       HELLO
C
80000       IF(PRSO.NE.0) GO TO 80100
C ANY OBJ?
       CALL RSPEAK(346+ZRND(4))
C NO, VANILLA HELLO.
       RETURN
C
80100       IF(PRSO.NE.AVIAT) GO TO 80200
C HELLO AVIATOR?
       CALL RSPEAK(350)
C NOTHING HAPPENS.
       RETURN
C
80200       IF(PRSO.NE.SAILO) GO TO 80300
C HELLO SAILOR?
       HS=HS+1
C COUNT.
       I=351
C GIVE NORMAL OR
       IF(MOD(HS,10).EQ.0) I=352
C RANDOM MESSAGE.
       IF(MOD(HS,20).EQ.0) I=353
       CALL RSPEAK(I)
C SPEAK UP.
       RETURN
C
80300       IF(OBJACT()) RETURN
C OBJ HANDLE?
       I=354
C ASSUME VILLAIN.
       IF(ZAND(OFLAG2(PRSO),(VILLBT+ACTRBT)).EQ.0) I=355
       CALL RSPSUB(I,ODO2)
C HELLO THERE
C 
       RETURN
C
C V152--       LOOK INTO
C
81000       IF(OBJACT()) RETURN
C OBJ HANDLE?
       IF(ZAND(OFLAG1(PRSO),DOORBT).EQ.0) GO TO 81300
C DOOR?
       IF(.NOT.QOPEN(PRSO)) GO TO 81200
C OPEN?
       CALL RSPSUB(628,ODO2)
C OPEN DOOR- UNINTERESTING.
       RETURN
C
81200       CALL RSPSUB(525,ODO2)
C CLOSED DOOR- CANT SEE.
       RETURN
C
81300       IF(ZAND(OFLAG2(PRSO),VEHBT).NE.0) GO TO 81400
C VEHICLE?
       IF(QOPEN(PRSO).OR.(ZAND(OFLAG1(PRSO),TRANBT).NE.0))
     1       GO TO 81400
C OPEN OR SEE INSIDE?
       IF(ZAND(OFLAG1(PRSO),CONTBT).NE.0) GO TO 81200
C CLOSED CONT?
       CALL RSPSUB(630,ODO2)
C CANT LOOK INSIDE.
       RETURN
C
81400       IF(QEMPTY(PRSO)) GO TO 81500
C VEH OR SEE IN.  EMPTY?
       CALL PRINCO(PRSO,573)
C NO, LIST CONTENTS.
       RETURN
C
81500       CALL RSPSUB(629,ODO2)
C EMPTY.
       RETURN
C
C V153--       LOOK UNDER
C
82000       IF(.NOT.OBJACT()) CALL RSPEAK(631)
C OBJECT HANDLE?
       RETURN
C VAPPLI, PAGE 12
C
C V154--       PUMP
C
83000       IF((OROOM(PUMP).EQ.HERE).OR.(OADV(PUMP).EQ.WINNER))
     1       GO TO 83100
C PUMP HERE?
       CALL RSPEAK(632)
C NO.
       RETURN
C
83100       PRSI=PUMP
C BECOMES INFLATE
       PRSA=INFLAW
C X WITH PUMP.
       GO TO 22000
C DONE.
C
C V155--       WIND
C
84000       IF(.NOT.OBJACT()) CALL RSPSUB(634,ODO2)
C OBJ HANDLE?
       RETURN
C
C V156--       CLIMB
C V157--       CLIMB UP
C V158--       CLIMB DOWN
C
85000       CONTINUE
86000       CONTINUE
87000       I=XUP
C ASSUME UP.
       IF(PRSA.EQ.CLMBDW) I=XDOWN
C UNLESS CLIMB DN.
       F=ZAND(OFLAG2(PRSO),CLMBBT).NE.0
       IF(F.AND.FINDXT(I,HERE)) GO TO 87500
C ANYTHING TO CLIMB?
       IF(OBJACT()) RETURN
C OBJ HANDLE?
       I=657
       IF(F) I=524
C VARIETY OF JOKES.
       IF(.NOT.F .AND.((PRSO.EQ.WALL).OR.
     1       ((PRSO.GE.WNORT).AND.(PRSO.LE.WNORT+3))))
     2       I=656
C IF WALLS.
       CALL RSPEAK(I)
C JOKE.
       RETURN
C
87500       PRSA=WALKW
C WALK
       PRSO=I
C IN SPECIFIED DIR.
       VAPPLI=WALK()
       RETURN
C
       END
C CLOCKD- CLOCK DEMON FOR INTERMOVE CLOCK EVENTS
C
C DECLARATIONS
C
       LOGICAL FUNCTION CLOCKD(X)
       IMPLICIT INTEGER (A-Z)
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       I = X
       CLOCKD=.FALSE.
C ASSUME NO ACTION.
       DO 100 I=1,CLNT
         IF(.NOT.CFLAG(I) .OR.(CTICK(I).EQ.0)) GO TO 100
         IF(CTICK(I).LT.0) GO TO 50
C PERMANENT ENTRY?
         CTICK(I)=CTICK(I)-1
         IF(CTICK(I).NE.0) GO TO 100
C TIMER EXPIRED?
50         CLOCKD=.TRUE.
         CALL CEVAPP(CACTIO(I))
C DO ACTION.
100       CONTINUE
       RETURN
C
       END

C DUNGEON-- MAIN PROGRAM
C
C COPYRIGHT 1980, INFOCOM COMPUTERS AND COMMUNICATIONS, CAMBRIDGE MA. 02142
C ALL RIGHTS RESERVED, COMMERCIAL USAGE STRICTLY PROHIBITED
C WRITTEN BY R. M. SUPNIK
C
       PROGRAM DUNGEO
C 1) INITIALIZE DATA STRUCTURES
C 2) PLAY GAME
C
       IMPLICIT INTEGER (A-Z)
       LOGICAL INIT
C      COMMONS ARE PRESENT TO AVOID "SAVE" STATEMENTS
       CHARACTER*20 INFMTX
       COMMON /XINFMT/ INFMTX 
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C PARSER STATE
C
       COMMON /ORPHS/ OFLAG,OACT,OSLOT,OPREP,ONAME
       COMMON /LAST/ LASTIT
       COMMON /PV/ ACT,OBJ1,OBJ2,PREP1,PREP2
       COMMON /SYNTAX/ SYN(11)
       COMMON /SYNFLG/ SDIR,SIND,SSTD,SFLIP,SDRIV,SVMASK
       COMMON /OBJFLG/ VABIT,VRBIT,VTBIT,VCBIT,VEBIT,VFBIT,VPMASK
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C SCREEN OF LIGHT STATE
C
       COMMON /SCREEN/ FROMDR,SCOLRM,SCOLAC
       COMMON /SCREEN/ SCOLDR(8),SCOLWL(12)
C
C PUZZLE ROOM STATE
C
       COMMON /PUZZLE/ CPDR(16),CPWL(8),CPVEC(64)
C
C MESSAGE INDEX
C
       COMMON /RMSG/ MLNT,RTEXT(1050)
C
C MISCELLANEOUS VARIABLES
C
       CHARACTER INBUF
        COMMON /INPUTL/ INLNT
       COMMON /INPUT/ INBUF(78)
       COMMON /STAR/ MBASE,STRBIT
       COMMON /VERS/ VMAJ,VMIN,VEDIT
       COMMON /TIME/ PLTIME,SHOUR,SMIN,SSEC
       COMMON /BATS/ BATDRP(9)
       COMMON /CHAN/ INPCH,OUTCH,DBCH,ZRECL
       COMMON /DEBUG/ DBGFLG,PRSFLG,GDTFLG
       COMMON /HYPER/ HFACTR
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1 
       COMMON /RINDEX/ MGRAT,MAZ15 
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF 
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU 
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C EXITS
C
       COMMON /EXITS/ XLNT,TRAVEL(900)
C
       COMMON /CURXT/ XTYPE,XROOM1,XSTRNG,XACTIO,XOBJ
C
       COMMON /XPARS/ XRMASK,XDMASK,XFMASK,XFSHFT,XASHFT,
     1       XELNT(4),XNORM,XNO,XCOND,XDOOR,XLFLAG
C
       COMMON /XSRCH/ XMIN,XMAX,XDOWN,XUP,
     1       XNORTH,XSOUTH,XENTER,XEXIT,XEAST,XWEST
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OROOM2/ R2LNT,O2(20),R2(20)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1       CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2       CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3       CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     5       CEVMRS,CEVPIN,CEVINQ,CEVFOL
 
C
C VILLAINS AND DEMONS
C
       LOGICAL THFFLG,SWDACT,THFACT
       COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
       COMMON /VILL/ VLNT,VILLNS(4),VPROB(4),VOPPS(4),VBEST(4),VMELEE(4)
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AFLAGS/ ASTAG
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE


       IF(INIT()) CALL GAME       
C IF INIT, PLAY GAME.
C DONE
       END
 
       BLOCK DATA AAAAA
C
C DECLARATIONS
C
       IMPLICIT INTEGER (A-Z)
C
C PARSER OUTPUT
C
       LOGICAL PRSWON
       COMMON /PRSVEC/ PRSA,PRSI,PRSO,PRSWON,PRSCON
C
C PARSER STATE
C
       COMMON /ORPHS/ OFLAG,OACT,OSLOT,OPREP,ONAME
       COMMON /LAST/ LASTIT
       COMMON /PV/ ACT,OBJ1,OBJ2,PREP1,PREP2
       COMMON /SYNTAX/ SYN(11)
       COMMON /SYNFLG/ SDIR,SIND,SSTD,SFLIP,SDRIV,SVMASK
       COMMON /OBJFLG/ VABIT,VRBIT,VTBIT,VCBIT,VEBIT,VFBIT,VPMASK
C
C GAME STATE
C
       LOGICAL TELFLG
       COMMON /PLAY/ WINNER,HERE,TELFLG
       COMMON /STATE/ MOVES,DEATHS,RWSCOR,MXSCOR,MXLOAD,
     1       LTSHFT,BLOC,MUNGRM,HS,EGSCOR,EGMXSC
C
C SCREEN OF LIGHT STATE
C
       COMMON /SCREEN/ FROMDR,SCOLRM,SCOLAC
       COMMON /SCREEN/ SCOLDR(8),SCOLWL(12)
C
C PUZZLE ROOM STATE
C
       COMMON /PUZZLE/ CPDR(16),CPWL(8),CPVEC(64)
C
C MESSAGE INDEX
C
       COMMON /RMSG/ MLNT,RTEXT(1050)
C
C MISCELLANEOUS VARIABLES
C
       CHARACTER INBUF
        COMMON /INPUTL/ INLNT
       COMMON /INPUT/ INBUF(78)
       COMMON /STAR/ MBASE,STRBIT
       COMMON /VERS/ VMAJ,VMIN,VEDIT
       COMMON /TIME/ PLTIME,SHOUR,SMIN,SSEC
       COMMON /BATS/ BATDRP(9)
       COMMON /CHAN/ INPCH,OUTCH,DBCH,ZRECL
       COMMON /DEBUG/ DBGFLG,PRSFLG,GDTFLG
       COMMON /HYPER/ HFACTR
C
C ROOMS
C
       COMMON /ROOMS/ RLNT,RDESC2,RDESC1(200),REXIT(200),
     1       RACTIO(200),RVAL(200),RFLAG(200)
C
       COMMON /RFLAG/ RSEEN,RLIGHT,RLAND,RWATER,RAIR,
     1       RSACRD,RFILL,RMUNG,RBUCK,RHOUSE,RNWALL,REND
C
       COMMON /RINDEX/ WHOUS,LROOM,CELLA
       COMMON /RINDEX/ MTROL,MAZE1 
       COMMON /RINDEX/ MGRAT,MAZ15 
       COMMON /RINDEX/ FORE1,FORE3,CLEAR,RESER
       COMMON /RINDEX/ STREA,EGYPT,ECHOR
       COMMON /RINDEX/ TSHAF 
       COMMON /RINDEX/ BSHAF,MMACH,DOME,MTORC
       COMMON /RINDEX/ CAROU 
       COMMON /RINDEX/ RIDDL,LLD2,TEMP1,TEMP2,MAINT
       COMMON /RINDEX/ BLROO,TREAS,RIVR1,RIVR2,RIVR3,MCYCL
       COMMON /RINDEX/ RIVR4,RIVR5,FCHMP,FALLS,MBARR
       COMMON /RINDEX/ MRAIN,POG,VLBOT,VAIR1,VAIR2,VAIR3,VAIR4
       COMMON /RINDEX/ LEDG2,LEDG3,LEDG4,MSAFE,CAGER
       COMMON /RINDEX/ CAGED,TWELL,BWELL,ALICE,ALISM,ALITR
       COMMON /RINDEX/ MTREE,BKENT,BKVW,BKTWI,BKVAU,BKBOX
       COMMON /RINDEX/ CRYPT,TSTRS,MRANT,MREYE
       COMMON /RINDEX/ MRA,MRB,MRC,MRG,MRD,FDOOR
       COMMON /RINDEX/ MRAE,MRCE,MRCW,MRGE,MRGW,MRDW,INMIR
       COMMON /RINDEX/ SCORR,NCORR,PARAP,CELL,PCELL,NCELL
       COMMON /RINDEX/ CPANT,CPOUT,CPUZZ
C
C EXITS
C
       COMMON /EXITS/ XLNT,TRAVEL(900)
C
       COMMON /CURXT/ XTYPE,XROOM1,XSTRNG,XACTIO,XOBJ
C
       COMMON /XPARS/ XRMASK,XDMASK,XFMASK,XFSHFT,XASHFT,
     1       XELNT(4),XNORM,XNO,XCOND,XDOOR,XLFLAG
C
       COMMON /XSRCH/ XMIN,XMAX,XDOWN,XUP,
     1       XNORTH,XSOUTH,XENTER,XEXIT,XEAST,XWEST
C
C OBJECTS
C
       COMMON /OBJCTS/ OLNT,ODESC1(220),ODESC2(220),ODESCO(220),
     1       OACTIO(220),OFLAG1(220),OFLAG2(220),OFVAL(220),
     2       OTVAL(220),OSIZE(220),OCAPAC(220),OROOM(220),
     3       OADV(220),OCAN(220),OREAD(220)
C
       COMMON /OROOM2/ R2LNT,O2(20),R2(20)
C
       COMMON /OFLAGS/ VISIBT,READBT,TAKEBT,DOORBT,TRANBT,FOODBT,
     1       NDSCBT,DRNKBT,CONTBT,LITEBT,VICTBT,BURNBT,FLAMBT,
     2       TOOLBT,TURNBT,ONBT
       COMMON /OFLAGS/ FINDBT,SLEPBT,SCRDBT,TIEBT,CLMBBT,ACTRBT,
     1       WEAPBT,FITEBT,VILLBT,STAGBT,TRYBT,NOCHBT,OPENBT,
     2       TCHBT,VEHBT,SCHBT
C
       COMMON /OINDEX/ GARLI,FOOD,GUNK,COAL,MACHI,DIAMO,TCASE,BOTTL
       COMMON /OINDEX/ WATER,ROPE,KNIFE,SWORD,LAMP,BLAMP,RUG
       COMMON /OINDEX/       LEAVE,TROLL,AXE
       COMMON /OINDEX/ RKNIF,KEYS,ICE,BAR
       COMMON /OINDEX/ COFFI,TORCH,TBASK,FBASK,IRBOX
       COMMON /OINDEX/ GHOST,TRUNK,BELL,BOOK,CANDL
       COMMON /OINDEX/ MATCH,TUBE,PUTTY,WRENC,SCREW,CYCLO,CHALI
       COMMON /OINDEX/ THIEF,STILL,WINDO,GRATE,DOOR
       COMMON /OINDEX/ HPOLE,LEAK,RBUTT,RAILI
       COMMON /OINDEX/ POT,STATU,IBOAT,DBOAT,PUMP,RBOAT
       COMMON /OINDEX/ STICK,BUOY,SHOVE,BALLO,RECEP,GUANO
       COMMON /OINDEX/ BROPE,HOOK1,HOOK2,SAFE,SSLOT,BRICK,FUSE
       COMMON /OINDEX/ GNOME,BLABE,DBALL,TOMB
       COMMON /OINDEX/ LCASE,CAGE,RCAGE,SPHER,SQBUT
       COMMON /OINDEX/ FLASK,POOL,SAFFR,BUCKE,ECAKE,ORICE,RDICE,BLICE
       COMMON /OINDEX/ ROBOT,FTREE,BILLS,PORTR,SCOL,ZGNOM
       COMMON /OINDEX/ EGG,BEGG,BAUBL,CANAR,BCANA
       COMMON /OINDEX/ YLWAL,RDWAL,PINDR,RBEAM
       COMMON /OINDEX/ ODOOR,QDOOR,CDOOR,NUM1,NUM8
       COMMON /OINDEX/ WARNI,CSLIT,GCARD,STLDR
       COMMON /OINDEX/ HANDS,WALL,LUNGS,SAILO,AVIAT,TEETH
       COMMON /OINDEX/ ITOBJ,EVERY,VALUA,OPLAY,WNORT,GWATE,MASTER
C
C CLOCK INTERRUPTS
C
       LOGICAL CFLAG
       COMMON /CEVENT/ CLNT,CTICK(25),CACTIO(25),CFLAG(25)
C
       COMMON /CINDEX/ CEVCUR,CEVMNT,CEVLNT,CEVMAT,CEVCND,
     1       CEVBAL,CEVBRN,CEVFUS,CEVLED,CEVSAF,CEVVLG,
     2       CEVGNO,CEVBUC,CEVSPH,CEVEGH,
     3       CEVFOR,CEVSCL,CEVZGI,CEVZGO,CEVSTE,
     5       CEVMRS,CEVPIN,CEVINQ,CEVFOL
 
C
C VILLAINS AND DEMONS
C
       LOGICAL THFFLG,SWDACT,THFACT
       COMMON /HACK/ THFPOS,THFFLG,THFACT,SWDACT,SWDSTA
       COMMON /VILL/ VLNT,VILLNS(4),VPROB(4),VOPPS(4),VBEST(4),VMELEE(4)
C
C ADVENTURERS
C
       COMMON /ADVS/ ALNT,AROOM(4),ASCORE(4),AVEHIC(4),
     1       AOBJ(4),AACTIO(4),ASTREN(4),AFLAG(4)
C
       COMMON /AFLAGS/ ASTAG
C
       COMMON /AINDEX/ PLAYER,AROBOT,AMASTR
C
C VERBS
C
       COMMON /VINDEX/ CINTW,DEADXW,FRSTQW,INXW,OUTXW
       COMMON /VINDEX/ WALKIW,FIGHTW,FOOW
       COMMON /VINDEX/ MELTW,READW,INFLAW,DEFLAW,ALARMW,EXORCW
       COMMON /VINDEX/ PLUGW,KICKW,WAVEW,RAISEW,LOWERW,RUBW
       COMMON /VINDEX/ PUSHW,UNTIEW,TIEW,TIEUPW,TURNW,BREATW
       COMMON /VINDEX/ KNOCKW,LOOKW,EXAMIW,SHAKEW,MOVEW,TRNONW,TRNOFW
       COMMON /VINDEX/OPENW,CLOSEW,FINDW,WAITW,SPINW,BOARDW,UNBOAW,TAKEW
       COMMON /VINDEX/ INVENW,FILLW,EATW,DRINKW,BURNW
       COMMON /VINDEX/ MUNGW,KILLW,ATTACW,SWINGW
       COMMON /VINDEX/ WALKW,TELLW,PUTW,DROPW,GIVEW,POURW,THROWW
       COMMON /VINDEX/ DIGW,LEAPW,STAYW,FOLLOW
       COMMON /VINDEX/ HELLOW,LOOKIW,LOOKUW,PUMPW,WINDW
       COMMON /VINDEX/ CLMBW,CLMBUW,CLMBDW,TRNTOW
C
C FLAGS
C
       LOGICAL TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF
       LOGICAL DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF
       LOGICAL MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF
       LOGICAL EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF
       LOGICAL GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF
       LOGICAL GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF
       LOGICAL MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF
       LOGICAL FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ TROLLF,CAGESF,BUCKTF,CAROFF,CAROZF,LWTIDF,
     1       DOMEF,GLACRF,ECHOF,RIDDLF,LLDF,CYCLOF,
     2       MAGICF,LITLDF,SAFEF,GNOMEF,GNODRF,MIRRMF,
     3       EGYPTF,ONPOLF,BLABF,BRIEFF,SUPERF,BUOYF,
     4       GRUNLF,GATEF,RAINBF,CAGETF,EMPTHF,DEFLAF,
     5       GLACMF,FROBZF,ENDGMF,BADLKF,THFENF,SINGSF,
     6       MRPSHF,MROPNF,WDOPNF,MR1F,MR2F,INQSTF,
     7       FOLLWF,SPELLF,CPOUTF,CPUSHF
       COMMON /FINDEX/ BTIEF,BINFF
       COMMON /FINDEX/ RVMNT,RVCLR,RVCYC,RVSND,RVGUA
       COMMON /FINDEX/ ORRUG,ORCAND,ORMTCH,ORLAMP
       COMMON /FINDEX/ MDIR,MLOC,POLEUF
       COMMON /FINDEX/ QUESNO,NQATT,CORRCT
       COMMON /FINDEX/ LCELL,PNUMB,ACELL,DCELL,CPHERE
C DUNGEON, PAGE 2
C
C DATA STATEMENTS FOR CONSTANT ARRAYS
C
       DATA VMAJ/2/,VMIN/5/,VEDIT/2/
C
       DATA SDIR/16384/,SIND/8192/,SSTD/4096/,
     1       SFLIP/2048/,SDRIV/1024/,SVMASK/511/
       DATA VABIT/16384/,VRBIT/8192/,VTBIT/4096/,
     1       VCBIT/2048/,VEBIT/1024/,VFBIT/512/,VPMASK/511/
C
       DATA BATDRP/66,67,68,69,70,71,72,65,73/
C
       DATA SCOLDR/1024,153,5120,154,3072,152,7168,151/
       DATA SCOLWL/151,207,3072,152,208,7168,
     1       153,206,5120,154,205,1024/
C
       DATA HFACTR/500/
C
       DATA CPDR/1024,-8,2048,-7,3072,1,4096,9,
     1       5120,8,6144,7,7168,-1,8192,-9/
       DATA CPWL/205,-8,206,8,207,1,208,-1/
       DATA CPVEC/1,1,1,1,1,1,1,1,
     1       1,0,-1,0,0,-1,0,1,
     2       1,-1,0,1,0,-2,0,1,
     3       1,0,0,0,0,1,0,1,
     4       1,-3,0,0,-1,-1,0,1,
     5       1,0,0,-1,0,0,0,1,
     6       1,1,1,0,0,0,1,1,
     7       1,1,1,1,1,1,1,1/
C
       DATA CEVCUR/1/,CEVMNT/2/,CEVLNT/3/,CEVMAT/4/,
     1       CEVCND/5/,CEVBAL/6/,CEVBRN/7/,CEVFUS/8/,
     2       CEVLED/9/,CEVSAF/10/,CEVVLG/11/,CEVGNO/12/,
     3       CEVBUC/13/,CEVSPH/14/,CEVEGH/15/,
     4       CEVFOR/16/,CEVSCL/17/,CEVZGI/18/,CEVZGO/19/,
     5       CEVSTE/20/,CEVMRS/21/,CEVPIN/22/,CEVINQ/23/,
     6       CEVFOL/24/
C
       DATA XRMASK/255/,XDMASK/31744/,XFMASK/3/
       DATA XFSHFT/256/,XASHFT/256/
       DATA XNORM/1/,XNO/2/,XCOND/3/,XDOOR/4/
       DATA XELNT/1,2,3,3/,XLFLAG/32768/
       DATA XMIN/1024/,XMAX/16384/,XUP/9216/,XDOWN/10240/
       DATA XNORTH/1024/,XSOUTH/5120/,XENTER/13312/,XEXIT/14336/
       DATA XEAST/3072/,XWEST/7168/
C
       DATA PLAYER/1/,AROBOT/2/,AMASTR/3/
       DATA ASTAG/32768/
C
       DATA RSEEN/32768/,RLIGHT/16384/,RLAND/8192/
       DATA RWATER/4096/,RAIR/2048/,RSACRD/1024/,RFILL/512/
       DATA RMUNG/256/,RBUCK/128/,RHOUSE/64/,RNWALL/32/,REND/16/
C
       DATA WHOUS/2/,LROOM/8/,CELLA/9/
       DATA MTROL/10/,MAZE1/11/
       DATA MGRAT/25/,MAZ15/30/
       DATA FORE1/31/,FORE3/33/,CLEAR/36/,RESER/40/
       DATA STREA/42/,EGYPT/44/,ECHOR/49/
       DATA TSHAF/61/
       DATA BSHAF/76/,MMACH/77/,DOME/79/,MTORC/80/
       DATA CAROU/83/
       DATA RIDDL/91/,LLD2/94/,TEMP1/96/,TEMP2/97/,MAINT/100/
       DATA MCYCL/101/,BLROO/102/,TREAS/103/,RIVR1/107/,RIVR2/108/
       DATA        RIVR3/109/
       DATA RIVR4/112/,RIVR5/113/,FCHMP/114/,MBARR/119/,FALLS/120/
       DATA MRAIN/121/,POG/122/,VLBOT/126/,VAIR1/127/,VAIR2/128/
       DATA        VAIR3/129/,VAIR4/130/
       DATA LEDG2/131/,LEDG3/132/,LEDG4/133/,MSAFE/135/,CAGER/140/
       DATA CAGED/141/,TWELL/142/,BWELL/143/,ALICE/144/,ALISM/145/
       DATA        ALITR/146/,MTREE/147/,BKENT/148/
       DATA BKVW/151/,BKTWI/153/,BKVAU/154/,BKBOX/155/
       DATA       CRYPT/157/,TSTRS/158/,MRANT/159/
       DATA MREYE/160/,MRA/161/,MRB/162/,MRC/163/,MRG/164/
       DATA       MRD/165/,FDOOR/166/,MRAE/167/
       DATA MRCE/171/,MRCW/172/,MRGE/173/,MRGW/174/,MRDW/176/
       DATA       INMIR/177/,SCORR/179/
       DATA NCORR/182/,PARAP/183/,CELL/184/,PCELL/185/,NCELL/186/
       DATA       CPANT/188/,CPOUT/189/
       DATA CPUZZ/190/
C
       DATA CINTW/1/,DEADXW/2/,FRSTQW/3/,INXW/4/
       DATA OUTXW/5/,WALKIW/6/,FIGHTW/7/,FOOW/8/
C
       DATA READW/100/,MELTW/101/
       DATA INFLAW/102/,DEFLAW/103/,ALARMW/104/,EXORCW/105/
       DATA PLUGW/106/,KICKW/107/,WAVEW/108/,RAISEW/109/,LOWERW/110/
       DATA RUBW/111/,PUSHW/112/,UNTIEW/113/,TIEW/114/,TIEUPW/115/
       DATA TURNW/116/,BREATW/117/,KNOCKW/118/,LOOKW/119/
       DATA EXAMIW/120/,SHAKEW/121/,MOVEW/122/,TRNONW/123/,TRNOFW/124/
       DATA OPENW/125/,CLOSEW/126/,FINDW/127/,WAITW/128/,SPINW/129/
       DATA BOARDW/130/,UNBOAW/131/,TAKEW/132/,INVENW/133/
       DATA FILLW/134/,EATW/135/,DRINKW/136/,BURNW/137/
       DATA MUNGW/138/,KILLW/139/,ATTACW/141/
       DATA SWINGW/140/,WALKW/142/,TELLW/143/,PUTW/144/
       DATA DROPW/145/,GIVEW/146/,POURW/147/,THROWW/148/
C
       DATA DIGW/89/,LEAPW/91/,STAYW/73/,FOLLOW/85/
       DATA HELLOW/151/,LOOKIW/152/,LOOKUW/153/,PUMPW/154/
       DATA WINDW/155/,CLMBW/156/,CLMBUW/157/,CLMBDW/158/,TRNTOW/159/
C
       DATA VISIBT/32768/,READBT/16384/,TAKEBT/8192/,DOORBT/4096/,
     1       TRANBT/2048/,FOODBT/1024/,NDSCBT/512/,DRNKBT/256/,
     2       CONTBT/128/,LITEBT/64/,VICTBT/32/,BURNBT/16/,
     3       FLAMBT/8/,TOOLBT/4/,TURNBT/2/,ONBT/1/
C
       DATA FINDBT/32768/,SLEPBT/16384/,SCRDBT/8192/,TIEBT/4096/,
     1       CLMBBT/2048/,ACTRBT/1024/,WEAPBT/512/,FITEBT/256/,
     2       VILLBT/128/,STAGBT/64/,TRYBT/32/,NOCHBT/16/,
     3       OPENBT/8/,TCHBT/4/,VEHBT/2/,SCHBT/1/
C
       DATA GARLI/2/,FOOD/3/,GUNK/4/,COAL/5/,MACHI/7/,DIAMO/8/
       DATA       TCASE/9/,BOTTL/10/
       DATA WATER/11/,ROPE/12/,KNIFE/13/,SWORD/14/,LAMP/15/,BLAMP/16/
       DATA       RUG/17/,LEAVE/18/,TROLL/19/,AXE/20/
       DATA RKNIF/21/,KEYS/23/,BAR/26/,ICE/30/
       DATA COFFI/33/,TORCH/34/,TBASK/35/,FBASK/36/,IRBOX/39/
       DATA GHOST/42/,TRUNK/45/,BELL/46/,BOOK/47/,CANDL/48/
       DATA MATCH/51/,TUBE/54/,PUTTY/55/,WRENC/56/,SCREW/57/
       DATA       CYCLO/58/,CHALI/59/
       DATA THIEF/61/,STILL/62/,WINDO/63/,GRATE/65/,DOOR/66/
       DATA HPOLE/71/,RBUTT/79/,LEAK/78/,RAILI/75/
       DATA POT/85/,STATU/86/,IBOAT/87/,DBOAT/88/,PUMP/89/,RBOAT/90/
       DATA STICK/92/,BUOY/94/,SHOVE/96/,GUANO/97/,BALLO/98/,RECEP/99/
       DATA BROPE/101/,HOOK1/102/,HOOK2/103/,SAFE/105/,SSLOT/107/
       DATA       BRICK/109/,FUSE/110/
       DATA GNOME/111/,BLABE/112/,DBALL/113/,TOMB/119/
       DATA LCASE/123/,CAGE/124/,RCAGE/125/,SPHER/126/,SQBUT/127/
       DATA FLASK/132/,POOL/133/,SAFFR/134/,BUCKE/137/,ORICE/139/
       DATA       ECAKE/138/,RDICE/140/
       DATA BLICE/141/,ROBOT/142/,FTREE/145/,BILLS/148/,PORTR/149/
       DATA SCOL/151/,ZGNOM/152/,EGG/154/,BEGG/155/,BAUBL/156/
       DATA       CANAR/157/,BCANA/158/,YLWAL/159/
       DATA RDWAL/161/,PINDR/164/
       DATA RBEAM/171/,ODOOR/172/,QDOOR/173/,CDOOR/175/
       DATA       NUM1/178/
       DATA NUM8/185/,WARNI/186/,CSLIT/187/,GCARD/188/,STLDR/189/
       DATA ITOBJ/192/,OPLAY/193/,EVERY/194/
       DATA       VALUA/195/,SAILO/196/,TEETH/197/,WALL/198/
       DATA HANDS/200/,LUNGS/201/,AVIAT/202/
       DATA WNORT/205/,GWATE/209/,MASTER/215/
C DUNGEON, PAGE 3
C
       END

#!/bin/sh
#	Dungeon wrapper
#  Written by A.M. Kuchling, fnord@binkley.cs.mcgill.ca
#  Creates a temporary directory in /tmp, cd's to it,
#  creates symlinks 

#  Location where the Dungeon executable and *.DAT files will be
DUNGEONDIR=/usr/lib/games/dungeon
#  Name of the binary to execute
DUNGEONPROG=dungeon.static
#  Directory to place the temporary directory in
TMPDIR=/tmp

#
#  Make a temporary directory
	curdir=`pwd`
	dir=`whoami`$$	# Build temp. directory name like fnord1538
	cd $TMPDIR
if [ ! -d $dir ]; then
  mkdir $dir
else
  echo The temporary directory $TMPDIR/$dir appears to already exist.
  exit
fi  
cd $dir

# Create symlinks

ln -s $DUNGEONDIR/DINDX.DAT ./DINDX.DAT
ln -s $DUNGEONDIR/DTEXT.DAT ./DTEXT.DAT

# Copy a saved game file from the former working directory, if one exists

if [ -f $curdir/DSAVE.DAT ]; then 
 cp $curdir/DSAVE.DAT .
fi

# Run the dungeon program

$DUNGEONDIR/$DUNGEONPROG

# Keep a saved game file, if one exists.

if [ -f DSAVE.DAT ]; then
 mv DSAVE.DAT $curdir
fi

# Delete the temporary directory

rm DINDX.DAT DTEXT.DAT
cd ..
rmdir $dir

# Change back to original directory

cd $curdir

# End of script
	
